#!/usr/bin/perl

require 'stat_inc.pl';
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "abilities.pl";
$table = "abilities";
$heading = "an Ability";
$keyfield = "abid";
$keyvalue = $CGI->param($keyfield);
$namefield = "name";
$tplfile = "abilities.tpl";

if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to edit Abilities."));
}

if ($action eq "new" || $action eq "edit")
{
	print $CGI->header();
	ParseForm($header);
	if ($keyvalue eq "")
	{
		print "<H1>Add $heading</H1>\n";
	}
	else
	{
        	print "<H1>Edit $heading</H1>\n";
	}
	print "<form action=\"$thispage?\" method=\"post\">";
	if ($tplfile eq "")
	{
		local($dbvar) = dbconnect();
		local($query) = $dbvar->prepare("explain $table");
		local(@array);
		local(@arrNames);
		$query->execute;
		local($ind) = 0;
		    while (@arrCols = $query->fetchrow_array)
		    {
		    $arrNames[$ind] = $arrCols[0];
		    $array[$ind] = $arrCols[1];
		    $ind++;
		    }
		$query->finish;
		$query = $dbvar->prepare("select * from $table where $keyfield = $keyvalue");
		$query->execute;
		local($indFirstRecord) = 0;
		print "<table border=0>\n";
		@arrVals = $query->fetchrow_array;
		$input = $arrVals[0];
		print "<tr>\n<td>$arrNames[0]:</td><td>$input</td>\n</tr>\n";
		local($i) = 0;    
		    for($i=1;$i<$ind;$i++)
		    {
			if ($array[$i] eq "tinyint(1)")
			{
			    if ($arrVals[$i] eq "on")
			    {
			    $checked = " CHECKED";
			    }
			    else
			    {
			    $checked = "";
			    }
			$input = "<input type=\"checkbox\" name=\"$arrNames[$i]\"$checked>";
			}
			elsif ($array[$i] eq "mediumtext")
			{
			$input = "<textarea name=\"$arrNames[$i]\" COLS=20 ROWS=5>$arrVals[$i]</textarea>";
			}
			else
			{
			$input = "<input type=\"text\" name=\"$arrNames[$i]\" size=20 value=\"$arrVals[$i]\">";
			}
		    print "<tr>\n<td>$arrNames[$i]:</td><td>$input</td>\n</tr>\n";
		    }
		$indFirstRecord = 1;
		$query->finish;
		$dbvar->disconnect;
		print "</table>";
	}
	else
	{
	     fillvars();
	     ParseForm($tplfile);
	     if ($type eq "Resource")
	     {
	        print "<HR>\n";
	        print "<H2>Resource Links</H2>\n";
	        print "<p><i>These links will only be saved for Abilities of type Resource.</i></p>\n";
		showResourceLinks();
	     }
	     if ($type eq "Spell")
	     {
	        print "<HR>\n";
	        print "<H2>Edit Spell Specifics</H2>\n";
	        print "<p><i>These values do duplicate some of the information in the spell, but they are used for the spell preparation mechanics.</i></p>\n";
		fillspellvars();
	        ParseForm("spellspecifics.tpl");
	     }
	}
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>";
	}
	else
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>";
	}
	print "</form>";
	print "<br><hr><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($action eq "giveaccess")
{
	print $CGI->header();
	ParseForm($header);
        fillvars();
        print "<H1>Give Characters Access to $name</H1>\n";
	print "<table border = 1>\n";
	print "<tr>\n";
	print "<td><b>Character Name</b></td>\n";
	print "<td><b>Has Access?</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	local($db) = dbconnect();
	local($query) = $db->prepare("select charid from characters order by clast");
	$query->execute;
	local (@array);
	while (@array = $query->fetchrow_array)
	{
	  print "<tr>\n";
	  local ($charid) = $array[0];
	  print "<td>".getCharName($charid)." (".getFullNameFromCharID($charid).")</td>\n";
	  local ($sql) = "select * from charabilityallowed where charid=$charid and abid=$keyvalue";
	  #print "$sql<BR>";
	  local($query2) = $db->prepare($sql);
	  $query2->execute;
	  if ($query2->rows > 0)
	  {
		print "<td><b>Yes</b></td>\n";
		print "<td><a href=\"abilities.pl?action=remaccess&charid=$charid&abid=$keyvalue\">Remove Access</a></td>\n";
		print "</tr>\n";
	  }
	  else
	  {
		print "<td>No</td>\n";
		print "<td><a href=\"abilities.pl?action=addaccess&charid=$charid&abid=$keyvalue\">Give Access</a></td>\n";
		print "</tr>\n";
	  }
	  $query2->finish;
	}
	$query->finish;
	print "</table>\n";
	print "<a href=\"abilities.pl\">Return to Abilities</a>\n";
	print "<br><hr><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($action eq "addaccess")
{
	# add and Redirect
	local ($charid) = $CGI->param("charid");
	$SQL = "insert into charabilityallowed (charid,abid) values ($charid, $keyvalue);";
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?action=giveaccess&abid=$keyvalue");
}
elsif ($action eq "remaccess")
{
	# Remove and Redirect
	local ($charid) = $CGI->param("charid");
	$SQL = "delete from charabilityallowed where charid=$charid and abid=$keyvalue;";
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?action=giveaccess&abid=$keyvalue");
}
elsif ($submit eq "Add")
{
	# Insert and Redirect
	@names = $CGI->param;
	$SQL = "INSERT into $table (";
	foreach $i(@names)
	{
	    if (($i ne $keyfield) && ($i ne "submit") && index($i,"rtid_") != 0)
	    {
		$SQL .= "$i, ";
	    }

	}
	chop $SQL;
	chop $SQL;
	$SQL .= ") values (";
	foreach $i(@names)
	{
	    if (($i ne $keyfield) && ($i ne "submit") && index($i,"rtid_") != 0)
	    {
		local($myCGI) = $CGI->param($i);
		$myCGI =~ s/'/''/g;
		$SQL .= "'" . $myCGI . "', ";
	    }
	 }
	chop $SQL;
	chop $SQL;
	$SQL .= ");";
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	updateResourceTypes();
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Added"));
}
elsif ($submit eq "Change")
{
	#print $CGI->header();
	# Update and Redirect
	$SQL = filltablefromCGI("abilities",0);
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	updateResourceTypes();
	updateSpellSpecial();
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Updated"));
}
elsif ($action eq "delete")
{
	# delete and Redirect
	$SQL = "delete from $table where $keyfield = $keyvalue;";
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Deleted"));
}
elsif ($action eq "dumpplayers")
{
	print $CGI->header;
	ParseForm($header);

	$abname = dosql("select $namefield from $table where $keyfield=$keyvalue;");
	$challenge = dosql("select challenge from $table where $keyfield=$keyvalue;");
	local($db) = dbconnect();
	
	print "<h1>Showing Characters who have $abname</h1>\n";
	
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Character</b></td>\n";
	print "<td><b>Level</b></td>\n";
	print "<td><b>Ability Rating<BR>$challenge</b></td>\n";
	print "<td><b>Text</b></td>\n";
	print "</tr>\n";
	
	$avglev = 0;
	$avgrat = 0;
	$totab = 0;
	
	$sql = "select * from characterabilities where $keyfield=$keyvalue order by level;";
	#print "$sql<BR>";
	local ($query) = $db->prepare($sql);
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())
	{
	  	$charid = $resptr->{"charid"};
	  	local ($mylev) = $resptr->{"level"};
	  	setSTATvars();
		print "<tr>\n";
	  	print "<td>".getCharName($charid)." (".getFullNameFromCharID($charid).")</td>\n";
		print "<td>$mylev</td>\n";
		print "<td>".getabilityrating($challenge,$mylev)."</td>\n";
		print "<td>".$resptr->{"text"}."</td>\n";
		print "</tr>\n";
		$totab++;
		$avglev += $mylev;
		$avgrat += getabilityrating($challenge,$mylev);

	}
	$sql = "select * from keyroleabilities a, keyrolecharacters b where a.$keyfield=$keyvalue  and a.krid=b.krid order by level;";
	#print "$sql<BR>";
	local ($query) = $db->prepare($sql);
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())
	{
	  	$charid = $resptr->{"charid"};
	  	setSTATvars();
		print "<tr bgcolor=#EEEEEE>\n";
	  	print "<td>".getCharName($charid)." (".getFullNameFromCharID($charid).")</td>\n";
		print "<td>".$resptr->{"level"}."</td>\n";
		print "<td>".getabilityrating($challenge,$resptr->{"level"})."</td>\n";
		print "<td>".$resptr->{"text"}."</td>\n";
		print "</tr>\n";

		$totab++;
		$avglev += $resptr->{"level"};
		$avgrat += getabilityrating($challenge,$resptr->{"level"});
	}
	print "<tr>\n";
	print "<td><b>Average</b></td>\n";
	print "<td><b>Level</b></td>\n";
	print "<td><b>Rating</b></td>\n";
	print "<td><b> </b></td>\n";
	print "</tr>\n";
	$avglev = $avglev / $totab;
	$avgrat = $avgrat / $totab;
	print "<tr>\n";
	print "<td>  </td>\n";
	print "<td>".int($avglev+0.5)."</td>\n";
	print "<td>".int($avgrat+0.5)."</td>\n";
	print "<td><b> </b></td>\n";
	print "</tr>\n";
	print "</table>\n";
	$query->finish;
	$db->disconnect;
	print "<br><hr><a href=\"$thispage\">Return to Abilities</a>.<BR>"; 
	print "<a href=\"login.pl\">Main menu</a>."; 
	ParseForm($footer);
}
elsif ($action eq "dump")
{
	local ($typeid) = $CGI->param("typeid");
	local ($typestr) = $CGI->param("typestr");
	print $CGI->header;
	ParseForm($header);
	print "<H1>Dump of All ".$typestr."s</h1>\n";
	local($db) = dbconnect();
	local($tab) = $db->prepare("explain abilities");
	$tab->execute;
	$i = 0;
	while (@arrtemp = $tab->fetchrow_array)
	{
	  $arr[$i] = $arrtemp[0];
	  $arrTypes[$i] = $arrtemp[1];
	  #print "$arr[$i] - $arrTypes[$i]<br>\n";
	  $i++;
	}
	$numFields = $i;
	$tab->finish;
	local ($sql) = "select * from abilities where type='$typestr' order by name;";
	local ($query) = $db->prepare($sql);
	$query->execute;
	while (@array = $query->fetchrow_array)
	{
		for ($k=0;$k<$tab->rows;$k++)
		{
		   $array[$k] =~ s/'/\\'/g;
		   $array[$k] =~ s/"/\"/g;
		   if ($arrTypes[$k] eq 'tinyint(1)')
		   {
			if ($cqquery[$k] > 0)
			{
			    eval("\$$arr[$k] = 'yes'");
			}
			else
			{
			    eval("\$$arr[$k] = 'no'");
			}
		   }
		   else
		   {
			eval("\$$arr[$k] = '$array[$k]'");
		   }
	   	}
		print"<p>\n";
		print"<H2>$name</H2>\n";

		print"<b>Ability Category:</b> $category\n";

		if ($defend eq "yes")
		{
		   print" -- defend";
		}

		print "&nbsp;&nbsp;&nbsp;&nbsp;\n";

		print"<b>Ability Cost Type:</b> $difficulty\n";


		if ($difficulty eq "Cost")
		{
			print"-- $cost<BR><BR>\n";
		}

		print"<BR>\n";

		$effect =~ s/\n/<BR>/g;
		print"<b>Effect:</b><BR>\n";
		print"$effect<BR>\n";

		print"<b>Challenge:</b>\n";
		print"$challenge";
		if ($challenge ne "Unchallenged")
		{
		   print" vs. $challenge_defense\n";
		}

		print"<BR>\n";

		print"<b>Time to Use:</b>  $time &nbsp;&nbsp;\n"; 

		print"<b>Number of Uses:</b>  $uses<BR>\n";

		$other_constraints =~ s/\n/<BR>/g;
		print"<b>Other Constraints:</b><BR>\n";
		print"$other_constraints<BR>\n";

		print"<b>Level of Availability:</b> $allowed\n";

		print"</p>\n";
        }
	$query->finish;
	$db->disconnect;
	print "<br><hr><a href=\"$thispage\">Return to Abilities</a>.<BR>"; 
	print "<a href=\"login.pl\">Main menu</a>."; 
	ParseForm($footer);
}
else
{
	print $CGI->header;
	ParseForm($header);
	print "<H1>Abilities Menu</h1>\n";

	local($db) = dbconnect();
	local ($sql) = "select typeid, type from abilitytypes order by type;";
	local ($query) = $db->prepare($sql);
	$query->execute;
	while (@array = $query->fetchrow_array)
	{
	   print "<H2>$array[1]s</H2>\n";
	   showabilities($array[1]);
	   print "<a href=\"$thispage?action=dump&typeid=$array[0]&typestr=$array[1]\">Dump $array[1]s</a>\n";
	}
	$query->finish;
	$db->disconnect;

	print "<BR><a href=\"abilities.pl?action=new\">ADD a NEW Ability</a>\n";
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"abilities.pl?action=delete&$keyfield=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
	
	ParseForm($footer);
}

exit 0;

sub showabilities()
{
	local ($abilitytype) = $_[0];
	local($db) = dbconnect();
	local ($sql) = "select * from abilities where type='$abilitytype' order by name;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td>Ability Name</td>\n";
	#print "<td>Effect</td>\n";
	print "<td>Action</td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   print "<tr>\n";
	   print "<td>".$resptr->{"name"}."</td>\n";
	   #print "<td>".$resptr->{"effect"}."</td>\n";
	   print "<td><a href=\"\" onClick=\"javascript:window.open('abilitypop.pl?$keyfield=".$resptr->{"$keyfield"}."','','width=450,height=550,left = 100,top = 100,scrollbars=1,resizable=1');\">Display</a>\n";
	   print " -- <a href=\"abilities.pl?action=edit&$keyfield=".$resptr->{"$keyfield"}."\">Edit</a>\n";
	   if ($resptr->{"allowed"} eq "By Request Only")
	   {
	   	print " -- <a href=\"abilities.pl?action=giveaccess&$keyfield=".$resptr->{"$keyfield"}."\">Give Characters Access</a>\n";
	   }
	   print " -- <a href=\"abilities.pl?action=dumpplayers&$keyfield=".$resptr->{"$keyfield"}."\">Show Players</a>\n";
	   print " -- <a href=\"javascript:deleteConfirm('".$resptr->{"name"}."',".$resptr->{"$keyfield"}.");\">Delete</a></td>\n";
	   print "</tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub fillvars()
{
	filltable();

	$catselect = makeDropDown("abilitycategories", "category", "category", "", "", $category);
	$challengeselect = makeDropDown("abilitychallenge", "challenge", "challenge", "", "", $challenge);
	$diffselect = makeDropDown("abilitydifficulty", "difficulty", "difficulty", "", "", $difficulty);
	$typeselect = makeDropDown("abilitytypes", "type", "type", "", "", $type);
	$allowedselect = makeDropDown("abilityallowed", "allowed", "allowed", "", "", $allowed);
}


sub showResourceLinks()
{
	local($db) = dbconnect();
	local ($sql) = "select typeid, type from resourcetypes;";
	local($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1 width=100%>\n";
	$k = 0;
	while (@array = $query->fetchrow_array())
	{
	   if ($k == 0)
	   {
	      print "<tr>";
	   }
	   $mylev = 0;
	   $sql = "select level from resourcetypelink where typeid=$array[0] and $keyfield=$keyvalue;";
	   local ($query2) = $db->prepare($sql);
	   $query2->execute;
	   $mylev = 0;
	   if ($query2->rows > 0)
	   {
	     @array2 = $query2->fetchrow_array();
	     $mylev = $array2[0];
	   }
	   $query2->finish;
	   print "<td>$array[1]:  <input type=text name=rtid_$array[0] value=\"$mylev\" maxsize=3 size=3></td>";
	   $k++;
	   if ($k == 5)
	   {
	      print "</tr>\n";
	      $k = 0;
	   }
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub updateResourceTypes()
{
	if ($CGI->param("type") ne "Resource")
	{
	    return;
	}
	local($db) = dbconnect();
	local ($sql) = "delete from resourcetypelink where $keyfield=$keyvalue;";
	#print "$sql<BR>";
	$db->do($sql);
	@names = $CGI->param;
	foreach $i(@names)
	{
	   local ($level) = $CGI->param($i) + 0;
	   if (index($i,"rtid_") == 0 && $level > 0)
	   {
	        local ($typeid) = $i;
	        $typeid =~ s/rtid_//g;
		$sql = "insert into resourcetypelink (typeid, abid, level) values ($typeid, $keyvalue, $level);";
		#print "$sql<BR>";
		$db->do($sql);
	   }
	}
	$db->disconnect;
}


sub fillspellvars()
{
	$table = "spellspecifics";
	filltable();

	$table = "abilities";
}

sub updateSpellSpecial()
{
	if ($CGI->param("type") ne "Spell")
	{
	    return;
	}
	local($db) = dbconnect();
	local ($sql) = "delete from spellspecifics where $keyfield=$keyvalue;";
	#print "$sql<BR>";
	$db->do($sql);
	
	$SQL = filltablefromCGI("spellspecifics",1);
	#print "$SQL<BR>";
	$db->do($SQL);
	$db->disconnect;
}

sub getabilityrating()
{
    local ($challenge) = $_[0];
    local ($level) = $_[1];
    local ($num) = $level;
    
    if ($challenge eq "5 + Ability Level")
    {
	$num = 5 + $level;
    }
    if ($challenge eq "DEX + Ability Level")
    {
	$num = $dex + $level;
    }
    if ($challenge eq "DEX - Ability Level")
    {
	$num = $dex - $level;
    }
    if ($challenge eq "IQ - Ability Level")
    {
	$num = $iq - $level;
    }
    if ($challenge eq "IQ + Ability Level")
    {
	$num = $iq + $level;
    }
    if ($challenge eq "Library Use + Ability Level")
    {
    	$libuse = getlevel("LIBRARY USE");
	$num = $libuse + $level;
    }
    if ($challenge eq "STR + Ability Level")
    {
	$num = $str + $level;
    }
    if ($challenge eq "STR - Ability Level")
    {
	$num = $str - $level;
    }
    if ($challenge eq "WILL - Ability Level")
    {
	$num = $will - $level;
    }
    if ($challenge eq "WILL + Ability Level")
    {
	$num = $will + $level;
    }
    if ($challenge eq "STR + Unarmed Combat")
    {
	$num = $str + getlevel("UNARMED/CLOSE WEAPONS");
    }
    if ($challenge eq "DEX + Ranged Weapons")
    {
	$num = $dex + getlevel("RANGED/THROWN WEAPONS");
    }
    if ($challenge eq "Status + Ability Level")
    {
	$num = $status + $level;
    }
    
    return $num;

}
