#!/usr/bin/perl

# Require and Use
# * These statements alert perl.exe that
# * you are going to be using functions, 
# * subroutines, and methods from other
# * perl programs. "require" is used for a
# * perl library, and the "use" statement 
# * is usually used to reference a perl
# * object (usually referred to as a 
# * module).
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$pid = getPlayerID();
$al = getAccessLevel($pid);

if ($al >= $developer_access)
{
$table = $CGI->param("table");
    if ($table eq "")
    {
      print $CGI->header();
      ParseForm($header);
      print "<H1>Direct Database Edit - Choose A Table</H1>\n";
      print "<form action=\"addedit.pl\" method=\"post\">\n";
      print "<table border=0><tr><td>\n";
      print makeTablesDropDown($al);
      print "</td><td></tr>\n";
      print "<tr><td></td><td><input type=\"submit\" name=\"submit\" value=\"Select A Record To Edit\"></td></tr>\n";
      print "<tr><td></td><td><input type=\"submit\" name=\"submit\" value=\"Add A New Record to Selected Table\"></td></tr>\n";
      print "<tr><td></td><td><input type=\"submit\" name=\"submit\" value=\"Delete Record from Selected Table\"></td></tr>\n";
      print "<tr><td></td><td><input type=\"submit\" name=\"submit\" value=\"Add A New Column to Selected Table\"></td></tr>\n";
      print "</table></form>\n";
    }
    elsif ($CGI->param("submit") eq "Add A New Column to Selected Table")
    {
    print $CGI->header();
    ParseForm($header);
    print "<br><br><font size=+1><b>Add A Column</b></font><br><hr>\n";
    print "<form action=\"addedit.pl\" method=\"post\">\n";
    print "<table border=0>\n";
    print "<tr><td>Column Name</td><td><input type=\"text\" name=\"colname\"></td></tr>\n";
    print "<tr><td>Column Type</td>\n<td>\n";
    print "<select name=\"coltype\">\n";
    print "<option value=\"varchar(2)\">Character (length 2)</option>\n";
    print "<option value=\"varchar(5)\">Character (length 5)</option>\n";
    print "<option value=\"varchar(10)\">Character (length 10)</option>\n";
    print "<option value=\"varchar(20)\">Character (length 20)</option>\n";
    print "<option value=\"varchar(30)\">Character (length 30)</option>\n";
    print "<option value=\"varchar(50)\">Character (length 50)</option>\n";
    print "<option value=\"varchar(100)\">Character (length 100)</option>\n";
    print "<option value=\"mediumtext\">Text Field</option>\n";
    print "<option value=\"integer\">Integer</option>\n";
    print "<option value=\"bit\">Yes/No</option>\n";
    print "<option value=\"float\">Decimal Number</option>\n";
    print "</select>\n";
    print "</td></tr>\n";
    print "<tr><td>Default Value</td><td><input type=\"text\" name=\"colval\"></td></tr>\n";
    print "</td>\n</tr>\n<tr><td colspan=2 align=\"center\">";
    print "<input type=\"submit\" name=\"submit\" value=\"Add Column\">";
    print "</td></tr>\n</table>\n</form\n>";
    }
    elsif ($CGI->param("submit") eq "Add A New Record to Selected Table")
    {
      print $CGI->header();
      ParseForm($header);
      print "<br><br><font size=+1><b>Add A New Record</b></font><br><hr>\n";
      local($dbvar) = dbconnect();
      local($query) = $dbvar->prepare("explain $table");
      $query->execute;
      print "<form action=\"addedit.pl?table=$table%action=add\" method=\"post\">";
      print "<table border=0>\n";
      @array = $query->fetchrow_array;
        while (@array = $query->fetchrow_array)
        {
            if ($array[1] eq "tinyint(1)")
            {
            $input = "<input type=\"checkbox\" name=\"$array[0]\">";
            }
            elsif ($array[1] eq "mediumtext")
            {
            $input = "<textarea name=\"$array[0]\" COLS=20 ROWS=5></textarea>";
            }
            else
            {
            $input = "<input type=\"text\" name=\"$array[0]\" size=20>";
            }
        print "<tr>\n<td>$array[0]:</td><td>$input</td>\n</tr>\n";
        }
     print "<input type=\"hidden\" name=\"table\" value=\"$table\">\n";
     print "<input type=\"hidden\" name=\"idfield\" value=\"$keyfield\">\n";
     print "<input type=\"hidden\" name=\"idval\" value=\"$keyvalue\">\n";
     print "<tr><td colspan=2 align=\"center\"><input type=\"submit\" name=\"submit\" value=\"Add\"</td></tr>";
      print "</table></form>";
      $query->finish;
      $dbvar->disconnect;
    }
    elsif ($CGI->param("submit") eq "Edit Record")
    {
    #Print Table Record For Editing
	print $CGI->header();
	ParseForm($header);
        print "<br><br><font size=+1><b>Edit Record</b></font><br><hr>\n";
        local($dbvar) = dbconnect();
        $keyfield = $CGI->param("idfield");
        $keyvalue = $CGI->param("idval");
        local($query) = $dbvar->prepare("explain $table");
        local(@array);
        local(@arrNames);
        $query->execute;
        local($ind) = 0;
            while (@arrCols = $query->fetchrow_array)
            {
            $arrNames[$ind] = $arrCols[0];
            $array[$ind] = $arrCols[1];
            $ind++;
            }
        $query->finish;
        $query = $dbvar->prepare("select * from $table where $keyfield = $keyvalue");
        $query->execute;
        local($indFirstRecord) = 0;
        print "<form action=\"addedit.pl?table=$table&action=edit&idfield=$keyfield&idval=$keyvalue\" method=\"post\">";
        print "<table border=0>\n";
        @arrVals = $query->fetchrow_array;
        $input = $arrVals[0];
        print "<tr>\n<td>$arrNames[0]:</td><td>$input</td>\n</tr>\n";
        local($i) = 0;    
            for($i=1;$i<$ind;$i++)
            {
                if ($array[$i] eq "tinyint(1)")
                {
                    if ($arrVals[$i] eq "on" || $arrVals[$i] eq "1")
                    {
                    $checked = " CHECKED";
                    }
                    else
                    {
                    $checked = "";
                    }
                $input = "<input type=\"checkbox\" name=\"$arrNames[$i]\"$checked value=1>";
                }
                elsif ($array[$i] eq "mediumtext")
                {
                $input = "<textarea name=\"$arrNames[$i]\" COLS=20 ROWS=5>$arrVals[$i]</textarea>";
                }
                else
                {
                $input = "<input type=\"text\" name=\"$arrNames[$i]\" size=20 value=\"$arrVals[$i]\">";
                }
            print "<tr>\n<td>$arrNames[$i]:</td><td>$input</td>\n</tr>\n";
            }
        $indFirstRecord = 1;
	print "<input type=\"hidden\" name=\"table\" value=\"$table\">\n";
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	print "<input type=\"hidden\" name=\"idfield\" value=\"$keyfield\">\n";
	print "<input type=\"hidden\" name=\"idval\" value=\"$keyvalue\">\n";
        print "<tr><td><input type=\"submit\" name=\"submit\" value=\"Change\"</td></tr>";
        print "</table></form>";
        $query->finish;
    $dbvar->disconnect;
    }
    elsif ($CGI->param("submit") eq "Change")
    {
	#print $CGI->header();
        local($dbvar) = dbconnect();
        $keyfield = $CGI->param("idfield");
        $keyvalue = $CGI->param("idval");
	$SQL = filltablefromCGI($table,0);
	#print $SQL . "\n\n";
	$dbvar->do($SQL);
    	$dbvar->disconnect;
	print $CGI->redirect("addedit.pl?table=$table&submit=Select A Record To Edit&idfield=$keyfield&idval=$keyvalue");
    }
    elsif ($CGI->param("submit") eq "Delete")
    {
        local($dbvar) = dbconnect();
        $keyfield = $CGI->param("idfield");
        $keyvalue = $CGI->param("idval");
	$SQL = "DELETE FROM $table WHERE $keyfield = $keyvalue";
	#print $SQL . "\n\n";
	$dbvar->do($SQL);
    	$dbvar->disconnect;
	print $CGI->redirect("addedit.pl?table=$table&submit=Delete Record from Selected Table&idfield=$keyfield&idval=$keyvalue");
    }
    elsif ($CGI->param("submit") eq "Add")
    {
       local($dbvar) = dbconnect();
        $keyfield = $CGI->param("idfield");
        $keyvalue = $CGI->param("idval");
    	$SQL = "Insert into $table";
	local(@names) = $CGI->param;
	local ($count) = 0;
	foreach my $parm (@names)
	{
	  if ($parm ne "mode" and $parm ne "submit" and $parm ne "table" and index($parm,"id") != 0)  
	  {
	    $count += 1;
	  }
	}
	foreach my $parm (@names)
	{
	  if ($parm ne "mode" and $parm ne "submit" and $parm ne "table" and index($parm,"id") != 0)  
	  {
	    $namestring .= ($parm);
	    $_ = $type{$parm};
	    if (/.*int.*/)
	    {
	    $valstring .= ($CGI->param($parm));
	    }
	    elsif ($CGI->param($parm) eq "on")
	    {
	    $valstring .= "1, \n";
	    }
	    else
	    {
	    $strCGI = $CGI->param($parm);
	    $strCGI =~ s/'/''/g;
	    $valstring .= ("'" . $strCGI . "'");            
	    }
	    $count -= 1;
	    if ($count > 0)
	    {
	    	$namestring .= ", ";
	    	$valstring .= ", ";
	    }
	  }
	}
    	$SQL .= " (" . $namestring . ") VALUES (" . $valstring . ")";
	#print $SQL . "\n\n";
	$dbvar->do($SQL);
    	$dbvar->disconnect;
	print $CGI->redirect("addedit.pl?table=$table&submit=Select A Record To Edit&idfield=$keyfield&idval=$keyvalue");
    }
    elsif ($CGI->param("submit") eq "Select A Record To Edit")
    {
    #Print Table Rows With links To Editing
    print $CGI->header();
    ParseForm($header);
    print "<br><br><font size=+1><b>Select A Record From " . uc($table) . "</b></font><br><hr>\n";
    local($dbvar) = dbconnect();
    local($query) = $dbvar->prepare("explain $table");
    $query->execute;
    
    print "<table border=1>\n";
    local($nameIndVar) = 0;
    while (@array = $query->fetchrow_array)
    {
    $arrNames[$nameIndVar] = $array[0];
    $nameIndVar++;
    }
    print "<tr>\n";
        foreach $fieldname (@arrNames)
        {
        print "<td><b>$fieldname</b></td>";
        }
    $query->finish;
    $query = $dbvar->prepare("select * from $table");
    $query->execute;
    print "\n</tr>\n";
        while (@array = $query->fetchrow_array)
        {
        $indFirstRecord = 0;
        $HTML = "<tr>\n";
            foreach $field (@array)
            {
                if ($indFirstRecord == 0)
                {
                $HTML .= "<td><a href=\"addedit.pl?table=$table&submit=Edit%20Record&idfield=$arrNames[0]&idval=$field\">$field</a></td>"; 
                }
                else
                {
                $HTML .= "<td>$field</td>";
                }
            $indFirstRecord = 1;
            }
        $HTML .= "</tr>\n";
        print $HTML;
        }
    print "</table>";
    $query->finish;
    $dbvar->disconnect;
    }
    elsif ($CGI->param("submit") eq "Delete Record from Selected Table")
    {
    #Print Table Rows With links To Editing
    print $CGI->header();
    ParseForm($header);
    print "<H1>Select A Record From " . uc($table) . "</H1>\n";
    local($dbvar) = dbconnect();
    local($query) = $dbvar->prepare("explain $table");
    $query->execute;
    
    print "<table border=1>\n";
    local($nameIndVar) = 0;
    while (@array = $query->fetchrow_array)
    {
    $arrNames[$nameIndVar] = $array[0];
    $nameIndVar++;
    }
    print "<tr>\n";
    foreach $fieldname (@arrNames)
    {
        print "<td><b>$fieldname</b></td>";
    }
    $query->finish;
    $query = $dbvar->prepare("select * from $table");
    $query->execute;
    print "\n</tr>\n";
        while (@array = $query->fetchrow_array)
        {
        $indFirstRecord = 0;
        $HTML = "<tr>\n";
            foreach $field (@array)
            {
                if ($indFirstRecord == 0)
                {
                $HTML .= "<td><a href=\"addedit.pl?table=$table&submit=Delete&idfield=$arrNames[0]&idval=$field\">$field</a></td>"; 
                }
                else
                {
                $HTML .= "<td>$field</td>";
                }
            $indFirstRecord = 1;
            }
        $HTML .= "</tr>\n";
        print $HTML;
        }
    print "</table>";
    $query->finish;
    $dbvar->disconnect;
    }
print "<br><hr><a href=\"addedit.pl\">Return to Direct Database Edit Menu</a>."; 
print "<br><a href=\"login.pl\">Return to Main Menu</a>."; 
ParseForm($footer);
}
else
{
print $CGI->redirect("login.pl?error=" . encodeURL("You do not have access to that function"));
}