#!/usr/bin/perl

# Require and Use
# * These statements alert perl.exe that
# * you are going to be using functions, 
# * subroutines, and methods from other
# * perl programs. "require" is used for a
# * perl library, and the "use" statement 
# * is usually used to reference a perl
# * object (usually referred to as a 
# * module).

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;

$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "addeditplayer.pl";
$table = "players";
$heading = "Player";
$keyfield = "playerid";
$keyvalue = $pid; #$CGI->param($keyfield);
$namefield = "concat(pfirst, ' ', plast)";
$namevalue = dosql("select $namefield from $table where $keyfield=$keyvalue;");
$tplfile = "addeditplayer.tpl";
$errstr = $CGI->param("error");

######################
# Use Case 1 - Blank #
######################
# * In this use case, the page is loading for the first time.
# * We load the form so it can be submitted to add a new user.
if ("$pid" eq "" and $submit ne "Submit")
{
   print $CGI->header();
   $doctitle = "Add New Player";
   ParseForm($header);

   if ($errstr ne "")
   {
	print "<br><font color=\"red\">$errstr</font><br>\n";
   }
   
   print "<H1>$doctitle</H1>\n";

   print "<form action=\"addeditplayer.pl\" method=\"post\">\n";
   fillvars();
   print "<input type=hidden name=\"psecurity\" value=\"1\">\n";
   print "<input type=hidden name=\"pXP\" value=\"0\">\n";
   print "<input type=hidden name=\"pXPspent\" value=\"0\">\n";
   ParseForm("addeditplayer.tpl");
   print "</form>\n";
   ParseForm($footer);

}
##########################
# Use Case 2 - Filled-In #
##########################
# * In this use case, we are loading the page for the first time, 
# * But the user is logged in, so we load their information for 
# * editing and print out the filled-in form.
elsif ("$pid" ne "" and $submit ne "Submit")
{

   print $CGI->header();
   $doctitle = "Edit $namevalue";
   ParseForm($header);

   goodfilltable("players", "playerid", $pid);

   $mselected = "";
   $fselected = "";

   if ($pgender eq "F")
   {
        $fselected = " SELECTED";
   }
   else
   {
        $mselected = " SELECTED";
   }

   if ($errstr ne "")
   {
      print "<br><font color=\"red\">$errstr</font><br>\n";
   }
    
   print "<H1>$doctitle</H1>\n";

   print "<form action=\"addeditplayer.pl\" method=\"post\">\n";
   print "<input type=hidden name=\"playerid\" value=\"$playerid\">\n";
   print "<input type=hidden name=\"psecurity\" value=\"$psecurity\">\n";
   print "<input type=hidden name=\"pXP\" value=\"$pXP\">\n";
   print "<input type=hidden name=\"pXPspent\" value=\"$pXPspent\">\n";
   ParseForm("addeditplayer.tpl");
   print "</form>\n";
   ParseForm($footer);
}
#######################
# Use Case 3 - Update #
#######################
# * In this use case, a user has submitted the update form. We will
# * update the database, and then redirect the user to the page to
# * display the filled-in form again, with the refreshed data.
elsif ("$pid" ne "" and $submit eq "Submit")
{

	$SQL = filltablefromCGI($table, 0);
	#print "$SQL<BR>";
	local($db) = dbconnect();
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("main.pl?error=Player info updated");

	# Exit
	# * Exit causes the rest of the script to be ignored. Zero is the 
	# * universally accepted value for a normal termination without error.
	exit 0;
}
else
{
#######################
# Use Case 4 - Insert #
#######################
# * In this case, we are inserting the record 
# * for the first time. Afterward, we will redirect
# * the user back to this page to see the filled-in form.

   if (checkDuplicateLogin($CGI->param("plogin")) == 1)
   {
   	print $CGI->redirect("addeditplayer.pl?error=" . encodeURL("The Login ID you have chosen is already in use. Please pick a different Login ID."));
   	exit 0;
   }
   else
   {
	# Validate the Parameters
	if ($CGI->param("plogin") eq NULL or $CGI->param("plogin") eq "")
	{
	   print $CGI->redirect("addeditplayer.pl?error=" . encodeURL("You must have a login id.  Please try again."));
	   exit 0;
	}
	if ($CGI->param("pfirst") eq NULL or $CGI->param("pfirst") eq "")
	{
	   print $CGI->redirect("addeditplayer.pl?error=" . encodeURL("You must have a first name.  Please try again."));
	   exit 0;
	}
	if ($CGI->param("plast") eq NULL or $CGI->param("plast") eq "")
	{
	   print $CGI->redirect("addeditplayer.pl?error=" . encodeURL("You must have a last name.  Please try again."));
	   exit 0;
	}
	if ($CGI->param("pemail") eq NULL or $CGI->param("pemail") eq "")
	{
	   print $CGI->redirect("addeditplayer.pl?error=" . encodeURL("You must have an e-mail address.  Please try again."));
	   exit 0;
	}
	$age = $CGI->param("page");
	if ($age !=~ "$age")
	{
	   $age = 0;
	}
	if ($CGI->param("ppassword") eq NULL or $CGI->param("ppassword") eq "")
	{
	   print $CGI->redirect("addeditplayer.pl?error=" . encodeURL("You must enter a password.  Please try again."));
	   exit 0;
	}

	# Execute the Insert Query
	$SQL = filltablefromCGI($table, 1);
	#print "$SQL<BR>";
	local($db) = dbconnect();
	$db->do($SQL);
	$db->disconnect;
	# Redirect
	print $CGI->redirect("login.pl?error=" . encodeURL($CGI->param("plogin") . " has been created.  Please log in."));
	exit 0;
   }
}
print "<br><hr><a href=\"main.pl\">Main menu</a>\n";
ParseForm($footer);


sub fillvars()
{
	$pfirst = $CGI->param("pfirst");
	$cmiddle = $CGI->param("cmiddle");
	$plast = CGI->param("plast");

	$pemail = $CGI->param("pemail");

	$pcelphone = $CGI->param("pcelphone");

	$page = $CGI->param("page");
	$pgender = $CGI->param("pgender");

	$mselected = " SELECTED";
	if ($pgender eq "F")
	{
	   $fselected = " SELECTED";
	}
	else
	{
	   $mselected = " SELECTED";
	}
	$plogin = $CGI->param("plogin");

}
