#!/usr/bin/perl

require 'common.pl';
require 'stat_inc.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "analyzeplan.pl";
$table = "WS_plans";
$heading = "Plan";
$keyfield = "planid";
$keyvalue = $CGI->param($keyfield);
$namefield = "name";
$errstr = $CGI->param("error");

$step = $CGI->param("step") + 0;
$charid = $CGI->param("charid");
$charname = getCharName($charid);
$planname = dosql("select $namefield from $table where $keyfield=$keyvalue;");

if ($al < $writer_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to visit this page!"));
}
elsid ($step == 2)
{
	print $CGI->header;
	$doctitle = "Analyze a Plan: $planname\n";
	ParseForm($header);
	
	print "<p><i>This page is for assistant/floor GMs to allow characters to analyze plans to get information from them.  If you need help working this page, find a GM.</i></p>\n";
	
	print "<form action=\"$thispage\" method=\"post\">";

	print "<h2>Step 2</h2>\n";
	
	print "<p><i>Select the characters who will be working on the plan.</i></p>\n";
	
	print makeCheckBoxes("characters","charid","concat(cfirst,' ',clast)")."<BR><BR>\n";

	print "<input type=\"hidden\" name=\"step\" value=\"2\"><BR>";
	print "<input type=\"submit\" name=\"submit\" value=\"Go To Step 2\"><BR>";
	print "</form>";
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	ParseForm($footer);
}
else
{
	print $CGI->header;
	$doctitle = "Analyze a Plan\n";
	ParseForm($header);
	
	print "<p><i>This page is for assistant/floor GMs to allow characters to analyze plans to get information from them.  If you need help working this page, find a GM.</i></p>\n";
	
	print "<form action=\"$thispage\" method=\"post\">";

	print "<h2>Step 1</h2>\n";
	
	print "<p><i>Select the plan from the list below.</i></p>\n";
	
	$sel1 = makeDropDown("WS_plans", "planid", "name");
	print "Plans: $sel1<BR><BR>\n";

	print "<input type=\"hidden\" name=\"step\" value=\"2\"><BR>";
	print "<input type=\"submit\" name=\"submit\" value=\"Go To Step 2\"><BR>";
	print "</form>";
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	ParseForm($footer);
}
exit 0;

sub createCharDrop
{
    local ($db) = dbconnect();
    $SQL = "select a.charid, concat(a.cfirst, ' ', a.clast), a.ctitle from characters a,  characterSTATs b where a.charid=b.charid and a.chartype <= $cast_character and a.charid > 0 order by a.clast;";
 
    local($query) = $db->prepare($SQL);
    #print "$SQL<BR>";
    $query->execute;

    local ($retVal) = "";
    if ($query->rows > 0)
    {
        $retVal = "<select name=\"charid\">\n";
        while (@array = $query->fetchrow_array)
        {
            $retVal .= "<option value=\"$array[0]\">$array[1]";
            if ($array[2] ne "")
            {
            	$retVal .= ", $array[2]";
            }
            
            $retVal .= "</option>\n";
        }
        $retVal .= "</select>\n";
    }
    $query->finish;
    $db->disconnect;
    return "$retVal";
}

# ******************
# * makeCheckBoxes *
# ******************
sub makeCheckBoxes
{
    local($table, $field1, $field2, $checksql) = @_;
    local ($db) = dbconnect();
    $SQL = "select $field1, $field2 from $table;";
    
    local($query) = $db->prepare($SQL);
    #print $CGI->header();
    #print "$SQL<BR>";
    $query->execute;

    local ($retVal) = "";
    #Check to make sure $query is not empty
    if ($query->rows > 0)
    {
        local ($num) = 0;
        local (@array);
        while (@array = $query->fetchrow_array)
        {        
           local ($csql) = eval qq/"$checksql"/;
           local ($checkval) = "";
           if (dosql($csql) + 0 > 0)
           {
             $checkval = "CHECKED";
           }
           $retVal .= "<input type=\"checkbox\" name=\"".$field1."_$num\" value=\"$array[0]\" $checkval>$array[1]</input>\n";
           $num++;
           if ($num % 5 == 0)
           {
               $retVal .=  "<BR>";
           }
        }
        $retVal .= "<input type=\"hidden\" name=\"".$field1."_total\" value=\"$num\">\n";
    }
    $query->finish;
    $db->disconnect;
    return $retVal;
}
