#!/usr/bin/perl

require 'bga_inc.pl';
require 'stat_inc.pl';
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "bga.pl";
$table = "bgas";
$heading = "Between Game Action";
$keyfield = "bgaid";
$keyvalue = $CGI->param($keyfield);
$tplfile = "bga.tpl";
$errstr = $CGI->param("error");

$charid = $CGI->param("charid") + 0;
$charname = getCharName($charid);

$approved = dosql("select charstatsapproved from characters where charid=$charid;") + 0;

if ($pid != getPIDFromCharID($charid) && $al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to submit BGAs for that character!"));
}
elsif ($approved == 0 && $al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You may not perform between game actions until your character STATs are approved.  Please e-mail your GM to approve your STATs"));
}
elsif ($action eq "new" || $action eq "edit")
{
	print $CGI->header();
	if ($keyvalue eq "")
	{
		$doctitle = "New $heading for $charname";
	}
	else
	{
        	$doctitle = "Edit $heading for $charname";
	}
	ParseForm($header);
	print "<H1>$doctitle</H1>\n";
	print "<form action=\"$thispage\" method=\"post\">";
        fillvars();
        ParseForm($tplfile);

	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	print "<input type=\"submit\" name=\"submit\" value=\"Go To Step 2\"><BR>";
	
	print "<b>Types of BGAs</b>:<BR>";
	print "<i>Here is an explanation of BGAs that you may perform:</i><BR><BR>";
	
	print "$bga_list<BR>";

	print "</form>";
	print "<br><hr><a href=\"$thispage\">Return</a>.";
	print "<br><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($submit eq "Go To Step 2")
{
	handlebgastep2();
}
elsif ($submit eq "Add")
{
	# Insert and Redirect
	#print $CGI->header();
	$SQL = createAddBGAsql();
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?charid=$charid&error=" . encodeURL("$heading Added"));
}
elsif ($submit eq "Change")
{
	#print $CGI->header();
	$SQL = createChangeBGAsql();
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?charid=$charid&error=" . encodeURL("$heading Updated"));
}
elsif ($action eq "delete")
{
	#print $CGI->header();
	# delete and Redirect
	$SQL = "select priority from $table where $keyfield = $keyvalue;";
	#print "$SQL<BR>";
	$priority = dosql($SQL);
	local($dbvar) = dbconnect();
	$SQL = "delete from $table where $keyfield = $keyvalue;";
	$dbvar->do($SQL);
	$SQL = "update $table set priority = (priority-1) where charid=$charid and priority>$priority and period=$current_bgp;";
	#print "$SQL<BR>";
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?charid=$charid&error=" . encodeURL("$heading Deleted"));
}
elsif ($action eq "down")
{
	#print $CGI->header();
	$max = dosql("select max(priority) from $table where charid=$charid and period=$current_bgp;");
	$priority = dosql("select priority from $table where $keyfield=$keyvalue;");
	if ($priority < $max)
	{
		local($dbvar) = dbconnect();
		$SQL = "update $table set priority = (priority-1) where charid=$charid and priority=".($priority+1)." and period=$current_bgp;";
		#print "$SQL<BR>";
		$dbvar->do($SQL);
		$SQL = "update $table set priority = (priority+1) where $keyfield=$keyvalue;";
		#print "$SQL<BR>";
		$dbvar->do($SQL);
		$dbvar->disconnect;
	}
	print $CGI->redirect("$thispage?charid=$charid&error=" . encodeURL("$heading moved"));
}
elsif ($action eq "up")
{
	#print $CGI->header();
	$priority = dosql("select priority from $table where $keyfield=$keyvalue;");
	if ($priority > 1)
	{
		local($dbvar) = dbconnect();
		$SQL = "update $table set priority = (priority+1) where charid=$charid and priority=".($priority-1)." and period=$current_bgp;";
		#print "$SQL<BR>";
		$dbvar->do($SQL);
		$SQL = "update $table set priority = (priority-1) where $keyfield=$keyvalue;";
		#print "$SQL<BR>";
		$dbvar->do($SQL);
		$dbvar->disconnect;
	}
	print $CGI->redirect("$thispage?charid=$charid&error=" . encodeURL("$heading moved"));
}
elsif ($action eq "process")
{
	print $CGI->header();
	$doctitle = "Process ".$heading." for $charname";
	ParseForm($header);
	
	print "<H1>$doctitle</h1>\n";
	
	print processBGA();
	
	print "<br><hr><a href=\"$thispage?charid=$charid\">Return</a>."; 
	print "<br><a href=\"login.pl\">Main menu</a>."; 
	ParseForm($footer);
}
else
{
	print $CGI->header;
	$doctitle = "Manage ".$heading."s for $charname";
	ParseForm($header);
	
	if ("$errstr" ne "")
	{
	   print "<font color=red>$errstr</font><BR><BR>\n";
	}
	
	print "<H1>$doctitle</h1>\n";
	
	$num_allowed = $base_num_allowed + getlevel("SPARE TIME"); 
	$num_allowed -= getlevel("RESPONSIBILITIES"); 
	
  	$numoccs = dosql("select count(oid) from characteroccupations where charid=$charid;") - 1;
  	$numoccs = max(0,$numoccs);
  	$num_allowed -= $numoccs;
  	
	$num_allowed = max($num_allowed,1);
	
	print "<font color=\"0x335577\"><i><b>Between Game Actions.</b></i></font><BR><BR>\n";

	print "<H2>BGA Results For BGP $current_bgp: $bgpstring[$current_bgp]</h2>\n";
	showdata($current_bgp);
	
	print "You are allowed $num_allowed $heading(s) this Between Games Period.<BR>";
	if ($num_bgas < $num_allowed)
	{
	   print "<a href=\"$thispage?action=new&charid=$charid\">ADD a NEW $heading</a><BR><BR>\n";	
	}
	
	print "<i><sup>*</sup>Some BGAs can be processed automatically by the database without involving the GMs.</i><BR>\n";	
	print "<a href=\"#freeact\">Go to Free Between Game Actions</a><BR><BR>\n";	
	

	for ($i = $current_bgp - 1; $i > 0; $i--)
	{
	  print "<H2>BGA Results For BGP $i: $bgpstring[$i]</h2>\n";
	  showdata($i);
	}

	showFreeBGAMenu();
	
	print displayInventory();

	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?charid=$charid&action=delete&$keyfield=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
	
	ParseForm($footer);
}

exit 0;

sub showdata()
{
	local ($period) = $_[0];
	$num_bgas = 0;
	$max = dosql("select max(priority) from $table where charid=$charid and period=$period;");
	local($db) = dbconnect();
	local ($sql) = "select * from $table where charid=$charid and period=$period order by priority;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1 width=100%>\n";
	print "<tr>\n";
	print "<td><b>Name</b></td>\n";
	print "<td><b>Notes</b></td>\n";
	print "<td><b>Priority</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = dosql("select text from bgatypes where btid = ".$resptr->{"btid"}.";");
	   $key = $resptr->{"$keyfield"};
	   print "<tr>\n";
	   print "<td>$name</td>\n";
	   print "<td>".$resptr->{"data"}."</td>\n";
	   print "<td align=center>";
	   if ($resptr->{"priority"} > 1 && $period == $current_bgp)
	   {
	       print "<a href=\"$thispage?charid=$charid&action=up&$keyfield=$key\"><img src=\"up_arrow.gif\" alt=\"Move up\" border=0></a>";
	   }
	   else
	   {
	       print "<img src=\"empty.gif\">";
	   }	   
	   print "&nbsp;&nbsp;".$resptr->{"priority"}."&nbsp;&nbsp;";
	   if ($resptr->{"priority"} < $max && $resptr->{"priority"} > 0 && $period == $current_bgp)
	   {
	       print "<a href=\"$thispage?charid=$charid&action=down&$keyfield=$key\"><img src=\"down_arrow.gif\" alt=\"Move down\" border=0></a>";
	   }
	   else
	   {
	       print "<img src=\"empty.gif\">";
	   }	   
	   print "</td>\n";
	   print "<td>";
	   if ($resptr->{"handled"} + 0 == 0 && $period == $current_bgp)
	   {
		   print "<a href=\"$thispage?charid=$charid&action=edit&$keyfield=$key\">Edit</a>\n";
		   $name =~ s/'//g;
		   print " -- <a href=\"javascript:deleteConfirm('$name',$key);\">Delete</a>\n";
		   $isauto = dosql("select auto from bgatypes where btid=".$resptr->{"btid"}.";") + 0;
		   if ($isauto > 0 && $resptr->{"conspirators"} eq "")
		   {
		      print " -- <a href=\"$thispage?charid=$charid&action=process&$keyfield=$key\">Process</a><sup>*</sup>\n";
		   }
	   }
	   elsif ($resptr->{"handled"} + 0 == 0)
	   {
		print "<font color=#AA0000>This BGA will be processed soon.</font>";
	   }
	   else
	   {
		$results = $resptr->{"result"};
		$results =~ s/\n/<BR>\n/g;
		print "Processed: $results";
	   }
	   print "</td></tr>\n";
	   $num_bgas++;
	}
	print "</table><BR>\n";
	$query->finish;
	$db->disconnect;
}

sub handlebgastep2()
{
   fillvars();
   $btid = $CGI->param("btid") + 0;
   $priority = $CGI->param("priority") + 0;
   $tplfile = "bga2.tpl";
   if ($btid == 1) #research/investigate
   {
	$tatext= "Enter a description of what you are researching or the character you are investigating.  You do not need to mention your skills or what you have learned already.  We can get that information from the database and from your journal.  \n";
	$tatext .= "<i>Keep in mind that the GMs have to go through <i>hundreds</i> of BGAs.  Please be brief.  We may deduct from your roll if you are overly verbose.</i><BR><BR>\n";
	
	$moneytext = "You may spend money to assist in your research.  Spending money will add to your chance of success.  For every 15 you spend, we'll give you a +1 to your roll (up to a +6).<BR>";
	
	showbgaform2();
   }
   elsif ($btid == 3) #occupation
   {
  	$numoccs = dosql("select count(oid) from characteroccupations where charid=$charid;") + 0;
  	if ($numoccs > 1)
  	{
		$tplfile = "bgadrop.tpl";
		$tatext = "Choose your occupation.";
		$droptext = makeDropDown("occupations a, characteroccupations b", "a.oid", "a.oname", "a.oid = b.oid and b.charid=$charid order by a.oname");
		$droptext =~ s/name="occupations a, characteroccupations b"/name="data"/g;
		$droptext =~ s|a.oid|data|g;
		showbgaform2();
	}
	else
	{
	    $oid = dosql("select oid from characteroccupations where charid=$charid;");
	    print $CGI->redirect("$thispage?submit=Add&charid=$charid&priority=$priority&$keyfield=$keyvalue&btid=$btid&data=$oid&period=$current_bgp");
	}
   }
   elsif ($btid == 4) #gamble
   {
	$moneytext = "Enter the amount you wish to gamble.<BR>";
	$tplfile = "bga3.tpl";
	
	showbgaform2();
   }
   elsif ($btid == 5) #theft
   {
	$data = "From random NPC";
	
	#print $CGI->header;
	#print "$sql<BR>\n";
	#print "$data<BR>\n";

	print $CGI->redirect("$thispage?submit=Add&charid=$charid&data=$data&priority=$priority&$keyfield=$keyvalue&btid=$btid&period=$current_bgp");
   }
   elsif ($btid == 6) #explore
   {
	$tatext= "Enter a description or name of the location you wish to explore.  You do not need to mention your skills or what you have learned already.  We can get that information from the database and from your journal.  Do mention anyone you believe is accompanying you.  If you do not know where the location is, then your result may just give you clies\n";
	$tatext .= "<i>Keep in mind that the GMs have to go through <i>hundreds</i> of BGAs.  Please be brief.  We may deduct from your results if you are overly verbose.</i><BR><BR>\n";
	
	$moneytext = "Enter the maximum amount of money you're willing to spend to explore this area.  It may cost less.<BR>";
	
	showbgaform2();
   }
   elsif ($btid == 7) #weird science build
   {
	$tplfile = "bgahost.tpl";
	$tatext = "Select the device you want to build.  Note that very complex devices may require several BGAs to build.";
	$droptext = makeDropDown("WS_plans a, characterplans b", "a.planid", "a.name", "a.planid=b.planid and b.charid=$charid");
	$droptext =~ s/name="a.planid"/name="data"/g;
	$moneytext = "Building a Weird Science device requires parts and money.  Enter the maximum amount of money you are willing to spend.";
	showbgaform2();
   }
   elsif ($btid == 8) #weird science plan
   {
	$tatext= "Please enter the name of the new device you wish to build and a brief description of its function.<BR><BR>\n";
	
	$moneytext = "This may cost you some money to produce the plan.  Enter the maximum amount you'd be willing to spend.<BR>";
	showbgaform2();
   }
   elsif ($btid == 9) #magical research
   {
	$tplfile = "bgamagic.tpl";
	$tatext = makeDropDown("characterabilities a, abilities b", "b.name", "b.name", "a.abid=b.abid and a.charid=$charid and b.type='Spell'", " onchange=\"javascript:myform.data.value=value;\"");
	showbgaform2();
   }
   elsif ($btid == 10) #influence public opinion
   {
	$tplfile = "bgainfluence.tpl";
	$tatext = makeDropDown("global_variables", "name", "name", "speechable=1 order by name", "");
	$tatext =~ s/name="name"/name="data"/g;
	showbgaform2();
   }
   elsif ($btid == 11) #ward a VL
   {
	$tplfile = "bgaward.tpl";
	$tatext = "Select the virtual location you wish to ward from the list below.";
	$droptext = makeDropDown("virtuallocations", "vlname", "vlname", "vlowner=$charid");
	$droptext =~ s/name="vlname"/name="data"/g;
	$droptext =~ s|</select>||g;
	$str = makeDropDown("virtuallocations a, VLaccess b", "a.vlname", "a.vlname", "b.charid=$charid and a.vlid=b.vlid");
	if ($droptext eq "")
	{
	   $str =~ s/name="a.vlname"/name="data"/g;
	}
	else
	{
	   $str =~ s/<select name="a.vlname">//g;
	}
	if ($str eq "")
	{
	   $droptext .= "</select>";
	}
	$droptext .= $str;
	$comptext = makeDropDown("inventory_sc a, spellcomponents b", "b.scid", "b.scname", "a.charid=$charid and a.scid=b.scid order by b.scname");
	$comptext =~ s/name="b.scid"/name="scid"/;
	showbgaform2();
   }
   elsif ($btid == 12) #consecrate a VL
   {
	$tplfile = "bgadrop.tpl";
	$tatext = "Select the virtual location you wish to consecrate from the list below.";
	$droptext = makeDropDown("virtuallocations", "vlname", "vlname", "vlowner=$charid");
	$droptext =~ s/name="vlname"/name="data"/g;
	$droptext =~ s|</select>||g;
	$str = makeDropDown("virtuallocations a, VLaccess b", "a.vlname", "a.vlname", "b.charid=$charid and a.vlid=b.vlid");
	if ($droptext eq "")
	{
	   $str =~ s/name="a.vlname"/name="data"/g;
	}
	else
	{
	   $str =~ s/<select name="a.vlname">//g;
	}
	if ($str eq "")
	{
	   $droptext .= "</select>";
	}
	$droptext .= $str;
	showbgaform2();
   }
   elsif ($btid == 13) #empower a VL
   {
	$tplfile = "bgadrop.tpl";
	$tatext = "Select the virtual location you wish to empower from the list below.";
	$droptext = makeDropDown("virtuallocations", "vlname", "vlname", "vlowner=$charid");
	$droptext =~ s/name="vlname"/name="data"/g;
	$droptext =~ s|</select>||g;
	$str = makeDropDown("virtuallocations a, VLaccess b", "a.vlname", "a.vlname", "b.charid=$charid and a.vlid=b.vlid");
	if ($droptext eq "")
	{
	   $str =~ s/name="a.vlname"/name="data"/g;
	}
	else
	{
	   $str =~ s/<select name="a.vlname">//g;
	}
	if ($str eq "")
	{
	   $droptext .= "</select>";
	}
	if ($str eq "")
	{
	   $droptext .= "</select>";
	}
	$droptext .= $str;
	showbgaform2();
   }
   elsif ($btid == 15) #host a party
   {
	$tplfile = "bgahost.tpl";
	$tatext = "Select the virtual location where you wish to host the party from the list below.";
	$droptext = makeDropDown("virtuallocations", "vlid", "vlname", "vlowner=$charid");
	$droptext =~ s/name="vlid"/name="data"/g;
	$droptext =~ s|</select>||g;
	$str = makeDropDown("virtuallocations a, VLaccess b", "a.vlid", "a.vlname", "b.charid=$charid and a.vlid=b.vlid");
	if ($droptext eq "")
	{
	   $str =~ s/name="a.vlid"/name="data"/g;
	}
	else
	{
	   $str =~ s/<select name="a.vlid">//g;
	}
	$droptext .= $str;
	if ($str eq "")
	{
	   $droptext .= "</select>";
	}
        $status = dosql("select status from characterSTATs where charid=$charid") * 10;
	$moneytext = "You may spend money to assist in hosting the party.  Spending money will add to your chance of throwing a good party.  For every $status you spend, we'll give you a +1 to your roll (up to a +6).";
	showbgaform2();
   }
   elsif ($btid == 16) #perform a craft
   {
	$tplfile = "bgahost.tpl";
	$tatext = "Select the craft skill you wish to use to make money.";
	$droptext = makeDropDown("characterabilities", "text", "text", "charid=$charid and abid=82");
	$droptext =~ s/name="text"/name="data"/g;
	$moneytext = "Producing something with your craft costs money for materials.  Enter the maximum amount you'd be willing to spend.  Higher materials means a higher price for the finished object.";
	showbgaform2();
   }
   elsif ($btid == 17) #perform
   {
	$tplfile = "bgahost.tpl";
	$tatext = "Select the performance skill you wish to use to make money. <i>Note that using this skill also counts as Staying in the Public Eye for purposes of Fame</i>";
	$droptext = makeDropDown("characterabilities", "text", "text", "charid=$charid and abid=84");
	$droptext =~ s/name="text"/name="data"/g;
	$moneytext = "Performing costs money for advertising, costumes, and the like.  Enter the maximum amount you'd be willing to spend.  The more you spend, the more you are likely to get in return.";
	showbgaform2();
   }
   elsif ($btid == 18) #stay in public eye
   {
	$data = "Stay in the Public Eye";
	
	#print $CGI->header;
	#print "$sql<BR>\n";
	#print "$data<BR>\n";

	print $CGI->redirect("$thispage?submit=Add&charid=$charid&data=$data&priority=$priority&$keyfield=$keyvalue&btid=$btid&period=$current_bgp");
   }
   elsif ($btid == 20) #Thwart
   {
	$tatext= "Enter the name of the character(s) and the BGA you believe said character(s) are doing.   You do not need to mention your skills or what you have learned already.  We can get that information from the database and from your journal.  \n";
	$tatext .= "<i>Keep in mind that the GMs have to go through <i>hundreds</i> of BGAs.  Please be brief.  We may deduct from your roll if you are overly verbose.</i><BR><BR>\n";
	
	$moneytext = "You may spend money to assist in your thwarting.  Spending money will add to your chance of success.<BR>";
	
	showbgaform2();
   }
   elsif ($btid == 23) #donate to the fund
   {
	$moneytext = "Enter the amount you wish to donate to the fund created by the Antiquities Protection & Restoration Act.<BR>";
	$tplfile = "bga3.tpl";
	
	showbgaform2();
   }
   elsif ($btid == 25) #gather dirt
   {
	$tplfile = "bgahost.tpl";
	$tatext = "<H3>Dig Up Dirt</H3>\n";
	$tatext .= "Choose the PC or NPC that you wish to find blackmail infomation on.  \n";
	$tatext .= "<i>You can choose NO CHARACTER to get a random blackmail tidbit.</i>\n";

	$moneytext = "You may spend money to assist in your dirt gathering.  Spending money will add to your chance of success.<BR>";
	$droptext = makebizarrecharacterblackamildropdown();
		
	showbgaform2();
   }
   elsif ($btid == 26) #group BGA
   {
	$tplfile = "bgahost.tpl";
	$tatext = "<H3>Group BGA</H3>\n";
	$tatext .= "Choose the group whose BGA you wish to contribute to.</i>\n";
	
	$datastr = "concat('<!--',a.groupid,'-->',a.groupname)";
	
	$droptext = makeDropDown("charactergroups a, charactergroupmembers b", $datastr, "a.groupname", "a.candobga > 0 and a.groupid=b.groupid and b.charid=$charid order by a.groupname");
	$droptext =~ s/name=\"(.*)\"/name=\"data\"/;
		
	$moneytext = "You may spend money to assist in the group BGA.  Spending money will add to the group's results.<BR>";
	
	showbgaform2();
   }
   elsif ($btid == 27) #african BGA
   {
	$data = "Explore Africa";
	
	#print $CGI->header;
	#print "$sql<BR>\n";
	#print "$data<BR>\n";

	print $CGI->redirect("$thispage?submit=Add&charid=$charid&data=$data&priority=$priority&$keyfield=$keyvalue&btid=$btid&period=$current_bgp");
   }
   else #other
   {
	$tatext= "Do something that is not handled by the main list.  The GMs must manually handle this, so it may take longer to get your results.  Enter your Between Games Action below.  Note that \"informational\" BGAs such as, \"I set up a bird feeder in my back yard,\" or \"I go to Paris,\" will not garner a response from the GMs.<BR><BR>\n";
	$tatext .= "<i>Keep in mind that the GMs have to go through <i>hundreds</i> of BGAs.  Please be brief.  We may deduct from your results if you are overly verbose.</i><BR><BR>\n";
	
	$moneytext = "Most BGAs cost money to perform.  Enter the money you are willing to spend on this BGA.<BR>";
	showbgaform2();
   }
}

sub showbgaform2
{
	print $CGI->header;
	$doctitle = "Manage ".$heading."s for $charname";
	ParseForm($header);
	print "<h1>$doctitle</h1>\n";
	print "<h2>Step Two</h2>\n";
	
	$yourmoney = getMoney($charid);
	
	print "<form action=\"$thispage\" name=\"myform\" method=\"post\">";
	ParseForm($tplfile);
	
	if ($keyvalue eq "")
	{
		print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>"; 	
	}
	else
	{
		print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>"; 	
	}
 	print "</form>";
 	
	print "<br><hr><a href=\"$thispage?charid=$charid\">Return to BGAs</a>."; 
	print "<br><a href=\"login.pl\">Main menu</a>."; 
	ParseForm($footer);
}

sub fillvars()
{
	$tc = $charid;
	filltable();
	$charid=$tc;
	$bga_types = createBGAdropdown();
	$bga_list = createBGAlist();
	
	if ($period < $current_bgp)
	{
	  $period = $current_bgp;
	}
	
	if ($priority == 0)
	{
	  $priority = dosql("select max(priority) from bgas where charid=$charid and period=$period;") + 1;
	}
}

sub createBGAdropdown
{
    local ($db) = dbconnect();
    $SQL = "select * from bgatypes order by text";
    
    local($query) = $db->prepare($SQL);
    $query->execute;

    local ($num) = 0;
    local($retVal) = "<select name=\"btid\">\n";
    while ($resptr = $query->fetchrow_hashref())
    {
        if ($resptr->{"text"} eq "Other")
        {
           $num = $resptr->{"btid"};
        }
        elsif (bgaok($resptr->{"stat_req"},$charid) > 0)
        {
           $selected = "";
           if ($resptr->{"btid"} == $btid)
           {
             $selected = "SELECTED";
           }
    	   $retVal .= "<option value=\"".$resptr->{"btid"}."\" $selected>".$resptr->{"text"}."</option>\n";
    	}
    }
    if ($num > 0)
    {
    	$retVal .= "<option value=\"$num\">Other</option>\n";
    }
    $retVal .= "</select>\n";
    $query->finish;
    $db->disconnect;
    return $retVal;
}

sub createBGAlist
{
    local ($db) = dbconnect();
    $SQL = "select * from bgatypes order by text";
    
    local($query) = $db->prepare($SQL);
    $query->execute;

    local ($num) = 0;
    local($retVal) = "<table border=1 width=100%>\n";
    $retVal .= "<tr>\n";
    $retVal .= "<td width=20%><b>Action</b></td>\n";
    $retVal .= "<td><b>Explanation</b></td>\n";
    $retVal .= "</tr>\n";
    while ($resptr = $query->fetchrow_hashref())
    {
        if (bgaok($resptr->{"stat_req"},$charid) > 0)
        {
    		$retVal .= "<tr>\n";
    		$retVal .= "<td bgcolor=\"$bgcolor\">".$resptr->{"text"}."</td>\n";
    		$retVal .= "<td bgcolor=\"$bgcolor\">".$resptr->{"explanation"}."</td>\n";
    		$retVal .= "</tr>\n";
    	}
    }
    $retVal .= "</table>\n";
    $query->finish;
    $db->disconnect;
    return $retVal;
}

sub bgaok()
{
   local ($compval) = $_[0];
   local ($charid) = $_[1];
  
   $bgcolor = "FFFFFF";
   if ($compval eq "")
   {
     return 1;
   }
   
   if ($compval eq "occupation")
   {
      $sql = "select count(charid) from characteroccupations where charid=$charid;";
      #print "$sql<BR>";
      return dosql($sql);
   }
   
   if ($compval eq "group membership")
   {
      $sql = "select count(a.groupid) from charactergroupmembers a join charactergroups b on a.groupid=b.groupid where a.charid=$charid and b.candobga > 0;";
      #print "$sql<BR>";
      $bgcolor = "EEEEEE";
      return dosql($sql);
   }
   
   $bgcolor = "EEEEEE";
   $sql = "select $compval from characterSTATs where charid=$charid;";
   #print "$sql<BR>";
   local($val) = dosql($sql) + 0;
   
   $val += getlevel($compval);
   
   return $val;
}

sub showFreeBGAMenu()
{
	print "<A NAME=\"freeact\"><H2>Free Action Menu</H2></A>\n";
	print "<p><i>The following actions are free Between Game Actions.  You may perform as many of them between games as you wish.  They are automatically handled by the database.</i></p>\n";
	print "<ul>\n";
	print "<li><a href=\"docketforplayers.pl?charid=$charid\">Manage your docket items.</a></li>\n";
	print "<li><a href=\"journal.pl?charid=$charid\">Manage your journal</a></li>\n";
	print "<li><a href=\"bgafree.pl?charid=$charid&action=money\">Transfer money to another character</a></li>\n";
	if (dosql("select count(a.groupid) from charactergroupmembers a join charactergroups b on a.groupid=b.groupid where a.charid=$charid and b.allowedbudget > 0;") + 0 > 0)
	{
		print "<li><a href=\"bgafree.pl?charid=$charid&action=groupmoney\">Transfer money to a character group</a></li>\n";
	}
	print "<li><a href=\"bgafree.pl?charid=$charid&action=tithe\">Tithe</a></li>\n";
	print "<li><a href=\"bgafree.pl?charid=$charid&action=vl\">Manage access to your Virtual Locations</a></li>\n";
	print "<li><a href=\"bgafree.pl?charid=$charid&action=buyinvest\">Buy Investments</a></li>\n";
	print "<li><a href=\"bgafree.pl?charid=$charid&action=sellinvest\">Sell Investments</a></li>\n";
	print "<li><a href=\"xp.pl?charid=$charid\">Spend XP</a></li>\n";
	print "<li><a href=\"freespend.pl?charid=$charid\">Manage your SubStatus Freebies</a></li>\n";
	if (dosql("select inspiration from characterSTATs where charid=$charid;") + 0 > 0)
	{
		print "<li><a href=\"bgafree.pl?charid=$charid&action=wspart\">Purchase Weird Science Part</a></li>\n";
		print "<li><a href=\"bgafree.pl?charid=$charid&action=wsaccess\">Set Access to Your Weird Science Plans</a></li>\n";
		print "<li>Sell a Weird Science Device</li>\n";
	}
	if (dosql("select mana from characterSTATs where charid=$charid;") + 0 > 0)
	{
		print "<li><a href=\"bgafree.pl?charid=$charid&action=spcomp\">Purchase Spell Component</a></li>\n";
	}
	print "<br>\n";
	print "</ul>\n";
}

sub createAddBGAsql()
{
	$btid = $CGI->param("btid") + 0;
	$conspirators = $CGI->param("conspirators");
	$conspirators =~ s/'/''/g;
	local ($retStr) = "";
	$money = $CGI->param("money") + 0;
	if ($btid == 10) #influence public opinion
	{
	   $data = "<!--" . $CGI->param("favors") . "-->" . $CGI->param("data");
	   $data =~ s/'/''/g;
	   $retStr="insert into $table (charid,btid,data,money,priority,conspirators,period) values ($charid,$btid,'$data',$money,".$CGI->param("priority").",'$conspirators',".$CGI->param("period").");";
	}
	elsif ($btid == 3) #Occupation
	{
	   $money = $CGI->param("data");
	   $data = dosql("select oname from occupations where oid=$money;");
	   $retStr="insert into $table (charid,btid,data,money,priority,conspirators,period) values ($charid,$btid,'$data',$money,".$CGI->param("priority").",'$conspirators',".$CGI->param("period").");";
	}
	elsif ($btid == 4 || $btid == 23) #Gamble or donate to fund
	{
	   $data = "".$CGI->param("money");
	   $retStr="insert into $table (charid,btid,data,money,priority,conspirators,period) values ($charid,$btid,'$data',$money,".$CGI->param("priority").",'$conspirators',".$CGI->param("period").");";
	}
	elsif ($btid == 7) #WS Build
	{
	   $data = $CGI->param("data");
	   $data = "<!--$data-->" . dosql("select name from WS_plans where planid=$data;");
	   $data =~ s/'/''/g;
	   $retStr="insert into $table (charid,btid,data,money,priority,conspirators,period) values ($charid,$btid,'$data',$money,".$CGI->param("priority").",'$conspirators',".$CGI->param("period").");";
	}
	elsif ($btid == 11) #Ward
	{
	   $data = "<!--" . $CGI->param("scid") . "-->" . $CGI->param("data");
	   $data =~ s/'/''/g;
	   $retStr="insert into $table (charid,btid,data,money,priority,conspirators,period) values ($charid,$btid,'$data',0,".$CGI->param("priority").",'$conspirators',".$CGI->param("period").");";
	}
	elsif ($btid == 15) #Host
	{
	   $data = $CGI->param("data");
	   $name = dosql("select vlname from virtuallocations where vlid='$data';"); 
	   $data = "<!--" . $CGI->param("data") . "-->" . $name;
	   $data =~ s/'/''/g;
	   $retStr="insert into $table (charid,btid,data,money,priority,conspirators,period) values ($charid,$btid,'$data',$money,".$CGI->param("priority").",'$conspirators',".$CGI->param("period").");";
	}
	else
	{
	   $retStr = filltablefromCGI($table, 1);
	}
	
	return $retStr;
}

sub createChangeBGAsql()
{
	$btid = $CGI->param("btid") + 0;
	$conspirators = $CGI->param("conspirators");
	$conspirators =~ s/'/''/g;
	local ($retStr) = "";
	if ($btid == 10) #influence public opinion
	{
	   $data = "<!--" . $CGI->param("favors") . "-->" . $CGI->param("data");
	   $data =~ s/'/''/g;
	   $retStr="update $table  set data='$data', money=".$CGI->param("money").",priority=".$CGI->param("priority").", conspirators='$conspirators' where $keyfield=$keyvalue;";
	}
	elsif ($btid == 3) #Occupation
	{
	   $money = $CGI->param("data");
	   $data = dosql("select oname from occupations where oid=$money;");
	   $retStr="update $table  set data='$data', money=$money,priority=".$CGI->param("priority").", conspirators='$conspirators' where $keyfield=$keyvalue;";
	}
	elsif ($btid == 4 || $btid == 23) #Gamble or donate to fund
	{
	   $data = "".$CGI->param("money");
	   $retStr="update $table  set data='$data', money=".$CGI->param("money").",priority=".$CGI->param("priority").", conspirators='$conspirators' where $keyfield=$keyvalue;";
	}
	elsif ($btid == 7) #WS Build
	{
	   $data = $CGI->param("data");
	   $data = "<!--$data-->" . dosql("select name from WS_plans where planid=$data;");
	   $data =~ s/'/''/g;
	   $retStr="update $table  set data='$data', money=".$CGI->param("money").",priority=".$CGI->param("priority").", conspirators='$conspirators' where $keyfield=$keyvalue;";
	}
	elsif ($btid == 11) #Ward
	{
	   $data = "<!--" . $CGI->param("scid") . "-->" . $CGI->param("data");
	   $data =~ s/'/''/g;
	   $retStr="update $table  set data='$data',priority=".$CGI->param("priority").", conspirators='$conspirators' where $keyfield=$keyvalue;";
	}
	elsif ($btid == 15) #Host
	{
	   $data = $CGI->param("data");
	   $name = dosql("select vlname from virtuallocations where vlid='$data';"); 
	   $data = "<!--" . $CGI->param("data") . "-->" . $name;
	   $data =~ s/'/''/g;
	   $retStr="update $table  set data='$data', money=".$CGI->param("money").",priority=".$CGI->param("priority").", conspirators='$conspirators' where $keyfield=$keyvalue;";
	}
	else
	{
	   $retStr = filltablefromCGI($table, 0);
	}
	
	return $retStr;
}

sub makebizarrecharacterblackamildropdown()
{
    local ($db) = dbconnect();
    $sql = "select charid, concat(cfirst, ' ', clast), ctitle from characters where (chartype = $player_character or  chartype = $cast_character or chartype = $alias_character) and charid > 0 order by clast";
    
    local($query) = $db->prepare($sql);
    $query->execute;

    local ($num) = 0;
    local($retVal) = "<select name=\"data\">\n";
    $retVal .= "<option value=\"<!--0-->NO CHARACTER\">NO CHARACTER</option>\n";
    local(@array);
    while (@array = $query->fetchrow_array())
    {
       local ($name) = $array[1];
       if ("$array[2]" ne "")
       {
       	  $name .= ", $array[2]";
       }
       $retVal .= "<option value=\"<!--$array[0]-->$name\">$name</option>\n";
    }
    $query->finish;
    $sql = "select npcsid, charname from npcsecrets order by charname";
    
    $query = $db->prepare($sql);
    $query->execute;
    while (@array = $query->fetchrow_array())
    {
       $retVal .= "<option value=\"<!--NPC-$array[0]-->$array[1]\">$array[1] \[NPC\]</option>\n";
    }
    $query->finish;
    $db->disconnect;
    $retVal .= "</select>\n";
    return $retVal;
}

