#!perl
require 'g_ws.pl';
require 'g_invest.pl';

$base_num_allowed = 6;

$bgpstring[1] = "June - September 2004";
$bgpstring[2] = "October - November 2004";
$bgpstring[3] = "February - April 2005";
$bgpstring[4] = "July - October 2005";
$bgpstring[5] = "February - June 2006";
$bgpstring[6] = "June 2006 - August 2006";

sub processBGA()
{
   filltable();
   local($retVal);
   
   if ("$handled" ne "")
   {
      $retVal = "This BGA has been processed already.";   
   }
   elsif ($btid == 3) #occupation
   {
      $retVal = "<h2>Process Occupation: $data</H2>\n";
      $oid = $money;
      
      if (validateoccupation($charid,$oid) < 0)
      {
        $retVal .= $occstr;
        $retVal .= "<BR>This BGA has not been processed.<BR>";
        return $retVal;
      }
      
      $base_bga_income = dosql("select base_bga_income from occupations where oid=$oid;");
      $d10_bga_income = dosql("select d10_bga_income from occupations where oid=$oid;");
      $sql = "select stipend from occupations where oid=$oid;";
      $stipend = dosql($sql) + 0;
      $num = ($base_bga_income) + d11($d10_bga_income);
            
      if ($num > 0)
      {
          if ($stipend > 0)
          {
            $sql = "update global_variables set level=level-$num where name='The Treasury';";
   	    dosql($sql);
          }
          $result = "You earn $num performing your occupation.";
          $taxes = handletaxes($num);
          $num -= $taxes;
          $result .= "<BR>After $taxes in taxes, that's $num.";
          
      }
      elsif ($num < 0)
      {
          $result = "<font color=red>You lost ".($num*-1)." performing your occupation.</font>";
      }
      else
      {
          $result = "You made no money performing your occupation.";
      }
      
      $retVal .= "<p>$result</p>";
      
      $money = $num;
      $num += getMoney($charid);
      $retVal .= "<p>You now have $num in your ledger.</p>";
   }
   elsif ($btid == 4) #gamble
   {
      $retVal = "<h2>Process Gambling</H2>\n";
      
      $money = min($money,getMoney($charid));
      $money = max(0,$money);
      $retVal .= "You are gambling $money<BR>";
      $num = getlevel("GAMBLE/GAMING: ___________") + getlevel("LUCK") - getlevel("UNLUCKY");

      $num += int(rand(18) - 10);

      $num = int($money * ($num/10));             
      if ($num > 0)
      {
          $result = "You earn $num gambling.";
          $taxes = handletaxes($num);
          $num -= $taxes;
          $result .= "<BR>After $taxes in taxes, that's $num.";
          
      }
      elsif ($num < 0)
      {
          $result = "<font color=red>You lost ".($num*-1)." gambling.</font>";
      }
      else
      {
          $result = "You made no money gambling.";
      }
      
      $retVal .= "<p>$result</p>";
      
      $money = $num;
      $num += getMoney($charid);
      $retVal .= "<p>You now have $num in your ledger.</p>";
   }
   elsif ($btid == 5) #theft
   {
      $retVal = "<h2>Process Theft</H2>\n";
      
      $money = min($money,getMoney($charid));
      $money = max(0,$money);
      $retVal .= "You are attempting to steal from a random NPC.<BR>";
      $roll1 = dosql("select dex from characterSTATs where charid=$charid;");
      $roll1 += getlevel("PICK POCKET") + getlevel("LUCK") - getlevel("UNLUCKY");

      $roll2 = 3;
      
      $roll1 += d11(1);
      $roll2 += d11(1);
      
      if ($roll1 > $roll2)
      {
          $money = d11($roll1 - $roll2);
          $result = "You stole $money.";        
      }
      elsif ($roll1 < $roll2 - 5)
      {
          $money = d11($roll2 - $roll1);
          $result = "You were caught stealing and were fined $money.  This may have other in-game ramifications.";   
          $money *= -1;
      }
      else
      {
          $money = 0;
          $result = "You failed to steal, but at least you didn't get caught!";        
      }
     
      $retVal .= "<p>$result</p>";
      
      $num = $money + getMoney($charid);
      $retVal .= "<p>You now have $num in your ledger.</p>";
   }
   elsif ($btid == 7) #WS Build
   {
      $retVal = "<h2>Process Weird Science Build</H2>\n";
      
      $money = min($money,getMoney($charid));
      $money = max(0,$money);
      $name = $data;
      $name =~ s/<!--(.*)->//g;
      $planid = $data;
      $planid =~ s/-->(.*)$//g;
      $planid =~ s/<!--//g;
      $retVal .= "Attempting to build: $name<BR>";
      
      $complexity = dosql ("select complexity from WS_plans where planid=$planid;") + 0;
      $level = dosql ("select level from WS_plans where planid=$planid;") + 0;
      $cost = $build_cost[$complexity] * $build_mult[$level];
      $state = dosql ("select stateid from WS_plans where planid=$planid;") + 0;
      $planstate = dosql("select statetext from planstates where stateid=$state;");
      
      local ($db) = dbconnect();
      local(@array);
      
      local($sql) = "select a.wpid, b.wpname from planparts a, WS_parts b where a.planid=$planid and a.wpid=b.wpid;";
      local($query) = $db->prepare($sql);
      $query->execute;
      local ($canbuild) = 1;
      while(@array = $query->fetchrow_array())
      {
        $wpid = $array[0] +0;
	$haspart = dosql("select wpid from inventory_ws where charid=$charid and wpid=$wpid and amount > 0;") + 0;
	if ($wpid == $haspart)
	{
	  $retVal .= "Plan requires $array[1], check!<BR>\n";
	}
	else
	{
	  $retVal .= "Plan requires $array[1], which you do not have.<BR>\n";
	  $canbuild = 0;
	}
      }
      $query->finish;
      
      if ($canbuild == 0)
      {
	  $retVal .= "<BR>You cannot build this device; you do not have all the necessary parts.<BR>\n";
	  return $retVal;
      }

      local($sql) = "select mfid from planmfs where planid=$planid;";
      local($query) = $db->prepare($sql);
      $query->execute;
      $roll1 = 100;
      
      while(@array = $query->fetchrow_array())
      {
	    $cost *= $build_mf_mult[$array[0]];
	    $roll1 = min($roll1, dosql("select level from charactermotiveforces where mfid=$array[0] and charid=$charid;"));
      }
      $query->finish;
      
      local($sql) = "select aid from planapplications where planid=$planid;";
      local ($db) = dbconnect();
      local($query) = $db->prepare($sql);
      $query->execute;
      
      while(@array = $query->fetchrow_array())
      {
	    $roll1 = min($roll1, dosql("select level from characterapplications where aid=$array[0] and charid=$charid;"));
      }
      $query->finish;
      
      if ($roll1 == 0)
      {
	 $retVal .= "<BR>You do not have the right combination of Motive Forces and Applications in your Weird Science grid to build this device.\n";
         return $retVal;
      }
      if ($money < $cost)
      {
	 $retVal .= "<BR>This costs $cost to build.  You only spent $money.  You need to spend more to build this device.\n";
         return $retVal;
      }
      
      $slots = int($complexity / 3);
      if (countfreeslots() <= $slots - 1)
      {
	 $retVal .= "<BR>This device requires $slots BGA slots to build, including this one.  You have ".countfreeslots()." free BGA slots.  You must free up more slots before you can build the device this BGP.\n";
         return $retVal;      
      }

      #finally, time to roll
      $cost = int(($money - $cost) / ($complexity * 4));
      $cost = min($cost,6);
      $roll1 += dosql("select iq from characterSTATs where charid=$charid;") + $cost + d11(1);     
      $roll2 = 2 + $complexity + d11(1);
      
      $result = "You have built a $name.";

      if ($roll1 - $roll2 <= -5)
      {
        $res = 1;
      }
      elsif ($roll1 - $roll2 < -1)
      {
        $res = 2;
      }
      elsif ($roll1 - $roll2 == -1)
      {
        $res = 3;
      }
      elsif ($roll1 - $roll2 == 0)
      {
        $res = 4;
      }
      elsif ($roll1 - $roll2 < 5)
      {
        $res = 5;
      }
      else
      {
        $res = 6;
      }
      
      updateDEVinventory($planid, $build_results[$state][$res], 1);
      
      if ($build_known[$state][$res] > 0)
      {
        $sql = "update WS_plans set stateknown = 1 where planid=$planid;";
        $db->do($sql);
        
        $retVal .= "<BR>You now know that the plans are $planstate.";
      }
      
      local($sql) = "select wpid from planparts where planid=$planid;";
      local($query) = $db->prepare($sql);
      $query->execute;
      local ($canbuild) = 1;
      while(@array = $query->fetchrow_array())
      {
	removeWSinventory($array[0],1);
      }
      $query->finish;
      
      for ($i = 0; $i < $slots - 1; $i++)
      {
        $data2 = "<font color=\"0x999999\">Additional BGA Slot for building a $name</font>";
        $sql = "insert into bgas (charid, btid, data, handled, result) values ($charid, 7, '$data2',1,'$result');";
        $db->do($sql);
      }

      $db->disconnect;
    
      $money *= -1;
      $retVal .= "<BR>$result\n";
      
   }
   elsif ($btid == 9) #magical research
   {
      $retVal = "<h2>Process Magical Research</H2>\n";
      
      if (hasability($data))
      {
      	$retVal .= "<p>Researching a new component for $data.</p>";
        $num = getlevel($data) + getlevel("LUCK") - getlevel("UNLUCKY");
        $num += rand(20);
        if ($num > 10)
        {
           $data =~ s/'/''/g;
           $sql = "select count(b.sclid) from spellcomponentslink b, abilities a where a.abid=b.abid and a.name='$data';";
	   #print "$sql<BR>";
      	   $num = dosql($sql) + 0;
      	   $num = int(rand($num)) + 1;
      	   $sql = "select * from spellcomponentslink b, abilities a, spellcomponents c where a.abid=b.abid and a.name='$data' and b.scid=c.scid;";
	   #print "$sql<BR>";
      	   local ($db) = dbconnect();
           local($query) = $db->prepare($sql);
	   $query->execute;
	   local($resptr);
	   for ($i = 0; $i < $num; $i++)
	   {
	       $resptr = $query->fetchrow_hashref();
	   }
	   $sclid .= $resptr->{"sclid"};
	   $scname .= $resptr->{"scname"};
	   $sceff .= $resptr->{"sideeffect"};
	   $query->finish; 
	   if (dosql("select sclid from spellcomponentscharacterlink where sclid=$sclid and charid=$charid") + 0 > 0)
	   {
           	$result = "Unable to learn a new component for the spell.";
	   }
	   else
	   {
	        $result = "You have learned the new component $scname: $sceff.";
	        $sql = "insert into spellcomponentscharacterlink (sclid,charid) values ($sclid, $charid);";
	        $db->do($sql);
	   }
	   $db->disconnect;

      	}
      	else
      	{
           $result = "Unable to learn a new component for the spell.";
      	}

      }
      else
      {
      	$retVal .= "<p>Researching access to the spell $data.</p>";
      	$name = $data;
      	$name =~ s/'/''/g;
        $abid = dosql("select abid from abilities where name='$name';") + 0;
        if ($abid == 0)
        {
      	   $retVal .= "<p>That spell does not exist.  This BGA does not count.  You may reenter it.</p>";
   	   return $retVal;
        }
        else
        {
           $num = getlevel("RITUAL KNOWLEDGE") + getlevel("LUCK") - getlevel("UNLUCKY");
           $num += rand(100);
           if ($num < 80)
           {
           	$result = "Unable to learn this spell.";
           }
           else
           {
           	$result = "You have gained a basic understanding of this spell.  You may now spend XP to buy this spell to cast it fairly reliably.";
           	$sql = "insert into charabilityallowed (abid, charid) values ($abid, $charid);";
           	dosql($sql);
           }
        }
      }
      $retVal .= "<p>$result</p>";
   }
   elsif ($btid == 10) #influence public opinion
   {
      $retVal = "<h2>Influence Public Opinion</H2>\n";
      $name = $data;
      $favors = 0;
      if ($name =~ m/<!--for-->/)
      {
          $favors = 1;
          $retVal .= "Arguing for ";
      }
      if ($name =~ m/<!--against-->/)
      {
          $favors = -1;
          $retVal .= "Arguing against ";
      }
      if ($favors == 0)
      {
      	   $retVal .= "<p>Poorly formed data string.  BGA Processing Cancelled.</p>";
   	   return $retVal;
      }
      $name =~ s/<!--for-->//;
      $name =~ s/<!--against-->//;
      $retVal .= "$name</p>";
      
      $name =~ s/'/''/g;
      $gvid = dosql("select gvid from global_variables where name='$name';") + 0;
      
      if ($gvid == 0)
      {
      	   $retVal .= "<p>Database unable to process this issue automatically.</p>";
   	   return $retVal;
      }
      
      $iq = dosql("select iq from characterSTATs where charid=$charid;");
      $iq += getlevel("GENUINE CURIOUSITY/FAMOUS") - getlevel("SOCIAL STIGMA ______________");
      
      $iq += getlevel("ORATE");
      	
      $money = min($money,getMoney($charid));
      $money = max($money,0);

      $roll1 = $iq + int(rand(10)) + int($money/15) + 1;
      $roll2 = 9 + int(rand(10));

	$changed = 0;
		
	if ($roll1 >= $roll2)
	{
	    $changed = $roll1 - $roll2;
	    
	    if ($did > 0)
	    {
	      $sql = "select weight, weight_min, weight_max from docket where did=$did;";
	    }
	    else
	    {
	      $sql = "select level, min_range, max_range from global_variables where gvid=$gvid;";
	    }  
	    
   	    local($db) = dbconnect();
	    local ($query) = $db->prepare($sql);
	    $query->execute;

	    @array = $query->fetchrow_array();
	    $level = $array[0];
	    $min_range = $array[1];
	    $max_range = $array[2];
	    $query->finish;
	    
	    $changed = min($changed, int(($max_range - $min_range) * 0.05));
	    $changed = min($changed, 9);
	    $result = $changed * $favors;
	    
	    #print "level - $level result - $result<BR>";
	    $level += $result;
	    $level = max($level, $min_range);
	    $level = min($level, $max_range);
	      
	    $sql = "update global_variables set level=$level where gvid=$gvid;";

	    #print "$sql<BR>";
	    $db->do($sql);
   	    $db->disconnect;
	    $res[0] = "You were unable to affect $name.";
	    $res[1] = "You have a slight effect.";
	    $res[2] = "You have a slight effect.";
	    $res[3] = "You have some small effect.";
	    $res[4] = "You have some small effect.";
	    $res[5] = "You have about the average effect.";
	    $res[6] = "You have an above average influence.";
	    $res[7] = "Your influence is known far and wide.";
	    $res[8] = "You have a strong effect.";
	    $res[9] = "Best possible result -- You have had a great impact on this issue.";
	    $result = "$res[$changed]";
	}
	else
	{
	    $result = "You were unable to affect $name";
	}     
      $retVal .= "<p>$result</p>";
      $money *= -1;
   }
   elsif ($btid == 11) #ward
   {
      $retVal = "<h2>Ward a Virtual Location</H2>\n";
      
      $name = $data;
      $name =~ s/<!--(.*)->//g;
      $name =~ s/'/''/g;
      
      $vlid = dosql("select vlid from virtuallocations where vlname='$name';") + 0;
      
      $retVal .= "Attempting to ward: $data<BR>\n";
      
      $scid = $data;
      $scid =~ s/-->(.*)$//g;
      $scid =~ s/<!--//g;
      $scname = dosql("select scname from spellcomponents where scid=$scid;");
      $retVal .= "Spell component: $scname<BR>\n";
      
      $roll1 = dosql("select will from characterSTATs where charid=$charid");
      $roll1 += getlevel("WARD");
      
      $sql = "select sum(vlslevel) from VLstatlink where vlid=$vlid and vlsid=2;";
      #print "$sql<BR>";
      $roll2 = dosql($sql) + 0;
      
      $retVal .= "rolling $roll1 vs $roll2<BR>";
      $fails = 0;
      $result = "";
      
      if ($scid == 40) #bamboo
      {
         $roll1 -= 2;
      }
      elsif ($scid == 58) #chameleon
      {
      }
      elsif ($scid == 28) #redrose
      {
         if ($roll2 > 1)
         {
           $fails = 1;
         }
      }
      elsif ($scid == 57) #rhino hide
      {
         $result = "<font color=blue>Regardless of success, you will suffer an unfortunate incident this BGP.<BR></font>";
      }
      elsif ($scid == 56) #thistle
      {
         if ($roll2 > 1)
         {
           $fails = 1;
         }
      }
      elsif ($scid == 55) #turtle shell
      {
         if ($roll2 > 2)
         {
           $fails = 1;
         }
      }
      else
      {
         $retVal .= "<font color=red>Cannot automatically process $scname.  This must be manually processed by the GMs</font><BR>";
         return $retVal;
      }
      
      if (($roll1 + d11(1) > $roll2 + d11(1)) && $fails == 0)
      {
      	 $roll2++;
      	 
      	 $sql = "select count(vlslevel) from VLstatlink where vlid=$vlid and charid=$charid and vlsid=2;";
      	 #print "$sql<BR>";
      	 if (dosql($sql) + 0 > 0)
      	 {
      	    $sql = "update VLstatlink set vlslevel=vlslevel+1 where vlid=$vlid and charid=$charid and vlsid=2;";
      	 }
      	 else
      	 {
      	    $sql = "insert into VLstatlink (vlid, vlsid, charid, vlslevel) values ($vlid, 2, $charid, 1);";
      	 }
      	 
      	 #print "$sql<BR>";
      	 dosql($sql);
	 
         $result .= "Your attempt to ward is successful.  Ward is now level $roll2.";
      }
      else
      {
         $result .= "Your attempt to ward has failed.";
      }
      removeSCinventory($scid,1);
      $retVal .= "<p>$result</p>";
   }
   elsif ($btid == 12) #conscrate
   {
      $retVal = "<h2>Consecrate a Virtual Location</H2>\n";
      $name = $data;
      $name =~ s/'/''/g;
      
      $vlid = dosql("select vlid from virtuallocations where vlname='$name';") + 0;
      
      $retVal .= "Attempting to consecrate: $data<BR>\n";
      
      $roll1 = dosql("select will from characterSTATs where charid=$charid");
      $roll1 += getlevel("CONSECRATE");
      
      $sql = "select sum(vlslevel) from VLstatlink where vlid=$vlid and (vlsid=3 or vlsid=7);";
      #print "$sql<BR>";
      $roll2 = dosql($sql) + 0;
      if ($roll1 + d11(1) > $roll2 + d11(1))
      {
      	 $sql = "select count(vlslevel) from VLstatlink where vlid=$vlid and charid=$charid and vlsid=3;";
      	 $sql2 = "select count(vlslevel) from VLstatlink where vlid=$vlid and vlsid=7;";
      	 #print "$sql<BR>";
      	 if (dosql($sql) + 0 > 0) #raise by 1
      	 {
      	    $sql = "update VLstatlink set vlslevel=vlslevel+1 where vlid=$vlid and charid=$charid and vlsid=3;";
      	 }
      	 elsif (dosql($sql2) + 0 > 0) #lower unhallow by 1
      	 {
      	    if ($roll2 == 1)
      	    {
      	    	$sql = "delete from VLstatlink where vlid=$vlid and vlsid=7;";
      	    }
      	    else
      	    {
      	    	$sql = "update VLstatlink set vlslevel=vlslevel-1 where vlid=$vlid and vlsid=7;";
      	    }
      	 }
      	 else  #consecrate
      	 {
      	    $sql = "insert into VLstatlink (vlid, vlsid, charid, vlslevel) values ($vlid, 3, $charid, 1);";
      	 }
      	 
      	 #print "$sql<BR>";
      	 dosql($sql);
	 
         $result .= "Your attempt to consecrate is successful.";
      }
      else
      {
         $result .= "Your attempt to consecrate has failed.";
      }
      $retVal .= "<p>$result</p>";
      
   }
   elsif ($btid == 15) #host a party
   {
      $retVal = "<h2>Host a Party</H2>\n";
      $name = $data;
      $name =~ s/'/''/g;
      
      $vlid = $data;
      $vlid =~ s/-->(.*)$//g;
      $vlid =~ s/<!--//g;
      
      $retVal .= "Hosting a party/salon at: $data<BR>\n";
      
      $status = dosql("select status from characterSTATs where charid=$charid");
      
      $roll1 = getVLtotal($vlid,"vl_fancy","vla_fancy") - $status;
      #$retVal .= "roll1 now $roll1<BR>";
      $roll1 += getVLtotal($vlid,"vl_location","vla_location") - $status;
      #$retVal .= "roll1 now $roll1<BR>";

      $money = min($money,getMoney($charid));
      $money = max($money,0);
      $roll1 += $status + geteffectivestatus($charid);
      #$retVal .= "roll1 now $roll1<BR>";
      $roll1 += int($money/($status * 10));
      #$retVal .= "roll1 now $roll1<BR>";
      
      $roll2 = $status * 2;
      
      #$retVal .= "roll2 now $roll2<BR>";
      $num = ($roll1 + d11(1)) - ($roll2 + d11(1));

      if ($num > 4)
      {	 
         $result .= "Your party was the hit of the social season.";
         $num = 4;
      }
      elsif ($num > 2)
      {
         $result .= "Your party was a great success.";
      }
      elsif ($num > 0)
      {
         $result .= "Your party was a success.";
      }
      elsif ($num == 0)
      {
         $result .= "Nobody really seemed to care one way or another.";
      }
      elsif ($num > -2)
      {
         $result .= "Your party was kind of a flop.";
      }
      elsif ($num > -5)
      {
         $result .= "Your party was unfortunate.";
      }
      else
      {
         $result .= "Your party was a complete disaster.";
         $num = -5;
      }
      
      $money *= -1;
      
      local($oldrank) = getStatusRank($charid);
      $sql = "update characterSTATs set substatus=substatus+($num) where charid=$charid;";
      #print "$sql<BR>";
      dosql($sql);
      
      if (getStatusRank($charid) < $oldrank)
      {
   	    $thedate = getDBDate();
	    $sql = "insert into charactersubstatpoints (charid,points,entrydate,notes) values ($charid, 1, '$thedate', 'Character advanced in substatus rank');";
	    dosql($sql);	  
	    $result .= "<BR>You gained a SubStatus Freebie Point.";
      }
      $retVal .= "<p>$result</p>";
   }
   elsif ($btid == 16) #perform a craft
   {
      $retVal = "<h2>Perform A Craft</H2>\n";
      
      $retVal .= "Specific Craft Skill: $data<BR>\n";
      
      $roll1 = dosql("select dex from characterSTATs where charid=$charid;");
      $roll1 += getlevel("ARTISAN/CRAFTSMAN: _____________",$data);
      
      $money = min($money,getMoney($charid));
      $money = max($money,0);
      
      $roll2 = 6;
           
      $num = ($roll1 + d11(1)) - ($roll2 + d11(1));
      
      $retVal .= "Spending $money<BR>\n";

      if ($num > 4)
      {	 
      	 $newmon = d11($roll1 + ($money / 10));
         $result .= "You made $newmon.";
         $money = ($newmon * -1);
      }
      elsif ($num > 1)
      {
      	 $newmon = d11($money / 10);
         $result .= "You made $newmon.";
         $money = ($newmon * -1);
      }
      elsif ($num > 0)
      {
      	 $newmon = d11($money / 20);
         $result .= "You made $newmon.";
         $money = ($newmon * -1);
      }
      elsif ($num == 0)
      {
         $result .= "You were able to recoup half your money.";
         $money = int($money / 2);
      }
      else
      {
         $result .= "Your craftsmanship did not garner you any money.";
      }
      $retVal .= "<p>$result</p>";
      
      $money *= -1;
   }
   elsif ($btid == 17) #perform on stage
   {
      $retVal = "<h2>Perform On Stage</H2>\n";
      
      $retVal .= "Specific Performance Skill: $data<BR>\n";
      
      $roll1 = dosql("select iq from characterSTATs where charid=$charid;");
      $roll1 += getlevel("PERFORMER: _____________",$data);
      
      $money = min($money,getMoney($charid));
      $money = max($money,0);
      
      $roll2 = 6;
           
      $num = ($roll1 + d11(1)) - ($roll2 + d11(1));
      
      $retVal .= "Spending $money<BR>\n";

      if ($num > 5)
      {	 
      	 $newmon = d11($roll1 + ($money / 10));
         $result .= "You made $newmon.";
         $money = ($newmon * -1);
      }
      elsif ($num > 2)
      {
      	 $newmon = d11($money / 10);
         $result .= "You made $newmon.";
         $money = ($newmon * -1);
      }
      elsif ($num > 0)
      {
      	 $newmon = d11($money / 20);
         $result .= "You made $newmon.";
         $money = ($newmon * -1);
      }
      elsif ($num == 0)
      {
         $result .= "You were able to recoup half your money.";
         $money = int($money / 2);
      }
      else
      {
         $result .= "Your performance did not garner you any money.";
      }
      $retVal .= "<p>$result</p>";
      
      $money *= -1;
      
      $sql = "update characterSTATs set substatus=substatus+($num) where charid=$charid;";
      #print "$sql<BR>";
      dosql($sql);
   }
   elsif ($btid == 23) #donate to fund
   {
      $retVal = "<h2>Process Donation to Antiquities Fund</H2>\n";
      
      $money = min($money,getMoney($charid));
      $money = max(0,$money);
      $result = "You have donated $money<BR>";
      
      $retVal .= "<p>$result</p>";
      
      $sql = "update global_variables set level=level+$money where gvid=36;";
     
      dosql($sql);
      
      $money *= -1;
      $num = getMoney($charid) + $money;
      $retVal .= "<p>You now have $num in your ledger.</p>";
   }
   elsif ($btid == 25) #gather dirt
   {
     $retVal = "<h2>Gather Dirt</h2>\n";

     $money = min($money,getMoney($charid));
     $money = max(0,$money);

     $targetname = $data;

     $targetid = $data;
     $targetid =~ s/-->(.*)$//;
     $targetid =~ s/<!--//;
	
     if ("$targetid" eq "0")
     {
	$retVal .= "Gathering Dirt on a random character...<BR><BR>\n";

	$sql = "select * from blackmail a;";
	#$retVal .= "$sql<BR>\n";	
	local($db) = dbconnect();
	local ($query) = $db->prepare($sql);
	$query->execute;

	if ($query->rows > 0)
	{
	 	$num = int(rand($query->rows));
	 	$pcchar[0] = "\[NPC\]";
	 	$pcchar[1] = "\[PC\]";

		#$retVal .= "$num out of ".$query->rows."<BR>\n";	
	    	for ($i = 0; $i <= $num; $i++)
		{
	   	      $resptr = $query->fetchrow_hashref();
		}
		$result = $resptr->{"text"}. " ". $pcchar[$resptr->{"isplayersecret"}];
		$sql = "insert into blackmailcharacters (bid,charid,entrydate) values (".$resptr->{"bid"}.", $charid, CURDATE());";
		dosql($sql);
	}
	else
	{
		$result = "You were unable to find any blackmail information.";
	}
	$query->finish;
	$db->disconnect();

     }
     elsif ("$targetid" =~ /NPC/)
     {
        $targetid =~ s/NPC-//;
	$retVal .= "Gathering Dirt on $targetname [NPC]...<BR><BR>\n";
	
	#your iq + blackmail material + contacts
	$roll1 = dosql("select iq from characterSTATs where charid=$charid;");
	$roll1 += getlevel("BLACKMAIL MATERIAL");
	$roll1 += getlevel("STREET CONTACTS");
	$roll1 += getlevel("CONTACT: SERVANT'S NETWORK");
	$roll1 += getlevel("HIGH SOCIETY CONTACTS");
	$roll1 += $money / 15;
	$roll1 += d11(1);
	
	#vs their will + status
	$roll2 = dosql("select will from npcsecrets where npcsid=$targetid;");
	$roll2 += dosql("select status from npcsecrets where npcsid=$targetid;");
	$roll2 += d11(1);
	
	if ($roll1 > $roll2)
	{

	   $sql = "select a.* from blackmail a join npcsecrets b on a.linkid=b.npcsid where b.npcsid=$targetid and a.isplayersecret=0;";
	   #$retVal .= "$sql<BR>\n";	
	   local($db) = dbconnect();
	   local ($query) = $db->prepare($sql);
	   $query->execute;
	
	   if ($query->rows > 0)
	   {
	
		$num = int(rand($query->rows));

		#$retVal .= "$num out of ".$query->rows."<BR>\n";	
		for ($i = 0; $i <= $num; $i++)
		{
		   $resptr = $query->fetchrow_hashref();
		}
		$result = $resptr->{"text"};
		$sql = "insert into blackmailcharacters (bid,charid,entrydate) values (".$resptr->{"bid"}.", $charid, CURDATE());";
		dosql($sql);
	   }
	   else
	   {
		$result = "You were unable to find any blackmail information.";
	   }
	   $query->finish;
	   $db->disconnect();
      
	}
	else
	{
		$result = "You were unable to find any blackmail information.";
	}

     }
     else
     {

	$retVal .= "Gathering Dirt on $targetname...<BR><BR>\n";
	
	#your iq + blackmail material + contacts
	$roll1 = dosql("select iq from characterSTATs where charid=$charid;");
	$roll1 += getlevel("BLACKMAIL MATERIAL");
	$roll1 += getlevel("STREET CONTACTS");
	$roll1 += getlevel("CONTACT: SERVANT'S NETWORK");
	$roll1 += getlevel("HIGH SOCIETY CONTACTS");
	$roll1 += $money / 25;
	$roll1 += d11(1);
	
	#vs their IQ + contacts
	$roll2 = dosql("select iq from characterSTATs where charid=$targetid;");
	$roll2 += getlevelforchar("INSCRUTABLE","",$targetid);
	$roll2 += getlevelforchar("STREET CONTACTS","",$targetid);
	$roll2 += getlevelforchar("CONTACT: SERVANT'S NETWORK","",$targetid);
	$roll2 += getlevelforchar("HIGH SOCIETY CONTACTS","",$targetid);
	$roll2 += d11(1);

	#$retVal .= "$roll1 vs $roll2<BR>\n";
	if ($roll1 > $roll2)
	{

	   $sql = "select a.* from blackmail a join characterabilities b on a.linkid=b.caid where b.charid=$targetid and a.isplayersecret=1;";
	   #$retVal .= "$sql<BR>\n";	
	   local($db) = dbconnect();
	   local ($query) = $db->prepare($sql);
	   $query->execute;
	
	   if ($query->rows > 0)
	   {
		$num = int(rand($query->rows));

		#$retVal .= "$num out of ".$query->rows."<BR>\n";	
		for ($i = 0; $i <= $num; $i++)
		{
		   $resptr = $query->fetchrow_hashref();
		}
		$result = $resptr->{"text"};
		$sql = "insert into blackmailcharacters (bid,charid,entrydate) values (".$resptr->{"bid"}.", $charid, CURDATE());";
		dosql($sql);
	   }
	   else
	   {
		$result = "You were unable to find any blackmail information.";
	   }
	   $query->finish;
	   $db->disconnect();
      
	}
	else
	{
		$result = "You were unable to find any blackmail information.";
	}
	
     }
	
     $money *= -1;
     $retVal .= "$result<BR>\n";	
	
   }
   elsif ($btid == 18) #Stay in public eye
   {
      $retVal = "<h2>Stay In Public Eye</H2>\n";
      
      $result = "Noted.";

      $retVal .= "<p>$result</p>";
      
      $money = 0;
      $retVal .= "<p>You now have $num in your ledger.</p>";
   }
   elsif ($btid == 24) #do nothing
   {
      $retVal = "<h2>Do Nothing</H2>\n";
      
      $num = int(rand(10));
      $money = 0;
      
      if ($num < 4)
      {
         $money = int(rand(10)) + 1;
         $result = "You found $money.";
      }
      elsif ($num < 5)
      {
         $num = rand(2) + 1;
         $sql = "update characterSTATs set substatus=substatus+($num) where charid=$charid;";
         #print "$sql<BR>";
         dosql($sql);
         $result = "You gain a touch of subStatus.";
      }
      else
      {
         $result = "Nothing special happens.";
      }

      $retVal .= "<p>$result</p>";
      
      $num = getMoney($charid) + $money;
      $retVal .= "<p>You now have $num in your ledger.</p>";
   }
   else #anything else
   {
      $retVal = "I cannot handle that type of BGA.";
      return $retVal;
   }
   
   setProcessedBGA($keyvalue, $result, $money);
   return $retVal;
}

sub setProcessedBGA()
{
   local($varID) = $_[0];
   local($varStr) = $_[1];
   local($money) = $_[2];
   $varStr =~ s/'/''/g;
   dosql("update bgas set handled=1, result='$varStr' where bgaid=$varID;");
   
   $sql = "insert into money (charid, pounds, entrydate, notes) values ($charid,$money,'";
   $sql .= getDBDate() . "', 'BGA Result');";
   #print "$sql<BR>";
   dosql($sql);   
}

sub handletaxes()
{
   local($varID) = $_[0];

   local ($gotcha) = int($varID * 0.05);
   dosql("update global_variables set level=level+$gotcha where name='The Treasury';");
   return $gotcha;
}

sub updateDEVinventory()
{
   local ($planid) = $_[0];
   local ($state) = $_[1];
   local ($num) = $_[2];
   
   local ($amount) = dosql("select sum(amount) from inventory_dev where planid=$planid and stateid=$state and charid=$charid");
   local($db) = dbconnect();
   local ($sql) = "delete from inventory_dev where planid=$planid and stateid=$state and charid=$charid;";
   $db->do($sql);
   $amount += $num;
   if ($amount > 0)
   {
	   $sql = "insert into inventory_dev (planid, charid, stateid, amount) values ($planid, $charid, $state, $amount);";
	   $db->do($sql);
   }
   $db->disconnect;
}

sub removeWSinventory()
{
   local ($wpid) = $_[0];
   local ($num) = $_[1];
   
   local ($amount) = dosql("select sum(amount) from inventory_ws where wpid=$wpid and charid=$charid");
   local($db) = dbconnect();
   local ($sql) = "delete from inventory_ws where wpid=$wpid and charid=$charid;";
   $db->do($sql);
   $amount -= $num;
   if ($amount > 0)
   {
	   $sql = "insert into inventory_ws (wpid, charid, amount) values ($wpid, $charid, $amount);";
	   $db->do($sql);
   }
   $db->disconnect;
}

sub removeSCinventory()
{
   local ($scid) = $_[0];
   local ($num) = $_[1];
    
   local ($amount) = dosql("select sum(amount) from inventory_sc where scid=$scid and charid=$charid");
   local($db) = dbconnect();
   local ($sql) = "delete from inventory_sc where scid=$scid and charid=$charid;";
   $db->do($sql);
   $amount -= $num;
   if ($amount > 0)
   {
	   $sql = "insert into inventory_sc (scid, charid, amount) values ($scid, $charid, $amount);";
	   $db->do($sql);
   }
   $db->disconnect;
}

sub displayInventory()
{
    local ($retval) = "<H2>Inventory</H2>\n";
    
    local($db) = dbconnect();
    $sql = "select * from inventory_sc a, spellcomponents b where a.charid=$charid and a.scid=b.scid;";
    local($query) = $db->prepare($sql);
    $query->execute;
    if ($query->rows > 0)
    {
    	$retval .= "<H3>Spell Components</H3>\n";
       	$retval .=  "<table border=1>\n";
	$retval .=  "<tr>\n";
	$retval .=  "<td><b>Name</b></td>\n";
	$retval .=  "<td><b>Amount</b></td>\n";
	$retval .=  "<td><b>Worth (ea)</b></td>\n";
	$retval .=  "</tr>\n";       	
       	while ($resptr = $query->fetchrow_hashref())
       	{
	   $retval .=  "<tr>\n";
	   $retval .=  "<td>".$resptr->{"scname"}."</td>\n";
	   $retval .=  "<td>".$resptr->{"amount"}."</td>\n";
	   $retval .=  "<td>".$resptr->{"sccost"}."</td>\n";
	   $retval .=  "</tr>\n";       	
	}
    	$retval .=  "</table>\n";
    }
    $query->finish;

    $sql = "select * from inventory_ws a, WS_parts b, motiveforces c where a.charid=$charid and a.wpid=b.wpid and c.mfid = b.wpmfid;";
    local($query) = $db->prepare($sql);
    $query->execute;
    if ($query->rows > 0)
    {
    	$retval .= "<H3>Weird Science Parts</H3>\n";
       	$retval .=  "<table border=1>\n";
	$retval .=  "<tr>\n";
	$retval .=  "<td><b>Name</b></td>\n";
	$retval .=  "<td><b>Associated Motive Force</b></td>\n";
	$retval .=  "<td><b>Amount</b></td>\n";
	$retval .=  "<td><b>Worth (ea)</b></td>\n";
	$retval .=  "</tr>\n";       	
       	while ($resptr = $query->fetchrow_hashref())
       	{
	   $retval .=  "<tr>\n";
	   $retval .=  "<td>".$resptr->{"wpname"}."</td>\n";
	   $retval .=  "<td>".$resptr->{"mfname"}."</td>\n";
	   $retval .=  "<td>".$resptr->{"amount"}."</td>\n";
	   $retval .=  "<td>".$resptr->{"wpcost"}."</td>\n";
	   $retval .=  "</tr>\n";       	
	}
    	$retval .=  "</table>\n";
    }
    $query->finish;

    $sql = "select * from inventory_dev a, WS_plans b, planstates c where a.charid=$charid and a.planid=b.planid and a.stateid=c.stateid;";
    local($query) = $db->prepare($sql);
    $query->execute;
    if ($query->rows > 0)
    {
    	$retval .= "<H3>Weird Science Devices</H3>\n";
       	$retval .=  "<table border=1>\n";
	$retval .=  "<tr>\n";
	$retval .=  "<td><b>Name</b></td>\n";
	$retval .=  "<td><b>State</b></td>\n";
	$retval .=  "<td><b>Amount</b></td>\n";
	$retval .=  "</tr>\n";       	
       	while ($resptr = $query->fetchrow_hashref())
       	{
	   $retval .=  "<tr>\n";
	   $retval .=  "<td>".$resptr->{"name"}."</td>\n";
	   $retval .=  "<td>".$resptr->{"statetext"}."</td>\n";
	   $retval .=  "<td>".$resptr->{"amount"}."</td>\n";
	   $retval .=  "</tr>\n";       	
	}
    	$retval .=  "</table>\n";
    }
    $query->finish;

    $db->disconnect;

    return $retval;
}

sub countfreeslots()
{
   local ($freeslots) = $base_num_allowed + getlevel("SPARE TIME"); 
   $freeslots -= getlevel("RESPONSIBILITIES"); 
   $freeslots = max($freeslots,1);

   $freeslots -= dosql("select count(bgaid) from bgas where charid=$charid;");
   return $freeslots;
}

# ***************
# * Return True *
# ***************
# * A Perl Library must always return a true value,
# * or it doesn't compile in the require statement.
1;b