#!/usr/bin/perl

require 'bga_inc.pl';
require 'stat_inc.pl';
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "bgafree.pl";
$table = "bgas";
$heading = "Between Game Action";
$keyfield = "bgaid";
$keyvalue = $CGI->param($keyfield);
$tplfile = "bga.tpl";
$errstr = $CGI->param("error");

$charid = $CGI->param("charid") + 0;
$charname = getCharName($charid);

$num_allowed = 6;

if ($pid != getPIDFromCharID($charid) && $al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to submit BGAs for that character!"));
}
elsif ($action eq "money" && $submit eq "Go")
{
	#print $CGI->header;
	$money = $CGI->param("money");
     	$money = min($money,getMoney($charid));
      	$money = max($money,0);
	$targetid = $CGI->param("targetid");
	$targetname = getCharName($targetid);
      	$sql = "insert into money (charid, pounds, entrydate, notes) values ($charid,".($money * -1).",'";
      	$sql .= getDBDate() . "', 'money transferred to $targetname');";
      	#print "$sql<BR>";
      	dosql($sql);
      	$sql = "insert into money (charid, pounds, entrydate, notes) values ($targetid,$money,'";
      	$sql .= getDBDate() . "', 'money transfered from $charname');";
      	#print "$sql<BR>";
      	dosql($sql);
      	$myemail = getEmailFromID(getPIDFromCharID($charid));
      	$targetemail = getEmailFromID(getPIDFromCharID($targetid));
      	$myname = getCharName($charid);
      	$targetname = getCharName($targetid);
	$date = getDate();
      	open(MAIL, "| /usr/sbin/sendmail  -oi -t") or die "couldn't send mail: $!";
	print MAIL "From: $contact\n";
	print MAIL "To: $targetemail\n";
	print MAIL "Cc: $myemail\n";
	print MAIL "Subject: $campaign Monetary Transaction\n";
	print MAIL "\n";
	print MAIL "$myname has transferred $money to $targetname.\n";
	print MAIL "Today's date: $date\n";
	print MAIL "---------------------------------------------------------------------------\n";
	close(MAIL);

      	
	print $CGI->redirect("bga.pl?charid=$charid&error=" . encodeURL("$money transferred to $targetname"));
}
elsif ($action eq "money")
{
	$tplfile = "bgahost2.tpl";
	$tatext = "Select the character you wish to transfer money to.";
	$droptext = makeDropDown("characters", "charid", "concat(cfirst,' ',clast)", "chartype <= $cast_character order by clast");
	$droptext =~ s/charid/targetid/;
	$moneytext = "Enter the amount of money you wish to transfer.";
	$doctitle = "Transfer money for $charname";
	showbgaform2();
}
elsif ($action eq "groupmoney" && $submit eq "Go")
{
	#print $CGI->header;
	$money = $CGI->param("money");
     	$money = min($money,getMoney($charid));
      	$money = max($money,0);
	$targetid = $CGI->param("groupid");
	$targetname = dosql("select groupname from charactergroups where groupid=$targetid;");
      	$sql = "insert into money (charid, pounds, entrydate, notes) values ($charid,".($money * -1).",'";
      	$sql .= getDBDate() . "', 'money transferred to $targetname');";
      	#print "$sql<BR>";
      	dosql($sql);
	$sql = "update charactergroups set budget = budget + $money where groupid=$targetid;";
      	#print "$sql<BR>";
      	dosql($sql);
	print $CGI->redirect("bga.pl?charid=$charid&error=" . encodeURL("$money transferred to $targetname"));
}
elsif ($action eq "groupmoney")
{
	$tplfile = "bgahost2.tpl";
	$tatext = "Select the character group to whose budget you wish to donate.";
	$droptext = makeDropDown("charactergroups a, charactergroupmembers b", "a.groupid", "a.groupname", "a.allowedbudget > 0 and a.groupid=b.groupid and b.charid=$charid order by a.groupname");
	$droptext =~ s/a.groupid/groupid/;
	$moneytext = "Enter the amount of money you wish to transfer.";
	$doctitle = "Transfer money for $charname";
	showbgaform2();
}
elsif ($action eq "tithe" && $submit eq "Go")
{
	#print $CGI->header;
	$money = $CGI->param("money");
     	$money = min($money,getMoney($charid));
      	$money = max($money,0);
      	$sql = "insert into money (charid, pounds, entrydate, notes) values ($charid,".($money * -1).",'";
      	$sql .= getDBDate() . "', 'Tithing');";
      	#print "$sql<BR>";
      	dosql($sql);
	$sql = "update charactergroups set budget = budget + $money where groupid=11;";
      	#print "$sql<BR>";
      	dosql($sql);
      	$substat = int(rand($money / 75));
      	$substat = min($substat, 6);
	$sql = "update characterSTATs set substatus = substatus + $substat where charid=$charid;";      	
      	#print "$sql<BR>";
      	dosql($sql);
	print $CGI->redirect("bga.pl?charid=$charid&error=" . encodeURL("$money tithed"));
}
elsif ($action eq "tithe")
{
	$tplfile = "bgahost2.tpl";
	$tatext = "<i>Note: If your character is a good Christian, you probably tithe 10% of your income.  But despite the detail that we have put into the economy, there are a large number of day to day income and expenses we gloss over.  Tithing falls into that category.  This form is for tithing extra, above and beyond the call of duty.  Anyone can do it and it goes directly into the coiffers of the Anglican church.  You may gain a small substatus bump for doing so.  Maybe.</i>";
	$droptext = "";
	$moneytext = "Enter the amount of money you wish to tithe.";
	$doctitle = "Tithe: $charname";
	showbgaform2();
}
elsif ($action eq "spcomp"  && $submit eq "Go")
{
	#print $CGI->header;
	$scid = $CGI->param("scid");
	$scname = dosql("select scname from spellcomponents where scid=$scid;");
	$cost = dosql("select sccost from spellcomponents where scid=$scid;") + 0;
	if (hasability("HAGGLE"))
	{
	  $cost = max(int($cost * 0.8),1);
	}
	if ($cost > getMoney($charid))
	{
	    print $CGI->redirect("bga.pl?charid=$charid&error=" . encodeURL("You cannot afford to buy $scname"));
	}
	else
	{
	    $sql = "insert into money (charid, pounds, entrydate) values ($charid,".($cost * -1).",'";
	    $sql .= getDBDate() . "');";
	    #print "$sql<BR>";
	    dosql($sql);
	    
	    $sql = "insert into inventory_sc (scid, charid, amount) values ($scid, $charid, 1);";
	    dosql($sql);

	    print $CGI->redirect("bga.pl?charid=$charid&error=" . encodeURL("Purchased $scname for $cost"));
	}
}
elsif ($action eq "spcomp")
{
	$tplfile = "bgadrop2.tpl";
	$tatext = "Select the component you wish to purchase.<BR>";
	$tatext .= "<i>You have ".getMoney($charid)." to spend.</i>";
	$droptext = makeDropDown("spellcomponents a, spellcomponentslink b, spellcomponentscharacterlink c", "a.scid", "concat(scname,' -- Cost: ',sccost)", "a.sccanpurchase > 0 and a.scid=b.scid and b.sclid=c.sclid and c.charid=$charid order by scname");
	$droptext =~ s/a.scid/scid/;
	$doctitle = "Purchase a Spell Component";
	showbgaform2();
}
elsif ($action eq "wspart"  && $submit eq "Go")
{
	#print $CGI->header;
	$wpid = $CGI->param("wpid");
	$wpname = dosql("select wpname from WS_parts where wpid=$wpid;");
	$cost = dosql("select wpcost from WS_parts where wpid=$wpid;") + 0;
	if (hasability("HAGGLE"))
	{
	  $cost = max(int($cost * 0.8),1);
	}
	if ($cost > getMoney($charid))
	{
	    print $CGI->redirect("bga.pl?charid=$charid&error=" . encodeURL("You cannot afford to buy $scname"));
	}
	else
	{
	    $sql = "insert into money (charid, pounds, entrydate) values ($charid,".($cost * -1).",'";
	    $sql .= getDBDate() . "');";
	    #print "$sql<BR>";
	    dosql($sql);
	    
	    $sql = "insert into inventory_ws (wpid, charid, amount) values ($wpid, $charid, 1);";
	    dosql($sql);

	    print $CGI->redirect("bga.pl?charid=$charid&error=" . encodeURL("Purchased $scname for $cost"));
	}
}
elsif ($action eq "wspart")
{
	$tplfile = "bgadrop2.tpl";
	$tatext = "Select the part you wish to purchase.<BR>";
	$tatext .= "<i>You have ".getMoney($charid)." to spend.</i>";
	$droptext = makeDropDown("WS_parts", "wpid", "concat(wpname,' -- Cost: ',wpcost)", "wpcanpurchase > 0 order by wpmfid");
	$doctitle = "Purchase a Weird Science Part";
	showbgaform2();
}
elsif ($action eq "vl")
{
	$doctitle = "Manage Access To Your Virtual Locations";
	print $CGI->header;
	ParseForm($header);
	print "<h1>$doctitle</h1>\n";
	local($db) = dbconnect();
	local ($sql) = "select * from virtuallocations where vlowner=$charid order by vlname;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Name</b></td>\n";
	print "<td><b>Description</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   print "<tr>\n";
	   print "<td>".$resptr->{"vlname"}."</td>\n";
	   print "<td>".$resptr->{"vldesc"}."</td>\n";
	   print "<td>";
	   print "<a href=\"virtuallocations.pl?action=giveaccess&vlid=".$resptr->{"vlid"}."\">Manage Access</a>\n";
	   print "</td>";
	   print "</tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
	
	print "<br><hr><a href=\"bga.pl?charid=$charid\">Return to BGAs</a>.\n"; 
	print "<br><a href=\"login.pl\">Main menu\n</a>."; 
	ParseForm($footer);
}
elsif ($action eq "buyinvest")
{
	print $CGI->header;
	$doctitle = "Manage ".$heading."s for $charname";
	ParseForm($header);
	print "<h1>$doctitle</h1>\n";
	print "<h2>Step One -- Choose Investment</h2>\n";
	
	$yourmoney = getMoney($charid);
	
	print "<form action=\"$thispage\" name=\"myform\" method=\"post\">";

	print "Do you wish to:<BR>\n";
	print "<input type=\"radio\" name=\"investtype\" value=\"newtrade\" CHECKED> Invest in a <b>New</b> Trade Resource.</input><BR>\n";
	print "<input type=\"radio\" name=\"investtype\" value=\"newindustry\"> Invest in a <b>New</b> Industrial Resource.</input><BR>\n";
	print "<input type=\"radio\" name=\"investtype\" value=\"addtrade\"> Increase your investment in an <b>Existing</b> Trade Resource.</input><BR>\n";
	print "<input type=\"radio\" name=\"investtype\" value=\"addindustry\"> Increase your investment in an <b>Existing</b> Industrial Resource.</input><BR><BR>\n";
	print "<input type=\"hidden\" name=\"action\" value=\"invest2\"><BR>\n";
	print "<input type=\"hidden\" name=\"charid\" value=\"$charid\">\n";

	print "<input type=\"submit\" name=\"submit\" value=\"Go To Step 2\"><BR>"; 	
 	print "</form>";
 	
	print "<br><hr><a href=\"bga.pl?charid=$charid\">Return to BGAs</a>."; 
	print "<br><a href=\"login.pl\">Main menu</a>."; 
	ParseForm($footer);
}
elsif ($action eq "invest2")
{
	print $CGI->header;
	$doctitle = "Buy Investments for $charname";
	ParseForm($header);
	print "<h1>$doctitle</h1>\n";
	
	$yourmoney = getMoney($charid);
	$investtype = $CGI->param("investtype");
	
	print "<form action=\"$thispage\" name=\"myform\" method=\"post\">";
	print "<input type=\"hidden\" name=\"charid\" value=\"$charid\" >\n";

	if ($investtype eq "newtrade")
	{
	     print "<h2>Invest in a New Trade Resource</h2>\n"; 
	     print "Enter the name of the Trade Resource in which you wish to invest:<BR>";
	     print "<input type=\"text\" name=\"data\" value=\"$data\" size=80><BR><BR>\n";
	     print "<i>This will give you level 1 of that Resource.  You can raise levels with additional BGAs or by spending XP.  A level 1 Trade resource costs on average 250, but could cost as much as $350.  You have $yourmoney available.</i><BR>\n";
	}
	if ($investtype eq "newindustry")
	{
	     print "<h2>Invest in a New Industrial Resource</h2>\n"; 
	     print "Enter the name of the Industrial Resource in which you wish to invest:<BR>";
	     print "<input type=\"text\" name=\"data\" value=\"$data\" size=80><BR><BR>\n";
	     print "<i>This will give you level 1 of that Resource.  You can raise levels with additional BGAs or by spending XP.  A level 1 Industrial Resource costs on average 250, but could cost as much as $350.  You have $yourmoney available.</i><BR>\n";

	}
	if ($investtype eq "addtrade")
	{
	     print "<h2>Invest in a Current Trade Resource</h2>\n"; 
	     print "This is a list of your trade resources and their levels:<BR>";
	     $tradedrop = makeDropDown("characterabilities", "caid", "concat(text,' (Level: ',level,')')", "charid=$charid and abid=38 and level < 6");
	     $tradedrop =~ s/name="caid"/name="data"/g;
	     print "$tradedrop<BR><BR>";
	     print "<i>This will raise the level of this investment by 1.  You can raise levels with additional BGAs or by spending XP.  A Trade resource costs about 250/level.  You have $yourmoney available.</i><BR>\n";
	     $investtype = "addinvest";
	}
	if ($investtype eq "addindustry")
	{
	     print "<h2>Invest in a Current Industrial Resource</h2>\n"; 
	     print "This is a list of your industrial resources and their levels:<BR>";
	     $tradedrop = makeDropDown("characterabilities", "caid", "concat(text,' (Level: ',level,')')", "charid=$charid and abid=33 and level < 6");
	     $tradedrop =~ s/name="caid"/name="data"/g;
	     print "$tradedrop<BR><BR>";
	     print "<i>This will raise the level of this investment by 1.  You can raise levels with additional BGAs or by spending XP.  An industrial resource costs about 250/level.  You have $yourmoney available.</i><BR>\n";
	     $investtype = "addinvest";
	}

	print "<input type=\"hidden\" name=\"investtype\" value=\"$investtype\">\n";
	print "<input type=\"hidden\" name=\"action\" value=\"handlebuy\">\n";
	print "<input type=\"submit\" name=\"submit\" value=\"Go\"><BR>"; 	
 	print "</form>";
 	
	print "<br><hr><a href=\"bga.pl?charid=$charid\">Return to BGAs</a>."; 
	print "<br><a href=\"login.pl\">Main menu</a>."; 
	ParseForm($footer);
}
elsif ($action eq "handlebuy")
{
      #print $CGI->header;

      $data = $CGI->param("data");
      $name = $data;
      $investtype = $CGI->param("investtype");
      $yourmoney = getMoney($charid);
      $success = 0;
      
      #print "$data<BR>\n";
      #print "$investtype<BR>\n";
      #print "$yourmoney<BR>\n";
      
      if ($investtype eq "newtrade")
      {
	 $retVal = "<h2>Invest in a New Trade Resource</h2>\n"; 
	 $retVal .= "<h3>Investing in: $name</h3>\n"; 
	 
	 $num = max(getlevel("HAGGLE"),1);
	 $money = -10;
	 for ($i = 0; $i < $num; $i++)
	 {
    	     $amt = int(rand(10)) + int(rand(10)) + 2;
	     $amt = $inv_tr[$amt];
	     $amt = $res[2][$amt];
	     if ($amt < 100)
	     {  
	        $money = max($money,$amt);
	     }
	 }
	 
	 $money *= -10;
	 $money += 200 + d11(5);
	 
	 if ($money > $yourmoney)
	 {
	    $retVal .= "<p>This would cost $money, but you only have $yourmoney.  You cannot afford this.</p>";
	 }
	 else
	 {
		 $cost = getcost(1,1);

		 $name =~ s/'/''/g;
		 $sql = "insert into characterabilities (charid, abid, level, text, difficulty, cost) values ($charid, 38, 1, '$name', 'Easy', $cost);";
		 dosql($sql);
		 $caid = dosql("select max(caid) from characterabilities where charid=$charid and abid=38;");
		 $sql = "insert into characterresourcetypelink (typeid, abid, charid, level) values (5,$caid, $charid, 2);";
		 dosql($sql);
		 $sql = "insert into characterresourcetypelink (typeid, abid, charid, level) values (3,$caid, $charid, 1);";
		 dosql($sql);

		 $oldlevel = 0;
		 $level = 1;
		 $success = 1;
	 }
      }
      elsif ($investtype eq "newindustry")
      {
	 $retVal = "<h2>Invest in a New Industrial Resource</h2>\n"; 
	 $retVal .= "<h3>Investing in: $name</h3>\n"; 
	 
	 $num = max(getlevel("BUSINESS"),1);
	 $money = -10;
	 for ($i = 0; $i < $num; $i++)
	 {
    	     $amt = int(rand(10)) + int(rand(10)) + 2;
	     $amt = $inv_in[$amt];
	     $amt = $res[2][$amt];
	     if ($amt < 100)
	     {  
	        $money = max($money,$amt);
	     }
	 }
	 
	 $money *= -10;
	 $money += 200 + d11(5);
	 	 
	 if ($money > $yourmoney)
	 {
	    $retVal .= "<p>This would cost $money, but you only have $yourmoney.  You cannot afford this.</p>";
	 }
	 else
	 {
		 $cost = getcost(1,1);

		 if (d11(1) < 2)
		 {
		    $cost = getcost(2,1);
		    $sql = "insert into characterabilities (charid, abid, level, text, difficulty, cost) values ($charid, 33, 2, '$name', 'Easy', $cost);";
		    dosql($sql);
		    $caid = dosql("select max(caid) from characterabilities where charid=$charid and abid=33;");
		    $sql = "insert into characterresourcetypelink (typeid, abid, charid, level) values (5,$caid, $charid, 1);";
		    $retVal .= "<p>This Industrial Resource is a Low Income Resource, so you were able to purchase it at level 2.</p>";
		    $oldlevel = 0;
		    $level = 2;
		 }
		 else
		 {
		    $sql = "insert into characterabilities (charid, abid, level, text, difficulty, cost) values ($charid, 33, 1, '$name', 'Easy', $cost);";
		    dosql($sql);
		    $caid = dosql("select max(caid) from characterabilities where charid=$charid and abid=33;");
		    $sql = "insert into characterresourcetypelink (typeid, abid, charid, level) values (5,$caid, $charid, 2);";
		    dosql($sql);
		    $sql = "insert into characterresourcetypelink (typeid, abid, charid, level) values (3,$caid, $charid, 1);";
		    dosql($sql);
		    $oldlevel = 0;
		    $level = 1;
		 }
		 
		 $success = 1;
	}

      }
      else
      {
      	 $name = dosql("select text from characterabilities where caid=$data");

	 $retVal = "<h2>Increasing $name</h2>\n"; 
	 
	 $abid = dosql("select abid from characterabilities where caid=$data;");
	 
	 if ("$abid" eq "33") #industrial
	 {

	    $num = max(getlevel("BUSINESS"),1);
	    $money = -10;
	    for ($i = 0; $i < $num; $i++)
	    {
		$amt = int(rand(10)) + int(rand(10)) + 2;
		$amt = $inv_in[$amt];
		$amt = $res[2][$amt];
	        if ($amt < 100)
		{  
		   $money = max($money,$amt);
		}
	    }
	 }
	 else
	 {

	    $num = max(getlevel("HAGGLE"),1);
	    $money = -10;
	    for ($i = 0; $i < $num; $i++)
	    {
		$amt = int(rand(10)) + int(rand(10)) + 2;
		$amt = $inv_tr[$amt];
		$amt = $res[2][$amt];
	        if ($amt < 100)
		{  
		   $money = max($money,$amt);
		}
	    }
	 }
	 	 
	 $oldlevel = dosql("select level from characterabilities where caid=$data;");
	 $level = min($oldlevel+1,6);
	 $cost = getcost($level,1);

	 $money *= -10;
	 $money += 200 + d11(4 * $level);
	 
	 if ($money > $yourmoney)
	 {
	    $retVal .= "<p>This would cost $money, but you only have $yourmoney.  You cannot afford this.</p>";
	 }
	 else
	 {
		 $sql = "update characterabilities set level = $level, cost = $cost where caid=$data;";
		 dosql($sql);	  
		 $success = 1;
	 }
      }
    
      if ($success > 0)
      {
	      $result = "This cost you $money."; 
	      $money *= -1;
	      $retVal .= "<BR><p>$name now at level $level.</p>";
	      $retVal .= "<BR><p>$result</p>";

	      $name =~ s/'/''/g;
	      $sql = "insert into money (charid, pounds, entrydate, notes) values ($charid,$money,'";
	      $sql .= getDBDate() . "', 'Buying $name');";
	      #print "$sql<BR>";
	      dosql($sql);   

	      $xpcost = getcost($level, 1) - getcost($oldlevel, 1);
	      updateXP($charid, $xpcost, "Bought an investment with money");
      }

      print $CGI->redirect("$thispage?charid=$charid&action=processresults&retVal=" . encodeURL("$retVal"));
}
elsif ($action eq "processresults")
{
	print $CGI->header();
	$doctitle = "Process Investments for $charname";
	ParseForm($header);
	
	print "<H1>$doctitle</h1>\n";
	
	$retVal = $CGI->param("retVal");
	print $retVal;
	
	print "<br><hr><a href=\"bga.pl?charid=$charid\">Return To BGAs</a>."; 
	print "<br><a href=\"login.pl\">Main menu</a>."; 
	ParseForm($footer);
}
elsif ($action eq "sellinvest")
{
	$tplfile = "bgadrop2.tpl";
	$tatext = "You may sell multiple levels of an investment.  Note that if you sell all the levels of your investment, then it will be removed from your stat/skills.";
	$droptext = makeDropDown("characterabilities", "caid", "concat(text,' (Level: ',level,')')", "charid=$charid and (abid=33 or abid=38)");
	$droptext =~ s/name="caid"/name="data"/g;
	$droptext .= "<BR><BR>Enter the number of levels of this investment you wish to sell:  ";
	$droptext .= "<input type=text name=levels value=\"$levels\" size=5><BR>";
	
	$doctitle = "Process Investments for $charname";
	
	print $CGI->header;
	ParseForm($header);
	print "<h1>$doctitle</h1>\n";
	
	$yourmoney = getMoney($charid);
	
	print "<form action=\"$thispage\" name=\"myform\" method=\"post\">\n";
	print "<input type=hidden name=action value=\"handlesell\">\n";
	ParseForm($tplfile);
	
	print "<input type=\"submit\" name=\"submit\" value=\"Go\"><BR>\n"; 	
 	print "</form>\n";
 	
	print "<br><hr><a href=\"bga.pl?charid=$charid\">Return to BGAs</a>.\n"; 
	print "<br><a href=\"login.pl\">Main menu\n</a>."; 
	ParseForm($footer);
}
elsif ($action eq "handlesell")
{     
      $caid = $CGI->param("data");
      $name = dosql("select text from characterabilities where caid=$caid");
      $totlevels = dosql("select level from characterabilities where caid=$caid")+0;
      $levels = min($CGI->param("levels")+0,$totlevels);
      $yourmoney = getMoney($charid);
      
      $retVal = "<h2>Sell an Investment Resource</H2>\n";
      $retVal .= "<BR><p>Selling $levels levels of: $name</p>\n";
      
      if (dosql("select abid from characterabilities where caid=$caid") == 33) #industrial
      {
	    $num = max(getlevel("BUSINESS"),1);
	    @array = @inv_in;
      }
      else
      {
	    $num = max(getlevel("HAGGLE"),1);
	    @array = @inv_in;
      }
   
      $money = 0;
      $lev = dosql("select level from characterresourcetypelink where charid=$charid and abid=$caid and typeid=5")+0;
      for ($j = 0; $j < $levels; $j++)
      {
      	      $tmon = 1;
	      for ($i = 0; $i < $num; $i++)
	      {
		$amt = int(rand(10)) + int(rand(10)) + 2;
		$amt = $array[$amt];
		$amt = $res[$lev][$amt];
		if ($amt < 100)
		{  
		   $tmon = max($tmon,$amt);
		}
		elsif ($amt == $raiselev)
		{
		   $i--;
		   $lev++;
		}
		elsif ($amt == $lowerlev)
		{
		   $i--;
		   $lev--;
		}
	      }
	      
      	      $tlev2 = $totlevels - $j;
	      $money += ($tlev2 * $tlev2) * $tmon * 10;;
      }
            
      if ($money < 1)
      {
         $result = "You were unable to find a buyer for your investment";
         $money = 0;
      }
      else
      {
         $result = "You sold your investment for $money";
         
         if ($levels < $totlevels)
         {
            $sql = "update characterabilities set level=(level-$levels) where caid=$caid;";
            dosql($sql);
         }
         else
         {
            $sql = "delete from characterabilities where caid=$caid;";
            dosql($sql);
            $sql = "delete from characterresourcetypelink where abid=$caid;";
            dosql($sql);
         }
      }
      $retVal .= "<p>$result</p>";

      $sql = "insert into money (charid, pounds, entrydate) values ($charid,$money,'";
      $sql .= getDBDate() . "');";
      #print "$sql<BR>";
      dosql($sql);   
      print $CGI->redirect("$thispage?charid=$charid&action=processresults&retVal=" . encodeURL("$retVal"));
}
elsif ($action eq "wsaccess")
{
	$doctitle = "Manage Access To Your Weird Science Plans";
	print $CGI->header;
	ParseForm($header);
	print "<center><img src=\"doclib/plans.jpg\" width=500 height=170></center>\n";
	print "<h1>$doctitle</h1>\n";
	local($db) = dbconnect();
	local ($sql) = "select * from WS_plans a, characterplans b where a.planid=b.planid and b.charid=$charid order by a.name;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Name</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   print "<tr>\n";
	   print "<td>".$resptr->{"name"}."</td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=editplanchars&charid=$charid&planid=".$resptr->{"planid"}."\">Manage Access</a>\n";
	   print "</td>";
	   print "</tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
	
	print "<br><hr><a href=\"bga.pl?charid=$charid\">Return to BGAs</a>.\n"; 
	print "<br><a href=\"login.pl\">Main menu\n</a>."; 
	ParseForm($footer);
}
elsif ($action eq "editplanchars")
{
	$planid = $CGI->param("planid");
	if (!planaccess($charid))
	{
	    print $CGI->redirect("bga.pl?charid=$charid&error=" . encodeURL("You do not have access to those plans!"));
	    exit 0;
	}

	print $CGI->header;
	$planname = dosql("select name from WS_plans where planid=$planid;");
	$doctitle = "$planname -- Manage Characters";
	ParseForm($header);
	
	print "<center><img src=\"doclib/plans.jpg\" width=500 height=170></center>\n";
	
	print "<font color=red>$errstr</font><BR><BR>\n";
	
	print "<H1>$doctitle</H1>\n";

	print "<H2>Current Owners</H2>\n";
	print getplanowners($planid). "<BR>";
	
	print "<br><hr><a href=\"bga.pl?charid=$charid\">Return to BGAs</a>.\n"; 

	print "<H2>Add/Remove Characters</H2>\n";
	showChars();
	print "<br><hr><a href=\"bga.pl?charid=$charid\">Return to BGAs</a>.\n"; 
	print "<br><a href=\"login.pl\">Main menu</a>."; 
		
	ParseForm($footer);
}
elsif ($action eq "addplanchar")
{
	$planid = $CGI->param("planid");
	if (!planaccess())
	{
	    print $CGI->redirect("bga.pl?charid=$charid&error=" . encodeURL("You do not have access to those plans!"));
	    exit 0;
	}

	#print $CGI->header();
	local ($plancharid) = $CGI->param("plancharid");
	local($db) = dbconnect();
	$SQL = "insert into characterplans (charid, planid) values ($plancharid, $planid);";
	#print "$SQL<BR>\n";
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thispage?action=editplanchars&planid=$planid&charid=$charid");
}
elsif ($action eq "delplanchar")
{
	$planid = $CGI->param("planid");
	if (!planaccess())
	{
	    print $CGI->redirect("bga.pl?charid=$charid&error=" . encodeURL("You do not have access to those plans!"));
	    exit 0;
	}

	#print $CGI->header();
	local ($plancharid) = $CGI->param("plancharid");
	local($db) = dbconnect();
	$SQL = "delete from characterplans where charid=$plancharid and planid=$planid;";
	#print "$SQL<BR>\n";
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thispage?action=editplanchars&planid=$planid&charid=$charid");
}
else
{
	print $CGI->header;

	print "Error: Action = [$action]";
}


exit 0;

sub showbgaform2
{
	print $CGI->header;
	ParseForm($header);
	print "<h1>$doctitle</h1>\n";
	
	$yourmoney = getMoney($charid);
	
	print "<form action=\"$thispage\" name=\"myform\" method=\"post\">\n";
	print "<input type=hidden name=action value=\"$action\">\n";
	ParseForm($tplfile);
	
	print "<input type=\"submit\" name=\"submit\" value=\"Go\"><BR>\n"; 	
 	print "</form>\n";
 	
 	print displayInventory();
 	
	print "<br><hr><a href=\"bga.pl?charid=$charid\">Return to BGAs</a>.\n"; 
	print "<br><a href=\"login.pl\">Main menu\n</a>."; 
	ParseForm($footer);
}

sub showChars()
{
	local($db) = dbconnect();
	$SQL = "select charid from characters where chartype <= $cast_character order by clast;";
	#print "$SQL<BR>";
	local($query) = $db->prepare($SQL);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Character Name</b></td>\n";
	print "<td><b>Plan Owner</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	if ($query->rows > 0)
	{
	   local (@array);
	   while (@array = $query->fetchrow_array)
	   {
		   print "<tr>\n";
		   print "<td>".getCharPlayerStr($array[0])."</td>\n";
		   if (dosql("select count(charid) from characterplans where charid=$array[0] and planid=$planid;") > 0)
		   {
			print "<td><b>Yes</b></td>\n";
			print "<td><a href=\"$thispage?action=delplanchar&plancharid=$array[0]&planid=$planid&charid=$charid\">Remove</a>\n";
		   }
		   else
		   {
			print "<td>No</td>\n";
			print "<td><a href=\"$thispage?action=addplanchar&plancharid=$array[0]&planid=$planid&charid=$charid\">Add</a>\n";
		   }
		   print "</td></tr>\n";
	   }
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub getplanowners()
{
   	local($varID) = $_[0];
	local($db) = dbconnect();
	$SQL = "select charid from characterplans where planid=$varID;";
	#print "$SQL<BR>";
	local($query) = $db->prepare($SQL);
	$query->execute;
	$retVal = "";
	if ($query->rows > 0)
	{
	   local (@array);
	   while (@array = $query->fetchrow_array)
	   {
	      $retVal .= getCharPlayerStr($array[0])."<BR>\n";
	   }
	}
	$query->finish;
	$db->disconnect;
	return $retVal;
}

sub planaccess()
{
	if (dosql("select count(charid) from characterplans where charid=$charid and planid=$planid;") + 0 > 0)
	{
	   return 1;
	}
	
	return ($al >= $gm_access);
}