#!/usr/bin/perl

require 'gmnote_inc.pl';
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "chargroups.pl";
$table = "charactergroups";
$heading = "a Character Group";
$keyfield = "groupid";
$keyvalue = $CGI->param($keyfield);
$namefield = "groupname";
$tplfile = "chargroups.tpl";
$errstr = $CGI->param("error");
$showdel = 0;

if ($al < $writer_access)
{
	print $CGI->redirect("chargroupsforchars.pl");
}
elsif ($action eq "summary")
{
	print $CGI->header();
	ParseForm($header);
	
	showsummary();	
	showGMNconfirm();
	
	print "<br><hr><a href=\"$thispage\">Return to Character Groups</a><BR>\n";
	print "<a href=\"main.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($action eq "new" || $action eq "edit")
{
	print $CGI->header();
	ParseForm($header);
	if ($keyvalue eq "")
	{
		print "<H1>Add $heading</H1>\n";
	}
	else
	{
        	print "<H1>Edit $heading</H1>\n";
	}
	print "<form action=\"$thispage\" method=\"post\">";

	fillvars();
	ParseForm($tplfile);
	
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>";
	}
	else
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>";
	}
	print "</form>";
	print "<br><hr><a href=\"main.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($action eq "editchars")
{
	print $CGI->header();
	ParseForm($header);
	$showdel = 1;
        fillvars();
        print "<H1>Edit Character Membership in $groupname</H1>\n";
        
        print "<H2>Current Members</H2>\n";

	print "<form action=\"$thispage\" method=\"post\">";
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	print "<input type=\"hidden\" name=\"action\" value=\"secret\">\n";
	print "$memberstr<BR><BR>\n";
	print "<input type=\"submit\" name=\"submit\" value=\"Update\"></form><BR>";
	print "<a href=\"$thispage\">Return to Character Groups</a><BR><BR>\n";
	print "</form>";
	
	print "<form action=\"$thispage\" method=\"post\">";
	local($db) = dbconnect();
	local($query) = $db->prepare("select charid from characters order by clast");
	$query->execute;
	
	print "<table border=1><tr style=\"border: none;\">\n";
	print "<td style=\"border: none;\"><H2>Add Members</H2></td>\n";
	print "<td style=\"border: none;\" colspan=3 align=right>\n";
	print "<input type=\"submit\" name=\"submit\" value=\"Add All Checked\"></td>\n";
	print "</tr><tr>\n";
	print "<td><b>Character Name</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "<td><b>Character Name</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	$num = 0;
	while (@array = $query->fetchrow_array)
	{
	  local ($charid) = $array[0];
	  local ($sql) = "select * from charactergroupmembers where charid=$charid and $keyfield=$keyvalue";
	  #print "$sql<BR>";
	  local($query2) = $db->prepare($sql);
	  $query2->execute;
	  if ($query2->rows == 0)
	  {
	  	if ($num == 0)
	  	{
	  	   print "<tr>\n";
	  	}
	  	print "<td>".getCharName($array[0])." <i>(".getFullNameFromCharID($charid).")</i></td>\n";
		print "<td>\n";
		print "<input type=checkbox name=\"check_$charid\" value=\"1\"\> ";
		print "<a href=\"$thisfile?action=addaccess&charid=$charid&$keyfield=$keyvalue\">Add</a></td>\n";
		$num++;
		if ($num == 2)
		{
		  print "</tr>\n";
		  $num = 0;
		}
	  }
	  $query2->finish;
	}
	$query->finish;
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	print "<input type=\"hidden\" name=\"action\" value=\"addbulk\">\n";
	print "</table>\n";
	print "</form>";
	print "<BR><hr><a href=\"$thispage\">Return to Character Groups</a>\n";
	print "<br><a href=\"main.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($action eq "addbulk")
{
	# add and Redirect
	local($db) = dbconnect();
	local($query) = $db->prepare("select charid from characters order by clast");
	$query->execute;
	while (@array = $query->fetchrow_array)
	{
	  local ($charid) = $array[0];
	  local ($check) = $CGI->param("check_$charid") + 0;
	  
	  if ($check == 1)
	  {
	  	$sql = "insert into charactergroupmembers (charid,$keyfield, secret) values ($charid, $keyvalue, 0);";
		$db->do($sql);
	  }
	}
	$query->finish;

	print $CGI->redirect("$thispage?action=editchars&$keyfield=$keyvalue");
}
elsif ($action eq "addaccess")
{
	# add and Redirect
	local ($charid) = $CGI->param("charid");
	$sql = "insert into charactergroupmembers (charid,$keyfield, secret) values ($charid, $keyvalue, 0);";
	#print "$sql<BR>";
	local($db) = dbconnect();
	$db->do($sql);
	$db->disconnect;
	print $CGI->redirect("$thispage?action=editchars&$keyfield=$keyvalue");
}
elsif ($action eq "remaccess")
{
	# Remove and Redirect
	local ($charid) = $CGI->param("charid");
	$sql = "delete from charactergroupmembers where charid=$charid and $keyfield=$keyvalue;";
	#print "$sql<BR>";
	local($db) = dbconnect();
	$db->do($sql);
	$db->disconnect;
	print $CGI->redirect("$thispage?action=editchars&$keyfield=$keyvalue");
}
elsif ($action eq "secret")
{
	# Update and Redirect
	#print $CGI->header;
	updatesecret();
	print $CGI->redirect("$thispage?action=editchars&$keyfield=$keyvalue");
}
elsif ($submit eq "Add")
{
	# Insert and Redirect
	$sql = filltablefromCGI($table, 1);
	#print "$sql<BR>";
	local($db) = dbconnect();
	$db->do($sql);
	$db->disconnect;
	updatesecret();
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Added"));
}
elsif ($submit eq "Change")
{
	#print $CGI->header();
	# Update and Redirect
	$sql = filltablefromCGI($table, 0);
	#print "$sql<BR>";
	local($db) = dbconnect();
	$db->do($sql);
	$db->disconnect;
	updatesecret();
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Updated"));
}
elsif ($action eq "delete")
{
	# delete and Redirect
	#print "$sql<BR>";
	local($db) = dbconnect();
	$sql = "delete from $table where $keyfield = $keyvalue;";
	$db->do($sql);
	$sql = "delete from charactergroupmembers where $keyfield = $keyvalue;";
	$db->do($sql);
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Deleted"));
}
elsif ($action eq "email")
{
	#print $CGI->header;
	local($db) = dbconnect();
	$sql = "select charid, secret from charactergroupmembers where $keyfield = $keyvalue;";
	local($query) =$db->prepare($sql);
	$query->execute;
	$tostr = "emailPlayer.pl?topid=";
	$bccstr = "";
	$numto = 0;
	$numbcc = 0;
	if ($query->rows > 0)
	{
	    local (@array);
	    while (@array = $query->fetchrow_array)
	    {
	       if ($array[1] eq "0")
	       {
	          $tostr .= getPIDFromCharID($array[0]) . " ";
	          $numto++;
	       }
	       else
	       {
	          $bccstr .= getPIDFromCharID($array[0]) . " ";
	          $numbcc++;
	       }
	    }
	    chop($tostr);
	    $tostr .= "&numpid=$numto";
	    if ($numbcc > 0)
	    {
		    chop($bccstr);
		    $tostr .= "&bccpid=$bccstr&numbcc=$numbcc";
	    }
	}	
        $query->finish;
        $db->disconnect;
	print $CGI->redirect($tostr);
}
elsif ($action eq "dump")
{
	print $CGI->header(-type  =>  'application/msword', -filename  =>  'chargroups.doc');
        #print $CGI->header;
        print "<html><head>\n";
        print "<link href=\"../brassy.css\" rel=\"stylesheet\" type=\"text/css\">\n";
        print "</head>\n";
   	local($db) = dbconnect();
	local ($sql) = "select $keyfield from $table order by $namefield;";
   	#print"$sql<BR>";
   	local ($query) = $db->prepare($sql);
   	$query->execute;
   	local (@array);
        while (@array = $query->fetchrow_array)
        {
           $keyvalue = $array[0];
	   filltable();
	   creatememberstr();
	   print "<h1>$groupname</h1>\n";
	   print "<h2>Description</h2>\n";
	   print "<p>$groupdesc</p>\n";
	   print "<h2>Members</h2>\n";
	   print "$memberstr\n";
   	   print "<BR>[pb]<BR>\n";
   	}
   	$query->finish;
   	$db->disconnect;
        print "</html>\n";
}
else
{
	print $CGI->header;
	ParseForm($header);
	
	print "<font color=red>$errstr</font><BR><BR>";
	
	print "<H1>Manage Character Groups Menu</h1>\n";

	showchargroups();

	print "<BR><a href=\"$thispage?action=new\">ADD a NEW Character Group</a>\n";
	print "<BR><a href=\"$thispage?action=dump\" target=_new>Save Character Groups as Word Document</a>\n";
	print "<br><hr><a href=\"main.pl\">Main menu</a>."; 
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=delete&$keyfield=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
	
	ParseForm($footer);
}

exit 0;

sub showchargroups()
{
	local($db) = dbconnect();
	local ($sql) = "select * from $table order by $namefield;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Group Name</b></td>\n";
	print "<td><b>Description</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   print "<tr>\n";
	   print "<td>".$resptr->{"groupname"}."</td>\n";
	   print "<td>".$resptr->{"groupdesc"}."</td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=summary&$keyfield=".$resptr->{"$keyfield"}."\">Summary</a>\n";
	   print " -- <a href=\"$thispage?action=edit&$keyfield=".$resptr->{"$keyfield"}."\">Edit</a>\n";
	   print " -- <a href=\"javascript:deleteConfirm('".$resptr->{"$namefield"}."',".$resptr->{"$keyfield"}.");\">Delete</a>\n";
	   print " -- <a href=\"$thispage?action=editchars&$keyfield=".$resptr->{"$keyfield"}."\">Edit Members</a>\n";
	   print " -- <a href=\"$thispage?action=email&$keyfield=".$resptr->{"$keyfield"}."\">Email Members</a>\n";
	   print "</td></tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub showsummary()
{
	#xblank
	@xblank = { "&nbsp;", "X" };
	$xblank[0] = "&nbsp;";
	$xblank[1] = "X";

	filltable();
	
	print "<h1>$groupname</h1>\n";

	print "<h2>Members</h2>:\n";
	
	local($db) = dbconnect();

	$sql = "select * from charactergroupmembers where $keyfield=$keyvalue";

	$query = $db->prepare($sql);
	$query->execute;
	if ($query->rows > 0)
	{
	    print "<table border=1>\n";
	    print "<tr>\n";
	    print "<td><b>Character Name</b></td>\n";
	    print "<td><b>Notes</b></td>\n";
	    print "<td><b>Secret</b></td>\n";
	    print "<td><b>Leader</b></td>\n";
	    print "<td><b>Officer</b></td>\n";
	    print "</tr>\n";
	    $num = 0;
   	    local ($resptr);
	    while ($resptr = $query->fetchrow_hashref())
	    {
	        $charid = $resptr->{"charid"};
	    	print "<tr>\n";
	    	print "<td>".getCharPlayerStr($charid)."</td>\n";
	    	print "<td>".$resptr->{"notes"}." </td>\n";
	    	print "<td align=center>".$xblank[$resptr->{"secret"}]."</td>\n";
	    	print "<td align=center>".$xblank[$resptr->{"leader"}]."</td>\n";
	    	print "<td align=center>".$xblank[$resptr->{"officer"}]."</td>\n";
	    	print "</tr>\n";
	    	$num++;
	    }
	    print "</table>\n";
	}
	$query->finish;

	print "<h2>GM Notes</h2>\n";
	
	$sql = "select distinct b.* from linknotes a join gmnotes b on a.gmnid=b.gmnid where a.linktable='charactergroups' and a.linkid=$groupid;";
	local($query) = $db->prepare($sql);
	#print "$sql<BR>\n";
	$query->execute;
	if ($query->rows > 0)
	{
		local($resptr);
		while ($resptr = $query->fetchrow_hashref())
		{
		     print shownote($resptr,'Transparent');
		}
	}
	else
	{
		print "<p>None</p>";
	}
	$query->finish;
	$db->disconnect;


	$db->disconnect;
}

sub fillvars()
{

	filltable();
	
	print "<H1>$groupname</H1>\n";

	local($db) = dbconnect();
	$memberstr = "";
	$sql = "select * from charactergroupmembers where $keyfield=$keyvalue";

	$query = $db->prepare($sql);
	$query->execute;
	if ($query->rows > 0)
	{
	    $memberstr = "<table border=1>\n";
	    $memberstr .= "<tr>\n";
	    $memberstr .= "<td><b>Character Name</b></td>\n";
	    $memberstr .= "<td><b>Notes</b></td>\n";
	    $memberstr .= "<td><b>Secret</b></td>\n";
	    $memberstr .= "<td><b>Leader</b></td>\n";
	    $memberstr .= "<td><b>Officer</b></td>\n";
	    if ($showdel > 0)
	    {
	    	$memberstr .= "<td><b>Action</b></td>\n";
	    }
	    $memberstr .= "</tr>\n";
	    $num = 0;
   	    local ($resptr);
	    while ($resptr = $query->fetchrow_hashref())
	    {
	        $charid = $resptr->{"charid"};
	    	$memberstr .= "<tr>\n";
	    	$memberstr .= "<td>".getCharPlayerStr($charid)."</td>\n";
	    	$memberstr .= "<td><textarea name=\"secret_notes_$num\" COLS=35 ROWS=2>".$resptr->{"notes"}."</textarea></td>\n";
	    	$memberstr .= "<td><input type=hidden value=$charid name=\"secret_charid_$num\">";
	    	$memberstr .= "<input type=checkbox value=1 name=\"secret_$num\" ".$ischecked[$resptr->{"secret"}]."></input></td>\n";
	    	$memberstr .= "<td><input type=hidden value=$charid name=\"leader_charid_$num\">";
	    	$memberstr .= "<input type=checkbox value=1 name=\"leader_$num\" ".$ischecked[$resptr->{"leader"}]."></input></td>\n";
	    	$memberstr .= "<td><input type=hidden value=$charid name=\"officer_charid_$num\">";
	    	$memberstr .= "<input type=checkbox value=1 name=\"officer_$num\" ".$ischecked[$resptr->{"officer"}]."></input></td>\n";
	    	if ($showdel > 0)
	    	{
		   $memberstr .= "<td><a href=\"$thisfile?action=remaccess&charid=$charid&$keyfield=$keyvalue\">Remove</a></td>\n";
		}
	    	$memberstr .= "</tr>\n";
	    	$num++;
	    }
	    $memberstr .= "</table>\n";
	    $memberstr .= "<input type=hidden value=$num name=\"secret_num\">";
	}
	$query->finish;

	$db->disconnect;
}

sub creatememberstr()
{
	local($db) = dbconnect();
	$memberstr = "";
	$sql = "select charid, secret, notes from charactergroupmembers where $keyfield=$keyvalue and secret = 0";

	local($query);
	$query = $db->prepare($sql);
	$query->execute;
	if ($query->rows > 0)
	{
	    $memberstr = "<table border=1>\n";
	    $memberstr .= "<tr>\n";
	    $memberstr .= "<td><b>Character Name</b></td>\n";
	    $memberstr .= "<td><b>Notes</b></td>\n";
	    $memberstr .= "</tr>\n";
	    $num = 0;
   	    local (@array);
	    while (@array = $query->fetchrow_array)
	    {
	    	$memberstr .= "<tr>\n";
	    	$memberstr .= "<td>".getCharName($array[0])." <i>(".getFullNameFromCharID($array[0]).")</i></td>\n";
	    	$memberstr .= "<td>$array[2]</td>\n";
	    	$memberstr .= "</tr>\n";
	    	$num++;
	    }
	    $memberstr .= "</table>\n";
	}
	$query->finish;

	$db->disconnect;
}

sub updatesecret()
{
   local($db) = dbconnect();
   $num = $CGI->param("secret_num");
   for ($k=0; $k < $num; $k++)
   {
        local ($charid) = $CGI->param("secret_charid_$k");
        local ($sval) = $CGI->param("secret_$k") + 0;
        local ($lval) = $CGI->param("leader_$k") + 0;
        local ($oval) = $CGI->param("officer_$k") + 0;
        local ($notes) = $CGI->param("secret_notes_$k");
        $notes =~ s/'/''/g;
	local ($sql) = "update charactergroupmembers set secret=$sval, leader=$lval, officer=$oval, notes='$notes' where charid=$charid and $keyfield=$keyvalue;";
	#print "$sql<BR>";  
	$db->do($sql);
   }
   $db->disconnect;
}