#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "chargroupsforchars.pl";
$table = "charactergroups";
$heading = "a Character Group";
$keyfield = "groupid";
$keyvalue = $CGI->param($keyfield);
$namefield = "groupname";
$tplfile = "chargroups.tpl";
$errstr = $CGI->param("error");
$showdel = 0;

if ($action eq "display")
{
	$sql = "select a.charid from charactergroupmembers a join playercharacters b on a.charid=b.pccharid where a.$keyfield = $keyvalue and b.pcplayerid = $pid;";
	$ismember = dosql($sql) + 0;
	if ($al < $gm_access && $ismember == 0) 
	{
		print $CGI->redirect("login.pl?error=" . encodeURL("You are not a member of that character group."));
	}
	else
	{
		fillvars();
		$doctitle = "$groupname";
		print $CGI->header();
		ParseForm($header);
		print "<h1>$groupname</h1>\n";
		print "<h2>Description</h2>\n";
		print "<p>$groupdesc</p>\n";
		print "<h2>Members</h2>\n";
		print "$memberstr\n";
		print "<BR><i>Know someone who should be added to this group?</i><BR>\n";
		print "<a href=\"mailto:$contact\">Email the GMs</a> to get them added.\n";
		print "<br><br><a href=\"$thispage\">Character Groups List</a>."; 
		print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
		ParseForm($footer);
	}
}
elsif ($action eq "email")
{
	#print $CGI->header;
	local($db) = dbconnect();
	$SQL = "select charid, secret from charactergroupmembers where $keyfield = $keyvalue;";
	local($query) =$db->prepare($SQL);
	$query->execute;
	$tostr = "emailPlayer.pl?topid=";
	$bccstr = "";
	$numto = 0;
	$numbcc = 0;
	if ($query->rows > 0)
	{
	    local (@array);
	    while (@array = $query->fetchrow_array)
	    {
	       $sql = "select a.value from chartypetraitlink a, chartypetraits b, characters c where a.ctypeid=c.chartype and a.cttid=b.cttid and b.traitname='secret' and c.charid=$array[0]";
	       $issecret = dosql($sql) + 0;
	       if ($array[1] + $issecret == 0)
	       {
	          $tostr .= getPIDFromCharID($array[0]) . " ";
	          $numto++;
	       }
	       else
	       {
	          $bccstr .= getPIDFromCharID($array[0]) . " ";
	          $numbcc++;
	       }
	    }
	    chop($tostr);
	    $tostr .= "&numpid=$numto";
	    if ($numbcc > 0)
	    {
		    chop($bccstr);
		    $tostr .= "&bccpid=$bccstr&numbcc=$numbcc";
	    }
	}	
        $query->finish;
        $db->disconnect;
	print $CGI->redirect($tostr);
}
else
{
	$doctitle = "Display Your Character Groups";
	print $CGI->header;
	ParseForm($header);
	
	print "<font color=red>$errstr</font><BR><BR>";
	
	print "<H1>Display Your Character Groups Menu</h1>\n";

	showchargroups();

	print "<BR><i>Think <b>you</b> should be in a character group not listed here?<BR>\n";
	print "<BR><a href=\"mailto:$contact\">Email the GMs</a> to get yourself added.\n";
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	ParseForm($footer);
}

exit 0;

sub showchargroups()
{
   local($db) = dbconnect();
   local ($sql) = "select pccharid from playercharacters where pcplayerid=$pid;";
   local ($query) = $db->prepare($sql);
   $query->execute;
   local (@array);
   while (@array = $query->fetchrow_array)
   {
	$charid = $array[0];
	local ($sql) = "select a.* from $table a, charactergroupmembers b where b.charid=$charid and a.groupid=b.groupid order by $namefield;";
	#print "$sql<BR>";  
	local ($query2) = $db->prepare($sql);
	$query2->execute;
	print "<h2>Groups for ".getCharName($charid)."</h2>\n";
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Group Name</b></td>\n";
	print "<td><b>Description</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query2->fetchrow_hashref())
	{
	   print "<tr>\n";
	   print "<td>".$resptr->{"groupname"}."</td>\n";
	   print "<td>".$resptr->{"groupdesc"}."</td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=display&$keyfield=".$resptr->{"$keyfield"}."\">Display</a>\n";
	   print " -- <a href=\"$thispage?action=email&$keyfield=".$resptr->{"$keyfield"}."\">Email Members</a>\n";
	   print "</td></tr>\n";
	}
	print "</table>\n";
   }
   $query->finish;
   $db->disconnect;
}

sub fillvars()
{
	filltable();

	local($db) = dbconnect();
	$memberstr = "";
	$sql = "select charid, secret, notes from charactergroupmembers where $keyfield=$keyvalue";

	$query = $db->prepare($sql);
	$query->execute;
	if ($query->rows > 0)
	{
	    $memberstr = "<table border=1>\n";
	    $memberstr .= "<tr>\n";
	    $memberstr .= "<td><b>Character Name</b></td>\n";
	    $memberstr .= "<td><b>Player Name</b></td>\n";
	    $memberstr .= "<td><b>Notes</b></td>\n";
	    local (@array);
	    while (@array = $query->fetchrow_array)
	    {
	      $sql = "select a.value from chartypetraitlink a, chartypetraits b, characters c where a.ctypeid=c.chartype and a.cttid=b.cttid and b.traitname='secret' and c.charid=$array[0]";
	      $issecret = dosql($sql) + 0;
	      if ($array[1] + $issecret == 0)
	      {
	    	$memberstr .= "<tr>\n";
	    	$memberstr .= "<td>".getCharName($array[0])."</td>";
	    	$memberstr .= "<td>".getFullNameFromCharID($array[0])."</td>\n";
	    	$memberstr .= "<td>$array[2]";
	    	if ($groupname eq "Parliament") # Parliament
	    	{
	    	  $val = dosql("select votes from district_votes where charid=$array[0];") + 0;
	    	  $memberstr .= " -- $val District Votes";
	    	}
	    	$memberstr .= "</td>\n";
	    	$memberstr .= "</tr>\n";
	      }
	    }
	    $memberstr .= "</table>\n";
	}
	$query->finish;

	$db->disconnect;
}


