#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "charquest.pl";  	#Name of this web page
$table = "charquest2";  		#table you're editing
$heading = "Character Questionnaire";		#textual description, for example, "A parsnip"
$keyfield = "cqid";	#name of the primary key field of the table.
$keyvalue = $CGI->param($keyfield);	
$errstr = $CGI->param("error");
$charid = $CGI->param("charid") + 0;
$charname = getCharName($charid);

@cqmtypes = ( 'text','textarea','select','checkbox', 'static text' );
$cqmtext = 0;
$cqmtextarea = 1;
$cqmselect = 2;
$cqmcheckbox = 3;
$cqmstatic = 4;

if ($submit eq "Done")
{
	# Update and Redirect
	#print $CGI->header();
	dosql("delete from $table where cqcharid = $charid;");
	local($db) = dbconnect();
	local ($sql) = "select * from cqmeta order by cqmid;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())
	{
	   $key = $resptr->{"cqmid"};
	   $val = $CGI->param($key);
	   #print "$key is $val<BR>\n";
	   $val =~  s/'/''/g;
	   $sql = "insert into $table (cqcharid,cqmid,cqdata) values ($charid,$key,'$val');";
	   dosql($sql);
	}
	
	$query->finish;
	$db->disconnect;

	print $CGI->redirect("characters.pl?error=" . encodeURL("$charname: $heading Updated"));
}
else
{
	print $CGI->header();
        $doctitle = "$charname: Edit $heading";
	ParseForm($header);
     	print "<H1>$doctitle</H1>\n";
	print "<form action=\"$thispage\" method=\"post\">\n";
	fillvars();
	showdata();
	print "<input type=\"hidden\" name=\"charid\" value=\"$charid\">\n";
	print "<input type=\"submit\" name=\"submit\" value=\"Done\"><BR>";
	print "</form>";
	print "<br><hr><a href=\"$thispage\">Return/Cancel</a>.";
	print "<br><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}

exit 0;

sub showdata()
{
	local($db) = dbconnect();
	local ($sql) = "select * from cqmeta order by cqmorder;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"cqmname"};
	   $key = $resptr->{"cqmid"};
	   $type = $resptr->{"cqmtype"} + 0;
	   $val = dosql("select cqdata from $table where cqcharid = $charid and cqmid = $key");
	   if ($val eq "0")
	   {
	   	$val = "";
	   }

	   print "<h3>$name</h3>\n";
	   
	   if ($type == $cqmtextarea) # textara
	   {
	   	print "<textarea name=\"$key\" cols=60 rows=7>\n";
	   	print $val;
	   	print "</textarea><BR>\n";
	   }
	   elsif ($type == $cqmselect) # select
	   {
	   	local @array = split(/,/,$resptr->{"cqmdata"});
	   	print makeArrayDropDown(*array,"$key",$val);
	   }
	   elsif ($type == $cqmstatic) # static
	   {
	   	print $resptr->{"cqmdata"}."\n";
	   }
	   else
	   {
		print "<input type=\"".$cqmtypes[$type]."\" name=\"$key\"";

		if ($type == $cqmtext) # text
		{
		   print " value=\"$val\" size=\"".$resptr->{"cqmdata"}."\"";
		}
		elsif ($type == $cqmcheckbox) # text
		{
		   print " value=\"1\" ".$ischecked[$val+0];
		}

		print "></input><BR>\n";
	   }
	   print "<p>".$resptr->{"cqmnotes"}."</p>\n";
	}
	$query->finish;
	$db->disconnect;
}

sub fillvars()
{
	filltable();
}

