#!perl

require 'gameheader.pl';

#use Mail::POP3Client;

srand(time ^ $$);

# ***************************************************************************************
# * SUBROUTINE SECTION * All subroutines for the cgi-bin should be found in this script *
# ********************** for ease of debugging and code-reuse. This page should be      *
# * included in every other page using the statement 'require "common.pl";'             *
# * so that all the subroutines and global variables are available to that page.        *
# * Note that if you write other libraries, this one should be last in the main file.   *
# ***************************************************************************************

# *************
# * ParseForm *
# *************
# * ParseForm will read in an HTML template file, expand all Perl variables contained
# * within it, and print the resulting HTML to STDOUT.
sub ParseForm 
{
     open (TEMPLATE, $_[0]) || return;
     binmode (TEMPLATE) if $_[1];  # Prevents it from stopping on an embedded EOF char

     while (<TEMPLATE>)            # process one line at a time
     {
      s/"/\\"/g;               # convert " to \", so that double quotes will be
                   # treated properly in the next line

      print eval qq/"$_"/;     # expand Perl variables and print the resulting line
     }
     close (TEMPLATE);
}

# *************
# * dbconnect *
# *************
# * dbconnect returns a database connection
# * to the vialarp_signals database
sub dbconnect()
{
local($db) = DBI->connect("$whichDBI:$database:$hostname", $username, $password, {
      PrintError => 1,   ### Do report errors via warn(  )
      RaiseError => 0    ### Don't report errors via die(  )
});
return $db;
}

# ***************
# * getPlayerID *
# ***************
# * getPlayerID returns the player ID of
# * a player who has logged into login.pl
sub getPlayerID()
{
%cookieset = fetch CGI::Cookie;
$cookie = $cookieset{$cookiename};
   local (@array);
@array = split(/;/,$cookie);
@array = split(/=/,$array[0]);
if ($array[1] eq "")
{
    return "";
}
local($db) = dbconnect();
local($query) =$db->prepare("Select liplayerid from loggedin where licookie = '" . $array[1] . "'");
$query->execute;
@array = $query->fetchrow_array;
$query->finish;
$db->disconnect;
    if ($query->rows > 0)
    {
        $query->finish;
        $db->disconnect;
        return $array[0];
    }
    else
    {
        $query->finish;
        $db->disconnect;
        return "";
    }
}

# *****************
# * checkPassword *
# *****************
# * checkPassword checks that a playerid and password
# * combination that is passed to it are correct
sub checkPassword()
{
($id, $pass) = @_;
local($db) = dbconnect();
local($query) =$db->prepare("Select playerid from players where playerid = " . $id . " and ppassword='" . $pass .  "'");
$query->execute;
   local (@array);
@array = $query->fetchrow_array; 
    if ($query->rows > 0)
    {
        $query->finish;
        $db->disconnect;
        return 1;
    }
    else
    {
        $query->finish;
        $db->disconnect;
        return 0;
    }
}

# ***************
# * getPassword *
# ***************
# * getPassword returns the password for the 
# * playerid that is passed into it.
sub getPassword
{
($id) = $_[0];
local($db) = dbconnect();
local($query) =$db->prepare("Select ppassword from players where playerid = " . $id);
$query->execute;
   local (@array);
@array = $query->fetchrow_array; 
    if ($query->rows > 0)
    {
        $query->finish;
        $db->disconnect;
        return $array[0];
    }
    else
    {
        $query->finish;
        $db->disconnect;
        return "";
    }
}


# ********************
# * getCharPlayerStr *
# ********************
# * getCharPlayerStr returns the character and player
# * when passed a characterid
sub getCharPlayerStr()
{
   local($varID) = $_[0];
   local($retVal) = "";
   if (getAccessLevel($pid) >= $plotlevel)
   {
       $retVal .= "<a href=\"characters.pl?action=edit&charid=$varID\" target=_new>";
   }
   $retVal .= getCharName($varID);
   if (getAccessLevel($pid) >= $plotlevel)
   {
   	$retVal .= "</a>";
   }
   $retVal .= " <i>(";
   $retVal .= emailTagFromID(getPIDFromCharID($varID));
   $retVal .= ")</i>";

   return $retVal;
}


# ******************
# * getEmailFromID *
# ******************
# * getEmailFromID returns a person's email address
# * when passed a playerid
sub getEmailFromID()
{
$varID = $_[0];
if ($varID eq "")
{
return "";
}
local($db) = dbconnect();
local($query) =$db->prepare("select pemail from players where playerid = " . $varID);
$query->execute;
   local (@array);
@array = $query->fetchrow_array;;
    if ($query->rows > 0)
    {
        $query->finish;
        $db->disconnect;
        return $array[0];
    }
    else
    {
        $query->finish;
        $db->disconnect;
        return "";
    }
}

# *****************
# * getUserFromID *
# *****************
# * getUserFromID returns a person's user name
# * when passed a playerid
sub getUserFromID()
{
$varID = $_[0];
if ($varID eq "")
{
return "";
}
local($db) = dbconnect();
local($query) =$db->prepare("select plogin from players where playerid = " . $varID);
$query->execute;
   local (@array);
@array = $query->fetchrow_array;;
    if ($query->rows > 0)
    {
        $query->finish;
        $db->disconnect;
        return $array[0];
    }
    else
    {
        $query->finish;
        $db->disconnect;
        return "";
    }
}


# ******************
# * emailTagFromID *
# ******************
# * emailTagFromID returns 
# * an email tag statement
# * when passed a player id
sub emailTagFromID()
{
local($varID) = $_[0];
if ($varID eq "")
{
return "";
}
local($fn) = getFullNameFromID($varID);
return "<a href=\"emailPlayer.pl?topid=$varID\" title=\"E-mail $fn\">$fn</a>";
}


# *********************
# * getFullNameFromID *
# *********************
# * getFullNameFromID returns 
# * a person's first and last name
# * when passed a playerid
sub getFullNameFromID()
{
$varID = $_[0];
if ($varID eq "")
{
return "";
}
local($db) = dbconnect();
local($query) =$db->prepare("select concat(pfirst, ' ', plast) from players where playerid = " . $varID);
$query->execute;
   local (@array);
@array = $query->fetchrow_array;;
    if ($query->rows > 0)
    {
        $query->finish;
        $db->disconnect;
        return $array[0];
    }
    else
    {
        $query->finish;
        $db->disconnect;
        return "";
    }
}

# *************************
# * getFullNameFromCharID *
# *************************
# * getFullNameFromID returns 
# * a person's first and last name
# * when passed a character id
sub getFullNameFromCharID()
{
   local($varID) = $_[0];
   if ($varID eq "")
   {
	return "";
   }
   local($db) = dbconnect();
   local ($sql) = "select concat(a.pfirst, ' ', a.plast), c.chartype from players a, playercharacters b, characters c where b.pccharid='$varID' and a.playerid=b.pcplayerid and c.charid='$varID';";
   #print $sql;
   local($retStr) = "TBD";
   local($query) =$db->prepare($sql);
   $query->execute;
   local (@array);
   @array = $query->fetchrow_array;
   if ($query->rows > 0 && ($array[1] != 5 || getAccessLevel($pid) >= $writer_access)) #not an alias
   {
        $retStr = $array[0];
   }
   $query->finish;
   $db->disconnect;
   return $retStr;
}

# *************************
# * getCharTypeFromCharID *
# *************************
sub getCharTypeFromCharID()
{
local($varID) = $_[0];
if ($varID eq "")
{
return "";
}
local($db) = dbconnect();
local ($sql) = "select b.ctypedesc from characters a, chartypes b where a.charid=$varID and a.chartype=b.ctypeid";
#print $sql;
local($query) =$db->prepare($sql);
$query->execute;
local (@array);
@array = $query->fetchrow_array;
    if ($query->rows > 0)
    {
        $query->finish;
        $db->disconnect;
        return $array[0];
    }
    else
    {
        $query->finish;
        $db->disconnect;
        return "";
    }
}


# ********************
# * getPIDFromCharID *
# ********************
# * getPIDFromCharID returns 
# * a player ID
# * when passed a character id
sub getPIDFromCharID()
{
local($varID) = $_[0];
if ($varID eq "")
{
return "";
}
local($db) = dbconnect();
local ($sql) = "select pcplayerid from playercharacters where pccharid=$varID;";
#print $sql;
local($query) =$db->prepare($sql);
$query->execute;
    if ($query->rows > 0)
    {
	local (@array);
	@array = $query->fetchrow_array;
        $query->finish;
        $db->disconnect;
        return $array[0];
    }
    else
    {
        $query->finish;
        $db->disconnect;
        return "";
    }
}

# ***************
# * getCharName *
# ***************
# * getCharName returns 
# * a character's first and last name
# * when passed an id
sub getCharName()
{
$varID = $_[0];
if ($varID eq "")
{
   return "";
}

   local ($cnf) = $charnameformat;
   $cnf =~ s/\$varID/$varID/g;
   return dosql($cnf);
}

# *******************
# * getPIDFromEmail *
# *******************
# * getPIDFromEmail returns the playerid that matches
# * an email address that is passed in
sub getPIDFromEmail()
{
$varEmail = $_[0];
if ($varEmail eq "")
{
return "";
}
local($db) = dbconnect();
local($query) =$db->prepare("select playerid from players where pemail = '" . $varEmail . "'");
$query->execute;
   local (@array);
@array = $query->fetchrow_array;;
    if ($query->rows > 0)
    {
        $query->finish;
        $db->disconnect;
        return $array[0];
    }
    else
    {
        $query->finish;
        $db->disconnect;
        return "";
    }
}

# *******************
# * getPIDFromLogin *
# *******************
# * getPIDFromLogin returns the playerid that matches
# * a Login ID that is passed in
sub getPIDFromLogin()
{
$varLogin = $_[0];
if ($varLogin eq "")
{
return "";
}
local($db) = dbconnect();
local($query) =$db->prepare("select playerid from players where plogin = '$varLogin'");
$query->execute;
   local (@array);
@array = $query->fetchrow_array;
    if ($query->rows > 0)
    {
        $query->finish;
        $db->disconnect;
        return $array[0];
    }
    else
    {
        $query->finish;
        $db->disconnect;
        return "";
    }
}

# ***********
# * doLogin *
# ***********
# * doLogin updates the loggedin table - storing the playerid
# * and the matching session cookie
sub doLogin()
{
($ck, $pid) = @_;
local($db) = dbconnect();
$db->do("delete from loggedin where liplayerid = $pid;");
$db->do("insert into loggedin (liplayerid, licookie, lidate) values ($pid,'$ck', now());");
$db->disconnect;
}

# ******************
# * getAccessLevel *
# ******************
# * getAccessLevel returns the security access level 
# * for a player whose playerid is passed to it.
sub getAccessLevel()
{
$plid = $_[0];
if ($plid eq "")
{
return 0;
}
local($db) = dbconnect();
local($query) =$db->prepare("select psecurity from players where playerid = " . $plid );
$query->execute;
local (@array);
@array = $query->fetchrow_array;
    if ($query->rows > 0)
    {
        $query->finish;
        $db->disconnect;
        return $array[0];
    }
    else
    {
        $query->finish;
        $db->disconnect;
        return 0;
    }
}

# ***************
# * loginToMail *
# ***************
# * loginToMail just logs into the mail server using the
# * Mail::Pop3Client module.
sub loginToMail
{

  $pop = new Mail::POP3Client( HOST  => "mail.1948-signals.org" );
  $pop->User( "daiopowe" );
  $pop->Pass( "chandlr8" );
  $pop->Connect() >= 0 || print $CGI->header() . "POP3 Error! - " . $pop->Message();
  $pop->Close();
}

# ***********
# * getMail *
# ***********
# * getMail does the same thing as loginToMail, but
# * prints out the headers of any messages in the box.
sub getMail
{
$pop = new Mail::POP3Client( HOST  => "mail.1948-signals.org" );
  $pop->User( "daiopowe" );
  $pop->Pass( "chandlr8" );
  $pop->Connect() >= 0 || print $CGI->header() . "POP3 Error! - " . $pop->Message();
  print $CGI->header();
    for( my $i = 1; $i <= $pop->Count(); $i++ ) {
        foreach( $pop->Head( $i ) ) {
            /^(From|Subject):\s+/i && print $_, "\n";
        }
    }
    $pop->Close();
}

# ************
# * getMoney *
# ************
sub getMoney
{
	local($charid) = $_[0];
	return dosql("select sum(pounds) from money where charid=$charid;");
}


# ***********************
# * checkDuplicateLogin *
# ***********************
# * checkDuplicateLogin checks to see if the login
# * ID passed in is already in the database. If so, it returns 1.
sub checkDuplicateLogin
{
$login = $_[0];
local($db) = dbconnect();
local($query) =$db->prepare("Select plogin from players where plogin = '$login'");
$query->execute;
    if ($query->rows > 0)
    {
    $query->finish;
    $db->disconnect();
    return 1;
    }
    else
    {
    $query->finish;
    $db->disconnect();
    return 0;
    }
}

# *************
# * encodeURL *
# *************
# * encodeURL takes the string passed in and escapes all the characters
# * to work in the URL string of a web browser.
sub encodeURL
{
$string = $_[0];
$string =~s/([^a-zA-Z0-9_\-.])/uc sprintf("%%%02x",ord($1))/eg;
return $string;
}

# ****************
# * makeDropDown *
# ****************
# * makeDropDown takes three input parameters - table name, value field, and display field
# * and formats them into an HTML select named after the value field.
sub makeDropDown
{
local($table, $field1, $field2, $condition, $size, $value) = @_;
local ($db) = dbconnect();
$SQL = "select $field1, $field2 from $table";

#Check for condition
    if ($condition ne "")
    {
    $SQL .= " where $condition";
    }
    
local($query) = $db->prepare($SQL);
#print $CGI->header();
#print "$SQL<BR>[$value]<BR>";
$query->execute;

#Check to make sure $query is not empty
    if ($query->rows > 0)
    {
    $retVal = "<select name=\"$field1\"$size>\n";
   local (@array);
        while (@array = $query->fetchrow_array)
        {
        if ("$array[0]" eq "$value")
            {
            $retVal .= "<option value=\"$array[0]\" SELECTED>$array[1]</option>\n";
            }
        else
            {
            $retVal .= "<option value=\"$array[0]\">$array[1]</option>\n";
            }
        }
    $retVal .= "</select>\n";
    $query->finish;
    $db->disconnect;
    return $retVal;
    }
$query->finish;
$db->disconnect;
return "";
}

# ****************
# * makeArrayDropDown *
# ****************
# * makeArrayDropDown formats an array into a dropdown select list. It takes four params,
# * the list reference, a name for the dropdown, a reference tolist of selected values,
# * and a size.statement
sub makeArrayDropDown
{
local($listref, $name, $selref, $size, $shownum) = @_;
@list = @$listref;
@selected = @$selref;
$imax = @list;
$jmax = @selected;
$shownum += 0;
    if (@selected > 1)
    {
    $retVal = "<select MULTIPLE name=\"$name$size\">\n";
    }
    else
    {
    $retVal = "<select name=\"$name$size\">\n";
    }
    for ($i=0; $i<$imax; $i++)
    {
        if ("$list[$i]" ne "")
        {
		$tf = 0;
		for ($j=0; $j<$jmax; $j++)
		{
		    if (($list[$i] eq $selected[$j]) && ($selected[$j] ne ""))
			{
			$tf = 1;
			}
		}
		$retVal .= "<option ";
		if ($shownum > 0)
		{
		   $retVal .= "value=\"$i\" ";
		}
		if ($tf == 1)
		{
		    $retVal .= "SELECTED >$list[$i]</option>\n";
		    $tf = 0;
		}
		else
		{
		    $retVal .= ">$list[$i]</option>\n";
		}
	}
    }
    $retVal .= "</select>\n";
return $retVal;
}

# *******************
# * makeMultipleBox *
# *******************
# * makeMultipleBox makes a multiple selection box.
# * table - the table to select from.
# * value - the field to make the value of the row.
# * text - the field to make the text of the row.
# * condition - a condition for the table.
# * selected - the values that are selected.
sub makeMultipleBox
{
local($table, $value, $text, $condition, @selected) = @_;
local ($db) = dbconnect();
local ($sql) = "select $value, $text from $table";

if ($condition ne "")
{
    $sql .= " where $condition";
}
$sql .= " order by $text";
    
local($query) = $db->prepare($sql);
local ($valstr) = " @selected ";
#print $CGI->header();
#print "$sql<BR>[$condition]<BR>";
$query->execute;

if ($query->rows > 0)
{
    $retVal = "<select name=\"$value\" MULTIPLE size=15>\n";
    local (@array);
    while (@array = $query->fetchrow_array)
    {
        $selstr  = "";
        if ($valstr =~ m/ $array[0] /)
        {
           $selstr  = "SELECTED";
        }

        $retVal .= "<option value=\"$array[0]\" $selstr>$array[1]</option>\n";
    }
    $retVal .= "</select>\n";
}
$query->finish;
$db->disconnect;
return $retVal;
}


# ******************
# * makeGMDropDown *
# ******************
# * makeGMDropDown prints a scrolling list box, listing all the available GMs
sub makeGMDropDown
{
local($db) = dbconnect();
$SQL = "select playerid, concat(pfirst, ' ', plast) from players where psecurity >= $gm_access order by plast";
$query =$db->prepare($SQL);
$query->execute;
$iIndex = 0;
$sel = "";
#Check to make sure $query is not empty
    if ($query->rows > 0)
    {
    $retVal = "<select name=\"gmid\" MULTIPLE>\n";
   local (@array);
        while (@array = $query->fetchrow_array)
        {
            $sel = "";
        $retVal .= "<option value=\"$array[0]\"$sel>$array[1]</option>\n";
        }
    $retVal .= "</select>\n";
    $query->finish;
    $db->disconnect;
    return $retVal;
    }
$query->finish;
$db->disconnect;
return "";
}

# **********************
# * makeTablesDropDown *
# **********************
# * makeTablesDropDown prints a scrolling list box, listing all the available 
# * tables in the database
sub makeTablesDropDown()
{
    local($al) = $_[0];
    local($SQL) = "show tables";
    local($db) = dbconnect();
    local($query) =$db->prepare($SQL);
    if ($al >= 3)
    {
    $query->execute;

    #Check to make sure $query is not empty
        if ($query->rows > 0)
        {
        $retVal = "<select name=\"table\">\n";
            while ($strTable = $query->fetchrow_array)
            {
             if ($strTable ne "loggedin")
             {
              $retVal .= "<option>$strTable</option>\n";
             }
            }
        $retVal .= "</select>\n";
        $query->finish;
        $db->disconnect;
        return $retVal;
        }
    $query->finish;
    $db->disconnect;
    } 
    else
    {
    $query->finish;
    $db->disconnect;
    return "";
    }
}

# **************
# * sendDBMail *
# **************
# * sendDBMail takes an email address, subject, and message, and formats
# * an email, sending it out using sendmail.
sub sendDBMail
{
	local($email, $subject, $message) = @_;
	open(SENDMAIL, "|/usr/sbin/sendmail -oi -t") || print $CGI->redirect("login.pl?error=" . encodeURL("Can't fork for sendmail: $!\n"));
	print SENDMAIL "From: \"$campaign Database\" <$contact>\n";
	print SENDMAIL "Subject: $subject\n";
	print SENDMAIL "To: <$email>\n";
	print SENDMAIL "$message\n";

	close(SENDMAIL) || print $CGI->redirect("login.pl?error=" . encodeURL("sendmail didn't close nicely"));
}

# ***************
# * getBitField *
# ***************
# * getBitField returns " CHECKED" if passed a 1, otherwise,
# * it will return a blank string.
sub getBitField
{
local($bit) = $_[0];
if ($bit == 1)
{
    return " CHECKED";
}
else
{
    return "";
}
}

# **********
# * getBit *
# **********
# * getBit returns 1 if passed "on" or 0 otherwise.
sub getBit
{
local($bit) = $_[0];
    if ($bit eq "on")
    {
        return 1;
    }
    else
    {
        return 0;
    }
}

# *****************
# * GetDate    *
# *****************
sub getDate {

   my @days = ('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');
   my @months = ('January','February','March','April','May','June','July',
	      'August','September','October','November','December');
   my $days;
   my $months;

   my ($sec,$min,$hour,$mday,$mon,$year,$wday) = localtime();
   return sprintf ("%s, %s, %d, %d at %02d:%02d:%02d",
                    $days[$wday],
                    $months[$mon],
                    $mday,
                    $year + 1900,
                    $hour,
                    $min,
                    $sec);
}

# *****************
# * GetDBDate    *
# *****************
sub getDBDate {

   my $days;
   my $months;

   my ($sec,$min,$hour,$mday,$mon,$year,$wday) = localtime();
   return sprintf ("%d-%d-%d",
                    $year + 1900,
                    $mon+1,
                    $mday);
}

# *****************
# * FormatDate    *
# *****************
sub myFormatDate()
{
 local($dstr) = $_[0];
 #year-month-day
 local @months = ('January','February','March','April','May','June','July','August','September','October','November','December');
 local $months;
 
 $dstr =~ s/ /-/g;
 my ($yr, $mn, $day) = split '-', $dstr;
 
 return "$months[$mn-1] $day, $yr";
}

# *******
# * min *
# *******
# * min returns the lower of the parameters.
sub min
{
if ($_[0] < $_[1])
{
   return ($_[0]);
}
return ($_[1]);
}

# *******
# * max *
# *******
# * max returns the higher of the parameters.
sub max
{
if ($_[0] > $_[1])
{
   return ($_[0]);
}
return ($_[1]);
}

# *******
# * d11 *
# *******
# * d11 returns a d11 rolled x times.
sub d11
{
 local($num) = $_[0];
 local($ret) = 0;
 local($i) = 0;
 for ($i=0;$i<$num;$i++)
 {
   $ret += int(rand(11));
 }
 return $ret;
}

# *************
# * filltable *
# *************
# * filltable fills a table with variables named to the table fields.
# * it assumes the existance of global variables, table, keyfield, and keyvalue
sub filltable()
{
	goodfilltable($table, $keyfield, $keyvalue);
}


# *****************
# * goodfilltable *
# *****************
# * goodfilltable fills a table with variables named to the table fields.
sub goodfilltable()
{
	local ($table) = $_[0];
	local ($keyfield) = $_[1];
	local ($keyvalue) = $_[2];
	local($db) = dbconnect();
	local($tab) = $db->prepare("explain $table");
	$tab->execute;
	local($i) = 0;
	local (@arrtemp);
	while (@arrtemp = $tab->fetchrow_array)
	{
	  $arr[$i] = $arrtemp[0];
	  $arrTypes[$i] = $arrtemp[1];
	  #print "$arr[$i] - $arrTypes[$i]<br>\n";
	  $i++;
	}
	$numFields = $i;
	$tab->finish;
	local($sql) = "select * from $table where $keyfield = $keyvalue";
	#print "$sql<BR>\n";
	local($query) = $db->prepare($sql);
	$query->execute;
	local (@cqquery);
	@cqquery = $query->fetchrow_array;
	for ($i=0;$i<$tab->rows;$i++)
	{
	$cqquery[$i] =~ s/'/\\'/g;
	$cqquery[$i] =~ s/"/\"/g;
	#print "\$$arr[$i] = $cqquery[$i]<br>\n";
	    if ($arrTypes[$i] eq 'tinyint(1)')
	    {
		if ($cqquery[$i] > 0)
		{
		    eval("\$$arr[$i] = 'CHECKED'");
		}
		else
		{
		    eval("\$$arr[$i] = ''");
		}
	    }
	    else
	    {
		eval("\$$arr[$i] = '$cqquery[$i]'");
	    }
	}
	$query->finish;
}


# ********************
# * filltablefromCGI *
# ********************
# * filltable fills a table with variables named to the table fields.
# * instead of grabbing that information from the database, it grabs it from the CGI.
# * It also builds an sql statement for that table 0 = update; 1 = insert.
# * If an update, it assumes the global variables, keyfield and keyvalue.
sub filltablefromCGI()
{
	local ($mytab) = $_[0];
	local ($mykeyfield) = $_[2];
	local ($mykeyvalue) = $_[3];
	if ("$mykeyfield" eq "")
	{
		$mykeyfield = $keyfield;
	}
	if ("$mykeyvalue" eq "")
	{
		$mykeyvalue = $keyvalue;
	}
	local($db) = dbconnect();
	local($tab) = $db->prepare("explain $mytab");
	$tab->execute;
	local ($val);
	local (@arrtemp);
	local ($myarr);
	local ($sql1) = "insert into $mytab (";
	local ($sql2) = ") values (";
	local ($sql3) = "update $mytab set ";
	while (@arrtemp = $tab->fetchrow_array)
	{
	  $val = $CGI->param($arrtemp[0]);
	  $val =~ s/'/''/g;
	  $sql1 .= "$arrtemp[0]" . ", ";
	  $sql2 .= "'"."$val" . "', ";
	  $sql3 .= "$arrtemp[0] = '$val', ";
	}
	$tab->finish;
	chop $sql1;
	chop $sql1;
	chop $sql2;
	chop $sql2;
	chop $sql3;
	chop $sql3;
	$sql1 .= $sql2 . ");";
	$sql3 .= " where $mykeyfield = $mykeyvalue;";
	if ("$_[1]" eq "0")
	{
	  $sql1 = $sql3;
	}	
	return $sql1; 
}

# *******************************************
# * Fills the traits for the character type *
# *******************************************
sub filltraits()
{
	local($ctypeid) = $_[0];
	local($db) = dbconnect();
	local ($sql) = "select a.traitname, b.value from chartypetraits a join chartypetraitlink b on a.cttid=b.cttid where b.ctypeid=$ctypeid;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	local (@cqquery);
	while (@cqquery = $query->fetchrow_array)
	{
		eval("\$$cqquery[0] = '$cqquery[1]'");
		#print ("\$$cqquery[0] = '$cqquery[1]'<BR>\n");
	}
	$query->finish;
	$db->disconnect;

}

# *****************************************************
# * Returns the default string for the web page given *
# *****************************************************
sub fetchline()
{
	local($page) = $_[0];
	local($varID) = $_[1];
	local($retVal) = "";
	local($num) = dosql("select count(defstring) from pagedefaults where playerid=$varID and pageid='$page';") + 0;
	if ($num > 0)
	{
	    $retVal = dosql("select defstring from pagedefaults where playerid=$varID and pageid='$page';");
	}
	return $retVal;
}

# ******************************************
# * Sets the TabNum for the Web Page Given *
# ******************************************
sub setTabNum()
{
	local($page) = $_[0];
	local($plid) = $_[1];
	local($tabnum) = $_[2];
	local($num) = dosql("select count(pdid) from pagedefaults where playerid=$plid and pageid='$page';") + 0;
	if ($num > 0) #update
	{
	    dosql("update pagedefaults set tabnum=$tabnum where playerid=$plid and pageid='$page';");
	}
	else #insert
	{
	    local($sql) = "insert into pagedefaults (playerid, pageid, tabnum) values ($plid,'$page',$tabnum);";
	    dosql($sql);
	}
}


# *******************************************
# * Returns a variable froman sql statement *
# *******************************************
sub dosql()
{
	local ($sql) = $_[0];
	local ($retval) = 0;
	local($db) = dbconnect();
	#print"$sql<BR>";
	local ($query) = $db->prepare($sql);
	$query->execute;
	if ($query->rows > 0)
	{
  	   local(@array);
           @array = $query->fetchrow_array;
	   $retval = $array[0];
	}
	$query->finish;
	$db->disconnect;
	return $retval;
}

# ***************
# * Return True *
# ***************
# * A Perl Library must always return a true value,
# * or it doesn't compile in the require statement.
1;b