#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "cqmeta.pl";  	#Name of this web page
$table = "cqmeta";  		#table you're editing
$heading = "Character Questionnaire Element";		#textual description, for example, "A parsnip"
$keyfield = "cqmid";	#name of the primary key field of the table.
$keyvalue = $CGI->param($keyfield);	
$namefield = "cqmname";	#the name of the name field for the table.
$namevalue = dosql("select $namefield from $table where $keyfield=$keyvalue;");
$tplfile = "cqmeta.tpl";	#File to make specfic editing look good.
$errstr = $CGI->param("error");

@cqmtypes = ( 'text','textarea','select','checkbox', 'static text' );
$cqmtext = 0;
$cqmtextarea = 1;
$cqmselect = 2;
$cqmcheckbox = 3;

if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to edit $heading(s)!"));
}
elsif ($action eq "new" || $action eq "edit")
{
	print $CGI->header();
	if ($keyvalue eq "")
	{
		$doctitle = "Add $heading";
	}
	else
	{
        	$doctitle = "Edit $namevalue";
	}
	ParseForm($header);
     	print "<H1>$doctitle</H1>\n";
	print "<form action=\"$thispage\" method=\"post\">\n";
	fillvars();
	ParseForm($tplfile);
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>";
	}
	else
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>";
	}
	print "</form>";
	print "<br><hr><a href=\"$thispage\">Return/Cancel</a>.";
	print "<br><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($submit eq "Add")
{
	# Insert and Redirect
	$sql = filltablefromCGI($table, 1);
	#print "$sql<BR>";
	local($db) = dbconnect();
	$db->do($sql);
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Added"));
}
elsif ($submit eq "Change")
{
	#print $CGI->header();
	# Update and Redirect
	$sql = filltablefromCGI($table, 0);
	#print "$sql<BR>";
	local($db) = dbconnect();
	$db->do($sql);
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$namevalue Updated"));
}
elsif ($action eq "delete")
{
	#print $CGI->header();
	# delete and Redirect
	$SQL = "select cqmorder from $table where $keyfield = $keyvalue;";
	#print "$SQL<BR>";
	$cqmorder = dosql($SQL);
	local($db) = dbconnect();
	$SQL = "delete from $table where $keyfield = $keyvalue;";
	$db->do($SQL);
	$SQL = "update $table set cqmorder = (cqmorder-1) where cqmorder>$cqmorder;";
	#print "$SQL<BR>";
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$namevalue Deleted"));
}
elsif ($action eq "up")
{
	#print $CGI->header();
	$cqmorder = dosql("select cqmorder from $table where $keyfield=$keyvalue;");
	if ($cqmorder > 1)
	{
		local($db) = dbconnect();
		$SQL = "update $table set cqmorder = (cqmorder+1) where cqmorder=".($cqmorder-1).";";
		#print "$SQL<BR>";
		$db->do($SQL);
		$SQL = "update $table set cqmorder = (cqmorder-1) where $keyfield=$keyvalue;";
		#print "$SQL<BR>";
		$db->do($SQL);
		$db->disconnect;
	}
	print $CGI->redirect("$thispage?error=" . encodeURL("$namevalue moved"));
}
elsif ($action eq "down")
{
	#print $CGI->header();
	$max = dosql("select max(cqmorder) from $table;");
	$cqmorder = dosql("select cqmorder from $table where $keyfield=$keyvalue;");
	if ($cqmorder < $max)
	{
		local($db) = dbconnect();
		$SQL = "update $table set cqmorder = (cqmorder-1) where cqmorder=".($cqmorder+1).";";
		#print "$SQL<BR>";
		$db->do($SQL);
		$SQL = "update $table set cqmorder = (cqmorder+1) where $keyfield=$keyvalue;";
		#print "$SQL<BR>";
		$db->do($SQL);
		$db->disconnect;
	}
	print $CGI->redirect("$thispage?error=" . encodeURL("$namevalue moved"));
}
else
{
	print $CGI->header;
	$doctitle = "Manage ".$heading."s";
	ParseForm($header);
	
	if ("$errstr" ne "")
	{
	   print "<font color=red>$errstr</font><BR><BR>\n";
	}
	
	print "<H1>$doctitle </h1>\n";

	print "<a href=\"$thispage?action=new\">ADD a NEW $heading</a><BR><BR>\n";
	
	showdata();

	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=delete&$keyfield=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
	
	ParseForm($footer);
}

exit 0;

sub showdata()
{
	local($db) = dbconnect();
	local ($sql) = "select * from $table order by cqmorder;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Name</b></td>\n";
	print "<td><b>Type</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"$namefield"};
	   $key = $resptr->{"$keyfield"};
	   print "<tr>\n";
	   print "<td>$name</td>\n";
	   print "<td>".$cqmtypes[$resptr->{"cqmtype"}]."</td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=edit&$keyfield=$key\">Edit</a>\n";
	   $name =~ s/'//g;
	   print " -- <a href=\"javascript:deleteConfirm('$name',$key);\">Delete</a>\n";
	   print " -- <a href=\"$thispage?action=up&$keyfield=$key\"><img src=\"up_arrow.gif\" alt=\"Move up\" border=0></a>\n";
	   print " -- <a href=\"$thispage?action=down&$keyfield=$key\"><img src=\"down_arrow.gif\" alt=\"Move down\" border=0></a>\n";
	   print "</td></tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub fillvars()
{
	filltable();
	$typeselect = makeArrayDropDown(*cqmtypes,"cqmtype",[$cqmtypes[$cqmtype]],"",1);
	if ($cqmorder == 0)
	{
	  $cqmorder = dosql("select max(cqmorder) from $table ;") + 1;
	}
}

