#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "district.pl";
$table = "district_votes";
$heading = "District Vote";
$keyfield = "dvid";
$keyvalue = $CGI->param($keyfield);
$namefield = "x";
$tplfile = "district.tpl";
$errstr = $CGI->param("error");

if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to edit $heading(s)!"));
}
elsif ($action eq "new" || $action eq "edit")
{
	print $CGI->header();
	ParseForm($header);
	if ($keyvalue eq "")
	{
		print "<H1>Add $heading</H1>\n";
	}
	else
	{
        	print "<H1>Edit $heading</H1>\n";
	}
	print "<form action=\"$thispage\" method=\"post\">";
	if ($tplfile eq "")
	{
		local($dbvar) = dbconnect();
		local($query) = $dbvar->prepare("explain $table");
		local(@array);
		local(@arrNames);
		$query->execute;
		local($ind) = 0;
		    while (@arrCols = $query->fetchrow_array)
		    {
		    $arrNames[$ind] = $arrCols[0];
		    $array[$ind] = $arrCols[1];
		    $ind++;
		    }
		$query->finish;
		$query = $dbvar->prepare("select * from $table where $keyfield = $keyvalue");
		$query->execute;
		local($indFirstRecord) = 0;
		print "<table border=0>\n";
		@arrVals = $query->fetchrow_array;
		$input = $arrVals[0];
		print "<tr>\n<td>$arrNames[0]:</td><td>$input</td>\n</tr>\n";
		local($i) = 0;    
		    for($i=1;$i<$ind;$i++)
		    {
			if ($array[$i] eq "tinyint(1)")
			{
			    if ($arrVals[$i] eq "on")
			    {
			    $checked = " CHECKED";
			    }
			    else
			    {
			    $checked = "";
			    }
			$input = "<input type=\"checkbox\" name=\"$arrNames[$i]\"$checked>";
			}
			elsif ($array[$i] eq "mediumtext")
			{
			$input = "<textarea name=\"$arrNames[$i]\" COLS=20 ROWS=5>$arrVals[$i]</textarea>";
			}
			else
			{
			$input = "<input type=\"text\" name=\"$arrNames[$i]\" size=20 value=\"$arrVals[$i]\">";
			}
		    print "<tr>\n<td>$arrNames[$i]:</td><td>$input</td>\n</tr>\n";
		    }
		$indFirstRecord = 1;
		$query->finish;
		$dbvar->disconnect;
		print "</table>";
	}
	else
	{
	     fillvars();
	     ParseForm($tplfile);
	}
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>";
	}
	else
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>";
	}
	print "</form>";
	print "<br><hr><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($submit eq "Add")
{
	# Insert and Redirect
	$SQL = filltablefromCGI($table, 1);
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Added"));
}
elsif ($submit eq "Change")
{
	#print $CGI->header();
	# Update and Redirect
	$SQL = filltablefromCGI($table, 0);
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Updated"));
}
elsif ($action eq "delete")
{
	# delete and Redirect
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$SQL = "delete from $table where $keyfield = $keyvalue;";
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Deleted"));
}
else
{
	print $CGI->header;
	ParseForm($header);
	
	print "<font color=red>$errstr</font><BR><BR>\n";
	
	print "<H1>Manage ".$heading."s</h1>\n";

	print "<a href=\"$thispage?action=new\">ADD a NEW $heading</a><BR><BR>\n";
	
	showdata();

	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=delete&$keyfield=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
	
	ParseForm($footer);
}

exit 0;

sub showdata()
{
	local($db) = dbconnect();
	local ($sql) = "select * from $table;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Character</b></td>\n";
	print "<td><b>Votes</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = getCharName($resptr->{"charid"}) . "<i>(" . getFullNameFromCharID($resptr->{"charid"}). ")";
	   $key = $resptr->{"$keyfield"};
	   print "<tr>\n";
	   print "<td>$name</td>\n";
	   print "<td>".$resptr->{"votes"}."</td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=edit&$keyfield=$key\">Edit</a>\n";
	   $name =~ s/'//g;
	   print " -- <a href=\"javascript:deleteConfirm('$name',$key);\">Delete</a>\n";
	   print "</td></tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub fillvars()
{
	filltable();
	$chardrop = makeCharDropDown("charid","$charid");
}

# ********************
# * makeCharDropDown *
# ********************
# * makeCharDropDown makes a drop down field from characters.
sub makeCharDropDown
{
local($selectname) = $_[0];
local($value) = $_[1];
local ($db) = dbconnect();
$SQL = "select a.charid, concat(b.pfirst, ' ', b.plast) from characters a, players b, playercharacters c where c.pccharid=a.charid and b.playerid=c.pcplayerid and a.chartype != $test_character order by a.clast";
    
local($query) = $db->prepare($SQL);
$query->execute;

local ($retVal) = "";

#Check to make sure $query is not empty
    if ($query->rows > 0)
    {
        $retVal = "<select name=\"$selectname\">\n";
        local (@array);
        while (@array = $query->fetchrow_array)
        {
          if ("$array[0]" eq "$value")
          {
            $retVal .= "<option value=\"$array[0]\" SELECTED>".getCharName($array[0])." ($array[1])</option>\n";
          }
          else
          {
            $retVal .= "<option value=\"$array[0]\">".getCharName($array[0])." ($array[1])</option>\n";
          }
        }
        $retVal .= "</select>\n";
    }
$query->finish;
$db->disconnect;
return $retVal;
}