#!perl

# ***************************************************************************************
# * GLOBAL VARIABLE SECTION * All subroutines for the cgi-bin should be found in this   *
# *************************** script for ease of debugging and code-reuse. This page    *
# * should be included in every other page using the statement                          *
# * 'require "common.pl";' so that all the subroutines and global variables  *
# * are available to that page.                                                         *
# ***************************************************************************************

$header = "header.tpl"; #This is the html header for the top of your pages.
$footer = "footer.tpl"; #This is the html footer for the bottom of your pages.
$campaign = "Brassy's Men"; #This is the name of your LARP
$contact = "brassy\@interactivitiesink.com"; #This is your contact e-mail address
$gmlist = "brassys_gms\@yahoogroups.com"; #This is an e-mail list for the GMs
$siteURL = "http://www.interactivitiesink.com/larps/brassy/scripts"; #This is the URL of your Website
$doctitle = "$campaign Character/Player Database";  #this is the default title for your web pages.
$bgcolor = "#FFFFFF"; #this is the default background color for your web pages.
$bgpicture = "../paper.jpg"; #this is the default background picture for your web pages.
$cookiename = "BRASSYID"; #this is the name of the cookie for the website.
$cookiesite = "interactivitiesink.com";

#Connection variables
$database = ""; #This is the name of the database
$hostname = ""; #This is your database server
$username = ""; #This is the user id for logging in to your database
$password = ""; #This is the password that matches the user id
$whichDBI = "DBI:mysql"; #This is the DBI to use. Defaults to MYSQL, but Perl has several
                         #other possible DBI's.
#game stage
$gamestage = 3;
# Stage One tables are those that could be used by any LARP, even if the LARP doesn't use RTLB. For example, tables that track players, characters, and events can be used by any LARP.
# The Stage Two tables are those what could be used by any LARP running RTLB, even if they don't use the specialized mechanics of Brassy's Men.
# Stage Three tables are those that are used in specific Brassy's Men mechanics, such as speeches, votes, and weird science.
             
#access global variables                         
$no_access = 0;  #user has no access.
$player_access = 1;  #user is a player in the campaign.
$writer_access = 2;  #user is a writer for the campaign.
$gm_access = 3; #user is a GM in the campaign.
$developer_access = 4; #user is a database developer.
$playertype[$no_access] = "No Player";
$playertype[$player_access] = "Player";
$playertype[$writer_access] = "Writer/Staff";
$playertype[$gm_access] = "Game Master";
$playertype[$developer_access] = "Database Developer";

#levels
$charcreatelevel = $player_access;  #The access level the person must have to be able to create a character
$gmnotelevel = $gm_access;   #The access level the person must have to be able to create, edit, and delete GM notes
$plotlevel = $gm_access;   #The access level the person must have to be able to create, edit, and delete plots

#yesno
@yesno = { "no", "yes" };
$yesno[0] = "no";
$yesno[1] = "yes";
$yesnob[0] = "no";
$yesnob[1] = "<b>yes</b>";
$yesnoi[0] = "no";
$yesnoi[1] = "<i>yes</i>";

#ischecked
@ischecked = { "", "CHECKED" };
$ischecked[0] = "";
$ischecked[1] = "CHECKED";

#chartype global variables                         
$player_character = 1;
$cast_character = 2;
$test_character = 3;
$secret_character = 4;
$alias_character = 5;
$numchartypes=6;

$chartype[0] = "";
$chartype[1] = "Player Character";
$chartype[2] = "Cast Character";
$chartype[3] = "Test Character";
$chartype[4] = "Secret Character";
$chartype[5] = "Alternate Identity";

$charnameformat = "(select concat(cfirst, ' ', clast) from characters where (ctitle is NULL or ctitle='') and charid=\$varID) union (select concat(cfirst, ' ', clast, ', ', ctitle) from characters where (ctitle is not NULL and ctitle !='') and charid=\$varID);";

#player registration global variables 
$unregistered = 0;
$not_attending = 1;
$registered = 2;
$registeredpaid = 3;
$confirmed = 4;
$num_registered = 5;
$player_registration[$unregistered] = "Not Registered";
$player_registration[$not_attending] = "Not Attending";
$player_registration[$registered] = "Registered - Unpaid";
$player_registration[$registeredpaid] = "Registered - Paid";
$player_registration[$confirmed] = "Confirmed - Paid";

# The ID of the current or next episode in the event list.
$current_episode = 1; #Secret of Atlantis
$previous_episode = 0; #episode 6
$current_bgp = 1;

$allowjournal=1;
$dostats=1; 
$reqcharquest=1;
    
# ***************
# * Return True *
# ***************
# * A Perl Library must always return a true value,
# * or it doesn't compile in the require statement.
1;b