#!/usr/bin/perl

# Require and Use
# * These statements alert perl.exe that
# * you are going to be using functions, 
# * subroutines, and methods from other
# * perl programs. "require" is used for a
# * perl library, and the "use" statement 
# * is usually used to reference a perl
# * object (usually referred to as a 
# * module).
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;
$CGI = new CGI;
$pid = getPlayerID();
$access = getAccessLevel($pid);
$errstr = $CGI->param("error");

$numcpm= 11;
$cpm[0] = "No Plots Assigned";
$cpm[1] = "Plotting In Progress";
$cpm[2] = "Ready for Character Sheet";
$cpm[3] = "Summary Ready for Assistant Writer";
$cpm[4] = "Character Sheet Requires Minor Update";
$cpm[5] = "Character Sheet in Progress";
$cpm[6] = "Character Sheet Ready For Review";
$cpm[7] = "Character Sheet Ready For Formatting";
$cpm[8] = "Character Sheet Being Edited";
$cpm[9] = "Character Sheet Ready For Player";
$cpm[10] = "Character Sheet In Player Space";

$emailcpm[0] = 0;
$emailcpm[1] = 0;
$emailcpm[2] = 0;
$emailcpm[3] = 0;
$emailcpm[4] = 1;
$emailcpm[5] = 0;
$emailcpm[6] = 1;
$emailcpm[7] = 1;
$emailcpm[8] = 0;
$emailcpm[9] = 1;
$emailcpm[10] = 0;

$hidebox = $CGI->param("hidebox");
$sortby = $CGI->param("sortby") + 0;
$onlypaid = $CGI->param("onlypaid") + 0;

$allplayers = 0;
$paidplayers = 1;
$regplayers = 2;
$numplayertypes = 3;

$sortbychar = 0;
$sortbyplot = 1;
$sortbygms = 2;
$sortbystats = 3;
$sortbytype = 4;
$sortbyname = 5;
$numsorts = 6;

$ctntot = 0;
$numchartypes = dosql("select max(ctypeid) from chartypes;") + 1;
$chartypetext[0] = "All";
for ($i = 1; $i < $numchartypes; $i++)
{
   $chartypetext[$i] = dosql("select ctypedesc from chartypes where ctypeid=$i;");
   $charchecked[$i] = $CGI->param("chartype_$i") + 0;
   $ctntot += $charchecked[$i];
}
if ($ctntot == 0)
{
   $charchecked[0] = 1;
}

$action = $CGI->param('action');
$useglobalsql = 0;

$thispage = "gmchars.pl";

if ($access < $gm_access)
{
    print $CGI->redirect("login.pl?error=" . encodeURL("You may not access this page"));
}
elsif ($action eq 'delete')
{
   #print $CGI->header();
   $charid = $CGI->param("charid");
   local($dbvar) = dbconnect();
   local($sql) = "delete from characters where charid = $charid;";
   $dbvar->do($sql);
   local($sql) = "delete from GMcharacters where gmccharid = $charid;";
   $dbvar->do($sql);
   local($sql) = "delete from charquestionnaires where cqcharid = $charid;";
   $dbvar->do($sql);
   local($sql) = "delete from playerboxes where pbcharid = $charid;";
   $dbvar->do($sql);
   local($sql) = "delete from playercharacters where pccharid = $charid;";
   $dbvar->do($sql);
   local($sql) = "delete from plotchars where pccharid = $charid;";
   $dbvar->do($sql);
   local($sql) = "delete from charabilityallowed where charid = $charid;";
   $dbvar->do($sql);
   local($sql) = "delete from characterabilities where charid = $charid;";
   $dbvar->do($sql);
   local($sql) = "delete from characterMFallowed where charid = $charid;";
   $dbvar->do($sql);
   local($sql) = "delete from characterSTATs where charid = $charid;";
   $dbvar->do($sql);
   local($sql) = "delete from characterapplications where charid = $charid;";
   $dbvar->do($sql);
   local($sql) = "delete from charactermotiveforces where charid = $charid;";
   $dbvar->do($sql);
   local($sql) = "delete from characterresourcetypelink where charid = $charid;";
   $dbvar->do($sql);
   local($sql) = "delete from keyrolecharacters where charid = $charid;";
   $dbvar->do($sql);
   local($sql) = "delete from VLaccess where charid = $charid;";
   $dbvar->do($sql);
   local($sql) = "delete from VLstatlink where charid = $charid;";
   $dbvar->do($sql);
   local($sql) = "update virtuallocations set vlowner=0 where vlowner = $charid;";
   $dbvar->do($sql);
   local($sql) = "delete from characteroccupations where charid = $charid;";
   $dbvar->do($sql);
   local($sql) = "delete from charactergroupmembers where charid = $charid;";
   $dbvar->do($sql);
   local($sql) = "delete from money where charid = $charid;";
   $dbvar->do($sql);
   local($sql) = "delete from spellcomponentscharacterlink where charid = $charid;";
   $dbvar->do($sql);
   local($sql) = "delete from bgas where charid = $charid;";
   $dbvar->do($sql);
   local($sql) = "delete from damagechart where charid = $charid;";
   $dbvar->do($sql);
   local($sql) = "delete from charactersubfree where charid = $charid;";
   $dbvar->do($sql);
   local($sql) = "delete from characterplans where charid = $charid;";
   $dbvar->do($sql);
   local($sql) = "delete from inventory_dev where charid = $charid;";
   $dbvar->do($sql);
   local($sql) = "delete from inventory_ws where charid = $charid;";
   $dbvar->do($sql);
   local($sql) = "delete from journal where charid = $charid;";
   $dbvar->do($sql);
   local($sql) = "delete from inventory_sc where charid = $charid;";
   $dbvar->do($sql);
   local($sql) = "delete from bgas where charid = $charid;";
   $dbvar->do($sql);
   local($sql) = "delete from xp where charid = $charid;";
   $dbvar->do($sql);
   local($sql) = "delete from charactersubfree where charid = $charid;";
   $dbvar->do($sql);
   local($sql) = "delete from charactersubstatpoints where charid = $charid;";
   $dbvar->do($sql);
   local($sql) = "delete from linknotes where linktable='characters' and linkid = $charid;";
   $dbvar->do($sql);
   local($sql) = "delete from GMwriters where charid = $charid;";
   $dbvar->do($sql);
   $dbvar->disconnect;
   print $CGI->redirect("$thispage".fetchline($thispage,$pid));
}
elsif ($action eq 'makedef')
{

   #print $CGI->header();
   $myline = makeline();
   local($db) = dbconnect();
   $db->do("delete from pagedefaults where playerid=$pid and pageid='$thispage';");
   $db->do("insert into pagedefaults (playerid, pageid, defstring) values($pid,'$thispage','$myline');");
   $db->disconnect;
   print $CGI->redirect("$thispage".$myline);
}
elsif ($action eq 'assplay')
{
   print $CGI->header();
   ParseForm($header);
   $charid = $CGI->param("charid");
   $charname = getCharName($charid);
   
   print "<H1>Assign Player(s) to Character -- $charname</H1>";
 
   local($charpid) = getPIDFromCharID($charid);
   print "<form name=\"frmCreate\" action=\"gmchars.pl\" method=\"post\">\n";
   print makeMultipleBox("players","playerid","concat(plast,', ',pfirst)","psecurity > 0",$charpid);
  
   print "<input type=hidden name=action value=setPlayers>\n";
   print "<input type=hidden name=charid value=\"$charid\">\n";
   print "<BR><i>You can choose multiple players by using Ctrl + click or Shift + click.</i><BR>";

   print "<input type=\"submit\" name=\"submit\" value=\"Submit\"></form>\n";

}
elsif ($action eq 'setPlayers')
{
       #Update in Database
       $charid = $CGI->param("charid");
       local($db) = dbconnect();
       @players = $CGI->param("playerid");
       $sql = "delete from playercharacters where pccharid = $charid";
       $db->do($sql);
       foreach $i (@players)
       {
       	   $sql = "insert into playercharacters (pcplayerid, pccharid) values ($i, $charid)";
           $db->do($sql);
       }
       $db->disconnect;
       print $CGI->redirect("$thispage".fetchline($thispage,$pid)."#$charid");

}
elsif ($action eq 'assign')
{
   print $CGI->header();
   ParseForm($header);
   $charid = $CGI->param("charid");
   $charname = getCharName($charid);
   
   print "<H1>Assign GM(s) to Character -- $charname</H1>";
 
   print "<form name=\"frmCreate\" action=\"gmchars.pl\" method=\"post\">\n";
   print makeGMDropDown();
  
   print "<input type=hidden name=action value=setGM>\n";
   print "<input type=hidden name=charid value=$charid>\n";
   print "<input type=hidden name=sortby value=$sortby>\n";
   print "<input type=hidden name=onlypaid value=$onlypaid>\n";
   print "<BR>*You can choose multiple GMs by using Ctrl + click or Shift + click.<BR>";

   print "<input type=\"submit\" name=\"submit\" value=\"Submit\"></form>\n";

}
elsif ($action eq 'setGM')
{
       #Update in Database
       $charid = $CGI->param("charid");
       local($db) = dbconnect();
       @gms = $CGI->param("gmid");
       $sql = "delete from GMcharacters where gmccharid = $charid";
       $db->do($sql);
       foreach $i (@gms)
       {
       	   $sql = "insert into GMcharacters (gmcGMid, gmccharid) values ($i, $charid)";
           $db->do($sql);
       }
       $db->disconnect;
       print $CGI->redirect("$thispage".fetchline($thispage,$pid)."#$charid");
}
elsif ($action eq 'asswrite')
{
   print $CGI->header();
   ParseForm($header);
   $charid = $CGI->param("charid");
   $charname = getCharName($charid);
   
   print "<H1>Assign Writer(s) to Character -- $charname</H1>";
 
   print "<form name=\"frmCreate\" action=\"gmchars.pl\" method=\"post\">\n";
   print makeGMDropDown();
  
   print "<input type=hidden name=action value=setWriter>\n";
   print "<input type=hidden name=charid value=$charid>\n";
   print "<input type=hidden name=sortby value=$sortby>\n";
   print "<input type=hidden name=onlypaid value=$onlypaid>\n";
   print "<BR>*You can choose multiple Writers by using Ctrl + click or Shift + click.<BR>";

   print "<input type=\"submit\" name=\"submit\" value=\"Submit\"></form>\n";

}
elsif ($action eq 'setWriter')
{
       #Update in Database
       $charid = $CGI->param("charid");
       local($db) = dbconnect();
       @gms = $CGI->param("gmid");
       $sql = "delete from GMwriters where charid = $charid";
       $db->do($sql);
       foreach $i (@gms)
       {
       	   $sql = "insert into GMwriters (writerid, charid) values ($i, $charid)";
           $db->do($sql);
       }
       $db->disconnect;
       print $CGI->redirect("$thispage".fetchline($thispage,$pid)."#$charid");
}
elsif ($action eq "unlockstats")
{
       #Update in Database
       $charid = $CGI->param("charid");
       $sql = "update characters set charstatsapproved=0 where charid=$charid;";
       dosql($sql);
       print $CGI->redirect("$thispage".fetchline($thispage,$pid)."#$charid");
}
elsif ($action eq "edGMcomment")
{
        #Edit the GM Comments
	print $CGI->header();
	ParseForm($header);
        $charid = $CGI->param("charid");
        local($db) = dbconnect();
 	$sql = "select cqgmnotes from charquestionnaires where cqcharid = $charid;";
 	#print "$sql<BR>";
	local($query) = $db->prepare($sql);
	$query->execute;
	while (@array = $query->fetchrow_array)
	{
	   $gmcomments = $array[0];
	   $gmcomments =~ s/<BR>/\n/g;
	}
	if ($gmcomments eq NULL or $gmcomments eq "")
	{
	   $gmcomments = "None.";
	}
	print "<form action=\"gmchars.pl\" method=\"post\">\n";
	print "<input type=\"hidden\" name=\"charid\" value=\"$charid\">\n";
	print "<h2>Edit GM Comments</h2>\n";
	print "<textarea name=\"gmcomments\" COLS=80 ROWS=25>$gmcomments</textarea><BR>\n";
	print "<input type=\"hidden\" name=\"action\" value=\"updateComments\">\n";
   	print "<input type=hidden name=sortby value=$sortby>";
        print "<input type=hidden name=onlypaid value=$onlypaid>\n";
	print "<input type=\"submit\" name=\"submit\" value=\"Edit Comment\">\n";
	print "</form>\n";
	$query->finish;
        $db->disconnect;
	ParseForm($footer);
}
elsif ($action eq "updateComments")
{
        #Update the GM Comments
	#print $CGI->header();
        $charid = $CGI->param("charid");
        $gmcomments = $CGI->param("gmcomments");
	$gmcomments =~ s/<BR>/\n/g;
	$gmcomments =~ s/'/''/g;
        local($db) = dbconnect();
 	$sql = "update charquestionnaires set cqgmnotes='$gmcomments' where cqcharid = $charid;";
 	#print "$sql<BR>";
	$db->do($sql);
        $db->disconnect;
        print $CGI->redirect("$thispage".fetchline($thispage,$pid));
}
elsif ($action eq "reject")
{
        $charid = $CGI->param("charid");
        local($db) = dbconnect();
 	$sql = "update characters set charstoryapproved=0 where charid = $charid;";
 	#print "$sql<BR>";
	$db->do($sql);
        $db->disconnect;
        print $CGI->redirect("$thispage".fetchline($thispage,$pid));
}
elsif ($action eq "setplot")
{
        #Edit the GM Comments
	print $CGI->header();
	ParseForm($header);
        $charid = $CGI->param("charid");
        local($db) = dbconnect();
 	$sql = "select charplotapproved from characters where charid = $charid;";
 	#print "$sql<BR>";
	local($query) = $db->prepare($sql);
	$query->execute;
	$charplotapproved = 0;
	while (@array = $query->fetchrow_array)
	{
	   $charplotapproved = $array[0];
	}
	$query->finish;
        $db->disconnect;
	$plotselect = makeArrayDropDown(\@cpm,"charplotapproved",[$charplotapproved],"",1);

	print "<H1>Update Plot Status for ".getCharName($charid)."</H1>\n";
	print "<form action=\"gmchars.pl\" method=\"post\">\n";
	print "<input type=\"hidden\" name=\"charid\" value=\"$charid\">\n";
	print "<input type=\"hidden\" name=\"action\" value=\"updatePlot\">\n";
	print "Plot Status: ";
	print "$plotselect<BR><BR>\n";
  	print "<input type=hidden name=sortby value=$sortby>";
        print "<input type=hidden name=onlypaid value=$onlypaid>\n";
	print "<input type=\"submit\" name=\"submit\" value=\"Update\">\n";
	print "</form>\n";
	ParseForm($footer);
}
elsif ($action eq "updatePlot")
{
	#print $CGI->header();
        $charid = $CGI->param("charid");
        $charplotapproved = $CGI->param("charplotapproved");
        local($db) = dbconnect();
 	$sql = "update characters set charplotapproved=$charplotapproved where charid = $charid;";
 	#print "$sql<BR>";
	$db->do($sql);
        $db->disconnect;
        if ($emailcpm[$charplotapproved] == 1)
        {
   		$charname = getCharName($charid);
   		$playername = getFullNameFromID($pid);

		open(MAIL, "| /usr/sbin/sendmail -oi -t") or print "couldn't send mail: $!<BR>";
		print MAIL "From: $contact\n";
		print MAIL "To: $gmlist\n";
		print MAIL "Subject: $charname has been set to $cpm[$charplotapproved]\n";
		print MAIL "\n";
		print MAIL "$charname has been set to $cpm[$charplotapproved] by $playername.\n";
		print MAIL "Today's date: ".getDate()."\n";
		print MAIL "---------------------------------------------------------------------------\n";
		close(MAIL);
        }
        print $CGI->redirect("$thispage".fetchline($thispage,$pid)."#$charid");
}
elsif ($action eq "upload")
{
	print $CGI->header();
        $charid = $CGI->param("charid");
   	$charname = getCharName($charid);
	ParseForm($header);
	print $CGI->start_multipart_form(-name => "form1");
	print "<br><table border=0 align=\"center\"><tr><td align=\"center\"><b>Upload Character Sheet for $charname</b><BR><i>This is the Word document the GMs use when writing the character. It is not seen by players.</i></td></tr>\n<tr><td>\n";
	ParseForm("upnodir.tpl");
	print "</td></tr>\n</table>\n";
	print "<input type=\"hidden\" name=\"charid\" value=\"$charid\">\n";
	print "<input type=\"hidden\" name=\"action\" value=\"putfile\">\n";
   	print "<input type=hidden name=sortby value=$sortby>";
        print "<input type=hidden name=onlypaid value=$onlypaid>\n";
	print $CGI->end_form;
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	ParseForm($footer);
}
elsif ($action eq "uplink")
{
	print $CGI->header();
        $charid = $CGI->param("charid");
   	$charname = getCharName($charid);
	ParseForm($header);
	print $CGI->start_multipart_form(-name => "form1");
	print "<br><table border=0 align=\"center\"><tr><td align=\"center\"><b>Upload Character Sheet for $charname</b><BR><i>This is the HTML document the player will see before the game.  It should be properly formatted and approved by the GMs, and should not contain their contingency envelope text</i> </td></tr>\n<tr><td>\n";
	ParseForm("upnodir.tpl");
	print "</td></tr>\n</table>\n";
	print "<input type=\"hidden\" name=\"charid\" value=\"$charid\">\n";
	print "<input type=\"hidden\" name=\"action\" value=\"puthtml\">\n";
   	print "<input type=hidden name=sortby value=$sortby>";
        print "<input type=hidden name=onlypaid value=$onlypaid>\n";
	print $CGI->end_form;
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	ParseForm($footer);
}
elsif ($action eq "putfile")
{
    #print $CGI->header();
    $fn = $CGI->param('filename');
    $fh = $CGI->param('filename');
    
    #print "$fn<BR>";
    
    $fn =~ s!^.*(\\|\/)!!; 
    
    #print "$fn<BR>";

    #print "[$fh]<BR>";
    
    binmode $fh;
    chmod 0777, "chars/$fn";
    open (OUTFILE,">chars/$fn") || print $CGI->redirect("$thispage?error=" . encodeURL("Error creating $fn. Please try again."));
    binmode OUTFILE;
    binmode $fh;
    while (<$fh>)
    {
	   print OUTFILE $_;
    }
    close OUTFILE;
    close $fh;
    chmod 0777, "chars/$fn";
    
    $charid = $CGI->param("charid");
    local($dbvar) = dbconnect();
    $sql = "update characters set cdoclink='$fn' where charid = $charid;";
    $dbvar->do($sql);
    $dbvar->disconnect;
        
    print $CGI->redirect("$thispage".fetchline($thispage,$pid)."#$charid"); 
    exit 0;
}
elsif ($action eq "puthtml")
{
    #print $CGI->header();
    $fn = $CGI->param('filename');
    $fh = $CGI->param('filename');
    
    #print "$fn<BR>";
    
    $fn =~ s!^.*(\\|\/)!!; 
    
    #print "$fn<BR>";

    #print "[$fh]<BR>";
    
    binmode $fh;
    chmod 0777, "charhtml/$fn";
    open (OUTFILE,">charhtml/$fn") || print $CGI->redirect("$thispage?error=" . encodeURL("Error creating $fn. Please try again."));
    binmode OUTFILE;
    binmode $fh;
    while (<$fh>)
    {
	   print OUTFILE $_;
    }
    close OUTFILE;
    close $fh;
    chmod 0777, "charhtml/$fn";
    system ("/usr/local/bin/pcfix.pl charhtml/$fn");
    
    $charid = $CGI->param("charid");
    local($dbvar) = dbconnect();
    $sql = "update characters set chtmllink='$fn' where charid = $charid;";
    $dbvar->do($sql);
    $dbvar->disconnect;
        
    print $CGI->redirect("$thispage".fetchline($thispage,$pid)."#$charid"); 
    exit 0;
}
else
{
	print $CGI->header();
	$doctitle = "GM Character Approval Panel";
	ParseForm($header);
	print "<H1>$doctitle</H1>";
	
	if ("$errstr" ne "")
	{
	   print "<font color=red>$errstr</font><BR><BR>\n";
	}
	
	print "<a href=\"plotmatrix.pl\">Character/Plot Matrix</a><BR><BR>\n";

	if ("$hidebox" eq "1")
	{
	   $hidebox = 0;
	   print "<a href=\"$thispage".makeline()."\">Show Control Panel</a><BR>\n";
	}
	else
	{
	   showcontrolpanel();
	}
	
	if ($sortby == $sortbyplot) #sort by plot
	{
		print "<H1>Sorting by Plot</H1>\n";
		local($j);
		for ($j=0; $j < $numcpm; $j++)
		{
			print "<H2>$cpm[$j]</H2>\n";
			displayCharacters("charplotapproved",$j);
		}
	}
	elsif ($sortby == $sortbyname) 
	{
		print "<H1>Sorting by Character Last Name</H1>\n";
		displayCharacters("","");
	}
	elsif ($sortby == $sortbytype) 
	{
		print "<H1>Sorting by Character Type</H1>\n";
		local($db) = dbconnect();
		$sql = "select ctypeid, ctypedesc from chartypes order by ctypedesc;";
		#print "$sql<BR>";  
		local ($query) = $db->prepare($sql);
		$query->execute;
		local (@array);
		while (@array = $query->fetchrow_array)
		{
		   print "<H2>$array[1]</H2>\n";
		   displayCharacters("chartype",$array[0]);
		}
		$query->finish;
		$db->disconnect;
	}
	elsif ($sortby == $sortbystats) 
	{
		print "<H1>Sorting by STATs</H1>\n";
		print "<H2>STATs need to be approved</H2>\n";
		displayCharacters("charstatsapproved",0);
		print "<H2>STATs Approved</H2>\n";
		displayCharacters("charstatsapproved",1);
	}
	elsif ($sortby == $sortbygms) #sort by GM
	{
		print "<H1>Sorting by GM</H1>\n";
		$useglobalsql = 1;
		$wherestr = "";
		if ($charchecked[0] == 0)
		{
		      $wherestr .= "and a.charid > 0 and paren";
		      for ($i = 0; $i < $numchartypes; $i++)
		      {
			if ($charchecked[$i] > 0)
			{
			   $wherestr .= "or a.chartype=$i ";
			}
		      }

		      $wherestr =~ s/parenor/(/;
		      $wherestr .= ")";
		}
		local($dbvar) = dbconnect();
		$sql = "select playerid, concat(pfirst, ' ', plast) from players where psecurity>=$gm_access order by plast;";
		#print "$sql<BR>";  
		local ($query) = $dbvar->prepare($sql);
		$query->execute;
		local (@array);
		while (@array = $query->fetchrow_array)
		{
		   print "<H2>$array[1]</H2>\n";
		   if ($onlypaid == 2)
		   {
		 	$sql = "select * from characters a, eventplayers b, playercharacters c, GMcharacters d where d.gmcGMid=$array[0] and a.charid=d.gmccharid $wherestr and a.charid=c.pccharid and c.pcplayerid=b.playerid and b.reglevel>=$registered and b.eventid=$current_episode order by a.clast";
		   }
		   elsif ($onlypaid == 1)
		   {
		 	$sql = "select * from characters a, eventplayers b, playercharacters c, GMcharacters d where d.gmcGMid=$array[0] and a.charid=d.gmccharid $wherestr and a.charid=c.pccharid and c.pcplayerid=b.playerid and b.reglevel=$confirmed and b.eventid=$current_episode order by a.clast";
		   }
		   else
		   {
		   	$sql = "select a.* from characters a, GMcharacters b where b.gmcGMid=$array[0] and a.charid=b.gmccharid $wherestr order by a.clast;";
		   }
		   #print "$sql<BR>";  

		   displayCharacters("",0);
		}
		$query->finish;
		print "<H2>No GM</H2>\n";
		print "<table border=1>\n";
		print "<tr>\n";
		print "<td align=\"center\"><b>Character</b><BR>\n";
		print "<a href=\"gmchars.pl?sortby=$sortbyname\">Sort</a></td>\n";
		print "<td align=\"center\"><b>Type</b></td>\n";
		print "<td align=\"center\"><b>Character Questionnaire</b><BR>";
		print "<a href=\"gmchars.pl?sortby=$sortbychar\">Sort</a></td>\n";
		print "<td align=\"center\"><b>Plots</b><BR>";
		print "<a href=\"gmchars.pl?sortby=$sortbyplot\">Sort</a></td>\n";
		print "<td align=\"center\"><b>Stats</b><BR>\n";
		print "<a href=\"gmchars.pl?sortby=$sortbystats\">Sort</a></td>\n";
		print "<td align=\"center\"><b>GM(s) Assigned</b><BR>\n";
		print "<a href=\"gmchars.pl?sortby=$sortbygms\">Sort</a></td>\n";
		print "<td align=\"center\"><b>Action</b></td>\n";
		print "</tr>\n";

		$sql = "select a.* from characters a where a.charid=a.charid $wherestr order by a.clast;";
		#print "$sql<BR>\n";
		local ($query) = $dbvar->prepare($sql);
		$query->execute;
		local ($resptr);
		while ($resptr = $query->fetchrow_hashref())
		{
		   $num = dosql("select count(gmcGMid) from GMcharacters where gmccharid=".$resptr->{"charid"}) + 0;
		   if ($num == 0)
		   {
		     displaythechar($resptr);
		   }
		}
		$query->finish;
		print "</table>\n";

		$dbvar->disconnect;
		
	}
	else #sort by character history
	{
		print "<H1>Sorting by Character History</H1>\n";
		print "<H2>Characters Ready for Approval</H2>\n";

		displayCharacters("charstoryapproved",1);

		print "<H2>GM Approved Characters</H2>\n";

		displayCharacters("charstoryapproved",2);

		print "<H2>Characters in Progress</H2>\n";
		print "<i>These characters have not yet been submitted for approval and may change.</i>";

		displayCharacters("charstoryapproved",0);
	}

	print "<br><hr><a href=\"login.pl\">Return to main menu</a>.\n";
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jscharid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"gmchars.pl?action=delete&charid=\"+jscharid;\n";
	print "  }\n";
	print "}\n";
	
	print "function togglepaid()\n";
	print "{\n";
	print "  window.location = \"gmchars.pl?onlypaid=".(1-$onlypaid)."&sortby=$sortby\"\n";
	print "}\n";
	
	print "</script>\n";
	ParseForm($footer);
}


sub displayCharacters()
{
	local($dispVal) = $_[0];
	local($dispType) = $_[1];
	
	$dispstr = "";
	if ("$dispVal" ne "")
	{
	   $dispstr = "and a.$dispVal='$dispType' ";
	}

	local($dbvar) = dbconnect();
	if ($useglobalsql == 0)
	{
           local ($wherestr) = "";
	   if ($charchecked[0] == 0)
	   {
	      $wherestr .= "and a.charid > 0 and paren";
	      local ($i);
	      for ($i = 0; $i < $numchartypes; $i++)
	      {
	        if ($charchecked[$i] > 0)
	        {
		   $wherestr .= "or a.chartype=$i ";
	        }
	      }
	      
	      $wherestr =~ s/parenor/(/;
	      $wherestr .= ")";
	   }
	   if ($onlypaid == 1)
	   {
	      $sql = "select * from characters a, eventplayers b, playercharacters c where a.charid=c.pccharid $wherestr $dispstr and c.pcplayerid=b.playerid and b.reglevel=$confirmed and b.eventid=$current_episode order by a.clast";
	   }
	   elsif ($onlypaid == 2)
	   {
	      $sql = "select * from characters a, eventplayers b, playercharacters c where a.charid=c.pccharid $wherestr $dispstr and c.pcplayerid=b.playerid and b.reglevel>=$registered and b.eventid=$current_episode order by a.clast";
	   }
	   else
	   {
	      $sql = "select * from characters a where 5=5 $dispstr $wherestr order by a.clast";
	   }
	}
	#print "$sql<BR>";
	local($query) = $dbvar->prepare($sql);
	$query->execute;

	
	local($resptr) = 0;
	$numpcs[0] = $numpcs[1] = $numpcs[2] = $numpcs[3] = 0;
	
	while ($resptr = $query->fetchrow_hashref())
	{
	   displaythechar($resptr);
	}
	
	print "<p>$numpcs[3] Confirmed Player Characters in this section.<BR>\n";
	print "$numpcs[2] Registered Player Characters in this section.</p>\n";
	$dbvar->disconnect;
	return "";
}

sub displaythechar()
{
    local($resptr) = $_[0];
    local($bgcolor) = "white";
    local($charpid) = getPIDFromCharID($resptr->{"charid"});
    local($reglevel) = getRegLevel($charpid,$current_episode) + 0;
    if ($reglevel <= $unregistered)  #not registered
    {
      $bgcolor = "#FFEEEE";
      $hdcolor = "#EEDDDD";
    }
    elsif ($reglevel == $not_attending)  # not coming
    {
      $bgcolor = "#FFEEEE";
      $hdcolor = "#EEDDDD";
    }
    elsif ($reglevel == $registered || $reglevel == $registeredpaid) # registered but not confirmed
    {
      $bgcolor = "#FFFFEE";
      $hdcolor = "#EEEEDD";
    }
    else
    {
        $bgcolor = "#FFFFFF";
        $hdcolor = "#EEEEEE";
    }
    $numpcs[$reglevel]++;


    print "<table width=100% border=0 cellspacing=0 style=\"border: thin solid Black;\">\n";
    print "<tr>\n";
    print "<td width=30% style=\"font-weight: bold; background-color: $hdcolor; border-bottom: thin dashed Black;\">\n";
    print "<A NAME=\"".$resptr->{"charid"}."\"></A><a href=\"characters.pl?action=edit&charid=".$resptr->{"charid"}."\" Title=\"Click to Edit Character\">".getCharName($resptr->{"charid"})."</a>";
    print " -- <a href=\"charquest.pl?charid=".$resptr->{"charid"}."\" Title=\"Character Questionnaire\">Questionnaire</a>";
    print "</td>\n";
    print "<td width=40% style=\"font-weight: bold; background-color: $hdcolor; border-bottom: thin dashed Black;\">\n";
    print "<i><a href=\"gmchars.pl?action=assplay&charid=".$resptr->{"charid"}."\" Title=\"Click to Assign Player.\">".getFullNameFromID($charpid). "</a></i>";
    print "</td>\n";
    print "<td width=30% style=\"font-weight: bold; background-color: $hdcolor; border-bottom: thin dashed Black;\">\n";
    print $chartypetext[$resptr->{"chartype"}]." -- $player_registration[$reglevel]";
    print "</td>";
    print "</tr>\n";

    print "<tr>\n";
    print "<td width=30% style=\"background-color: $bgcolor;\">\n";
    print "<b>History:</b> ";
    if ($resptr->{"charstoryapproved"} ne "2") 
    {
       print "<a href=\"alertPlayer.pl?charid=".$resptr->{"charid"}."\" Title=\"Click to Approve\">Not Approved</a>";
    }
    else
    {
       print "Approved";
    }
    print "</td>\n";
    print "<td width=40% style=\"background-color: $bgcolor;\">\n";
    print "<b>Plots:</b> ";
    print "<a href=\"gmchars.pl?action=setplot&charid=".$resptr->{"charid"}."&sortby=$sortby&onlypaid=$onlypaid\"  Title=\"Click to Set Level\">".$cpm[$resptr->{"charplotapproved"}]."</a>";
    print "</td>\n";
    print "<td width=30% style=\"background-color: $bgcolor;\">\n";
    print "<b>STATs:</b> ";
    if ($resptr->{"charstatsapproved"} > 0)
    {
      print "Approved ";
      print "(<a href=\"$thispage?action=unlockstats&charid=".$resptr->{"charid"}."\"  Title=\"Click to Unlock\">Unlock</a>)";
    }
    else
    {
       print "<a href=\"gmvalidate.pl?charid=".$resptr->{"charid"}."\"  Title=\"Click to Validate\">Not Approved</a>";
    }
    print "</td>\n";
    print "</tr>\n";
    
    local ($charid) = $resptr->{"charid"};
    print "<tr>\n";
    print "<td style=\"background-color: $bgcolor; border-bottom: thin dashed Black;\">\n";
    print "<b>Contact GMs:</b> ";
    showGMs($resptr->{"charid"});
    print "</td>\n";
    print "<td style=\"background-color: $bgcolor; border-bottom: thin dashed Black;\">\n";
    print "&nbsp;</td>\n";
    print "<td style=\"background-color: $bgcolor; border-bottom: thin dashed Black;\">\n";
    $charid = $resptr->{"charid"};
    print "<b>Writers:</b> ";
    showWriters($resptr->{"charid"});
    print "</td>\n";
    print "</tr>\n";
    
    print "<tr>\n";
    print "<td colspan=3 style=\"background-color: $bgcolor;\">\n";
    local($sql) = "select defstring from pagedefaults where playerid=$pid and pageid='gmnotes.pl';";
    local ($defstr) = dosql($sql);
    if ("$defstr" eq "0")
    {
    	$defstr = "gmnotes.pl?linktable=characters&linkid=$charid"
    }
    else
    {
    	$defstr = "gmnotes.pl".$defstr."&linktable=characters&linkid=$charid"
    }
    print"<a href=\"$defstr\">GM Comments</a>";
    print" -- <a href=\"gmchars.pl?action=upload&charid=$charid&sortby=$sortby&onlypaid=$onlypaid\">Upload Doc (GM Version)</a>";
    if ($resptr->{"charplotapproved"} >= 7)
    {
      print" -- <a href=\"gmchars.pl?action=uplink&charid=$charid&sortby=$sortby&onlypaid=$onlypaid\">Upload HTML Sheet (Player Version)</a>";
    }
    print " -- <a href=\"stats.pl?charid=$charid\">Edit STATs</a>";
    if ($resptr->{"cdoclink"} ne "")
    {
       print" -- <a href=\"chars/".$resptr->{"cdoclink"}."\" target=_new>Review Doc (GM Version)</a>";
    }
    if ($resptr->{"chtmllink"} ne "")
    {
       print" -- <a href=\"charhtml/".$resptr->{"chtmllink"}."\" target=_new>Review HTML (Player Version)</a>";
    }
    if (dosql("select charid from journal where charid=$charid;") + 0 > 0)
    {
       print" -- <a href=\"journal.pl?charid=$charid\">Review Character Journal</a>";
    }
    if (dosql("select charid from bgas where charid=$charid;") + 0 > 0)
    {
       print" -- <a href=\"gmbga.pl?charid=$charid\">Review BGAs</a>";
    }
    print" -- <a href=\"javascript:deleteConfirm('".$resptr->{"cfirst"}." ".$resptr->{"clast"}."','$charid');\"> Delete</a>";
    print "</td>";
    print "</tr>\n";
    print "</table>\n";
}

sub showGMs()
{
    local($charid) = $_[0];
    $sql = "select concat(a.pfirst, ' ', a.plast) from players a, GMcharacters b where b.gmccharid = $charid and a.playerid = b.gmcGMid";
    local($dbvar) = dbconnect();
    local($query2) = $dbvar->prepare($sql);
    $query2->execute;
    if ($query2->rows > 0)
    {
	while (@array = $query2->fetchrow_array)
	{
	   print "$array[0], ";
	}
	print"<BR><a href=\"gmchars.pl?action=assign&charid=".$resptr->{"charid"}."\">Change GM(s)</a>";
    }
    else
    {
	print"None<BR><a href=\"gmchars.pl?action=assign&charid=".$resptr->{"charid"}."\">Assign GM(s)</a>";
    }
    $query2->finish;
    $dbvar->disconnect;
}

sub showWriters()
{
    local($charid) = $_[0];
    $sql = "select concat(a.pfirst, ' ', a.plast) from players a, GMwriters b where b.charid = $charid and a.playerid = b.writerid";
    #print "$sql<BR>\n";
    local($dbvar) = dbconnect();
    local($query2) = $dbvar->prepare($sql);
    $query2->execute;
    if ($query2->rows > 0)
    {
	while (@array = $query2->fetchrow_array)
	{
	   print "$array[0], ";
	}
	print"<a href=\"gmchars.pl?action=asswrite&charid=".$resptr->{"charid"}."\">Change Writer(s)</a>";
    }
    else
    {
	print"None<BR><a href=\"gmchars.pl?action=asswrite&charid=".$resptr->{"charid"}."\">Assign Writer(s)</a>";
    }
    $query2->finish;
    $dbvar->disconnect;
}


sub getRegLevel()
{
	local($charpid) = $_[0];
	local($event) = $_[1];
	$sql = "select reglevel from eventplayers where eventid=$event and playerid=$charpid;";
	$retval = dosql($sql) + 0;
	if ($retval == 0)
	{
		$retval = 1;
	}
	return $retval;
}

sub showcontrolpanel()
{
	for ($i = 0; $i < $numsorts; $i++)
	{
	  $sortchecked[$i] = "";
	}
	$sortchecked[$sortby] = "checked";

	for ($i = 0; $i < $numplayertypes; $i++)
	{
	  $playchecked[$i] = "";
	}
	$playchecked[$onlypaid] = "checked";
	
	$ctn = 0;

	print "<form action=\"$thispage\" method=\"post\">";
	print "<p><table border=1 cellspacing=0 cellpadding=0 align=left bgcolor=#eeeeee width=100%><tr><td>\n";
	print "<table border=0  cellspacing=1 cellpadding=1 align=center bgcolor=#eeeeee width=100%>\n";
	print "<tr><td><b>Control Panel</b></td></tr>\n";
	
	print "<tr>";
	print "<td style=\"font-size : xx-small;\" valign=middle><input type=radio name=sortby value=0 $sortchecked[0]>Sort By History Approval</input></td>\n";
	print "<td style=\"font-size : xx-small;\"><input type=radio name=onlypaid value=\"1\" $playchecked[1]>Show Confirmed Players Only</input></td>\n";
	print "<td style=\"font-size : xx-small;\">";
	if ($numchartypes > $ctn)
	{
		print "<input type=checkbox name=chartype_$ctn value=\"1\" $ischecked[$charchecked[$ctn]]>Show $chartypetext[$ctn] Characters</input>";
	}
	print "</td>\n";
	$ctn++;
	print "</tr>";
	
	print "<tr>";
	print "<td style=\"font-size : xx-small;\" valign=middle><input type=radio name=sortby value=1 $sortchecked[1]>Sort By Plotting</input></td>\n";
	print "<td style=\"font-size : xx-small;\"><input type=radio name=onlypaid value=\"2\" $playchecked[2]>Show Confirmed and Registered Players</input></td>\n";
	print "<td style=\"font-size : xx-small;\">";
	if ($numchartypes > $ctn)
	{
		print "<input type=checkbox name=chartype_$ctn value=\"1\" $ischecked[$charchecked[$ctn]]>Show $chartypetext[$ctn] Characters</input>";
	}
	print "</td>\n";
	$ctn++;
	print "</tr>";
	
	print "<tr>";
	print "<td style=\"font-size : xx-small;\" valign=middle><input type=radio name=sortby value=2 $sortchecked[2]>Sort By GM</input></td>\n";
	print "<td style=\"font-size : xx-small;\"><input type=radio name=onlypaid value=\"0\" $playchecked[0]>Show All Players</input></td>\n";
	print "<td style=\"font-size : xx-small;\">";
	if ($numchartypes > $ctn)
	{
		print "<input type=checkbox name=chartype_$ctn value=\"1\" $ischecked[$charchecked[$ctn]]>Show $chartypetext[$ctn] Characters</input>";
	}
	print "</td>\n";
	$ctn++;
	print "</tr>";
	
	print "<tr>";
	print "<td style=\"font-size : xx-small;\" valign=middle><input type=radio name=sortby value=3 $sortchecked[3]>Sort By STATs Approval</input></td>\n";
	print "<td style=\"font-size : xx-small;\"></td>\n";
	print "<td style=\"font-size : xx-small;\">";
	if ($numchartypes > $ctn)
	{
		print "<input type=checkbox name=chartype_$ctn value=\"1\" $ischecked[$charchecked[$ctn]]>Show $chartypetext[$ctn] Characters</input>";
	}
	print "</td>\n";
	$ctn++;
	print "</tr>";
	
	print "<tr>";
	print "<td style=\"font-size : xx-small;\" valign=middle><input type=radio name=sortby value=4 $sortchecked[4]>Sort By Character Type</input></td>\n";
	print "<td style=\"font-size : xx-small;\"></td>\n";
	print "<td style=\"font-size : xx-small;\">";
	if ($numchartypes > $ctn)
	{
		print "<input type=checkbox name=chartype_$ctn value=\"1\" $ischecked[$charchecked[$ctn]]>Show $chartypetext[$ctn] Characters</input>";
	}
	print "</td>\n";
	$ctn++;
	print "</tr>";
	
	print "<tr>";
	print "<td style=\"font-size : xx-small;\" valign=middle><input type=radio name=sortby value=5 $sortchecked[5]>Sort By Character Name</input></td>\n";
	print "<td style=\"font-size : xx-small;\"></td>\n";
	print "<td style=\"font-size : xx-small;\">";
	if ($numchartypes > $ctn)
	{
		print "<input type=checkbox name=chartype_$ctn value=\"1\" $ischecked[$charchecked[$ctn]]>Show $chartypetext[$ctn] Characters</input>";
	}
	print "</td>\n";
	$ctn++;
	print "</tr>";
		
	for (;$ctn < $numchartypes; $ctn++)
	{
		print "<tr>";
		print "<td style=\"font-size : xx-small;\" valign=middle></td>\n";
		print "<td style=\"font-size : xx-small;\"></td>\n";
		print "<td style=\"font-size : xx-small;\">";
		print "<input type=checkbox name=chartype_$ctn value=\"1\" $ischecked[$charchecked[$ctn]]>Show $chartypetext[$ctn] Characters</input>";
		print "</td>\n";
		print "</tr>";
	}
		
	print "<tr><td style=\"font-size : xx-small;\"><input type=checkbox name=hidebox value=1><i>Hide Control Panel</i></input</td>\n";
	print "<td style=\"font-size : xx-small;\"><input type=checkbox name=\"action\" value=\"makedef\"><i>Make Default</i></input</td>\n";
	print "<td style=\"font-size : xx-small;\"><input type=\"submit\" name=\"submit\" value=\"Submit\"></td>\n";
	print "</tr>";	
	print "</table>\n";
	print "</td></tr></table></p></form><BR>\n";
}

sub makeline()
{
	local($retVal) =  "?sortby=$sortby";
	$retVal .= "&onlypaid=$onlypaid";
	$retVal .= "&hidebox=$hidebox";
	for ($i = 0; $i < $numchartypes; $i++)
	{
	   $retVal .= "&chartype_$i=$charchecked[$i]";
	}
	return $retVal;
}

