#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "gmxp.pl";
$table = "characters";
$heading = "Experience Points";
$keyfield = "charid";
$keyvalue = $CGI->param($keyfield);
$namevalue = getCharPlayerStr($keyvalue);
$tplfile = "gmxp.tpl";
$errstr = $CGI->param("error");

if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to edit $heading(s)!"));
}
elsif ($action eq "addXP")
{
	print $CGI->header();
	$doctitle = "Add $heading for $namevalue";
	ParseForm($header);
     	print "<H1>$doctitle</H1>\n";
	print "<form action=\"$thispage\" method=\"post\">\n";
	fillvars();
	ParseForm($tplfile);
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>";
	print "</form>";
	print "<br><hr><a href=\"$thispage\">Return/Cancel</a>.";
	print "<br><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($submit eq "Add")
{
	# Insert and Redirect
	$SQL = filltablefromCGI("xp", 1);
	#print "$SQL<BR>";
	local($db) = dbconnect();
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thispage?action=details&$keyfield=$keyvalue&error=" . encodeURL("$heading added for $namevalue"));
}
elsif ($submit eq "Change")
{
	#print $CGI->header();
	# Update and Redirect
	$SQL = filltablefromCGI($table, 0);
	#print "$SQL<BR>";
	local($db) = dbconnect();
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$namevalue Updated"));
}
elsif ($action eq "delete")
{
	# delete and Redirect
	#print "$SQL<BR>";
	local($db) = dbconnect();
	$SQL = "delete from $table where $keyfield = $keyvalue;";
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$namevalue Deleted"));
}
elsif ($action eq "details")
{
	print $CGI->header;
	$doctitle = "Show XP Details for $namevalue";
	ParseForm($header);
	
	if ("$errstr" ne "")
	{
	   print "<font color=red>$errstr</font><BR><BR>\n";
	}
	
	print "<H1>$doctitle </h1>\n";
	
	print "<a href=\"$thispage?action=addXP&$keyfield=$keyvalue\">Add XP</a><BR><BR>\n";
	
	local($db) = dbconnect();
	local ($sql) = "select * from xp where charid=$keyvalue order by entrydate;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>XP</b></td>\n";
	print "<td><b>Notes</b></td>\n";
	print "<td><b>Entrydate</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $xp = $resptr->{"xp"};
	   print "<tr>\n";
	   print "<td>$xp</td>\n";
	   print "<td>".$resptr->{"notes"}."</td>\n";
	   print "<td>".$resptr->{"entrydate"}."</td>\n";
	   print "</tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;

	print "<br><hr><a href=\"$thispage\">Return</a>."; 
	print "<br><a href=\"login.pl\">Main menu</a>."; 
		
	ParseForm($footer);
}
else
{
	print $CGI->header;
	$doctitle = "Manage ".$heading;
	ParseForm($header);
	
	if ("$errstr" ne "")
	{
	   print "<font color=red>$errstr</font><BR><BR>\n";
	}
	
	print "<H1>$doctitle </h1>\n";
	
	showdata();

	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=delete&$keyfield=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
	
	ParseForm($footer);
}

exit 0;

sub showdata()
{
	local($db) = dbconnect();
	local ($sql) = "select $keyfield from $table order by clast;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Character Name</b></td>\n";
	print "<td><b>XP</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $key = $resptr->{"$keyfield"};
	   $name = getCharPlayerStr($key);
	   print "<tr>\n";
	   print "<td>$name</td>\n";
	   $xp = dosql("select sum(xp) from xp where charid=$key;") + 0;
	   print "<td>$xp</td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=addXP&$keyfield=$key\">Add XP</a> -- \n";
	   print "<a href=\"$thispage?action=details&$keyfield=$key\">Show Details</a>\n";
	   print "</td></tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub fillvars()
{
	filltable();
	$entrydate = getDBDate();
}

