#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "journal.pl";
$table = "journal";
$heading = "Journal";
$keyfield = "jid";
$keyvalue = $CGI->param($keyfield);
$namefield = "entrydate";
$tplfile = "journal.tpl";
$errstr = $CGI->param("error");
$charid = $CGI->param("charid") + 0;
$charname = getCharName($charid);

if ($pid != getPIDFromCharID($charid) && $al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to edit that character's Journal"));
}
elsif ($action eq "new" || $action eq "edit")
{
	print $CGI->header();
	if ($keyvalue eq "")
	{
		$doctitle = "Add $heading\n";
	}
	else
	{
        	$doctitle = "Edit $heading\n";
	}
	ParseForm($header);
	print "<H1>$doctitle</H1>\n";
	print "<form action=\"$thispage\" method=\"post\">";
	fillvars();
	ParseForm($tplfile);
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>";
	}
	else
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>";
	}
	print "</form>";
	print "<br><hr><a href=\"$thispage\">Return</a>.";
	print "<br><hr><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($submit eq "Add")
{
	# Insert and Redirect
	$SQL = filltablefromCGI($table, 1);
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?charid=$charid&error=" . encodeURL("$heading Added"));
}
elsif ($submit eq "Change")
{
	#print $CGI->header();
	# Update and Redirect
	$SQL = filltablefromCGI($table, 0);
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?charid=$charid&error=" . encodeURL("$heading Updated"));
}
elsif ($action eq "delete")
{
	# delete and Redirect
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$SQL = "delete from $table where $keyfield = $keyvalue;";
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?charid=$charid&error=" . encodeURL("$heading Deleted"));
}
elsif ($action eq "addgmcomment")
{
	# Update and Redirect
	#print $CGI->header;
	$oldcomment = dosql("select gmcomments from journal where $keyfield = $keyvalue;"); 
	$newcomment = $CGI->param("gmcomments");
	$newcomment =~ s/'/''/g;
	$myname =  getFullNameFromID(getPlayerID());
	$date = getDate();
	$oldcomment .= "\n<b>$date - $myname</b>\n$newcomment\n";
	$SQL = "update journal set gmcomments='$oldcomment' where $keyfield = $keyvalue;";  
	#print "$SQL<BR>\n";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?charid=$charid&error=" . encodeURL("GM Comment Added"));
}
elsif ($action eq "editgmcomments")
{
	print $CGI->header;
	$doctitle = "Manage Journal for $charname";
	ParseForm($header);
	$oldcomment = dosql("select gmcomments from journal where $keyfield = $keyvalue;"); 
	print "<H2>Edit GM Comments</H2>";
	print "<form action=\"$thispage\" method=\"post\">";
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	print "<input type=\"hidden\" name=\"action\" value=\"updategmcomments\">\n";
	print "<input type=\"hidden\" name=\"charid\" value=\"$charid\">\n";
	print "<textarea name=\"gmcomments\" COLS=80 ROWS=10>$oldcomment</textarea><BR>\n";
	print "<input type=\"submit\" name=\"submit\" value=\"Update Comments\"><BR>";
	print "</form>";
	
	ParseForm($footer);
}
elsif ($action eq "updategmcomments")
{
	# Update and Redirect
	#print $CGI->header;
	$newcomment = $CGI->param("gmcomments");
	$newcomment =~ s/'/''/g;
	$SQL = "update journal set gmcomments='$newcomment' where $keyfield = $keyvalue;";  
	#print "$SQL<BR>\n";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?charid=$charid&error=" . encodeURL("GM Comment Updated"));
}
else
{
	print $CGI->header;
	
	if ($action eq "bydate" && $al >= $gm_access)
	{
		$doctitle = "Manage Journals By Date";
		ParseForm($header);

		print "<font color=red>$errstr</font><BR><BR>\n";
 		
 		local @monthnames= ('January','February','March','April','May','June','July','August','September','October','November','December');
		
		$month = $CGI->param("month");
		$day = $CGI->param("day");
		$year = $CGI->param("year");

		print "<H1>All Journals On Or After $monthnames[$month] $day, $year</H1>\n";

		showbydatedata();
	}
	else
	{
		$doctitle = "Manage Journal for $charname";
		ParseForm($header);

		print "<font color=red>$errstr</font><BR><BR>\n";

		print "<H1>$doctitle</H1>\n";

		print "<a href=\"$thispage?charid=$charid&action=new\">ADD a NEW Journal Entry</a><BR><BR>\n";

		print "<p><i>Please keep in mind that your journal entry is private between you and the GMs.  Nobody else can read it.  All we care asbout is what you did during the episode, what happened to you and what your plans are.  This does not have to be literature.</i></p>\n";

		showdata();
	}

	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?charid=$charid&action=delete&$keyfield=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	
	print "function toggleElementState(id)\n";
	print "{\n";
	print "	   var show = document.getElementById('show_' + id);\n";
	print "	   var toggle = document.getElementById('toggle_' + id);\n";
	print "	   show.value = 1 - show.value;\n";
	print "	   var element = document.getElementById('comment_' + id);\n";
	print "	   if (show.value > 0)\n";
	print "    {\n";
	print "		element.style[\"display\"] = \"inline\";\n";
	print "	 	toggle.innerHTML=\"[-]\";\n";
	print "    }\n";
	print "	   else\n";
	print "    {\n";
	print "		element.style[\"display\"] = \"none\";\n";
	print "	 	toggle.innerHTML=\"[+]\";\n";
	print "    }\n";
	print "}\n";

	print "</script>\n";
	
	ParseForm($footer);
}

exit 0;

sub showbydatedata()
{
	local($db) = dbconnect();
	$month++;
	local ($sql) = "select * from $table where $namefield >= '$year-$month-$day' order by $namefield desc;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	local ($resptr);
	while ($resptr = $query->fetchrow_hashref())
	{
	   showentry($resptr);
	}
	$query->finish;
	$db->disconnect;
}

sub showdata()
{
	local($db) = dbconnect();
	local ($sql) = "select * from $table where charid=$charid order by $namefield desc;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	local ($resptr);
	while ($resptr = $query->fetchrow_hashref())
	{
	   showentry($resptr);
	}
	$query->finish;
	$db->disconnect;
}

sub showentry()
{
	local ($resptr) = $_[0];
	$key = $resptr->{"$keyfield"};
	$entry = $resptr->{"entry"};
	$gmcomments = $resptr->{"gmcomments"};

	print "<hr><h2>".$resptr->{"title"}."</h2>\n";
	print "<a ID=\"toggle_$key\" href=\"javascript:toggleElementState('$key');\">[-]</a> \n";
	print "<i>".$resptr->{"entrydate"}."\n";
	if ($action eq "bydate")
	{
		print " -- ".getCharPlayerStr($resptr->{"charid"})."\n";
	}
	print "</i><BR>\n";

	$entry =~ s/\n/<BR>/g;
	$gmcomments =~ s/\n/<BR>/g;
	print "<input type=hidden ID=\"show_$key\" value=1>\n";
	print "<div ID=\"comment_$key\">\n";
	print "<table border=1 cellspacing=0 cellpadding=1 width=100% bgcolor=\"#eeeeee\">\n";
	print "<tr><td>\n";
	print "<p>$entry</p>\n";
	print "</td></tr></table>\n";
	print "</div>\n";
	print "<a href=\"$thispage?charid=$charid&action=edit&$keyfield=$key\">Edit</a> -- \n";
	print "<a href=\"javascript:deleteConfirm('this entry',$key);\">Delete</a>\n";
}

sub fillvars()
{
	$t = $charid;
	filltable();
	$charid = $t;
	if ($entrydate eq "")
	{
	   $entrydate = getDBDate();
	}
}

