#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "keyroles.pl";
$table = "keyroles";
$heading = "a Key Role";
$keyfield = "krid";
$keyvalue = $CGI->param($keyfield);
$namefield = "krname";
$tplfile = "";

if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to edit Key Roles."));
}

if ($action eq "new" || $action eq "edit")
{
	print $CGI->header();
	ParseForm($header);
	if ($keyvalue eq "")
	{
		print "<H1>Add $heading</H1>\n";
	}
	else
	{
        	print "<H1>Edit $heading</H1>\n";
	}
	print "<form action=\"$thispage?\" method=\"post\">";
	if ($tplfile eq "")
	{
		local($dbvar) = dbconnect();
		local($query) = $dbvar->prepare("explain $table");
		local(@array);
		local(@arrNames);
		$query->execute;
		local($ind) = 0;
		    while (@arrCols = $query->fetchrow_array)
		    {
		    $arrNames[$ind] = $arrCols[0];
		    $array[$ind] = $arrCols[1];
		    $ind++;
		    }
		$query->finish;
		$query = $dbvar->prepare("select * from $table where $keyfield = $keyvalue");
		$query->execute;
		local($indFirstRecord) = 0;
		print "<table border=0>\n";
		@arrVals = $query->fetchrow_array;
		$input = $arrVals[0];
		print "<tr>\n<td>$arrNames[0]:</td><td>$input</td>\n</tr>\n";
		local($i) = 0;    
		    for($i=1;$i<$ind;$i++)
		    {
			if ($array[$i] eq "tinyint(1)")
			{
			    if ($arrVals[$i] eq "on")
			    {
			    $checked = " CHECKED";
			    }
			    else
			    {
			    $checked = "";
			    }
			$input = "<input type=\"checkbox\" name=\"$arrNames[$i]\"$checked>";
			}
			elsif ($array[$i] eq "mediumtext")
			{
			$input = "<textarea name=\"$arrNames[$i]\" COLS=20 ROWS=5>$arrVals[$i]</textarea>";
			}
			else
			{
			$input = "<input type=\"text\" name=\"$arrNames[$i]\" size=20 value=\"$arrVals[$i]\">";
			}
		    print "<tr>\n<td>$arrNames[$i]:</td><td>$input</td>\n</tr>\n";
		    }
		$indFirstRecord = 1;
		$query->finish;
		$dbvar->disconnect;
		print "</table>";
	}
	else
	{
	     fillvars();
	     ParseForm($tplfile);
	}
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>";
	}
	else
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>";
	}
	print "</form>";
	print "<br><hr><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($submit eq "Add")
{
	# Insert and Redirect
	@names = $CGI->param;
	$SQL = "INSERT into $table (";
	foreach $i(@names)
	{
	    if (($i ne $keyfield) && ($i ne "submit"))
	    {
		$SQL .= "$i, ";
	    }

	}
	chop $SQL;
	chop $SQL;
	$SQL .= ") values (";
	foreach $i(@names)
	{
	    if (($i ne $keyfield) && ($i ne "submit"))
	    {
		local($myCGI) = $CGI->param($i);
		$myCGI =~ s/'/''/g;
		$SQL .= "'" . $myCGI . "', ";
	    }
	 }
	chop $SQL;
	chop $SQL;
	$SQL .= ");";
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Added"));
}
elsif ($submit eq "Change")
{
	# Update and Redirect
	@names = $CGI->param;
	$SQL = "UPDATE $table set ";
	foreach $i(@names)
	{
	    if (($i ne $keyfield) && ($i ne "submit"))
	    {
		local($myCGI) = $CGI->param($i);
		$myCGI =~ s/'/''/g;
		$SQL .= "$i = '" . $myCGI . "', ";
	    }
	}
	chop $SQL;
	chop $SQL;
	$SQL .= " where $keyfield = $keyvalue;";
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Updated"));
}
elsif ($action eq "delete")
{
	# delete and Redirect
	$SQL = "delete from $table where $keyfield = $keyvalue;";
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Deleted"));
}
elsif ($action eq "addabilities")
{
	print $CGI->header();
	ParseForm($header);
	fillvars();
	print "<h1>Add/Edit Abilities for $krname</H1>\n";
	print "<form action=\"keyroles.pl\" name=\"myform\" method=\"post\">\n";
	$myabilities = getmyabilities();
	$abilitiesstr = getabilitiesstr();
	ParseForm("kraddab.tpl");
	ParseForm("stats/stats-js.tpl");
	print "<input type=hidden name=\"$keyfield\" value=\"$keyvalue\">\n";
	print "<input type=hidden name=\"tab\" value=\"999\">\n";
	print "<input type=hidden name=\"abremain\" value=\"0\">\n";
	print "<input type=hidden name=\"aballowed\" value=\"0\">\n";
	print "<input type=hidden name=\"handicaptot\" value=\"0\">\n";
	print "<input type=hidden name=\"abcost\" value=\"0\">\n";
	print "</form>\n";
	ParseForm($footer);
}
elsif ($submit eq "AddAbility")
{
	#print $CGI->header();
	updateAbilities();

	local ($difficulty) = 0;
	local ($cost) = 0;
	local ($abid) = $CGI->param("abid");
	local($db) = dbconnect();
	local ($sql) = "select difficulty, cost, type from abilities where abid=$abid;";
	#print "$sql<BR>";
	local ($query) = $db->prepare($sql);
	$query->execute;
	while (@array = $query->fetchrow_array)
	{
	   $difficulty = $array[0];
	   $cost = $array[1];
	   $type = $array[2];
	}
	$query->finish;
	$sql = "insert into keyroleabilities ($keyfield, abid, difficulty, cost) values ($keyvalue, $abid, '$difficulty', $cost);";
	#print "$sql<BR>";
	$db->do($sql);
        if ($type eq "Resource")
        {
		$sql = "select max(kraid) from keyroleabilities where $keyfield=$keyvalue and abid=$abid;";
		$query = $db->prepare($sql);
		$query->execute;
		local ($kraid) = 0;
		while (@array = $query->fetchrow_array)
		{
		   $kraid = $array[0]; 
		}
		$query->finish;
		$sql = "select typeid, level from resourcetypelink where abid=$abid;";
		$query = $db->prepare($sql);
		$query->execute;
		while (@array = $query->fetchrow_array)
		{
		   $sql = "insert into keyrolerresourcetypelink (typeid, level, $keyfield, abid) values ($array[0], $array[1], $keyvalue, $kraid)";
		   $db->do($sql);
		}
		$query->finish;
		}
	$db->disconnect;

	print $CGI->redirect("$thispage?action=addabilities&$keyfield=$keyvalue");
}
elsif ($submit eq "RemoveAbility")
{
	#print $CGI->header();
	updateAbilities();

	local ($kraid) = $CGI->param("kraid");
	local($db) = dbconnect();
	$sql = "delete from keyroleabilities where kraid=$kraid;";
	#print "$sql<BR>";
	$db->do($sql);
   	$sql = "delete from keyrolerresourcetypelink where abid=$kraid;";
   	#print "$sql<BR>";
   	$db->do($sql);
	$db->disconnect;

	print $CGI->redirect("$thispage?action=addabilities&$keyfield=$keyvalue");
}
elsif ($action eq "finishabilities")
{
	#print $CGI->header();
	updateAbilities();
	
	print $CGI->redirect("$thispage");
}
elsif ($action eq "addcharacters")
{
	print $CGI->header();
	ParseForm($header);
	fillvars();
	print "<h1>Add/Edit Characters for $krname</H1>\n";
	print "<h2>My Characters</h2>";
	print getmycharacters();
	print "<a href=\"$thispage\">Done</a>\n";
	print "<h2>Available Characters</h2>";
	print getcharactersstr();
	ParseForm($footer);
}
elsif ($action eq "addchar")
{
	#print $CGI->header();

	local ($charid) = $CGI->param("charid");
	local($db) = dbconnect();
	local ($sql) = "insert into keyrolecharacters (krid, charid) values ($keyvalue, $charid);";
	#print "$sql<BR>";
	$db->do($sql);
	$db->disconnect;

	print $CGI->redirect("$thispage?action=addcharacters&$keyfield=$keyvalue");
}
elsif ($action eq "remchar")
{
	#print $CGI->header();

	local ($charid) = $CGI->param("charid");
	local($db) = dbconnect();
	local ($sql) = "delete from keyrolecharacters where krid=$keyvalue and charid=$charid;";
	#print "$sql<BR>";
	$db->do($sql);
	$db->disconnect;

	print $CGI->redirect("$thispage?action=addcharacters&$keyfield=$keyvalue");
}
else
{
	print $CGI->header;
	ParseForm($header);
	print "<H1>Key Role Menu</h1>\n";
	print "<H2>Edit Key Roles</h2>\n";

	showkeyroles();

	print "<BR><a href=\"$thispage?action=new\">ADD a NEW Key Role</a>\n";
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=delete&$keyfield=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
	
	ParseForm($footer);
}

exit 0;

sub showkeyroles()
{
	local($db) = dbconnect();
	local ($sql) = "select * from keyroles order by $namefield;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Key Role</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   print "<tr>\n";
	   print "<td>".$resptr->{"$namefield"}."</td>\n";
	   print "<td><a href=\"\" onClick=\"javascript:window.open('krpop.pl?$keyfield=".$resptr->{"$keyfield"}."','','width=450,height=550,left = 100,top = 100,scrollbars=1,resizable=1');\">Display</a>\n";
	   print " -- <a href=\"$thispage?action=edit&$keyfield=".$resptr->{"$keyfield"}."\">Edit</a>\n";
	   print " -- <a href=\"$thispage?action=addabilities&$keyfield=".$resptr->{"$keyfield"}."\">Add Abilities</a>\n";
	   print " -- <a href=\"$thispage?action=addcharacters&$keyfield=".$resptr->{"$keyfield"}."\">Add Characters</a>\n";
	   print " -- <a href=\"javascript:deleteConfirm('".$resptr->{"$namefield"}."',".$resptr->{"$keyfield"}.");\">Delete</a></td>\n";
	   print "</tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub fillvars()
{
	filltable();

	$catselect = makeDropDown("abilitycategories", "category", "category", "", "", $category);
	$challengeselect = makeDropDown("abilitychallenge", "challenge", "challenge", "", "", $challenge);
	$diffselect = makeDropDown("abilitydifficulty", "difficulty", "difficulty", "", "", $difficulty);
	$typeselect = makeDropDown("abilitytypes", "type", "type", "", "", $type);
	$allowedselect = makeDropDown("abilityallowed", "allowed", "allowed", "", "", $allowed);
}

sub getmyabilities()
{
	$totalcost = 0;
	local ($retstr) = "";
	local($db) = dbconnect();
	local ($sql) = "select a.kraid, a.abid, b.name, b.type, a.level, a.text, a.difficulty, a.cost from keyroleabilities a, abilities b where a.$keyfield=$keyvalue and a.abid=b.abid order by b.type, b.name;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	$retstr .= "<table border=1>\n";
	$retstr .= "<tr>\n";
	$retstr .= "<td><b>Level</b></td>\n";
	$retstr .= "<td><b>Type</b></td>\n";
	$retstr .= "<td><b>Name</b></td>\n";
	$retstr .= "<td><b>Text</b></td>\n";
	$retstr .= "<td><b>Difficulty</b></td>\n";
	$retstr .= "<td><b>Cost</b></td>\n";
	$retstr .= "<td><b>Action</b></td>\n";
	$retstr .= "</tr>\n";
	local ($num) = 0;
	while ($resptr = $query->fetchrow_hashref())
	{
	   local($mult) = 1;
	   if ($resptr->{"type"} eq "Handicap")
	   {
	   	$mult = -1;
	   }
	   $retstr .= "<input type=hidden name=kraid_$num value=".$resptr->{"kraid"}.">\n";
	   $retstr .= "<tr>\n";
	   $retstr .= "<td><input type=text name=level_$num value=".$resptr->{"level"}." maxsize=5 size=5 OnKeyUp=\"setcost(this.form,parseInt(this.value), 'cost_$num','".$resptr->{"difficulty"}."');\"></td>\n";
	   $retstr .= "<td>".$resptr->{"type"}."</td>\n";
	   $retstr .= "<td><a href=\"\" onClick=\"javascript:window.open('abilitypop.pl?abid=".$resptr->{"abid"}."','','width=450,height=550,left = 500,top = 100,scrollbars=1,resizable=1');\">".$resptr->{"name"}."</a></td>\n";
	   $retstr .= "<td><input type=text name=text_$num value=\"".$resptr->{"text"}."\" maxsize=50 size=50>\n";
	   if ($resptr->{"type"} eq "Resource")
	   {
	       $retstr .= showResourceLinks($resptr->{"kraid"});
	   }
	   $retstr .= "</td>\n";
	   $retstr .= "<td>".$resptr->{"difficulty"}."</td>\n";
	   local ($cost) = $resptr->{"cost"} * $mult;
	   $retstr .= "<td><input type=text name=cost_$num ID=cost_$num value=$cost maxsize=5 size=5 READONLY style=\"background : #DDDDDD;\"></td>\n";
	   $retstr .= "<td><a href=\"javascript:createredirect('$thispage?kraid=".$resptr->{"kraid"}."&submit=RemoveAbility')\">Remove</a></td>";
	   $retstr .= "</tr>\n";
	   $totalcost += $cost;
	   $num += 1;
	}
	$retstr .= "</table>\n";
	$retstr .= "<input type=hidden name=num_abs value=$num>\n";
	$query->finish;
	$db->disconnect;
	return $retstr;
}

sub getabilitiesstr()
{
	local ($retstr) = "";
	local($db) = dbconnect();
	local ($sql) = "select * from abilities where allowed!='None' order by type, name;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	$retstr .= "<table border=1>\n";
	$retstr .= "<tr>\n";
	$retstr .= "<td><b>Name</b></td>\n";
	$retstr .= "<td><b>Type</b></td>\n";
	$retstr .= "<td><b>Action</b></td>\n";
	$retstr .= "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
		$retstr .= "<tr>\n";
		$retstr .= "<td>".$resptr->{"name"}."</td>\n";
		$retstr .= "<td>".$resptr->{"type"}."</td>\n";
		$retstr .= "<td><a href=\"\" onClick=\"javascript:window.open('abilitypop.pl?abid=".$resptr->{"abid"}."','','width=450,height=550,left = 500,top = 100,scrollbars=1,resizable=1');\">Display</a>\n";
		$retstr .= " -- <a href=\"javascript:createredirect('$thispage?abid=".$resptr->{"abid"}."&submit=AddAbility')\">Add</a>\n";
		$retstr .= "</tr>\n";
	}
	$retstr .= "</table>\n";
	$query->finish;
	$db->disconnect;
	return $retstr;
}

sub showResourceLinks()
{
  	local ($abid) = $_[0];
	local($db) = dbconnect();
	local ($sql) = "select a.type, b.level from resourcetypes a, keyrolerresourcetypelink b where a.typeid=b.typeid and b.abid=$abid;";
	#print "$sql<BR>";
	local($query) = $db->prepare($sql);
	$query->execute;
	$levels[0] = "None";
	$levels[1] = "Low";
	$levels[2] = "Average";
	$levels[3] = "High";
	local (@array);
	$rlretstr = "<table border = 0 width=100% cellspacing=0 cellpadding=0><tr>\n";
	while (@array = $query->fetchrow_array())
	{
	     $rlretstr .= "<td style=\"font-family : Arial, Helvetica, sans-serif; font-size: 12;\"><b>$array[0]:</b>  $levels[$array[1]]</td>";
	}
	$rlretstr .= "</tr></table>\n";
	$query->finish;
	$db->disconnect;
	return $rlretstr;
}

sub updateAbilities()
{
	#print $CGI->header;
	local ($numabs) = $CGI->param("num_abs") * 1;
	local($db) = dbconnect();
	for ($num = 0; $num < $numabs; $num++)
	{
	  local ($level) = $CGI->param("level_$num");
	  local ($text) = $CGI->param("text_$num");
          $text =~ s/'/''/g;
	  local ($cost) = $CGI->param("cost_$num");
	  local ($kraid) = $CGI->param("kraid_$num");
	  local $sql = "update keyroleabilities set level=$level, text='$text',cost=$cost where kraid=$kraid;";
	  #print"$sql<BR>";
	  $db->do($sql);
	}
	$db->disconnect;
}

sub getmycharacters()
{
	$totalcost = 0;
	local ($retstr) = "";
	local($db) = dbconnect();
	local ($sql) = "select * from keyrolecharacters where $keyfield=$keyvalue;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	$retstr .= "<table border=1>\n";
	$retstr .= "<tr>\n";
	$retstr .= "<td><b>Character Name</b></td>\n";
	$retstr .= "<td><b>Type</b></td>\n";
	$retstr .= "<td><b>Player Name</b></td>\n";
	$retstr .= "<td><b>Action</b></td>\n";
	$retstr .= "</tr>\n";
	local ($num) = 0;
	while ($resptr = $query->fetchrow_hashref())
	{
	   local ($charid) = $resptr->{"charid"};
	   $retstr .= "<tr>\n";
	   $retstr .= "<td>".getCharName($charid)."</td>\n";
	   $retstr .= "<td>".getCharTypeFromCharID($charid)."</td>\n";
	   $retstr .= "<td>".getFullNameFromCharID($charid)."</td>\n";
	   $retstr .= "<td><a href=\"$thispage?$keyfield=$keyvalue&charid=$charid&action=remchar\">Remove</a></td>\n";
	   $retstr .= "</tr>\n";
	}
	$retstr .= "</table>\n";
	$query->finish;
	$db->disconnect;
	return $retstr;
}

sub getcharactersstr()
{
	local ($retstr) = "";
	local($db) = dbconnect();
	local ($sql) = "select * from characters order by clast;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	$retstr .= "<table border=1>\n";
	$retstr .= "<tr>\n";
	$retstr .= "<td><b>Character Name</b></td>\n";
	$retstr .= "<td><b>Type</b></td>\n";
	$retstr .= "<td><b>Player Name</b></td>\n";
	$retstr .= "<td><b>Action</b></td>\n";
	$retstr .= "</tr>\n";
	local ($num) = 0;
	while ($resptr = $query->fetchrow_hashref())
	{
	   local ($charid) = $resptr->{"charid"};
	   $retstr .= "<tr>\n";
	   $retstr .= "<td>".getCharName($charid)."</td>\n";
	   $retstr .= "<td>".getCharTypeFromCharID($charid)."</td>\n";
	   $retstr .= "<td>".getFullNameFromCharID($charid)."</td>\n";
	   $retstr .= "<td><a href=\"$thispage?$keyfield=$keyvalue&charid=$charid&action=addchar\">Add</a></td>\n";
	   $retstr .= "</tr>\n";
	}
	$retstr .= "</table>\n";
	$query->finish;
	$db->disconnect;
	return $retstr;
}