#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "ledger.pl";
$table = "money";
$heading = "Ledger";
$keyfield = "charid";
$keyvalue = $CGI->param($keyfield);
$tplfile = "ledger.tpl";
$errstr = $CGI->param("error");

if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to edit $heading(s)!"));
}
elsif ($action eq "edit")
{
	print $CGI->header();
	$doctitle="Edit $heading";
	ParseForm($header);
        print "<H1>$doctitle</H1>\n";
	print "<form action=\"$thispage\" method=\"post\">";
        fillvars();
        ParseForm($tplfile);
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>";
	print "</form>";
	print "<br><hr><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($action eq "add")
{
	print $CGI->header();
        fillvars();
        $doctitle="Add Transactions For $charname";
	ParseForm($header);
        print "<H1>$doctitle</H1>\n";
	print "<form action=\"$thispage\" method=\"post\">";
	print "<i>Starting money: $money<BR>\n";
	print "<table border=0 width=100%>\n";
	for ($i = 0; $i < 10; $i++)
	{
	  print "<tr>";
	  print "<td>Transaction ".($i+1).":</td><td><input type=\"text\" name=\"trans_$i\" value=\"0\" size=5></td>\n";
	  print "<td>Notes: <input type=\"text\" name=\"notes_$i\" value=\"\" size=50></td>\n";
	  print "</tr>\n";
	}
	print "</table>\n";
	print "<input type=\"checkbox\" name=\"keepgoing\" value=\"1\"> Enter more transactions</input><BR>\n";
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	print "<input type=\"submit\" name=\"submit\" value=\"Update\"><BR>";
	print "</form>";
	print "<br><hr><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($submit eq "Update")
{
	# Insert and Redirect
	local($dbvar) = dbconnect();
	for ($i = 0; $i < 10; $i++)
	{
	  $money = $CGI->param("trans_$i") + 0;
	  $notes = $CGI->param("notes_$i");
	  $notes =~ s/'/''/g;
	  if ($money != 0)
	  {
		$SQL = "insert into money (charid, pounds, entrydate, notes) values ($keyvalue,";
		$SQL .= "$money,'";
		$SQL .= getDBDate() . "', '$notes');";
		$dbvar->do($SQL);
	  }
	}
	$dbvar->disconnect;
	if ($CGI->param("keepgoing") + 0 > 0)
	{
	   print $CGI->redirect("$thispage?action=add&charid=$keyvalue");
	}
	else
	{
	   print $CGI->redirect("$thispage?error=" . encodeURL("$heading Added"));
	}
}
elsif ($submit eq "Change")
{
	#print $CGI->header();
	# Update and Redirect
	$SQL = "insert into money (charid, pounds, entrydate) values ($keyvalue,";
	$SQL .= ($CGI->param("money") - getMoney($keyvalue)).",'";
	$SQL .= getDBDate() . "');";
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Updated"));
}
elsif ($action eq "history")
{
	print $CGI->header();
        fillvars();
        $doctitle="Show Transaction History For $charname";
	ParseForm($header);
        print "<H1>$doctitle</H1>\n";
        
	local($db) = dbconnect();
	local ($sql) = "select * from money where $keyfield=$keyvalue order by entrydate;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Date</b></td>\n";
	print "<td><b>Money</b></td>\n";
	print "<td><b>Notes</b></td>\n";
	print "</tr>\n";
	local ($resptr);
	while ($resptr = $query->fetchrow_hashref())
	{
	   print "<tr>\n";
	   print "<td>".$resptr->{"entrydate"}."</td>\n";
	   print "<td>".$resptr->{"pounds"}."</td>\n";
	   print "<td>".$resptr->{"notes"}."</td>\n";
	   print "</tr>\n";
	}
	print "<tr>\n";
	print "<td><b><i>Total</i></b></td>\n";
	print "<td><b><i>".getMoney($keyvalue)."</i></b></td>\n";
	print "</tr>\n";
	print "</table>\n";
	$query->finish;
	$db->disconnect;        
        
	print "<br><a href=\"$thispage\">Return</a>.";
	print "<br><hr><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
else
{
	print $CGI->header;
	$doctitle = "Manage ".$heading."s";
	ParseForm($header);
	
	print "<font color=red>$errstr</font><BR><BR>\n";
	
	print "<H1>$doctitle</h1>\n";

	showdata();

	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=delete&$keyfield=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
	
	ParseForm($footer);
}

exit 0;

sub showdata()
{
	local($db) = dbconnect();
	local ($sql) = "select charid from characters where chartype <= $cast_character order by clast;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td width=55%><b>Character</b></td>\n";
	print "<td><b>Money</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	local (@array);
	while (@array = $query->fetchrow_array)
	{
	   $charid = $array[0];
	   $name = getCharPlayerStr($charid);
	   $money = getMoney($charid);
	   print "<tr>\n";
	   print "<td width=55%>$name</td>\n";
	   print "<td>$money</td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=edit&$keyfield=$charid\">Edit</a>\n";
	   $name = getCharName($charid);
	   $name =~ s/'//g;
	   print " -- <a href=\"$thispage?action=add&$keyfield=$charid\">Add Transactions</a>\n";
	   print " -- <a href=\"$thispage?action=history&$keyfield=$charid\">Show History</a>\n";
	   print "</td></tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub fillvars()
{
	$charname = getCharName($keyvalue);
	$money = getMoney($keyvalue);
}

