#!/usr/bin/perl

# Require and Use
# * These statements alert perl.exe that
# * you are going to be using functions, 
# * subroutines, and methods from other
# * perl programs. "require" is used for a
# * perl library, and the "use" statement 
# * is usually used to reference a perl
# * object (usually referred to as a 
# * module).
require 'common.pl';
use DBI;
use CGI;
use CGI::Cookie;

$CGI = new CGI;
$pid = getPlayerID();
$plotid = $CGI->param("plotid");
$action = $CGI->param("action");

$thisfile = "linkgroups.pl";
$table = "plotgroups";
$keyfield = "groupid";
$keyvalue = $CGI->param("$keyfield");

if (getAccessLevel($pid) < $writer_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You don't have access to that function"));
}
elsif ($action eq "add")
{
	#print $CGI->header();
	local($db) = dbconnect();
	$SQL = "insert into $table (plotid, $keyfield) values ($plotid, $keyvalue);";
	#print "$SQL<BR>\n";
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thisfile?plotid=$plotid");
}
elsif ($action eq "del")
{
	#print $CGI->header();
	local($db) = dbconnect();
	$SQL = "delete from $table where plotid=$plotid and $keyfield=$keyvalue;";
	#print "$SQL<BR>\n";
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thisfile?plotid=$plotid");
}
else
{
	print $CGI->header();
	ParseForm($header);

	print "<H1>Link Groups To Plot:</H1>\n";
	print "<center>\n";
	
	local($db) = dbconnect();
	$SQL = "select groupid, groupname from charactergroups order by groupname;";
	#print "$SQL<BR>";
	local($query) = $db->prepare($SQL);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Group Name</b></td>\n";
	print "<td><b>Linked</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	if ($query->rows > 0)
	{
	   local (@array);
	   while (@array = $query->fetchrow_array)
	   {
		   print "<tr>\n";
		   print "<td>$array[1]</i></td>\n";
		   if (isLinked($array[0]))
		   {
			print "<td><b>Yes</b></td>\n";
			print "<td><a href=\"$thisfile?action=del&plotid=$plotid&$keyfield=$array[0]\">Remove</a></td>\n";
		   }
		   else
		   {
			print "<td>No</td>\n";
			print "<td><a href=\"$thisfile?action=add&plotid=$plotid&$keyfield=$array[0]\">Add</a></td>\n";
		   }
		   print "</tr>\n";
	   }
	}
	$query->finish;
	$db->disconnect;
	print "</table>\n";
	print "</center>\n";

	print "<a href=\"plots.pl?submit=Update&plotid=$plotid\">Return to Plot</a><BR>\n";
	print "<br><hr><a href=\"login.pl\">Return to the main menu</a>.\n";
        ParseForm($footer);
}


sub isLinked()
{
  local($varID) = $_[0];
  local($db) = dbconnect();
  local ($SQL) = "select * from $table where plotid=$plotid and $keyfield=$varID;";
  #print "$SQL<BR>";
  local($query) = $db->prepare($SQL);
  $query->execute;
  local ($retval) = $query->rows;
  $query->finish;
  $db->disconnect;
  return $retval;
}


