#!/usr/bin/perl -D

require 'stat_inc.pl';
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$table = "occupations";
$keyfield = "oid";
$keyvalue = $CGI->param($keyfield);
$charid = $CGI->param("charid");
$pid = getPlayerID();

filltable();

print $CGI->header();
print "<html>\n";
print "<head>\n";
print "<link href=\"../brassy.css\" rel=\"stylesheet\" type=\"text/css\">\n";
print "<title>$oname</title>\n";
print "</head>\n";
print "<body background=\"../paper.jpg\">\n";

print "<H1>$oname</H1>\n";

print "<b>Description</b>:<BR>\n";
print "$odesc<BR><BR>\n";

if ($stipend ne "")
{
  print "<i>The money for this job comes from the British Government.  If the government goes bankrupt, you won't get paid.</i><BR><BR>";
}

print "Your <b>Base Status</b> must be at least $req_status for you to get money from this occupation between games.<BR><BR>\n";

print "You will receive between $base_income and ".($base_income  + ($d10_base_income * 10))." each BGP (Between Games Period).<BR><BR>\n";

print "If your Effective Status drops below $req_status, you will lose between $base_stigma_modifier and ".($base_stigma_modifier  + ($d10_stigma_modifier * 10))." for each point your Effective Status is less than $req_status each BGP.<BR><BR>\n";

print "If you perform your occupation as a BGA, you will receive between $base_bga_income and ".($base_bga_income  + ($d10_bga_income * 10))." for each BGA performed as such.<BR><BR>\n";

print "<b>Abilities Required</b>:<BR>\n";
print "<i>You must have the following abilities at the following levels or you will not gain money from this occupation between games.  If an Ability is listed at level 0, then it is an optional Ability that adds to your level bonus, but is not required.</i><BR>\n";

print getoccabilities($oid);

print "<BR>If the sum of <i>your</i> levels of all the abilities above is at least ".($levtot + $skill_bonus_threshold).", you will receive between $base_skill_bonus and ".($base_skill_bonus  + ($d10_skill_bonus * 10))." per level greater than ".($levtot + $skill_bonus_threshold)." as additional income each BGP.<BR><BR>\n";

if ($charid ne "")
{
    $charname = getCharName($charid);
    print "<H1>$charname as a $oname</H1>\n";
    print "<i>An example BGP.</i><BR><BR>\n";
    
    setSTATvars();
    
    $tot = 0;
    
    if ($status < $req_status)
    {
	print $charname."'s Base Status of $status is not enough to perform the duties of a $oname.  Base Status of at least $req_status is required.<BR><BR>But let's pretend that the Status was high enough...<BR><BR>\n";
    }
    
    $num = $base_income + d11($d10_base_income);
    $tot = $num;
    print $charname." will receive a base income of between $base_income and ".($base_income  + ($d10_base_income * 10))." each BGP.  This BGP, the income is $num.<BR><BR>\n";
	
    $effstatus = $status + geteffectivestatus($charid);
    
    if ($effstatus < $req_status)
    {
	$amt = $req_status - $effstatus;
    	$num = ($base_stigma_modifier * $amt) + d11($d10_stigma_modifier * amt);
    	$tot -= $num;
    
    	print "Because $charname has an Effective Status of $effstatus, which is less than $req_status, $charname lost $num this BGP.<BR><BR>\n";
    }

    $amt = int(rand(3)) + 1;
    $num = ($base_bga_income * $amt) + d11($d10_bga_income * $amt);
    $tot += $num;
    print $charname." will receive an income of between $base_bga_income and ".($base_bga_income  + ($d10_bga_income * 10))." for each BGA.  Assume $amt BGAs performed as a $oname. The income from BGAs is $num.<BR><BR>\n";

    checkabilities();   
    
    print "<b>Total money earned this BGP is $tot.</b><BR>\n";
}
	
print "</body>\n";
print "</html>\n";

exit 0;


sub getoccabilities()
{
  	local ($val) = $_[0];
        $levtot = 0;
	local ($retstr) = "";
	local($db) = dbconnect();
	local ($sql) = "select a.ocabid, b.name, a.minlevel, a.text, b.req_text, b.abid from occupationabilities a, abilities b where a.oid=$val and a.abid=b.abid order by b.name, a.text;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	$retstr .= "<table border=1>\n";
	$retstr .= "<tr>\n";
	$retstr .= "<td><b>Name</b></td>\n";
	$retstr .= "<td><b>Text</b></td>\n";
	$retstr .= "<td><b>Min Level</b></td>\n";
	$retstr .= "</tr>\n";
	local ($num) = 0;
	local ($resptr);
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"name"};
	   $name =~ s/_//g;
	   $retstr .= "<tr>\n";
	   $retstr .= "<td>$name</td>\n";
	   $retstr .= "<td>".$resptr->{"text"}."</td>\n";
	   $retstr .= "<td>".$resptr->{"minlevel"}."</td>\n";
	   $retstr .= "</tr>\n";
	   $num++;
	   $levtot += $resptr->{"minlevel"};
	}
	if ($uses_weird_science ne "")
	{
	   $retstr .= "<tr>\n";
	   $retstr .= "<td>Weird Science</td>\n";
	   $retstr .= "<td> </td>\n";
	   $retstr .= "<td>1</td>\n";
	   $retstr .= "</tr>\n";
	   $num++;
	   $levtot += 1;
	}
	$retstr .= "</table>\n";
	$query->finish;
	$db->disconnect;
	return $retstr;
}


sub checkabilities()
{
        $levtot = 0;
        $mylev = 0;
        $failed = 0;
	local ($retstr) = "";
	local($db) = dbconnect();
	local ($sql) = "select a.abid, a.minlevel, a.text, b.name, b.req_text from occupationabilities a, abilities b where a.$keyfield=$keyvalue and a.abid=b.abid order by b.name, a.text;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"name"};
	   $text = $resptr->{"text"};
	   $num = getlevel($name, $text) + 0;
	   $name =~ s/_//g;
	   if ($resptr->{"req_text"} > 0)
	   {
	     $name .= " $text";
	   }
	   
	   if ($num == 0 && $resptr->{"minlevel"} > 0)
	   {
	      print "You need at least a ".$resptr->{"minlevel"}." in $name.  $charname does not even have this Ability.<BR>\n";
	      $failed++;
	   }
	   elsif ($num < $resptr->{"minlevel"})
	   {
	      print "You need at least a ".$resptr->{"minlevel"}." in $name.  $charname only has a $num.<BR>\n";
	      $failed++;
	   }
	   $levtot += $resptr->{"minlevel"};
	   $mylev += $num;
	}
	$query->finish;
	$db->disconnect;
	
	if ($uses_weird_science ne "")
	{
	   setSTATvars();
	   $num = $weirdscience;
	   if ($num == 0)
	   {
	      print "You need at least a 1 in Weird Science.  $charname does not even have this Ability.<BR>\n";
	      $failed++;
	   }
	   $levtot += 1;
	   $mylev += $num;
	}
	
	if ($failed > 0)
	{
	  print "<BR>$charname does not have the right Abilities to be a $oname.  Technically, $charname would receive no income between games as a $oname.<BR><BR>\n";
	}
	elsif ($mylev >= $levtot + $skill_bonus_threshold)
	{
	  $amt = $mylev + 1 - ($levtot + $skill_bonus_threshold);
    	  $num = ($base_skill_bonus * $amt) + d11($d10_skill_bonus * $amt);
    	  $tot += $num;
    	  
	  print "$charname is very skilled as a $oname and receives a bonus $num this BGP.<BR><BR>\n";
	}
	else
	{
	  print "$charname has the skills to be a $oname, but does not get any skill bonus.<BR><BR>\n";
	}	
}
