#!/usr/bin/perl

require 'stat_inc.pl';
require 'g_invest.pl';
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "packing.pl";
$table = "character";
$heading = "x";
$keyfield = "x";
$keyvalue = $CGI->param($keyfield);
$namefield = "x";
$tplfile = "x.tpl";
$errstr = $CGI->param("error");

if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to view this page!"));
}
else
{
	print $CGI->header;
	ParseForm($header);
	
	print "<font color=red>$errstr</font><BR><BR>\n";
	
	print "<H1>Character Packet Stuffing List</h1>\n";
	$sql = "select eventname from events where eventid=$current_episode;";
	print "<H2>".dosql($sql)."</h2>\n";
	print "<p><i>This will only show character types whose pack trait is 1.  <a href=\"chartypes.pl\">Manage character types</a></i></p>\n";
	
	showdata();

	print "<br><br>"; 
	
	print "<H2>Assumptions</H2>\n";
	print "This list operates under the following assumptions:<br>"; 
	print "<ul>"; 
	print "<li>Every player gets one packet."; 
	print "<li>Every player has one character."; 
	print "<li>Each character has a history/BGA Results/stats book.";
	print "<li>Each character has a name badge with a star chart on back."; 
	print "<li>Each character gets a combat card (if we get them made in time)."; 
	print "<li>Each player gets a rule book."; 
	print "<li>Some players have contingency envelopes (can't be tracked here)."; 
	print "<li>Characters with alternate identities also get name badges."; 
	print "<li>Members of Parliament get the docket."; 
	print "<li>Members of Parliament get district votes."; 
	print "<li>Mages get random components."; 
	print "<li>Inventors get plans, and random parts."; 
	print "<li>Alchemists get random alchemical components."; 
	print "<li>All characters get status votes."; 
	print "<li>All characters get a ledger sheet."; 
	print "<li>All characters get resource tokens."; 
	print "<li>All characters get scandal sheets equal to 2 + their level of scandalize + 4 if an AoP.";
	print "<li>AoPs get special information sheets and lists of substatus.";
	print "<li>All characters with Foreign Contacts get Politial Capital.";
	print "<li>Character get items.  Important items should be listed in the database.";
	print "<li>Characters with the Blackmail resource get blackmail snippets."; 
	print "</ul>"; 
	
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=delete&$keyfield=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
	
	ParseForm($footer);
}

exit 0;

sub showdata()
{
	$db = dbconnect();
	local ($sql) = "select * from players a, eventplayers b where a.playerid=b.playerid and b.eventid=$current_episode and b.reglevel > $not_attending order by a.plast;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	$numtok = 0;
	%numpcap = ();
	$numchar = 0;
	$numbadges = 0;
	$moneytot = 0;
	$numdocket = 0;
	$numss = 0;
	$cmcktot = 0;
	$tothome = 0;
	$manatot = 0;
	$holytot = 0;
	$insptot = 0;
	$scandtot= 0;
	$totpcap = 0;
	$box = "&nbsp;&nbsp;&nbsp;<img src=\"square.gif\">";
	$totbs = dosql("select max(groupid) from charactergroups;");
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"plast"} . ", " . $resptr->{"pfirst"};
	   $key = $resptr->{"playerid"};
	   @charidArr = getCharIDFromPID($key);
	   foreach $charid (@charidArr)
	   {
	     if ($charid > 0)
	     {
		$charname = getCharName($charid);
		$money = dosql("select pounds from money where charid=$varID;");
		$moneytot += $money;
		setSTATvars($charid);
		print "<b>$name: $charname</b><BR>\n";
		print "$box Character History/BGA Results/STATs Booklet<BR>\n";
		print "$box General Rules Book<BR>\n";
		print "$box $charname: Name Badge<BR>\n";
		showaliasnamebadges($key);
		print "$box $charname: Ledger for $money<BR>\n";
		
		showbluesheets($charid);
		
		$scandalsheets = 2 + getlevel("SCANDALIZE") + (4 * haskeyrole("Arbiter of Propriety"));
		$numss += $scandalsheets;
		print "$box $scandalsheets Scandal Sheets<BR>\n";

		$num = getnumresourcetokens($charid);
		$numtok += $num;
		print "$box $num Resource/Voting Tokens<BR>\n";
		local(%temphash) = getnumpoliticalcapital($charid);
	   	for my $key ( keys %temphash ) 
	   	{
		   $numpcap{$key} += $temphash{$key};
		   $totpcap += $temphash{$key};
	        }
		if ($ispar == 1)
		{
		   print "$box $charname: Parliament District Votes<BR>\n";
		   $tothome++;
		}
		
		print "$box 2 Status $status Favor Sheets/Game Period<BR>\n";
		$favors[$status] += 2;
		
		$sql = "select count(a.abid) from characterabilities a, abilities b where a.charid=$charid and a.abid = b.abid and b.type = 'Combat Manuever';";
		$num = dosql($sql);
		if ($num > 0)
		{
		   print "$box Combat Manuever Checklist<BR>\n";
		   $cmcktot++;
		}
		if ($mana > 0)
		{
		   print "$box $mana MANA<BR>\n";
		   $manatot += $mana;
		}
		if ($holy > 0)
		{
		   print "$box $holy Celestial<BR>\n";
		   $holytot += $holy;
		}
		if ($inspiration > 0)
		{
		   print "$box $inspiration Inspiration<BR>\n";
		   $insptot += $inspiration;
		}
		
		$num = 2 + getlevel("SCANDALIZE");
		if (haskeyrole("Arbiter of Propriety"))
		{
		   $num += 4;
		}
		print "$box $num Scandal Sheets<BR>\n";
		$scandtot += $num;
		
		$num = getlevel("BLACKMAIL MATERIAL") + 0;
		if ($num > 0)
		{
		   print "$box Blackmail Snippets<BR>\n";
		
		}
		showinventory($charid);
		
		print "<BR>\n";

		$numchar++;
	   } #charid > 0
	  } #foreach
	} #while
	$query->finish;
	$db->disconnect;
	
	$numbadges += $numchar;
	$nbsp = "&nbsp;&nbsp;&nbsp;&nbsp;";
	print "<H2>Summary</H2>\n";
	print "$nbsp $numchar characters<BR>\n";
	print "$nbsp $numchar general rules book<BR>\n";
	print "$nbsp $numbadges Name Badges<BR>\n";
	print "$nbsp $numtok voting/resource tokens<BR>\n";
	print "$nbsp $tothome District Votes<BR>\n";	
  	for my $key ( sort keys %numpcap ) 
  	{
  	      my $value = $numpcap{$key};
  	      print "$nbsp $value Political Capital for $key (double this for bonus)<BR>\n";
  	}
	print "$nbsp ".int($numtok*1.5)." Bonus Political Capital for England<BR>\n";  
	$topcap += int($numtok*1.5);
	print "$nbsp <i>$totpcap Total Political Capital</i><BR>\n";
	print "$nbsp $numss Scandal Sheets<BR>\n";
	print "$nbsp $moneytot in Ledgers<BR>\n";
   	#print "$nbsp $numchar RTLB: Brassy's Rules Sheets<BR>\n";
   	#print "$nbsp $numchar Social Rules Sheets<BR>\n";
   	#print "$nbsp $numchar Parliament/Speeches Rules Sheets<BR>\n";
	for ($i = 0; $i <$totbs + 25; $i++)
	{
	  if ($numbs[$i] > 0)
	  {
	     print "$nbsp $numbs[$i] $namebs[$i] Blue Sheets<BR>\n";
	  }
	}
   	print "$nbsp $numdocket Copies of the Docket<BR>\n";
	for ($i = 0; $i < 10; $i++)
	{
	  if ($favors[$i] > 0)
	  {
	     print "$nbsp $favors[$i] Status $i Favor Sheets/Game Period<BR>\n";
	  }
	}
   	print "$nbsp $cmcktot Combat Cards<BR>\n";
   	print "$nbsp $manatot MANA<BR>\n";
   	print "$nbsp $holytot Celestial<BR>\n";
   	print "$nbsp $insptot Inspiration<BR>\n";
   	print "$nbsp $scandtot Scandal Sheets<BR>\n";
	
}

sub getCharIDFromPID()
{
   $varID = $_[0];
   if ($varID eq "")
   {
	return 0;
   }
   local($query) = $db->prepare("select a.charid from characters a, playercharacters b where a.charid=b.pccharid and a.charid > 0 and b.pcplayerid=$varID;");
   $query->execute;
   local (@array);
   local (@retArr) = 0;
   local ($num) = 0;
   while (@array = $query->fetchrow_array)
   {
	local ($sql) = "select a.value from chartypetraitlink a, characters b, chartypetraits c where a.ctypeid = b.chartype and a.cttid = c.cttid and c.traitname = 'pack' and b.charid=$array[0];";
	if (dosql($sql) > 0)
	{
        	$retArr[$num] = $array[0];
        	$num++;
        }
   }
   $query->finish;
   return @retArr;
}



sub fillvars()
{
	filltable();
}


sub getnumresourcetokens()
{
   local($varID) = $_[0];
   local ($sql) = "select status from characterSTATs where charid=$varID;";
   #print $sql;
   local($retval) = "0";
   local($query) =$db->prepare($sql);
   $query->execute;
   local (@array);
   @array = $query->fetchrow_array;
   $retval = $array[0];
   $query->finish;
   
   $retval += getlevel("GENUINE CURIOUSITY/FAMOUS");
   $retval -= getlevel("SOCIAL STIGMA ______________");
   
   $sql = "select c.level, a.level from characterresourcetypelink a, resourcetypes b, characterabilities c where a.charid=$varID and a.typeid=b.typeid and b.type='Votes' and c.caid=a.abid;";
   #print "$sql<BR>\n";
   $query =$db->prepare($sql);
   $query->execute;
   while (@array = $query->fetchrow_array)
   {
      if ($array[1] == 1) #low
      {
        $retval += int($array[0] / 2);
      }
      if ($array[1] == 2) #average
      {
        $retval += $array[0];
      }
      if ($array[1] == 3) #high
      {
        $retval += $array[0] * 2;
      }
      if ($array[1] == 4) #super
      {
        $retval += $array[0] * 3;
      }
   }
   $query->finish;
   
  
   $sql = "select c.level, a.level from keyrolerresourcetypelink a, resourcetypes b, keyroleabilities c, keyrolecharacters d where a.typeid=b.typeid and b.type='Votes' and c.kraid=a.abid and a.krid=d.krid and d.charid=$varID;";
   #print "$sql<BR>\n";
   $query =$db->prepare($sql);
   $query->execute;
   while (@array = $query->fetchrow_array)
   {
      if ($array[1] == 1) #low
      {
        $retval += int($array[0] / 2);
      }
      if ($array[1] == 2) #average
      {
        $retval += $array[0];
      }
      if ($array[1] == 3) #high
      {
        $retval += $array[0] * 2;
      }
      if ($array[1] == 4) #super
      {
        $retval += $array[0] * 3;
      }
   }

   $query->finish;
   return int($retval/3);
}

sub getnumpoliticalcapital()
{
   local($varID) = $_[0];

   local(%myhash) = (); 

   #$sql = "select c.level, a.level, c.text from characterresourcetypelink a, resourcetypes b, characterabilities c where a.charid=$varID and a.typeid=b.typeid and b.type='Votes' and c.caid=a.abid and c.abid=35;";
   $sql = "select c.level, 2, c.text from characterabilities c where c.charid=$varID and c.abid=35;";
   #print "$sql<BR>\n";
   local($query) =$db->prepare($sql);
   $query->execute;
   while (@array = $query->fetchrow_array)
   {
      if ($array[1] == 1) #low
      {
        $myhash{$array[2]} += int($array[0] / 2);
      }
      if ($array[1] == 2) #average
      {
        $myhash{$array[2]} += $array[0];
      }
      if ($array[1] == 3) #high
      {
        $myhash{$array[2]} += $array[0] * 2;
      }
      if ($array[1] == 4) #super
      {
        $myhash{$array[2]} += $array[0] * 3;
      }
   }
   $query->finish;
   
  
   #$sql = "select c.level, a.level, c.text from keyrolerresourcetypelink a, resourcetypes b, keyroleabilities c, keyrolecharacters d where a.typeid=b.typeid and b.type='Votes' and c.kraid=a.abid and a.krid=d.krid and d.charid=$varID and c.abid=35;";
   $sql = "select c.level, 2, c.text from keyroleabilities c, keyrolecharacters d where d.charid=$varID and c.krid=d.krid and c.abid=35;";
   #print "$sql<BR>\n";
   $query =$db->prepare($sql);
   $query->execute;
   while (@array = $query->fetchrow_array)
   {
      if ($array[1] == 1) #low
      {
        $myhash{$array[2]} += int($array[0] / 2);
      }
      if ($array[1] == 2) #average
      {
        $myhash{$array[2]} += $array[0];
      }
      if ($array[1] == 3) #high
      {
        $myhash{$array[2]} += $array[0] * 2;
      }
      if ($array[1] == 4) #super
      {
        $myhash{$array[2]} += $array[0] * 3;
      }
   }
   $query->finish;


   for my $key ( keys %myhash ) 
   {
        my $value = $myhash{$key};
        print "$box $value Political Capital for $key<BR>\n";
    }
  
   
   return %myhash;
}


sub showaliasnamebadges()
{
   $varID = $_[0];
   if ($varID eq "")
   {
	return "";
   }
   local($query) =$db->prepare("select * from characters a, playercharacters b where b.pcplayerid=$varID and a.charid=b.pccharid and a.chartype=$alias_character;");
   $query->execute;
   local ($resptr);
   local ($retVal) = 0;
   if ($query->rows > 0)
   {
	while ($resptr = $query->fetchrow_hashref())
	{
	   print "$box ".$resptr->{"cfirst"}." ".$resptr->{"clast"}.": Name Badge<BR>\n";
	   $numbadges++;
        }
   }
   $query->finish;
}

sub showbluesheets()
{
   $varID = $_[0];
   if ($varID eq "")
   {
	return "";
   }
   local ($sql) = "select a.* from charactergroups a, charactergroupmembers b, playercharacters c where b.charid=c.pccharid and a.groupid=b.groupid and c.pcplayerid=$key order by a.groupname;";
   local($query) =$db->prepare($sql);
   $query->execute;
   local ($resptr);
   local ($retVal) = 0;
   $ispar = 0;
   if ($query->rows > 0)
   {
	while ($resptr = $query->fetchrow_hashref())
	{
	   #print "$box ".$resptr->{"groupname"}.": Blue Sheet/Membership List<BR>\n";
	   #$numbs[$resptr->{"groupid"}]++;
	   #$namebs[$resptr->{"groupid"}] = $resptr->{"groupname"};
   
   	   if ($resptr->{"groupname"} eq "Parliament")
   	   {
   	        $ispar = 1;
   		print "$box The Docket<BR>\n";
		$numdocket++;
   	   }
        }
   }
   $query->finish;
   
   #print "$box RTLB: Brassy's Rules Sheet<BR>\n";
   #print "$box Social Rules Sheet<BR>\n";
   #print "$box Parliament/Speeches Rules Sheet<BR>\n";
   
   #if ($mana > 0)
   #{
   #	print "$box Magic Blue Sheet<BR>\n";
   #	$numbs[$totbs + 10]++;
   #	$namebs[$totbs + 10] = "Magic";
   #}
   #if ($holy > 0)
   #{
   #	print "$box Celestial Blue Sheet<BR>\n";
   #	$numbs[$totbs + 11]++;
   #	$namebs[$totbs + 11] = "Celestial";
   #}
   #if ($inspiration > 0)
   #{
   #	print "$box Invention Blue Sheet<BR>\n";
   #	$numbs[$totbs + 12]++;
   #	$namebs[$totbs + 12] = "Invention/Weird Science";
   #}
   
   if ($status >= 7)
   {
   	print "$box Upperclass Blue Sheet<BR>\n";
	$numbs[$totbs + 13]++;
	$namebs[$totbs + 13] = "Upperclass";
   }
   elsif ($status >= 4)
   {
   	print "$box Middle Class Blue Sheet<BR>\n";
	$numbs[$totbs + 14]++;
	$namebs[$totbs + 14] = "Middle Class";
   }
   elsif ($status >= 1)
   {
   	print "$box Lower Class Blue Sheet<BR>\n";
	$numbs[$totbs + 15]++;
	$namebs[$totbs + 15] = "Lower Class";
   }
   
}

sub showinventory()
{
   $varID = $_[0];
   if ($varID eq "")
   {
	return;
   }
   local ($sql) = "select * from inventory where owner=$varID;";
   local($query) = $db->prepare($sql);
   $query->execute;
   if ($query->rows > 0)
   {
	while ($resptr = $query->fetchrow_hashref())
	{
	   print "$box ".$resptr->{"name"}."<BR>\n";
        }
   }
   $query->finish;
   
   local ($sql) = "select * from inventory_dev a join WS_plans b on a.planid=b.planid where a.charid=$varID;";
   local($query) = $db->prepare($sql);
   $query->execute;
   if ($query->rows > 0)
   {
	while ($resptr = $query->fetchrow_hashref())
	{
	   print "$box ".$resptr->{"amount"}.": ".$resptr->{"name"}." (Weird Science Device)<BR>\n";
        }
   }
   $query->finish;
   
   local ($sql) = "select * from inventory_ws a join WS_parts b on a.wpid=b.wpid where a.charid=$varID;";
   local($query) = $db->prepare($sql);
   $query->execute;
   if ($query->rows > 0)
   {
	while ($resptr = $query->fetchrow_hashref())
	{
	   print "$box ".$resptr->{"amount"}.": ".$resptr->{"wpname"}." (Weird Science Part)<BR>\n";
        }
   }
   $query->finish;
   
   $numcomp = 0;
   local ($sql) = "select * from inventory_sc a join spellcomponents b on a.scid=b.scid where a.charid=$varID;";
   local($query) = $db->prepare($sql);
   $query->execute;
   if ($query->rows > 0)
   {
	while ($resptr = $query->fetchrow_hashref())
	{
	   print "$box ".$resptr->{"amount"}.": ".$resptr->{"scname"}." (Spell Component)<BR>\n";
	   $numcomp += $resptr->{"amount"};
        }
   }
   $query->finish;
   
   if ($numcomp < $mana)
   {
   	print "$box ".($mana - $numcomp)." additional Spell/Alchemical Components<BR>\n";
   }

   $numplans = 0;
   local ($sql) = "select * from characterplans a join WS_plans b on a.planid=b.planid where a.charid=$varID;";
   local($query) = $db->prepare($sql);
   $query->execute;
   if ($query->rows > 0)
   {
	while ($resptr = $query->fetchrow_hashref())
	{
	   print "$box Plans for: ".$resptr->{"name"}."<BR>\n";
	   $numplans++;
        }
   }
   $query->finish;

   if ($numplans < $inspiration)
   {
      print "$box ".($inspiration - $numplans)." additional Weird Science Plans<BR>\n";
   }

}
