#!/usr/bin/perl 

require 'common.pl';
use DBI;
use CGI::Session;
use CGI::Cookie;
use CGI qw/:standard/;
use File::Copy;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = max(getAccessLevel($pid),$player_access);

$accessarray[$player_access] = "Player Access";
$accessarray[$writer_access] = "Staff Access";
$accessarray[$gm_access] = "GM Access";
$accessarray[$developer_access] = "Database Developer Access";

#globals for this file
$thispage = "photos.pl";
$table = "doclib2";
$heading = "Photograph";
$keyfield = "docid";
$keyvalue = $CGI->param($keyfield);
$namefield = "filename";
$errstr = $CGI->param("error");

if ($action eq "editpic" && $al >= $gm_access)
{
	print $CGI->header;

	filltable();
	$doctitle = "Edit Picture: $filename";

	$db = dbconnect();
	$path = "doclib/" . makepath($dfid,"") . $filename;
	$nextpic = getnext($keyvalue, $dfid) + 0;
	$prevpic = getprev($keyvalue, $dfid) + 0;
	$db->disconnect;
	ParseForm($header);

	print "<H1>$doctitle</h1>\n";

	print "<table width = 100% border = 1 cellpadding=0 cellspacing=0>\n";
	print "<tr>\n";
	print "<td colspan=3 align=center>\n";
	print "<a href=\"$thispage?folder=$dfid\">";
        print "<img border=0 src=\"icons/up8.png\" alt=\"Back to Folder\"></a>\n";
        print "</td>\n";
	print "</tr>\n";
	print "<tr>\n";
	print "<td>\n";
	if ($prevpic > 0)
	{
        	print "<a href=\"$thispage?action=showpic&$keyfield=$prevpic\">";
        }
        else
	{
        	print "<a href=\"$thispage?folder=$dfid\">";
        }
        print "<img border=0 src=\"icons/back8.png\" align=left></a>\n";
        print "</td>\n";
	print "<td>\n";
        print "<img border=0 src=\"$path\" align=center>\n";
        print "</td>\n";
	print "<td>\n";
	if ($nextpic > 0)
	{
        	print "<a href=\"$thispage?action=showpic&$keyfield=$nextpic\">";
        }
        else
	{
        	print "<a href=\"$thispage?folder=$dfid\">";
        }
        print "<img border=0 src=\"icons/next8.png\" align=right></a>\n";
        print "</td>\n";
	print "</tr>\n";
	print "<tr>\n";
	print "<td colspan=3 align=center>\n";
	print $CGI->start_multipart_form(-name => "form1");
	print "<textarea name=\"notes\" COLS=50 ROWS=3>\n";
	print "$notes";
	print "</textarea>\n";
	print "<input type=checkbox name=ispicture $ispicture value=1> Show Picture</input>\n";
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	print "<input type=\"hidden\" name=\"filename\" value=\"$filename\">\n";
	print "<input type=\"hidden\" name=\"creator\" value=\"$creator\">\n";
	print "<input type=\"hidden\" name=\"status\" value=\"$status\">\n";
	print "<input type=\"hidden\" name=\"access\" value=\"$access\">\n";
	print "<input type=\"hidden\" name=\"dfid\" value=\"$dfid\">\n";
	print "<input type=\"hidden\" name=\"action\" value=\"update\">\n";
	print "<input type=\"submit\" name=\"submit\" value=\"Done\"><BR>";
	print $CGI->end_form;
        print "</td>\n";
	print "</tr>\n";
	print "</table>";
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 

	ParseForm($footer);
}
elsif ($action eq "update" && $al >= $gm_access)
{
	#print $CGI->header();
	# Update and Redirect
	$SQL = filltablefromCGI($table, 0);
	#print "$SQL<BR>";
	local($db) = dbconnect();
	$db->do($SQL);
	$db->disconnect;
	$ispicture = dosql("select ispicture from doclib2 where $keyfield=$keyvalue;") + 0;
	if ($ispicture > 0)
	{
		print $CGI->redirect("$thispage?action=showpic&$keyfield=$keyvalue");
	}
	else
	{
		$dfid = dosql("select dfid from doclib2 where $keyfield=$keyvalue;");
		print $CGI->redirect("$thispage?folder=$dfid");
	}
}
elsif ($action eq "showpic")
{
	print $CGI->header;
	filltable();
	$doctitle = "Show Picture: $filename";

	$db = dbconnect();
	$path = "doclib/" . makepath($dfid,"") . $filename;
	$nextpic = getnext($keyvalue, $dfid) + 0;
	$prevpic = getprev($keyvalue, $dfid) + 0;
	$db->disconnect;
	ParseForm($header);

	print "<H1>$doctitle</h1>\n";

	print "<table width = 100% border = 1 cellpadding=0 cellspacing=0>\n";
	print "<tr>\n";
	print "<td colspan=3 align=center>\n";
	print "<a href=\"$thispage?folder=$dfid\">";
        print "<img border=0 src=\"icons/up8.png\" alt=\"Back to Folder\"></a>\n";
        if ($al >= $gm_access)
        {
        	print " -- <a href=\"$thispage?action=editpic&$keyfield=$keyvalue\">Edit Notes</a>\n";
        }
        print "</td>\n";
	print "</tr>\n";
	print "<tr>\n";
	print "<td>\n";
	if ($prevpic > 0)
	{
        	print "<a href=\"$thispage?action=showpic&$keyfield=$prevpic\">";
        }
        else
	{
        	print "<a href=\"$thispage?folder=$dfid\">";
        }
        print "<img border=0 src=\"icons/back8.png\" align=left></a>\n";
        print "</td>\n";
	print "<td>\n";
        print "<img border=0 src=\"$path\" align=center>\n";
        print "</td>\n";
	print "<td>\n";
	if ($nextpic > 0)
	{
        	print "<a href=\"$thispage?action=showpic&$keyfield=$nextpic\">";
        }
        else
	{
        	print "<a href=\"$thispage?folder=$dfid\">";
        }
        print "<img border=0 src=\"icons/next8.png\" align=right></a>\n";
        print "</td>\n";
	print "</tr>\n";
	print "<tr>\n";
	print "<td colspan=3 align=center>\n";
	print "$notes";
        print "</td>\n";
	print "</tr>\n";
	print "</table>";
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 

	ParseForm($footer);
}
elsif ($action eq "editallnotes" && $al >= $gm_access)
{
	print $CGI->header;
	$folder = $CGI->param("folder") + 0;

	$doctitle = "$campaign Photographs";
	ParseForm($header);

	print "<H1>$doctitle</h1>\n";

	$db = dbconnect();
	print $CGI->start_multipart_form(-name => "form1");
	showdata($folder,1);
	print $CGI->end_form;
	$db->disconnect;
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 

	ParseForm($footer);
}
elsif ($action eq "batchnotes" && $al >= $gm_access)
{
	#print $CGI->header();
	# Update and Redirect
	$numfiles = $CGI->param("numfiles");
	
	for ($i = 0; $i < $numfiles; $i++)
	{
	   $notes = $CGI->param("notes_$i");
	   $key = $CGI->param("$keyfield_$i");
	   $notes =~ s/'/''/g;
	   $sql = "update $table set notes='$notes' where $keyfield=$key;";
	   dosql($sql);

	}
	$dfid = $CGI->param("folder");
	print $CGI->redirect("$thispage?folder=$dfid");
}
else
{
	print $CGI->header;
	$folder = $CGI->param("folder") + 0;

	$doctitle = "$campaign Photographs";
	ParseForm($header);

	print "<H1>$doctitle</h1>\n";

	$db = dbconnect();
	showdata($folder,0);
	$db->disconnect;
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 

	ParseForm($footer);
}


exit 0;

sub showdata()
{
        local($folder) = $_[0];
        local($isedit) = $_[1];
        
        $columns = 5;
        
        local($parent) = dosql("select parent from doclibfolders where dfid=$folder;");
        print "<p>\n";
        if ($folder > 0)
        {
        	print "<a href=\"$thispage?folder=$parent\"><img border=0 src=\"icons/back8.png\" align=left></a>\n";
        }
        print makepath($folder,"")."</p>\n";
        if ($al >= $gm_access)
        {
           if ($isedit == 0)
           {
           	print "<a href=\"$thispage?action=editallnotes&folder=$folder\">[Edit]</a><BR>\n";
           }
           else
           {
		print "<input type=\"hidden\" name=\"action\" value=\"batchnotes\">\n";
		print "<input type=\"hidden\" name=\"folder\" value=\"$folder\">\n";
		print "<input type=\"submit\" name=\"submit\" value=\"Done\"><BR>";
           }
        }
	print "<table width = 100% border = 1 cellpadding=0 cellspacing=0>\n";
	showfiles($folder,$isedit);
	local ($sql) = "select * from doclibfolders where access <= $al and parent=$folder and haspictures=1 order by foldername;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	local($resptr);
	local ($num) = 0;
	print "<tr>";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"foldername"};
	   $key = $resptr->{"dfid"};
	   $descr = $resptr->{"description"};
	   
	   print "<td width=".100/$columns."% align=center valign=middle>\n";
           if ($isedit == 0)
           {
	   	print "<a href=\"$thispage?folder=$key\"><img src=\"icons/photofolder.png\" border=0></a><BR>\n";
           }
           else
           {
	   	print "<img src=\"icons/photofolder.png\" border=0><BR>\n";
           }
	   print "<p>$name</p>\n";
	   print "<p>$descr</p>\n";
	   print "</td>\n";
	   $num++;
	   
	   if ($num % $columns == 0)
	   {
	 	print "</tr><tr>\n";
	   }
	   
	}
	print "</tr>\n";
	print "</table>\n";
        if ($al >= $gm_access)
        {
           if ($isedit > 0)
           {
		print "<input type=\"submit\" name=\"submit\" value=\"Done\"><BR>";
           }
        }
	$query->finish;
}

sub showfiles()
{
        local($parent) = $_[0];
        local($isedit) = $_[1];
	local ($sql) = "select * from $table where access <= $al and ispicture=1 and dfid=$parent order by $namefield;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	local($resptr);
	print "<tr>";
	$filenum = 0;
	while ($resptr = $query->fetchrow_hashref())
	{
	   displayfile($resptr,$isedit);
	   $filenum++;

	   if ($filenum % $columns == 0)
	   {
		print "</tr><tr>\n";
	   }
	}
	print "<input type=\"hidden\" name=\"numfiles\" value=\"$filenum\">\n";	
	print "</tr>\n";
	$query->finish;
}


sub displayfile()
{
	local ($resptr) = $_[0];
        local($isedit) = $_[1];
	local ($name) = $resptr->{"$namefield"};
	local ($notes) = $resptr->{"notes"};
	local ($key) = $resptr->{"$keyfield"};
	local ($access) = $resptr->{"access"};
	$thumb = getthumbnail("doclib/" . makepath($resptr->{"dfid"},""), $name);
	print "<td width=".100/$columns."% align=center valign=middle>\n";
	print "<a href=\"$thispage?action=showpic&$keyfield=$key\"><img src=\"$thumb\" border=0></a><BR>\n";
	if ($al >= $gm_access) 
	{
		print "<p>$name</p>\n";
	}
	if ($isedit > 0)
	{
		print "<input type=text name=\"notes_$filenum\" size=15 value=\"$notes\">\n";
		print "<input type=\"hidden\" name=\"$keyfield_$filenum\" value=\"$key\">\n";	
	}
	else
	{
		print "<p>$notes</p>\n";
	}
	print "</td>\n";
}

sub getthumbnail()
{
        local($curpath) = $_[0];
        local($myname) = $_[1];
        
        local (@exts) = (".gif", ".jpg", ".png", ".bmp", ".GIF", ".JPG", ".PNG", ".BMP");
        
        $myname =~ s!\..*!!;
        
        $curpath = $curpath . "thumb_" . $myname;
        
	foreach $e(@exts)
	{
		#print $curpath.$e."<BR>\n";
		if (-e $curpath.$e)
		{ 
	  		return $curpath.$e;
		}
	}    
	
	return "icons/thumbnail.png";
	
}


sub makepath()
{
        local($dfid) = $_[0];
        local($curpath) = $_[1];
	local ($sql) = "select parent, foldername from doclibfolders where dfid=$dfid;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	local(@array);
	@array = $query->fetchrow_array();
	$query->finish;
	#print "$dfid, $curpath, $array[0], $array[1]<BR>\n";
	if ($array[0] > 0)
	{
	  $curpath = makepath($array[0],$curpath);
	}
	return $curpath . $array[1] . "/";
}

sub getnext()
{
        local($key) = $_[0];
        local($dfid) = $_[1];
	local ($sql) = "select docid from $table where access <= $al and ispicture=1 and dfid=$dfid order by $namefield;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	local(@array);
	while (@array = $query->fetchrow_array())
	{
		if ($array[0] == $key)
		{
		   @array = $query->fetchrow_array();
		   $query->finish;
		   return $array[0];
		}
	}
	$query->finish;
	return 0;
}

sub getprev()
{
        local($key) = $_[0];
        local($dfid) = $_[1];
	local ($sql) = "select docid from $table where access <= $al and ispicture=1 and dfid=$dfid order by $namefield;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	local(@array);
	$prevval = 0;
	while (@array = $query->fetchrow_array())
	{
		if ($array[0] == $key)
		{
		   $query->finish;
		   return $prevval;
		}
		$prevval = $array[0];
	}
	$query->finish;
	return 0;
}
