#!/usr/bin/perl

# Require and Use
# * These statements alert perl.exe that
# * you are going to be using functions, 
# * subroutines, and methods from other
# * perl programs. "require" is used for a
# * perl library, and the "use" statement 
# * is usually used to reference a perl
# * object (usually referred to as a 
# * module).
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$pid = getPlayerID();
$access = getAccessLevel($pid);
$g_Group = $CGI->param("groupid");
$submit = $CGI->param("submit");

if ($access != 0)
{
    if ($g_Group ne "" && (playerInGroup($pid, $g_Group) || $access >= $gm_access) && $submit eq "")
    {
	print $CGI->header();
	ParseForm($header);
	local($dbvar) = dbconnect();
	local($qvar) = $dbvar->prepare("select * from playergroups where groupid = $g_Group");
	$qvar->execute;
	@array = $qvar->fetchrow_array;
	$groupName = $array[1];
	$groupDesc = $array[2];
	print "<br><font size=+1>Create/Edit Player Group</font><br><br>\n";
	print "<form name=\"frmCreate\" action=\"playergroups.pl\" method=\"post\">\n<table border=0 align=\"center\">\n<tr align=\"center\">\n";
	print "<td align=\"center\">Group Name<br><input type=\"text\" name=\"groupname\" maxsize=30 value=\"$groupName\"></td>\n</tr>\n<tr align=\"center\">\n";
	print "<td align=\"center\">Group Description<br><input type=\"hidden\" name=\"groupid\" value=\"$g_Group\"><input type=\"hidden\" value=\"1\" name=\"mode\"><textarea name=\"groupdesc\" cols=50 rows=5>$groupDesc</textarea></td>\n</tr>\n<tr align=\"center\">\n";
	print "<td>Players In This Group</td>\n</tr>\n<tr align=\"center\">\n";
	print "<td>\n";
	showPlayersInGroup($g_Group);
	print "</td>\n</tr>\n<tr align=\"center\">\n";
	print "<td><input type=\"submit\" name=\"submit\" value=\"Create/Update\"></td>\n";
	print "<td><input type=\"submit\" name=\"submit\" value=\"Delete This Group\"></td>\n</tr>\n</table>\n</form>\n";
	print "<H2>Add Players to Group</H2>\n";
	showPlayersForGroups($g_Group);
	print "<br><a href=\"playergroups.pl\">Return to Player Groups</a>.\n";
	print "<br><hr><a href=\"login.pl\">Main Menu</a>.\n";
	ParseForm($footer);
    }
    elsif ($g_Group ne "" && (playerInGroup($pid, $g_Group) || $access >= $gm_access) && $submit eq "Create/Update")
    {
	    #Update in Database
	    local($db) = dbconnect();
	    $groupDesc = $CGI->param("groupdesc");
	    $groupDesc =~ s/\'/\\'/g;
	    $groupDesc =~ s/\n/\n<br>\n/g;
	    $groupName = $CGI->param("groupname");
	    $groupName =~ s/\'/\\'/g;
	    $groupName =~ s/\n/\n<br>\n/g;
	    $query = $db->prepare("update playergroups set groupname = '$groupName', groupdesc = '$groupDesc', groupowner = $pid where groupid = $g_Group");
	    $query->execute;
	    $query->finish;
	    $db->disconnect;

	    #Redirect With Happy Message
	    print $CGI->redirect("playergroups.pl?msg=" . encodeURL("Group Successfully Updated"))
    }
    elsif ($g_Group ne "" && (playerInGroup($pid, $g_Group) || $access >= $gm_access) && $submit eq "Delete This Group")
    {
	#Delete From Database
	local($db) = dbconnect();
	$query = $db->prepare("delete from playergroups where groupid = $g_Group");
	$query->execute;
	$query->finish;
	$query = $db->prepare("delete from playergroupmembers where groupid = $g_Group");
	$query->execute;
	$query->finish;
	$db->disconnect;

	#Redirect With Happy Message
	print $CGI->redirect("playergroups.pl?msg=" . encodeURL("Group Successfully Deleted"));
    }
    elsif ($g_Group ne "" && (playerInGroup($pid, $g_Group) || $access >= $gm_access) && $submit eq "addplayer")
    {
	#Add Player to Group
	local($db) = dbconnect();
	$plid = $CGI->param("plid");
	$query = $db->prepare("insert into playergroupmembers (playerid, groupid) values ($plid,$g_Group);");
	$query->execute;
	$query->finish;
	$db->disconnect;

	#Redirect With Happy Message
	print $CGI->redirect("playergroups.pl?groupid=$g_Group");
    }
    elsif ($g_Group ne "" && (playerInGroup($pid, $g_Group) || $access >= $gm_access) && $submit eq "delplayer")
    {
	#Remove Player from Group
	local($db) = dbconnect();
	$plid = $CGI->param("plid");
	$query = $db->prepare("delete from playergroupmembers where playerid=$plid and groupid=$g_Group;");
	$query->execute;
	$query->finish;
	$db->disconnect;

	#Redirect With Happy Message
	print $CGI->redirect("playergroups.pl?groupid=$g_Group");
    }
    elsif ($g_Group eq "")
    {
    print $CGI->header();
    ParseForm($header);
        if ($CGI->param("msg") ne "")
        {
        $msg = $CGI->param("msg");
        print "<br><br><font color=\"red\">$msg</font>\n";
        }
    print "<br><br><center><font size=+1><b>Choose from My Groups</b></font></center><br><hr>\n";
    print printGroupList("playergroups.pl",$pid, $access);
    print "<H2><a href=\"creategroups.pl?mode=1\">Add New Group</a></H2>";
    print "<br><hr><a href=\"login.pl\">Main menu</a>.\n";
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"playergroups.pl?groupid=\"+jsid+\"&submit=Delete This Group\";\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
    ParseForm($footer);
    }
    else
    {
    print $CGI->redirect("playergroups.pl?msg=" . encodeURL("You do not have access to edit that group"))
    }
}
else
{
print $CGI->redirect("login.pl?error=" . encodeURL("You do not have access to this function"))
}

# ******************
# * printGroupList *
# ******************
# * printGroupList prints out a formatted list of player groups belonging to the passed-in playerid
# * that when clicked, go to the passed-in URL, passing the groupid.
sub printGroupList()
{
   local($url, $pid, $al) = @_;
   local($db) = dbconnect();
   local($query);
   $query =$db->prepare("select groupid, groupname, groupdesc, groupowner from playergroups");
   $query->execute;
   $returnStr = "<table border = 1>\n";
   $returnStr .= "<tr>\n";
   $returnStr .= "<td><b>Group Name</b></td>\n";
   $returnStr .= "<td><b>Description</b></td>\n";
   $returnStr .= "<td><b>Action</b></td>\n";
   $returnStr .= "</tr>\n";

   while (@array = $query->fetchrow_array)
   {
      if ($access >= $gm_access || (playerInGroup($pid, $array[0]) && $array[0] > $player_access ))
      {
	$returnStr .= "<tr>\n";
	$returnStr .= "<td>$array[1]</td>\n";
	$returnStr .= "<td>$array[2]</td>\n";
	$returnStr .= "<td>\n";
	$returnStr .= "<a href=\"$url?groupid=$array[0]\">Edit</a>\n";
	if ($access >= $gm_access || $array[3] == $pid)
	{
	   $returnStr .= "-- <a href=\"javascript:deleteConfirm('$array[1]',$array[0]);\">Delete</a>\n";
	}
	$returnStr .= "-- <a href=\"emailPlayer.pl?topid=".createPlayerEmailListForGroup($array[0])."\">Email Members</a>\n";
	$returnStr .= "</td>\n";
	$returnStr .= "</tr>\n";  
      }
   }
$returnStr .= "</table>\n";
$query->finish;
$db->disconnect;
return $returnStr;
}

sub showPlayersInGroup
{
	local($gid) = $_[0];
	local($db) = dbconnect();
	$SQL = "select a.playerid, concat(b.pfirst, ' ', b.plast) from playergroupmembers a, players b where a.groupid = $gid and a.playerid=b.playerid order by b.plast";

	local($query) =$db->prepare($SQL);
	$query->execute;
	if ($query->rows > 0)
	{
	    print "<table border=1>\n";
	    print "<tr>\n";
	    print "<td><b>Player Name</b></td>\n";
	    print "<td><b>Action</b></td>\n";
	    print "</tr>\n";
	    while (@array = $query->fetchrow_array)
	    {
	    	print "<tr>\n";
	    	print "<td>$array[1]</td>\n";
	    	   print "<td></td>\n";
	    	print "</tr>\n";
	    }
	    print "</table>\n";
	}
	$query->finish;
	$db->disconnect;
}

sub showPlayersForGroups
{
	local($gid) = $_[0];
	local($db) = dbconnect();
	$SQL = "select playerid, concat(pfirst, ' ', plast) from players where psecurity > 0 order by plast";

	local($query) =$db->prepare($SQL);
	$query->execute;
	if ($query->rows > 0)
	{
	    print "<table border=1>\n";
	    print "<tr>\n";
	    print "<td><b>Player Name</b></td>\n";
	    print "<td><b>Action</b></td>\n";
	    print "<td><b>Player Name</b></td>\n";
	    print "<td><b>Action</b></td>\n";
	    print "<td><b>Player Name</b></td>\n";
	    print "<td><b>Action</b></td>\n";
	    print "</tr>\n";
	    $count = 0;
	    while (@array = $query->fetchrow_array)
	    {
	      if (playerInGroup($array[0],$gid) == 0)
	      {
	        if ($count == 0)
	        {
	    	   print "<tr>\n";
	    	}
	    	print "<td>$array[1]</td>\n";
	    	print "<td><a href=\"playergroups.pl?submit=addplayer&plid=$array[0]&groupid=$gid\">Add</a></td>\n";
	    	$count++;
	    	if ($count == 3)
	    	{
	    	    print "</tr>\n";
	    	    $count = 0;
	    	}
	      }
	    }
	    print "</table>\n";
	}
	$query->finish;
	$db->disconnect;
}

sub playerInGroup
{
	local($plid) = $_[0];
	local($gid) = $_[1];
	local($db) = dbconnect();
	$SQL = "select * from playergroupmembers where playerid=$plid and groupid = $gid;";
	local($query) =$db->prepare($SQL);
	$query->execute;
        $query->finish;
        $db->disconnect;
        return $query->rows;
}

sub createPlayerEmailListForGroup
{
	local($gid) = $_[0];
	local($db) = dbconnect();
	$SQL = "select playerid from playergroupmembers where groupid = $gid;";
	local($query) =$db->prepare($SQL);
	$query->execute;
	$retstr = "";
	if ($query->rows > 0)
	{
	    local (@array);
	    while (@array = $query->fetchrow_array)
	    {
	       $retstr .= $array[0] . " ";
	    }
	    chop($retstr);
	    $retstr .= "&numpid=".$query->rows;
	}	
        $query->finish;
        $db->disconnect;
        return $retstr;
}

# *******************
# * playerOwnsGroup *
# *******************
# * playerOwnsGroup returns zero if a player doesn't own the group identified
# * by the groupid passed in.
sub playerOwnsGroup()
{
local($gid, $pid, $al) = @_;
local($db) = dbconnect();
local($query);
if ($gid eq "")
{
return 0;
}
if ($al >= 3)
{
return 1;
}
$query =$db->prepare("select groupid from playergroups where groupid = $gid and groupowner = $pid");
$query->execute;
$rows = $query->rows;
$query->finish;
$db->disconnect;
return $rows;
}
