#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$pqplayerid = $CGI->param("pqplayerid");
$mode = $CGI->param("mode");
$pid = getPlayerID();
$al = getAccessLevel($pid);
$table = "playerquestionnaires";

if ($al < $player_access)
{
	print $CGI->redirect("main.pl?error=" . encodeURL("You must be logged in to fill out a player questionnaire."));
	exit(0);
}
elsif ($al < $gm_access && $pid != $pqplayerid)
{
	print $CGI->redirect("main.pl?error=" . encodeURL("You cannot fill out a player questionnaire for this player."));
	exit(0);
}
elsif ($mode eq "new")
{
	$mode = "add";
	print $CGI->header();
	ParseForm($header);
	fillvars($pqplayerid);
	ParseForm("playquest.tpl");
	print "<br><hr><a href=\"main.pl\">Main menu</a>."; 
	ParseForm($footer);
}
elsif ($mode eq "edit")
{
	$mode = "change";
	print $CGI->header();
	ParseForm($header);
	fillvars($pqplayerid);
	ParseForm("playquest.tpl");
	print "<br><hr><a href=\"main.pl\">Main menu</a>."; 
	ParseForm($footer);
}
elsif (($mode eq "add") || ($mode eq "change"))
{
#print $CGI->header;
	&makeSQL($mode);
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	updateBoxes();
	print $CGI->redirect("main.pl");
	exit 0;
}


sub createBoxes
{
	local($boxnum) = $_[0];

	local($db) = dbconnect();
	local($sql) = "select * from boxes where boxid = $boxnum";
	local($query) =$db->prepare($sql);
	$query->execute;

	local($resptr) = $query->fetchrow_hashref();

	local($boxstring) = "<h2>".$resptr->{"boxname"}."</h2>";
	$boxstring .= "<i>".$resptr->{"boxdesc"}."</i><br>";

	$query->finish;

	local($sql) = "select * from boxcategories where boxid = $boxnum";
	local($query) =$db->prepare($sql);
	$query->execute;

	$boxstring .= "<table border = 0>";

	while ($resptr = $query->fetchrow_hashref())
	{
	   $boxstring .= "<tr><td align=top width=20%><input type=checkbox name=bcat".$resptr->{"bcid"}." value=".$resptr->{"bcid"};

	   $sql = "select * from playerboxes where pbbcid=".$resptr->{"bcid"}." and pbcharid=$cqcharid";
	   local($query2) =$db->prepare($sql);
	   $query2->execute;
	   if ($query2->rows > 0)
	   {
		$boxstring .= " CHECKED ";
	   }
	   $query2.finish;

	   $boxstring .= "><b>".$resptr->{"bcname"}."</b></input></td>";
	   $boxstring .= "<td width=80%><i>".$resptr->{"bcdesc"}."</i></td></tr>";
	}
	$query->finish;

	$db->disconnect();

	$boxstring .= "</table>";
	return $boxstring;
}


sub fillvars()
{
	local($p) = @_;
	local($db) = dbconnect();
	local($tab) = $db->prepare("explain playerquestionnaires");
	$tab->execute;
	$i = 0;
	while (@arrtemp = $tab->fetchrow_array)
	{
	  $arr[$i] = $arrtemp[0];
	  $arrTypes[$i] = $arrtemp[1];
	  #print "$arr[$i] - $arrTypes[$i]<br>\n";
	  $i++;
	}
	$numFields = $i;
	$tab->finish;
	local($query) = $db->prepare("select * from playerquestionnaires where pqplayerid = $p");
	$query->execute;
	@cqquery = $query->fetchrow_array;
	for ($k=0;$k<$tab->rows;$k++)
	{
	$cqquery[$k] =~ s/'/\\'/g;
	$cqquery[$k] =~ s/"/\"/g;
	#print "\$$arr[$k] = $cqquery[$k]<br>\n";
	    if ($arrTypes[$k] eq 'tinyint(1)')
	    {
		if ($cqquery[$k] > 0)
		{
		    eval("\$$arr[$k] = 'CHECKED'");
		}
		else
		{
		    eval("\$$arr[$k] = ''");
		}
	    }
	    else
	    {
		eval("\$$arr[$k] = '$cqquery[$k]'");
	    }
	}
	$query->finish;
	$pqplayerid = $p;

	$larpselect = makeArrayDropDown(['Never LARPed Before','Played 1-3 Games','Played 4-6 Games','Played only games at conventions','Played only full weekend standalone theater style games', 'Played only live combat -- boffer -- games', 'Played only simulated combat adventure games', 'Played more than I can remember...','Write em, run em, play em'],"pqlarpexp",[$pqlarpexp]);

	$sendselect = makeArrayDropDown(['Microsoft Word','Rich Text Format (RTF)','HTML','Plain Text','PDF'],"pqsendpref",[$pqsendpref]);

	$rtlbselect = makeArrayDropDown(['Not at all','Used it in a game or two','I have designed characters using RTLB','I can floor GM RTLB','...in my sleep','I wrote the system'],"pqrtlb",[$pqrtlb]);

	$db->disconnect;
}

sub makeSQL()
{
	local($action) = @_;
	local($table) = $CGI->param("table");
	local($db) = dbconnect();
	local($tab) = $db->prepare("explain $table");
	$tab->execute;
	@arr = $tab->fetchall_arrayref;
	$tab->finish;
	$db->disconnect;
	foreach my $row (@arr)
	{
		$type{$row[0]} = $row[1];
	}
	@names = $CGI->param;
	$SQL = "";
	if ($action eq "add")
	{
	    local($namestring) = "";
	    local($valstring) = "";
	    $SQL = "Insert into $table";
	    foreach my $parm (@names)
	    {
		if ($parm ne "mode" and $parm ne "submit" and $parm ne "table" and index($parm,"bcat") != 0)  
		{
		 $namestring .= ($parm . ", ");
		 $_ = $type{$parm};
		    if (/.*int.*/)
		    {
		    $valstring .= ($CGI->param($parm) . ", \n");
		    }
		    elsif ($CGI->param($parm) eq "on")
		    {
		    $valstring .= "1, \n";
		    }
		    else
		    {
		    $strCGI = $CGI->param($parm);
		    $strCGI =~ s/'/''/g;
		    $valstring .= ("'" . $strCGI . "', \n");            
		    }
		}
	    }
	    $SQL .= " (" . $namestring . "pqdate) VALUES (" . $valstring . "now())";
	    #print $CGI->header();
	    #print $SQL . "\n\n";
	}
	elsif($action eq "change")
	{
	    $SQL = "UPDATE $table SET ";
	    foreach my $parm (@names)
	    {
		if ($parm ne "mode" and $parm ne "submit" and $parm ne "table" and index($parm,"bcat") != 0)  
		{
		    $_ = $type{$parm};
		    if (/.*int.*/)
		    {
		    $SQL .= $parm . " = " . $CGI->param($parm) . ", \n";            
		    }
		    elsif ($CGI->param($parm) eq "on")
		    {
		    $SQL .= $parm . " = 1, \n";
		    }
		    else
		    {
		    $strCGI = $CGI->param($parm);
		    $strCGI =~ s/'/''/g;
		    $SQL .= $parm . " = '" . $strCGI . "', \n";            
		    }
		}
	    #print $parm . "<br>\n";
	    #print $SQL . "<br>\n";
	    }
	    $SQL .= "pqdate=now() where pqplayerid = " . $CGI->param("pqplayerid");
	    #print $CGI->header();
	    #print $SQL . "\n\n";
	}
	else
	{
	return "";
	}
}

sub updateBoxes()
{
local($table) = $CGI->param("table");
local($db) = dbconnect();
local($tab) = $db->prepare("explain $table");
$tab->execute;
@arr = $tab->fetchall_arrayref;
$tab->finish;
$db->disconnect;
foreach my $row (@arr)
{
        $type{$row[0]} = $row[1];
}
@names = $CGI->param;
local($myid)= $CGI->param("pqplayerid");
local($dbvar) = dbconnect();
$dbvar->do("delete from playerboxes where pbcharid=$myid");
foreach my $parm (@names)
{
   if (index($parm,"bcat") == 0)  
   {
	$strCGI = $CGI->param($parm);
	$strCGI =~ s/'/''/g;
	
	$SQL = "insert into playerboxes (pbbcid,pbcharid) values ($strCGI,$myid)";
	$dbvar->do($SQL);
   }
}
$dbvar->disconnect;
}

