#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "plotmatrix.pl";
$table = "plots";
$heading = "a Plot";
$keyfield = "sortby";
$keyvalue = $CGI->param($keyfield);
$namefield = "plname";
$tplfile = "abilities.tpl";

$approved[0] = "Unsubmitted";
$approved[1] = "Submitted";
$approved[2] = "Approved";


if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to view this page."));
}
else
{
	print $CGI->header;
	ParseForm($header);
	print "<H1>Character Plot/Matrix</h1>\n";
	
	$hidebox = $CGI->param("hidebox");
	if ("$hidebox" eq "1")
	{
	   print "<a href=\"$thispage?hidebox=0\" style=\"font-size : xx-small;\">Show Control Panel</a><BR>\n";
	}
	else
	{
	   plotcontrolpanel();
	}
	
	
	if ("$keyvalue" eq "2")
	{ 
	   sortbyplayername();
	}
	elsif ("$keyvalue" eq "3")
	{ 
	   sortbyGM();
	}
	elsif ("$keyvalue" eq "4")
	{ 
	   sortbyplot();
	}
	elsif ("$keyvalue" eq "5")
	{ 
	   sortbyepisode();
	}
	elsif ("$keyvalue" eq "6")
	{ 
	   sortbyboxes();
	}
	else #keyvalue is 1 or anything else
	{
	   sortbycharactername();
	}

	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	ParseForm($footer);
}

exit 0;

sub plotcontrolpanel()
{
	$didchecked = 0;
	for ($k=1;$k<7;$k++)
	{
	   if ("$k" eq "$keyvalue")
	   { 
	   	$ischecked[$k] = "checked";
	   	$didchecked = $k;
	   }
	   else
	   {
	   	$ischecked[$k] = "";
	   }
	}
	
	if ($didchecked == 0)
	{
	   $ischecked[1] = "checked";
	}
	
	$ssc= $CGI->param("ssc");
	$sapc= $CGI->param("sapc");
	$salc= $CGI->param("salc");
	$sti= $CGI->param("sti");
	
	$wherestr = "";
	$wherestr1 = "";
	$notestr = "<BR>";
	if ($salc ne "checked" && $ssc ne "checked" && $sapc ne "checked")
	{
	  $salc = "checked";
	}
	if ($salc ne "checked" && $ssc eq "checked" && $sapc ne "checked")
	{
	  $wherestr = "where charstoryapproved=1";
	  $wherestr1 = "and a.charstoryapproved=1";
	  $notestr = "<font color=blue><b>Submitted Characters Only</b></font><BR><BR>";
	}
	if ($salc ne "checked" && $ssc ne "checked" && $sapc eq "checked")
	{
	  $wherestr = "where charstoryapproved=2";
	  $wherestr1 = "and a.charstoryapproved=2";
	  $notestr = "<font color=blue><b>Approved Characters Only</b></font><BR><BR>";
	}
	if ($salc ne "checked" && $ssc eq "checked" && $sapc eq "checked")
	{
	  $wherestr = "where charstoryapproved>0";
	  $wherestr1 = "and a.charstoryapproved>0";
	  $notestr = "<font color=blue><b>Submitted and Approved Characters Only</b></font><BR><BR>";
	}
	if ($salc eq "checked")
	{
	  $wherestr = "";
	  $notestr = "";
	}
	
	print "<form action=\"$thispage\" method=\"post\">";
	print "<p><table border=1 cellspacing=0 cellpadding=0 align=left bgcolor=#eeeeee width=100%><tr><td>\n";
	print "<table border=0  cellspacing=1 cellpadding=1 align=center bgcolor=#eeeeee width=100%>\n";
	print "<tr><td><b>Plot Matrix Control Panel</b></td></tr>\n";
	
	print "<tr>";
	print "<td style=\"font-size : xx-small;\" valign=middle><input type=radio name=$keyfield value=1 $ischecked[1]>Sort By Character Name</input></td>\n";
	print "<td style=\"font-size : xx-small;\"><input type=checkbox name=ssc value=\"checked\" $ssc>Show Submitted Characters</input></td>\n";
	print "</tr>";
	
	print "<tr>";
	print "<tr><td style=\"font-size : xx-small;\" valign=middle><input type=radio name=$keyfield value=2 $ischecked[2]>Sort By Player Name</input></td>\n";
	print "<td style=\"font-size : xx-small;\"><input type=checkbox name=sapc value=\"checked\" $sapc>Show Approved Characters</input></td>\n";
	print "</tr>";
	
	print "<tr>";
	print "<tr><td style=\"font-size : xx-small;\" valign=middle><input type=radio name=$keyfield value=3 $ischecked[3]>Sort By GM</input></td>\n";
	print "<td style=\"font-size : xx-small;\"><input type=checkbox name=salc value=\"checked\" $salc>Show All Characters</input></td>\n";
	print "</tr>";
	
	print "<tr>";
	print "<tr><td style=\"font-size : xx-small;\" valign=middle><input type=radio name=$keyfield value=4 $ischecked[4]>Sort By Plot</input></td>\n";
	print "<td style=\"font-size : xx-small;\">Show Submitted Plots</td>\n";
	print "</tr>";
	
	print "<tr>";
	print "<tr><td style=\"font-size : xx-small;\" valign=middle><input type=radio name=$keyfield value=5 $ischecked[5]>Sort By Episode</input></td>\n";
	print "<td style=\"font-size : xx-small;\">Show Approved Plots</td>\n";
	print "</tr>";
	
	print "<tr>";
	print "<tr><td style=\"font-size : xx-small;\" valign=middle><input type=radio name=$keyfield value=6 $ischecked[6]>Sort By Boxes</input></td>\n";
	print "<td style=\"font-size : xx-small;\">Show All Plots</td>\n";
	print "</tr>";	
	
	print "<tr><td style=\"font-size : xx-small;\"><input type=checkbox name=hidebox value=1><i>Hide Control Panel</i></input</td>\n";
	print "<td style=\"font-size : xx-small;\"><input type=checkbox name=sti value=\"checked\" $sti><i>Show Tangential Involvement</i></input</td>\n";
	print "<td style=\"font-size : xx-small;\"><input type=\"submit\" name=\"submit\" value=\"Submit\"></td>\n";
	print "</tr>";	
	print "</table>\n";
	print "</td></tr></table><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR></p></form>\n";
}

sub sortbycharactername()
{
	print "<H2>Sort By Character Name</h2>\n";
	print "$notestr\n";
	local($db) = dbconnect();
	local ($sql) = "select charid, concat(cfirst, ' ', clast), charstoryapproved from characters $wherestr order by clast;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	while (@array = $query->fetchrow_array)
	{
		local($chid) = $array[0];
		print "<b>$array[1]</b>\n";
		print " (".getFullNameFromCharID($chid).") -- \n";
		print " (".$approved[$array[2]].") -- \n";
		print "<i>GM(s): ".getGMFromCharID($chid)."</i><BR>\n";
		showplotsforchar($chid);
		print "<BR>\n";
	}
	$query->finish;
	$db->disconnect;
}

sub sortbyplayername()
{
	print "<H2>Sort By Player Name</h2>\n";
	print "$notestr\n";
	local($db) = dbconnect();
	local ($sql) = "select a.charid, b.playerid, concat(a.cfirst, ' ', a.clast), concat(b.pfirst, ' ', b.plast) from characters a, players b, playercharacters c where b.playerid=c.pcplayerid and c.pccharid = a.charid $wherestr1 order by b.plast;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	while (@array = $query->fetchrow_array)
	{
		local($chid) = $array[0];
		local($chplid) = $array[1];
		print "<b>$array[2]</b>\n";
		print " ($array[3]) -- \n";
		print "<i>GM(s): ".getGMFromCharID($chid)."</i><BR>\n";
		showplotsforchar($chid,$chplid);
		print "<BR>\n";
	}
	$query->finish;
	$db->disconnect;
}

sub sortbyGM()
{
	print "<H2>Sort By GM</h2>\n";
	print "$notestr\n";
	local($db) = dbconnect();
	local ($sql) = "select playerid, concat(pfirst, ' ', plast) from players where psecurity>=$gm_access order by plast;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	while (@array = $query->fetchrow_array)
	{
		local($gmid) = $array[0];
		print "<H2><u>$array[1]</u></H2>\n";
		
		$sql = "select a.charid, concat(a.cfirst, ' ', a.clast) from characters a, GMcharacters b where b.gmcGMid=$gmid and a.charid=b.gmccharid $wherestr1 order by a.clast;";
		local ($query2) = $db->prepare($sql);
		$query2->execute;
		while (@array = $query2->fetchrow_array)
		{
			local($chid) = $array[0];
			print "<b>$array[1]</b>\n";
			print " (".getFullNameFromCharID($chid).")<BR>\n";
			showplotsforchar($chid);
			print "<BR>\n";
		}
	}
	$query->finish;
	$db->disconnect;
}

sub sortbyplot()
{
	print "<H2>Sort By Plot</h2>\n";
	print "$notestr\n";
	local($db) = dbconnect();
	local ($sql) = "select plotid, plauthor, plname from plots order by plname;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	while (@array = $query->fetchrow_array)
	{
		local($plotid) = $array[0];
		print "<b>$array[2]</b>\n";
		print " (Author: ".getFullNameFromID($array[1]).") -- \n";
		print "<i>Episode(s): ".getEpisodeFromPlot($plotid)."</i>\n";
		print "<BR>\n";
		showcharsforplot($plotid);
		print "<BR>\n";
	}
	$query->finish;
	$db->disconnect;
}

sub sortbyepisode()
{
	print "<H2>Sort By Episode</h2>\n";
	print "$notestr\n";
	local($db) = dbconnect();
	local ($sql) = "select eventid, eventname from events order by eventid;";
	local ($query) = $db->prepare($sql);
	$query->execute;
	while (@array = $query->fetchrow_array)
	{
		local ($eventid) = $array[0];
		print "<H2><u>$array[1]</u></H2>\n";
		$sql = "select a.plotid, a.plauthor, a.plname from plots a, plotevents b where a.plotid=b.plotid and b.eventid=$eventid order by a.plname;";
		#print "$sql<BR>";  
		local ($query2) = $db->prepare($sql);
		$query2->execute;
		while (@array = $query2->fetchrow_array)
		{
			local($plotid) = $array[0];
			print "<b>$array[2]</b>\n";
			print " (Author: ".getFullNameFromID($array[1]).")\n";
			print "<BR>\n";
			showcharsforplot($plotid);
			print "<BR>\n";
		}
		$query2->finish;
	}
	$query->finish;
	$db->disconnect;
}

sub sortbyboxes()
{
	print "<H2>Sort By Boxes</h2>\n";
	print "$notestr\n";
	local($db) = dbconnect();
	local ($sql) = "select boxid, boxname from boxes order by boxname;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	local (@array);
	while (@array = $query->fetchrow_array)
	{
		local($boxid) = $array[0];
		print "<H1>$array[1]</H1>\n";
		showboxes($boxid);
		print "<BR>\n";
	}
	$query->finish;
	$db->disconnect;
}


# *******************
# * showboxes *
# *******************
sub showboxes()
{
	local($varID) = $_[0];
	if ($varID eq "")
	{
	   return;
	}
	local($db) = dbconnect();
	local ($sql) = "select bcid, bcname from boxcategories where boxid=$varID order by bcname;";
	#print $sql;
	local($query) =$db->prepare($sql);
	$query->execute;
	local (@array);
	if ($query->rows > 0)
	{
	   while (@array = $query->fetchrow_array)
	   {
		local ($bcid) = $array[0];
		print "<h2>$array[1]</h2> \n";
		showboxplayers($bcid);
		showboxplots($bcid);
		print "<BR>\n";
	   }
	}
        $query->finish;
        $db->disconnect;
}

sub showboxplayers()
{
	local($varID) = $_[0];
	if ($varID eq "")
	{
	   return;
	}
	local($db) = dbconnect();
	local ($sql) = "select a.charid, concat(a.cfirst, ' ', a.clast), a.charstoryapproved from characters a, playerboxes b where b.pbbcid=$varID and b.pbcharid=a.charid $wherestr1 order by a.clast;";
	#print $sql;
	local($query) =$db->prepare($sql);
	$query->execute;
	if ($query->rows > 0)
	{
	   print "<u>Characters for this Box</u><BR>\n";
	   local (@array);
	   while (@array = $query->fetchrow_array)
	   {
		local($chid) = $array[0];
		print "$array[1]\n";
		print " (".getFullNameFromCharID($chid).") -- \n";
		print " (".$approved[$array[2]].") -- \n";
		print "<i>GM(s): ".getGMFromCharID($chid)."</i>\n";
		print "<BR>\n";
	   }
	}
        $query->finish;
        $db->disconnect;
}

sub showboxplots()
{
	local($varID) = $_[0];
	if ($varID eq "")
	{
	   return;
	}
	local($db) = dbconnect();
	local ($sql) = "select a.plotid, a.plauthor, a.plname from plots a, plotboxes b where b.bcid = $varID and a.plotid = b.plotid order by a.plname;";
	#print $sql;
	local($query) =$db->prepare($sql);
	$query->execute;
	if ($query->rows > 0)
	{
	   print "<u>Plots for this Box</u><BR>\n";
	   local (@array);
	   while (@array = $query->fetchrow_array)
	   {
		local ($plotid) = $array[0];
		print "$array[2] \n";
		print "(Author: ".getFullNameFromID($array[1]).") --\n";
		print "<i>Episode(s): ".getEpisodeFromPlot($plotid)."</i>\n";
		print "<BR>\n";
	   }
	}
        $query->finish;
        $db->disconnect;
}

# *******************
# * showplotsforchar *
# *******************
sub showplotsforchar()
{
	local($varID1) = $_[0];
	local($varID2) = $_[1];
	showplotsforchar1($varID1);
	#showplotsforchar2($varID2);
	showplotsforchar3($varID1);
}

#directly involved
sub showplotsforchar1()
{
	local($varID) = $_[0];
	if ($varID eq "")
	{
	   return;
	}
	local($db) = dbconnect();
	local ($sql) = "select a.plotid, a.plauthor, a.plname from plots a, plotchars b where b.pccharid = $varID and a.plotid = b.plotid order by a.plname;";
	#print $sql;
	local($query) =$db->prepare($sql);
	$query->execute;
	if ($query->rows > 0)
	{
	   print "&nbsp;&nbsp;&nbsp;&nbsp;<u>Directly Involved:</u><BR>\n";
	   while (@array = $query->fetchrow_array)
	   {
		local ($plotid) = $array[0];
		print "&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"plots.pl?submit=Review&plotid=$array[0]\" target=_new>$array[2]</a> \n";
		print "(Author: ".getFullNameFromID($array[1]).") --\n";
		print "<i>Episode(s): ".getEpisodeFromPlot($plotid)."</i>\n";
		print "<BR>\n";
	   }
	}
        $query->finish;
        $db->disconnect;
}

#group involved -- needs to be reworked
sub showplotsforchar2()
{
	local($varID) = $_[0];
	if ($varID eq "")
	{
	   return;
	}
	local($db) = dbconnect();
	local($sql) = "select distinct a.plotid, a.plauthor, a.plname from plots a, plotgroups b, playergroupmembers d, where a.plotid=b.plotid and b.groupid=d.groupid and d.playerid=$varID order by a.plname;";
	print "$sql<BR>";
	local($query) =$db->prepare($sql);
	$query->execute;
	if ($query->rows > 0)
	{
	   print "&nbsp;&nbsp;&nbsp;&nbsp;<u>Involved Via Group:</u><BR>\n";
	   while (@array = $query->fetchrow_array)
	   {
		local ($plotid) = $array[0];
		print "&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"plots.pl?submit=Review&plotid=$array[0]\" target=_new>$array[2]</a> \n";
		print "(Author: ".getFullNameFromID($array[1]).") --\n";
		print "<i>Episode(s): ".getEpisodeFromPlot($plotid)."</i>\n";
		print "<BR>\n";
	   }
	}
        $query->finish;
        $db->disconnect;
}

#boxes match
sub showplotsforchar3()
{
	local($varID) = $_[0];
	if ($varID eq "")
	{
	   return;
	}
	if ($sti eq "")
	{
	   return;
	}
	local($db) = dbconnect();
	local($sql) = "select distinct a.plotid, a.plauthor, a.plname from plots a, plotboxes b, playerboxes c where c.pbcharid = $varID and a.plotid = b.plotid and b.bcid = c.pbbcid order by a.plname;";
	#print $sql;
	local($query) =$db->prepare($sql);
	$query->execute;
	if ($query->rows > 0)
	{
	   print "&nbsp;&nbsp;&nbsp;&nbsp;<u>Tangentially Involved:</u><BR>\n";
	   while (@array = $query->fetchrow_array)
	   {
		local ($plotid) = $array[0];
		print "&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"plots.pl?submit=Review&plotid=$array[0]\" target=_new>$array[2]</a> \n";
		print "(Author: ".getFullNameFromID($array[1]).") --\n";
		print "<i>Episode(s): ".getEpisodeFromPlot($plotid)."</i>\n";
		print "<BR>\n";
	   }
	}
        $query->finish;
        $db->disconnect;
}

# *******************
# * showplotsforchar *
# *******************
sub showcharsforplot()
{
	local($varID1) = $_[0];
	showcharsforplot1($varID1);
	showcharsforplot2($varID1);
	showcharsforplot3($varID1);
}

#directly involved
sub showcharsforplot1()
{
	local($varID) = $_[0];
	if ($varID eq "")
	{
	   return;
	}
	local($db) = dbconnect();
	local ($sql) = "select a.charid, concat(a.cfirst, ' ', a.clast), a.charstoryapproved from characters a, plotchars b where b.plotid=$varID and b.pccharid=a.charid $wherestr1 order by a.clast;";
	#print $sql;
	local($query) =$db->prepare($sql);
	$query->execute;
	if ($query->rows > 0)
	{
	   print "&nbsp;&nbsp;&nbsp;&nbsp;<u>Directly Involved:</u><BR>\n";
	   while (@array = $query->fetchrow_array)
	   {
		local($chid) = $array[0];
		print "&nbsp;&nbsp;&nbsp;&nbsp;$array[1]\n";
		print " (".getFullNameFromCharID($chid).") -- \n";
		print " (".$approved[$array[2]].") -- \n";
		print "<i>GM(s): ".getGMFromCharID($chid)."</i>\n";
		print "<BR>\n";
	   }
	}
        $query->finish;
        $db->disconnect;
}

#group involved -- needs to be reworked
sub showcharsforplot2()
{
	local($varID) = $_[0];
	if ($varID eq "")
	{
	   return;
	}
	local($db) = dbconnect();
	local ($sql) = "select distinct a.charid, concat(a.cfirst, ' ', a.clast), e.groupname, a.charstoryapproved from characters a, playercharacters b, playergroupmembers c, plotgroups d, playergroups e where a.charid=b.pccharid and b.pcplayerid=c.playerid and c.groupid = d.groupid and d.plotid=$varID and d.groupid=e.groupid $wherestr1 order by a.clast;";
	#print "$sql<BR>";
	local($query) =$db->prepare($sql);
	$query->execute;
	if ($query->rows > 0)
	{
	   print "&nbsp;&nbsp;&nbsp;&nbsp;<u>Involved Via Group:</u><BR>\n";
	   while (@array = $query->fetchrow_array)
	   {
		local($chid) = $array[0];
		local($groupname) = $array[2];
		print "&nbsp;&nbsp;&nbsp;&nbsp;$array[1]\n";
		print " (".getFullNameFromCharID($chid).") -- \n";
		print " (".$approved[$array[3]].") -- \n";
		print " (Group: $groupname) -- \n";
		print "<i>GM(s): ".getGMFromCharID($chid)."</i>\n";
		print "<BR>\n";
	   }
	}
        $query->finish;
        $db->disconnect;
}

#boxes match
sub showcharsforplot3()
{
	local($varID) = $_[0];
	if ($varID eq "")
	{
	   return;
	}
	if ($sti eq "")
	{
	   return;
	}
	local($db) = dbconnect();
	local ($sql) = "select distinct a.charid, concat(a.cfirst, ' ', a.clast), a.charstoryapproved from characters a, plotboxes b, playerboxes c where b.plotid=$varID and b.bcid = c.pbbcid and c.pbcharid=a.charid  $wherestr1 order by a.clast;";
	#print $sql;
	local($query) =$db->prepare($sql);
	$query->execute;
	if ($query->rows > 0)
	{
	   print "&nbsp;&nbsp;&nbsp;&nbsp;<u>Tangentially Involved:</u><BR>\n";
	   while (@array = $query->fetchrow_array)
	   {
		local($chid) = $array[0];
		print "&nbsp;&nbsp;&nbsp;&nbsp;$array[1]\n";
		print " (".getFullNameFromCharID($chid).") -- \n";
		print " (".$approved[$array[2]].") -- \n";
		print "<i>GM(s): ".getGMFromCharID($chid)."</i>\n";
		print "<BR>\n";
	   }
	}
        $query->finish;
        $db->disconnect;
}


#These should be moved to common?

# *******************
# * getGMFromCharID *
# *******************
# * getGMFromCharID returns 
# * the GMs assigned to the character
# * when passed a character id
sub getGMFromCharID()
{
	local($varID) = $_[0];
	if ($varID eq "")
	{
	   return "";
	}
	local($db) = dbconnect();
	local ($sql) = "select concat(a.pfirst, ' ', a.plast) from players a, GMcharacters b where b.gmccharid = $varID and a.playerid = b.gmcGMid";
	#print $sql;
	local($query) =$db->prepare($sql);
	$query->execute;
	local ($retstr) = "";
	while (@array = $query->fetchrow_array)
	{
	   $retstr .= "$array[0], ";
	}
	chop $retstr;
	chop $retstr;
        $query->finish;
        $db->disconnect;
        return $retstr;
}

# *******************
# * getEpisodeFromPlot *
# *******************
# * getEpisodeFromPlot returns 
# * the episodes assigned to the plot
# * when passed a plot id
sub getEpisodeFromPlot()
{
	local($varID) = $_[0];
	if ($varID eq "")
	{
	   return "";
	}
	local($db) = dbconnect();
	local ($sql) = "select a.eventname from events a, plotevents b where b.plotid = $varID and a.eventid = b.eventid";
	#print $sql;
	local($query) =$db->prepare($sql);
	$query->execute;
	local ($retstr) = "";
	while (@array = $query->fetchrow_array)
	{
	   $retstr .= "$array[0], ";
	}
	chop $retstr;
	chop $retstr;
        $query->finish;
        $db->disconnect;
        return $retstr;
}


