#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "printplans.pl";

if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to print plans"));
}
elsif ($action eq "doc")
{
	print $CGI->header(-type  =>  'application/vnd.ms-excel', -filename  =>  'plans.xls');
				
	$db = dbconnect();
	local ($sql) = "select * from WS_plans;";
	local ($query) = $db->prepare($sql);
	$query->execute;
	local ($resptr);
	
	print "<table border=0>\n";
        print "<tr>\n";
        print "<td>PlanName</td>\n";
        print "<td>Inventors</td>\n";
        print "<td>PatentNumber</td>\n";
        print "<td>DevDate</td>\n";
        print "<td>Level</td>\n";
        print "<td>MotiveForces</td>\n";
        print "<td>Complexity</td>\n";
        print "<td>Application</td>\n";
        print "<td>Description</td>\n";
        print "<td>Components</td>\n";
        print "<td>Value</td>\n";
        print "<td>State</td>\n";
        print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   local ($planid) = $resptr->{"planid"};
	   print "<tr>\n";
	   print "<td valign=top>".$resptr->{"name"}."</td>\n";
	   print "<td valign=top>".showinventors($planid)."</td>\n";
	   $num = 0;
	   foreach $i (split //, $resptr->{"name"}) 
	   { 
             $num += ord($i);
           }
	   print "<td valign=top>$num-$planid</td>\n";
	   $mydate = $resptr->{"entrydate"};
	   $mydate =~ s/200/187/g;
	   print "<td valign=top>$mydate</td>\n";
	   $planlev = dosql("select levtext from planlevels where levid=".$resptr->{"level"}.";");
	   print "<td valign=top>$planlev</td>\n";
	   print "<td valign=top>".showmfs($planid)."</td>\n";
	   print "<td valign=top>".$resptr->{"complexity"}."</td>\n";
	   print "<td valign=top>".showapps($planid)."</td>\n";
	   print "<td valign=top>".$resptr->{"description"}."</td>\n";
	   print "<td valign=top>".showcomps($planid)."</td>\n";
	   print "<td valign=top>".$resptr->{"value"}."</td>\n";
	   $planstate = dosql("select statetext from planstates where stateid=".$resptr->{"stateid"}.";");
	   if ($resptr->{"stateknown"} == 0)
	   {
	   	$planstate = "Unknown";
	   }
	   print "<td valign=top>$planstate</td>\n";
	   print "</tr>\n";
	}
	print "</table>\n";
	
	$query->finish;
	
	$db->disconnect;
}
else
{
	print $CGI->header;
	ParseForm($header);
	
	print "<h1>Print All Weird Science Plans</H1>\n";
	
	print "1.  Step One.  Download the Microsoft XL Document.<BR>\n";
	print "Save this document as plans.xls in your Brassy's folder:\n";
	print "<a href=\"$thispage?action=doc\" target=_new>Click me</a><BR><BR>\n";
		
	print "2.  Step Two.  Download the Microsoft Word Document.<BR>\n";
	print "Save this document as Plans.doc in your Brassy's folder:\n";
	print "<a href=\"doclib/Print/Plans.doc\" target=_new>Click me</a><BR><BR>\n";
		
	print "3.  Step Three.  Open and print the Microsoft Word Document.<BR>\n";
	print "Open plans.doc in Microsoft Word.  Perform the mail merge.<BR>\n";
	print "Do a global search and replace, changing [BR] to ^p.  Print.<BR><BR>\n";

	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	ParseForm($footer);
}

exit 0;

sub showinventors()
{
   	local($varID) = $_[0];
	local ($sql) = "select charid from characterplans where planid=$varID;";
   	local $retStr = "";
	local ($query) = $db->prepare($sql);
	$query->execute;
	local (@array);
	while (@array = $query->fetchrow_array)
	{
	  $retStr .= getCharName($array[0]);
	  $retStr .= "; ";
	}
	chop($retStr);
	chop($retStr);
	$query->finish;	
	return $retStr;
}

sub showmfs()
{
   	local($varID) = $_[0];
	local ($sql) = "select a.mfname from motiveforces a join planmfs b on a.mfid=b.mfid where b.planid=$varID;";
   	local $retStr = "";
	local ($query) = $db->prepare($sql);
	$query->execute;
	local (@array);
	while (@array = $query->fetchrow_array)
	{
	  $retStr .= $array[0];
	  $retStr .= ", ";
	}
	chop($retStr);
	chop($retStr);
	$query->finish;	
	return $retStr;
}

sub showapps()
{
   	local($varID) = $_[0];
	local ($sql) = "select a.aname from applications a join planapplications b on a.aid=b.aid where b.planid=$varID;";
   	local $retStr = "";
	local ($query) = $db->prepare($sql);
	$query->execute;
	local (@array);
	while (@array = $query->fetchrow_array)
	{
	  $retStr .= $array[0];
	  $retStr .= ", ";
	}
	chop($retStr);
	chop($retStr);
	$query->finish;	
	return $retStr;
}

sub showcomps()
{
   	local($varID) = $_[0];
	local ($sql) = "select b.wpname, c.mfname from planparts a, WS_parts b, motiveforces c where a.planid=$varID and b.wpmfid=c.mfid and a.wpid=b.wpid;";
   	local $retStr = "";
	local ($query) = $db->prepare($sql);
	$query->execute;
	local (@array);
	$i = 1;
	while (@array = $query->fetchrow_array)
	{
	  $retStr .= "$i. ";
	  $retStr .= "$array[0] ($array[1])";
	  $retStr .= "[BR]";
	  $i++;
	}
	$query->finish;	
	return $retStr;
}

