#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "resources.pl";
$table = "characterabilities";
$heading = "Resource";
$keyfield = "caid";
$keyvalue = $CGI->param($keyfield);
$namefield = "name";
$errstr = $CGI->param("error");
$tplfile = "edres.tpl";

$levels[0] = "None";
$levels[1] = "Low";
$levels[2] = "Average";
$levels[3] = "High";
$levels[4] = "Super";
$levels[5] = "Bankrupt";


if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to edit $heading(s)!"));
}
elsif ($action eq "new" || $action eq "edit")
{
	print $CGI->header();
	ParseForm($header);
	if ($keyvalue eq "")
	{
		print "<H1>Add $heading</H1>\n";
	}
	else
	{
        	print "<H1>Edit $heading</H1>\n";
	}
	print "<form action=\"$thispage\" method=\"post\">";

	fillvars();
	ParseForm($tplfile);
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>";
	}
	else
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>";
	}
	print "</form>";
	print "<br><hr><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($submit eq "Add")
{
	# Insert and Redirect
	@names = $CGI->param;
	$SQL = "INSERT into $table (";
	foreach $i(@names)
	{
	    if (($i ne $keyfield) && ($i ne "submit"))
	    {
		$SQL .= "$i, ";
	    }

	}
	chop $SQL;
	chop $SQL;
	$SQL .= ") values (";
	foreach $i(@names)
	{
	    if (($i ne $keyfield) && ($i ne "submit"))
	    {
		local($myCGI) = $CGI->param($i);
		$myCGI =~ s/'/''/g;
		$SQL .= "'" . $myCGI . "', ";
	    }
	 }
	chop $SQL;
	chop $SQL;
	$SQL .= ");";
	#print "$SQL<BR>";
	local($db) = dbconnect();
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Added"));
}
elsif ($submit eq "Change")
{
	#print $CGI->header();
	# Update and Redirect
	$text = $CGI->param("text");
	$text =~ s\'\''\g;
	$charid = $CGI->param("charid");
	local($db) = dbconnect();
	$SQL = "update $table set text='$text' where $keyfield=$keyvalue;";
	#print "$SQL<BR>";
	$db->do($SQL);
	$SQL = "delete from characterresourcetypelink where abid=$keyvalue and charid=$charid;";
	#print "$SQL<BR>";
	$db->do($SQL);
	$SQL = "select * from resourcetypes;";
	local($query) = $db->prepare($SQL);
	$query->execute;
	local ($resptr);
	while ($resptr = $query->fetchrow_hashref())
	{
	     if ($CGI->param($resptr->{"type"}) ne "0")
	     {
	       $SQL = "insert into characterresourcetypelink (typeid, abid, charid, level) values (".$resptr->{"typeid"}.",$keyvalue,$charid,".$CGI->param($resptr->{"type"}).");";
		#print "$SQL<BR>";
		$db->do($SQL);	       
	     }
	}
	$query->finish;
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Updated"));
}
elsif ($action eq "delete")
{
	# delete and Redirect
	#print "$SQL<BR>";
	local($db) = dbconnect();
	$SQL = "delete from $table where $keyfield = $keyvalue;";
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Deleted"));
}
else
{
	print $CGI->header;
	ParseForm($header);
	
	print "<font color=red>$errstr</font><BR><BR>\n";
	
	print "<H1>Manage Player ".$heading."s</h1>\n";
	
	showdata();

	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=delete&$keyfield=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
	
	ParseForm($footer);
}

exit 0;

sub showdata()
{
	local($db) = dbconnect();
	local ($sql) = "select * from characterabilities a, abilities b, characters c where a.abid=b.abid and b.type='Resource' and a.charid=c.charid and c.chartype <= $cast_character order by b.name;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Name</b></td>\n";
	print "<td><b>Text</b></td>\n";
	print "<td><b>Character</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	local ($resptr);
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"$namefield"};
	   $name =~ s/_//g;
	   $key = $resptr->{"$keyfield"};
	   print "<tr>\n";
	   print "<td>$name</td>\n";
	   print "<td>".$resptr->{"text"}. " (level: ".$resptr->{"level"}. ")" ;
	   print showResourceLinks($key);
	   print "</td>\n";
	   print "<td>".getCharName($resptr->{"charid"})."</td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=edit&$keyfield=$key\">Edit</a>\n";
	   $name =~ s/'//g;
	   print "</td></tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub showResourceLinks()
{
  	local ($caid) = $_[0];
	local($db) = dbconnect();
	local ($sql) = "select a.type, b.level, a.isnumeric from resourcetypes a, characterresourcetypelink b where a.typeid=b.typeid and b.abid=$caid order by a.type;";
	#print "$sql<BR>";
	local($query) = $db->prepare($sql);
	$query->execute;
	local (@array);
	$rlretstr = "<table border = 0 width=100% cellspacing=0 cellpadding=0><tr>\n";
	while (@array = $query->fetchrow_array())
	{
	   if ($array[2] == 0)
	   {
	     $rlretstr .= "<td style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\"><b>$array[0]:</b>  $levels[$array[1]]</td>";
	   }
	   else
	   {
	     $rlretstr .= "<td style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\"><b>$array[0]:</b>  $array[1]</td>";
	   }
	}
	$rlretstr .= "</tr></table>\n";
	$query->finish;
	$db->disconnect;
	return $rlretstr;
}

sub fillvars()
{
	filltable();
	$table = "abilities";
	$keyfield = "abid";
	$keyvalue = $abid;
	filltable();
	$table = "characterabilities";
	$keyfield = "caid";
	$keyvalue = $CGI->param($keyfield);
	$charname = getCharName($charid);
	
	$links = showEditResourceLinks($caid);
}

sub showEditResourceLinks()
{
  	local ($caid) = $_[0];
	local($db) = dbconnect();
	local ($sql) = "select * from resourcetypes order by type;";
	#print "$sql<BR>";
	local($query) = $db->prepare($sql);
	$query->execute;
	$rlretstr = "<table border = 0 width=100% cellspacing=0 cellpadding=0><tr>\n";
	local ($resptr);
	while ($resptr = $query->fetchrow_hashref())
	{
	   $rlretstr .= "<td><b>";
	   $rlretstr .= $resptr->{"type"} . ":</b> ";
	   $lev = getLevel($caid,$resptr->{"typeid"});
	   if ($resptr->{"isnumeric"} == 0)
	   {
	     $rlretstr .= makeArrayDropDown(\@levels,$resptr->{"type"},[$levels[$lev]],"",1);
	   }
	   else
	   {
	     $rlretstr .= "<input type=text size=3 maxsize=3 name=\"".$resptr->{"type"}."\" value=\"$lev\">";
	   }
	   $rlretstr .= "</td>";
	}
	$rlretstr .= "</tr></table>\n";
	$query->finish;
	$db->disconnect;
	return $rlretstr;
}

sub getLevel()
{
  	local ($caid) = $_[0];
  	local ($typeid) = $_[1];
  	$retVal = 0;
	local($db) = dbconnect();
	local ($sql) = "select level from characterresourcetypelink where abid=$caid and typeid=$typeid and charid=$charid;";
	#print "$sql<BR>";
	local($query) = $db->prepare($sql);
	$query->execute;
	if ($query->rows > 0)
	{
	   local (@array);
	   @array = $query->fetchrow_array();
	   $retVal = $array[0];
	}
	$query->finish;
	$db->disconnect;
	return $retVal;
}

