#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;
use XML::RSS;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "rss.pl";
$table = $CGI->param("table");
$heading = "RSS Feed";
$errstr = $CGI->param("error");

if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to edit $heading(s)!"));
}
elsif ($action eq "new")
{
	print $CGI->header();
	$doctitle = "Add $heading";
	ParseForm($header);
     	print "<H1>$doctitle</H1>\n";
	print "<form action=\"$thispage\" method=\"post\">\n";

	print "Choose a Table: ";
	print makeTablesDropDown($al);

	print "<input type=\"submit\" name=\"submit\" value=\"RSS\"><BR>";
	print "</form>";
	print "<br><hr><a href=\"$thispage\">Return/Cancel</a>.";
	print "<br><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($submit eq "RSS")
{
	print "Content-Type: text/xml\n\n";
	local($db) = dbconnect();
	local($query) = $db->prepare("explain $table");
	$query->execute;
	local @array;
	local @columns;
	local($num) = 0;
	while (@array = $query->fetchrow_array)
	{
	   $columns[$num] = $array[0];
	   $num++;
	}
	$query->finish;
	
	my $rss = new XML::RSS;
	$rss->channel(
		title           => $table,
		'link'          => $siteURL,
		description     => $table,
	);

	$sql = "select * from $table";
	$query = $db->prepare($sql);
	$query->execute;

	while ($resptr = $query->fetchrow_hashref())
	{
	   for ($i = 0; $i < $num; $i++)
	   {
		$rss->add_item(
		    title   => $columns[$i],
		    'link'      => $siteURL,
		    'description'  => $resptr->{$columns[$i]},
		);
	   }
	}
	$query->finish;
	$db->disconnect;

	my $data = $rss->as_string;
	print "$data\n";
}
elsif ($submit eq "Add")
{
	# Insert and Redirect
	$SQL = filltablefromCGI($table, 1);
	#print "$SQL<BR>";
	local($db) = dbconnect();
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Added"));
}
elsif ($submit eq "Change")
{
	#print $CGI->header();
	# Update and Redirect
	$SQL = filltablefromCGI($table, 0);
	#print "$SQL<BR>";
	local($db) = dbconnect();
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$namevalue Updated"));
}
elsif ($action eq "delete")
{
	# delete and Redirect
	#print "$SQL<BR>";
	local($db) = dbconnect();
	$SQL = "delete from $table where $keyfield = $keyvalue;";
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$namevalue Deleted"));
}
else
{
	print $CGI->header;
	$doctitle = "Manage ".$heading."s";
	ParseForm($header);
	
	if ("$errstr" ne "")
	{
	   print "<font color=red>$errstr</font><BR><BR>\n";
	}
	
	print "<H1>$doctitle </h1>\n";

	print "<a href=\"$thispage?action=new\">ADD a NEW $heading</a><BR><BR>\n";
	
	showdata();

	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=delete&$keyfield=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
	
	ParseForm($footer);
}

exit 0;

sub showdata()
{
	local($db) = dbconnect();
	local ($sql) = "select * from $table order by $namefield;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Name</b></td>\n";
	print "<td><b>Description</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"$namefield"};
	   $key = $resptr->{"$keyfield"};
	   print "<tr>\n";
	   print "<td>$name</td>\n";
	   print "<td>".$resptr->{"desc"}."</td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=edit&$keyfield=$key\">Edit</a>\n";
	   $name =~ s/'//g;
	   print " -- <a href=\"javascript:deleteConfirm('$name',$key);\">Delete</a>\n";
	   print "</td></tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub fillvars()
{
	filltable();
}

