#!/usr/bin/perl

require 'stat_inc.pl';
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "scandal.pl";
$table = "speech";
$heading = "Speech";
$keyfield = "abid";
$keyvalue = $CGI->param($keyfield);
$namefield = "name";
$tplfile = "x.tpl";
$errstr = $CGI->param("error");

$step = $CGI->param("step") + 0;
$charid = $CGI->param("charid");
$charname = getCharName($charid);
$witnessid = $CGI->param("witnessid");
$witname = getCharName($witnessid);
$anony = $CGI->param("anony") + 0;
$period = $CGI->param("period") + 0;
$withaop = $CGI->param("withaop") + 0;
$behaviour = $CGI->param("behaviour");

$rumorsize = $CGI->param("rumorsize") + 0;
$numblack = $CGI->param("numblack") + 0;
$plausable = $CGI->param("plausable") + 0;
$statloss = $CGI->param("statloss") + 0;

$doctitle = "Runtime Scandal Mechanics for Floor GMs";

if ($al < $writer_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to visit this page!"));
}
elsif ($step == 2)
{
	print $CGI->header;
	ParseForm($header);
	
	print "<H1>$doctitle</h1>\n";

	print "<h2>Step 2</h2><BR>\n";
	print "<h3>$witname is attempting to scandalize $charname.</h3><BR>\n";
	
	if ($anony > 0)
	{
		print "<h3>This is being submitted anonymously via an Arbiter of Propriety.</h3><BR>\n";
	}
	
	$targetbasestatus = dosql("select status from characterSTATs where charid=$charid") + 0;
	$witnessbasestatus = dosql("select status from characterSTATs where charid=$witnessid") + 0;
	
	if (abs($witnessbasestatus - $targetbasestatus) > 2)
	{
	  	print "<p><font color=red>$charname has a base status of $targetbasestatus.<BR>\n";
	  	print "<font color=red>$witname has a base status of $witnessbasestatus.<BR><BR>\n";
	  	print "<font color=red>These are more than two apart.<BR>\n";
	  	print "<font color=red>$witname <i><b>may not</b></i> scandalize $charname.  Sorry</font><BR></p>\n";
	}
	else
	{
		print "<form action=\"$thispage\" method=\"post\">\n";
		print "<input type=\"hidden\" name=\"charid\" value=\"$charid\">\n";
		print "<input type=\"hidden\" name=\"witnessid\" value=\"$witnessid\">\n";
		print "<input type=\"hidden\" name=\"anony\" value=\"$anony\">\n";
		print "<input type=\"hidden\" name=\"period\" value=\"$period\">\n";
		print "<input type=\"hidden\" name=\"behaviour\" value=\"$behaviour\">\n";
		print "<input type=\"hidden\" name=\"aopapproved\" value=\"$aopapproved\">\n";
		
		print "<input type=checkbox name=withaop value=\"1\"> Check this box if the character has an AoP's approval to submit the rumor.</input><br><br>\n";   

		print "<input type=checkbox name=rumorsize value=\"1\"> Check this box if you feel this is a <i>large</i><sup>*</sup> rumor.</input><br><br>\n";   

		print "How many pieces of blackmail material for the character does the witness have, if any? <input type=text name=numblack value=\"0\" size=4><br><br>\n";   

		print "How plausible do you feel the rumor is (absolutely believable=0; completely impossible=10)? <input type=text name=plausable value=\"0\" size=4><br><br>\n";   
		
		print "How much status would you say $charname would lose should the rumour be proven true (1=minimum; 5=maximum)? <input type=text name=statloss value=\"1\" size=4><br><br>\n";   
	
		print "<sup>*</sup> A <i>large</i> rumor is different from a small rumor for reasons we will explain right here. <br>\n";   
		
		
		$eccentric = getlevelforchar("ECCENTRIC: _________","",$charid);

		if ($eccentric > 0)
		{
			print "<input type=\"hidden\" name=\"step\" value=\"3\"><BR>";
		}
		else
		{
			print "<input type=\"hidden\" name=\"step\" value=\"4\"><BR>";
		}
		print "<input type=\"submit\" name=\"submit\" value=\"Go To Step 3\"><BR>";

		print "</form>";
	}
	
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	ParseForm($footer);
}
elsif ($step == 3)
{
	print $CGI->header;
	ParseForm($header);
	
	print "<H1>$doctitle</h1>\n";

	print "<h2>Step 3</h2>\n";
	print "<h3>$witname is attempting to scandalize $charname.</h3><BR>\n";

	print "<p>Text of the rumor: $behaviour</p>\n";

	print "<form action=\"$thispage\" method=\"post\">\n";
	
	print "<p>$charname has Eccentricities.  Please check all eccentricities that are relevent.</p>\n";
	
	$num = 0;
	$sql = "select * from characterabilities a, abilities b where a.charid=$charid and a.abid=b.abid and b.abid=162;";
 	local($db) = dbconnect();
	local ($query) = $db->prepare($sql);
	$query->execute;
	local ($resptr);
	while ($resptr = $query->fetchrow_hashref())
	{
	   $text = $resptr->{"text"};
	   $level = $resptr->{"level"};
	   $name =~ s/_//g;
	   print "<input type=checkbox name=\"cb$num\" value=\"$level\"> $text</input><BR>\n";
	   $num = $num + 1;
	}
	$query->finish;
	$db->disconnect;

	
	print "<input type=\"hidden\" name=\"numcb\" value=\"$num\">\n";
	print "<input type=\"hidden\" name=\"charid\" value=\"$charid\">\n";
	print "<input type=\"hidden\" name=\"witnessid\" value=\"$witnessid\">\n";
	print "<input type=\"hidden\" name=\"anony\" value=\"$anony\">\n";
	print "<input type=\"hidden\" name=\"period\" value=\"$period\">\n";
	print "<input type=\"hidden\" name=\"rumorsize\" value=\"$rumorsize\">\n";
	print "<input type=\"hidden\" name=\"numblack\" value=\"$numblack\">\n";
	print "<input type=\"hidden\" name=\"plausable\" value=\"$plausable\">\n";
	print "<input type=\"hidden\" name=\"behaviour\" value=\"$behaviour\">\n";
	print "<input type=\"hidden\" name=\"withaop\" value=\"$aopapproved\">\n";
	print "<input type=\"hidden\" name=\"statloss\" value=\"$statloss\">\n";

	print "<input type=\"hidden\" name=\"step\" value=\"4\"><BR>";
	print "<input type=\"submit\" name=\"submit\" value=\"Go to Confirmation\"><BR>";

	print "</form>";
	
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	ParseForm($footer);
}
elsif ($step == 4)
{
	print $CGI->header;
	ParseForm($header);
	
	print "<H1>$doctitle</h1>\n";

	print "<h2>Confirmation</h2><BR>\n";
	print "<h3>$witname is attempting to scandalize $charname.</h3><BR>\n";
	
	print "<h3>The final check.</h3><BR>\n";
	
	$targetbasestatus = dosql("select status from characterSTATs where charid=$charid") + 0;
	$cost = $targetbasestatus * 5;
	
	print "<ul>\n";
	
	if ($withaop > 0)
	{
		print "<li>This has been approved by an Arbiter of Propriety.<BR>\n";
	}
	else
	{
		print "<li>This has <i>not</i> been approved by an Arbiter of Propriety.<BR>\n";
	}
	
	if ($anony > 0)
	{
		print "<li>This is being submitted anonymously via an Arbiter of Propriety.<BR>\n";
	}
	else
	{
		print "<li>$witname will have his/her name on the rumor for the target to see.<BR>\n";
	}
	
	if ($rumorsize > 0)
	{
		print "<li>This is a large rumor.<BR>\n";
		$cost = $cost * 3;
	}
	else
	{
		print "<li>This is a small rumor.<BR>\n";
	}
	
	print "<li>$charname will gain a social stigma of level $statloss if this rumor is proven true.<BR>\n";
	print "<li>There are $numblack blackmail items attached to this rumor.<BR>\n";
	print "<li>This rumor has a plausibility factor of $plausable.  (Lower is more plausable)<BR>\n";	
	
	$numcb = $CGI->param("numcb");
	$eccentric = 0;
	for ($i = 0; $i < $numcb; $i++)
	{
	   $eccentric = $eccentric + $CGI->param("cb$i");
	}
	
	print "<li>$charname has $eccentric points worth of relevant eccentricities.<BR>\n";	

	print "</ul>\n";
	
	print "<p>Text of the rumor: $behaviour</p>\n";
	
	print "<BR>$witname must pay $cost to submit this rumor.<BR>\n";
	
	print "<form action=\"$thispage\" method=\"post\">\n";
	print "<input type=\"hidden\" name=\"charid\" value=\"$charid\">\n";
	print "<input type=\"hidden\" name=\"witnessid\" value=\"$witnessid\">\n";
	print "<input type=\"hidden\" name=\"anony\" value=\"$anony\">\n";
	print "<input type=\"hidden\" name=\"period\" value=\"$period\">\n";
	print "<input type=\"hidden\" name=\"rumorsize\" value=\"$rumorsize\">\n";
	print "<input type=\"hidden\" name=\"numblack\" value=\"$numblack\">\n";
	print "<input type=\"hidden\" name=\"plausable\" value=\"$plausable\">\n";
	print "<input type=\"hidden\" name=\"behaviour\" value=\"$behaviour\">\n";
	print "<input type=\"hidden\" name=\"withaop\" value=\"$aopapproved\">\n";
	print "<input type=\"hidden\" name=\"eccentric\" value=\"$eccentric\">\n";
	print "<input type=\"hidden\" name=\"statloss\" value=\"$statloss\">\n";

	print "If everything is OK, click the button to produce the rumor sheet, then print the rumor sheet and hand it to the player. <br>\n";   

	print "<input type=\"hidden\" name=\"step\" value=\"5\"><BR>";
	print "<input type=\"submit\" name=\"submit\" value=\"Produce the Rumor Sheet\"><BR>";

	print "</form>";
	
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	ParseForm($footer);
}
elsif ($step == 5)
{
	print $CGI->header;
	ParseForm("revheader.tpl");
	
	$targetbasestatus = dosql("select status from characterSTATs where charid=$charid") + 0;
	if ($anony > 0)
	{
		$witname = "Anonymous via Arbiter of Propriety";
	}
	
	$period= $period + 1;
	if ($period > 4)
	{
	  $period = "the end of the game";
	}
	else
	{
	  $period = "Game Period $period";
	}

	$targeteffstatus = $targetbasestatus + geteffectivestatus($charid);
	
	$strength = dosql("select status from characterSTATs where charid=$witnessid") + 0;
	$strength = $strength + geteffectivestatus($witnessid);
	$strength = $strength + 5;
	$strength = $strength + getlevelforchar("SCANDALIZE","",$witnessid);
	if ($rumorsize > 0)
	{
		$strength = $strength + 2;
	}
	if ($withaop > 0)
	{
		$strength = $strength + 2;
	}
	$strength = $strength + $numblack;
	if ($anony > 0)
	{
		$strength = $strength - 3;
	}
	$strength = $strength - $plausable;
	
	$base = $targeteffstatus;
	$base = $base + getlevelforchar("PROPRIETY","",$charid); 
	$base = $base + $CGI->param("$eccentric"); 
	
	ParseForm("scandal.tpl");
}
else
{
	print $CGI->header;
	ParseForm($header);
	
	print "<H1>$doctitle</h1>\n";
	
	print "<p><i>This page is for assistant/floor GMs to handle producing a scandal sheet.  If you need help working this page, find a GM.</i></p>\n";
	
	print "<form action=\"$thispage\" method=\"post\">";

	print "<h2>Step 1</h2>\n";
	
	print "<p><i>Select the character being scandalized from the list below.  This is a list of all player characters with STATs. </i></p>\n";
	
	print createCharDrop() ."<BR><BR>\n";

	print "<p><i>Select the character who is doing the scandalizing.  This is a list of all player characters with STATs. </i></p>\n";
	
	$c2 = createCharDrop();
	$c2 =~ s/charid/witnessid/;
	
	print "$c2<BR><BR>\n";

	print "<p><i>Is this an anonymous submission, going via an AoP?</i><BR>\n";
	
	print "<input type=checkbox name=anony value=\"1\"> Anonymous</input><br>\n";   

	print "<p><i>For what behavior is the target being scandalized?  If you feel this would not be scandalous behavior, please find a GM.</i></p>\n";
	
	print "<textarea name=\"behaviour\" COLS=80 ROWS=10></textarea><BR><BR>";
		
	print "<p><i>What game period is it?</i><BR>\n";
	
	print "<input type=text name=period value=\"1\"><br>\n";   

	print "<input type=\"hidden\" name=\"step\" value=\"2\"><BR>";
	print "<input type=\"submit\" name=\"submit\" value=\"Go To Step 2\"><BR>";

	print "</form>";
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	ParseForm($footer);
}
exit 0;

sub createCharDrop
{
    local ($db) = dbconnect();
    $SQL = "select a.charid, concat(a.cfirst, ' ', a.clast), a.ctitle from characters a,  characterSTATs b where a.charid=b.charid and a.chartype <= $cast_character and a.charid > 0 order by a.clast;";
 
    local($query) = $db->prepare($SQL);
    #print "$SQL<BR>";
    $query->execute;

    local ($retVal) = "";
    if ($query->rows > 0)
    {
        $retVal = "<select name=\"charid\">\n";
        while (@array = $query->fetchrow_array)
        {
            $retVal .= "<option value=\"$array[0]\">$array[1]";
            if ($array[2] ne "")
            {
            	$retVal .= ", $array[2]";
            }
            
            $retVal .= "</option>\n";
        }
        $retVal .= "</select>\n";
    }
    $query->finish;
    $db->disconnect;
    return "$retVal";
}
