#!/usr/bin/perl

require 'gmnote_inc.pl';
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$pid = getPlayerID();
$al = getAccessLevel($pid);
$search = $CGI->param("search");
$searchchars = $CGI->param("searchchars") + 0;
$searchplots = $CGI->param("searchplots") + 0;
$searchbgas = $CGI->param("searchbgas") + 0;
$searchjournals = $CGI->param("searchjournals") + 0;
$searchsheets = $CGI->param("searchsheets") + 0;
$searchgmnotes = $CGI->param("searchgmnotes") + 0;

$orsearch = 0;
$andsearch = 1;
$phrasesearch = 2;

$searchtype = $CGI->param("searchtype") + 0;
$st[$orsearch] = "";
$st[$andsearch] = "";
$st[$phrasesearch] = "";
$st[$searchtype] = "checked";

if ($al < $gm_access)
{
    print $CGI->redirect("login.pl?error=" . encodeURL("You do not have access to search the database."));
}
else
{
    print $CGI->header();
    $doctitle = "Database Keyword Search: $search";
    ParseForm($header);

    print "<img src=\"doclib/Clip Art/search.jpg\" align=left border=0>\n";
    print "<center>\n";
    print "<h1>Database Keyword Search</h1>";
    print "<form action=\"searchdb.pl\" method=\"post\">\n";
    print "<table>\n";
    print "<tr><td>\n";
    print "<b>Search For:</b><BR><input type=\"text\" size=\"50\" name=\"search\" value=\"$search\"><BR>";
    print "<input type=\"radio\" name=\"searchtype\" value=\"$orsearch\" $st[$orsearch]>OR Search</input> \n";
    print "&nbsp;&nbsp;&nbsp;&nbsp;\n";
    print "<input type=\"radio\" name=\"searchtype\" value=\"$andsearch\" $st[$andsearch]>AND Search</input> \n";
    print "&nbsp;&nbsp;&nbsp;&nbsp;\n";
    print "<input type=\"radio\" name=\"searchtype\" value=\"$phrasesearch\" $st[$phrasesearch]>Phrase Search</input> \n";
    print "</td>\n";
    print "<td>\n";
    print "<b>Search:</b><BR>\n";
    print "<input type=\"checkbox\" name=\"searchchars\" value=\"1\" $ischecked[$searchchars]>  Characters</input><BR>\n";
    print "<input type=\"checkbox\" name=\"searchbgas\" value=\"1\" $ischecked[$searchbgas]>  BGAs</input><BR>\n";
    print "<input type=\"checkbox\" name=\"searchplots\" value=\"1\" $ischecked[$searchplots]>  Plots</input><BR>\n";
    print "<input type=\"checkbox\" name=\"searchjournals\" value=\"1\" $ischecked[$searchjournals]>  Journals</input><BR>\n";
    print "<input type=\"checkbox\" name=\"searchgmnotes\" value=\"1\" $ischecked[$searchgmnotes]>  GM Notes</input><BR>\n";
    print "<input type=\"checkbox\" name=\"searchsheets\" value=\"1\" $ischecked[$searchsheets]>  Character Sheets (long)</input><BR>";        print "</td></tr>\n";
    print "</table>\n";
    print "<input type=\"submit\" value=\"Submit\">\n";
    print "</form>\n</center>\n";
    if ($searchchars > 0)
    {
        print "<hr><h2>Searching Characters</h2>\n";
    	dosearch("select characters.charid , charquestionnaires.*, characters.* from characters, charquestionnaires where characters.charid = charquestionnaires.cqcharid","charid");
    }
    if ($searchbgas > 0)
    {
        print "<hr><h2>Searching Between Game Actions</h2>\n";
    	dosearch("select characters.charid , bgas.* from characters, bgas where characters.charid = bgas.charid","bgaid");
    }
    if ($searchplots > 0)
    {
        print "<h2>Searching Plots</h2>\n";
    	dosearch("select plotid, plots.* from plots","plotid");
    }
    if ($searchjournals > 0)
    {
        print "<h2>Searching Journals</h2>\n";
    	dosearch("select charid, journal.* from journal","jid");
    }
    if ($searchsheets > 0)
    {
        print "<h2>Searching Character Sheets</h2>\n";
    	searchcharsheets();
    }
    if ($searchgmnotes > 0)
    {
        print "<h2>Searching GM Notes</h2>\n";
    	dosearch("select gmnid, gmnotes.* from gmnotes","gmnid");
    }
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteGMNConfirm(delName, jsid)\n";
	print "{\n";
	print "  alert(\"Sorry, you cannot delete GM Notes from this page\");\n";
	print "}\n";
	print "</script>\n";

    print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
    ParseForm($footer);
}

exit 0;

sub dosearch()
{
	local ($sql) = $_[0];
	local ($keyfield) = $_[1];
	local(@array);
	@searchterms = split(/\s/, $search);
	@returnchars = ("");
	$numret = 0;
	$db = dbconnect();
	$query = $db->prepare($sql);
	$query->execute();
	while (@array = $query->fetchrow_array)
	{
	    local(%matchvals) = ();
	    $nummatch = 0;
	    foreach $field (@array)
	    {
		if ($searchtype == $phrasesearch)
		{
		    $_ = $field;
		    while (m/$search/i)
		    {   
			$nummatch++;
			$_ = $';
		    }
		}
		if ($searchtype == $orsearch)
		{
		  foreach $term (@searchterms)
		  {
		    $_ = $field;
		    while (m/$term/i)
		    {   
			$nummatch++;
			$_ = $';
		    }
		  }
		}
		if ($searchtype == $andsearch)
		{
		  foreach $term (@searchterms)
		  {
		    $_ = $field;
		    while (m/$term/i)
		    {   
		        $matchvals{$term}++ ;
			$_ = $';
		    }
		  }
		}
	    }
	    
	    if ($searchtype == $andsearch)
	    {
	       $nummatch = 9999;
	       foreach $term (@searchterms)
	       {
	          $nummatch = min($nummatch,$matchvals{$term}+0);
	       }
	    }
	    
	    if ($nummatch > 0)
	    {
		$matchstr = "matches";
		if ($nummatch == 1)
		{
			$matchstr = "match";
		}
		if ($keyfield eq "charid")
		{
		   $charid = $array[0];
		   $charname = getCharName($array[0]);
		   $playername = getFullNameFromCharID($array[0]);
		   $returnchars[$numret] = "$nummatch $matchstr - <a href=\"charquest.pl?mode=review&cqcharid=$charid\">$charname</a> ($playername)";
		}
		if ($keyfield eq "bgaid")
		{
		   $charid = $array[0];
		   $charname = getCharName($array[0]);
		   $playername = getFullNameFromCharID($array[0]);
		   $returnchars[$numret] = "$nummatch $matchstr - <a href=\"gmbga.pl?charid=$charid\">$charname</a> ($playername)";
		}
		if ($keyfield eq "plotid")
		{
		   $plotid = $array[0];
		   $plotname = dosql("select plname from plots where plotid=$plotid;");
		   $authorid = dosql("select plauthor from plots where plotid=$plotid;");
		   $authorname = getFullNameFromID($authorid);
		   $returnchars[$numret] = "$nummatch $matchstr - <a href=\"plots.pl?submit=Review&plotid=$plotid\">$plotname</a> ($authorname)";
		}
		if ($keyfield eq "jid")
		{
		   $charid = $array[0];
		   $charname = getCharName($charid);
		   $playername = getFullNameFromCharID($charid);
		   $returnchars[$numret] = "$nummatch $matchstr - <a href=\"journal.pl?charid=$charid\">$charname</a> ($playername)";
		}
		if ($keyfield eq "gmnid")
		{
		   $gmnid = $array[0];
		   $note = shownotefromid($gmnid);
		   $returnchars[$numret] = "$nummatch $matchstr:<BR>$note";
		}
		$numret++;
	    }
	}
	searchres();
}

sub searchcharsheets()
{
	local(@array);
	@searchterms = split(/\s/, $search);
	@returnchars = ("");
	$numret = 0;
	$db = dbconnect();
	$query = $db->prepare("select charid, chtmllink from characters where chtmllink is not null");
	$query->execute();
	while (@array = $query->fetchrow_array)
	{
	    $charid = $array[0];
	    local(%matchvals) = ();
	    $nummatch = 0;
	    #print "$array[1]<BR>\n";
     	    open (HTMLFILE, "charhtml/$array[1]");
     	    while (<HTMLFILE>)            # process one line at a time
     	    {
     	        $line = $_;
		if ($searchtype == $phrasesearch)
		{
		    while ($line =~ m/$search/i)
		    {   
			$nummatch++;
			$line = $';
		    }
		}
		if ($searchtype == $orsearch)
		{
		  foreach $term (@searchterms)
		  {
		    while ($line =~ m/$term/i)
		    {   
			$nummatch++;
			$line = $';
		    }
		  }
		}
		if ($searchtype == $andsearch)
		{
		  foreach $term (@searchterms)
		  {
		    while ($line =~ m/$term/i)
		    {   
		        $matchvals{$term}++ ;
			$line = $';
		    }
		  }
		}
     	    }
     	    close (HTMLFILE);
	    if ($searchtype == $andsearch)
	    {
	       $nummatch = 9999;
	       foreach $term (@searchterms)
	       {
	          $nummatch = min($nummatch,$matchvals{$term}+0);
	       }
	    }
	    if ($nummatch > 0)
	    {
		$matchstr = "matches";
		if ($nummatch == 1)
		{
			$matchstr = "match";
		}
		$charname = getCharName($array[0]);
		$playername = getFullNameFromCharID($array[0]);
		$returnchars[$numret] = "$nummatch $matchstr - <a href=\"charquest.pl?mode=review&cqcharid=$charid\">$charname</a> ($playername) ";
		$returnchars[$numret] .= "<a href=\"charhtml/$array[1]\" target=_new>Character Sheet</a>";
		$numret++;
	    }
	}
	searchres();
}

sub searchres()
{
        print "<b>Results by Relevance</b><br><br>\n";
        print "<b>Searching For:</b> @searchterms<br><br>\n";
        @returnchars = sort returnnum @returnchars;
        foreach $line (@returnchars)
        {
            print "$line<BR>\n";
        }
}

sub returnnum
{
    @arr1 = split (/\s/, $a);
    @arr2 = split (/\s/, $b);
    return $arr2[0] <=> $arr1[0];
}