#!/usr/bin/perl

require 'stat_inc.pl';
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "speech.pl";
$table = "speech";
$heading = "Speech";
$keyfield = "abid";
$keyvalue = $CGI->param($keyfield);
$namefield = "name";
$tplfile = "x.tpl";
$errstr = $CGI->param("error");

$step = $CGI->param("step") + 0;
$charid = $CGI->param("charid");
$charname = getCharName($charid);
$gvid = $CGI->param("gvid") + 0;
$favors = $CGI->param("favors") + 0;

$doctitle = "Runtime Speech Mechanics for Floor GMs";

if ($al < $writer_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to visit this page!"));
}
elsif ($submit eq "New Topic")
{
	print $CGI->header;
	ParseForm($header);
	
	print "<H1>Create New Topic</h1>\n";
	print "<form action=\"$thispage\" method=\"post\">";
	
	print "<p><i>In general, you want a clear name that can easily be understood.  The description can be as long as you want.  ";
	print "Popular support for things should range from -100 to 100.  Relations between countries should range from 0 to 100.  ";
	print "Feel free to get a GM to get the starting level of this topic.</i></p>\n";
	
	$speechable = "checked";
	$gvid = 0;
	ParseForm("global.tpl");
	
	print "<h2>Step 3 -- Assorted Variables</h2>\n";
	
	print "<p><i>Is $charname for (raises number) or against (lowers number) this topic?</i><BR>\n";
	
	if ($favors >= 0)
	{
	  $forchecked = "checked";
	  $againstchecked = "";
	}
	else
	{
	  $forchecked = "";
	  $againstchecked = "checked";
	}
	
	print "<input type=radio name=favors value=\"1\" $forchecked > <b>for</b></input><br>\n";   
	print "<input type=radio name=favors value=\"-1\" $againstchecked > <b>against</b></input><br></p>\n";   

	print "<input type=\"hidden\" name=\"step\" value=\"3a\"><BR>";
	print "<input type=\"hidden\" name=\"charid\" value=\"$charid\"><BR>";
	print "<input type=\"submit\" name=\"submit\" value=\"Go To Step 4\"><BR>";

	print "</form>";
	
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	ParseForm($footer);
}
elsif ($step == 7)
{
	print $CGI->header;
	ParseForm($header);
	
	print "<H1>Speech Finished</h1>\n";

	$topicname = dosql("select name from global_variables where gvid=$gvid;");
	
	if ($favors > 0)
	{
	  $fstring = "<i>for</i>";
	}
	else
	{
	  $fstring = "<i>against</i>";
	}
	
	print "<h3>$charname is speaking $fstring $topicname.</h3><BR><BR>\n";
	
	$changed = $CGI->param("changed") + 0;
	print "<h3>Changed by $changed $fstring</h3>";
	
	$res[0] = "No effect -- The crowd is silent and unmoved.";
	$res[1] = "The crowd seems slightly moved.";
	$res[2] = "Average low -- a welcoming crowd.";
	$res[3] = "Average high -- a good crowd.";
	$res[4] = "The crowd cheers.";
	$res[5] = "The crowd goes wild.  Yay!";
	$res[6] = "Best possible result -- the crowd loves you!";
	print "$res[$changed]<BR>\n";
	
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	ParseForm($footer);
}
elsif ($step == 6)
{
	#print $CGI->header;
	$sec = $CGI->param("sec") + ($CGI->param("min") * 60) - 180;
	$sec = int($sec / 15);
	$sec = max($sec, 0);
	
	setSTATvars();
	$effstat = getlevel("GENUINE CURIOUSITY/FAMOUS") - getlevel("SOCIAL STIGMA ______________");

	$skilllevels = getlevel("ORATE");
	
	$roll1 = $iq + $effstat + $skilllevels + int(rand(10)) + 1;
	$roll2 = 9 + int(rand(10)) + $sec;
	
	#print "roll ".($iq + $effstat + $skilllevels)." vs. 8<BR>\n";
	#print "roll $roll1 vs. $roll2<BR>\n";
	
	$changed = 0;
		
	if ($roll1 >= $roll2)
	{
	    $changed = $roll1 - $roll2;
	    
	    $sql = "select level, min_range, max_range from global_variables where gvid=$gvid;";
	    
   	    local($db) = dbconnect();
	    local ($query) = $db->prepare($sql);
	    $query->execute;

	    @array = $query->fetchrow_array();
	    $level = $array[0];
	    $min_range = $array[1];
	    $max_range = $array[2];
	    $query->finish;
	    
	    $changed = min($changed, int(($max_range - $min_range) * 0.05));
	    $changed = min($changed, 6);
	    $result = $changed * $favors;
	    
	    #print "$changed * $favors<BR>\n";

	    #print "old level: $level<BR>\n";
	    $level += $result;
	    #print "a level: $level<BR>\n";
	    $level = max($level, $min_range);
	    #print "b level: $level<BR>\n";
	    $level = min($level, $max_range);
	    #print "new level: $level<BR>\n";
	    
	    $sql = "insert into speech (charid,gvid,result) values ($charid,$gvid,$changed);";
   	    #print "$sql<BR>";
	    $db->do($sql);
	    
	    $sql = "update global_variables set level=$level where gvid=$gvid;";

	    #print "$sql<BR>";
	    #uncomment the do before game
	    $db->do($sql);
   	    $db->disconnect;
	}
	else
	{
	    $sql = "insert into speech (charid,gvid,result) values ($charid,$gvid,0);";
	    dosql($sql);
	}

   	print $CGI->redirect("speech.pl?changed=$changed&charid=$charid&gvid=$gvid&step=7&favors=$favors");
}
elsif ($step == "3a")
{
	# Insert and Redirect
	#print $CGI->header;
	$SQL = filltablefromCGI("global_variables", 1);
	#print "$SQL<BR>";
	local($db) = dbconnect();
	$db->do($SQL);
	$gvid = $db->{'mysql_insertid'};
	$db->disconnect;
	print $CGI->redirect("speech.pl?charid=$charid&gvid=$gvid&step=4&favors=$favors");
}
elsif ($step == 4 && $gvid > 0)
{
	print $CGI->header;
	ParseForm($header);
	
	print "<H1>Make A Speech</h1>\n";

	$topicname = dosql("select name from global_variables where gvid=$gvid;");
	
	if ($favors > 0)
	{
	  $fstring = "<i>for</i>";
	}
	else
	{
	  $fstring = "<i>against</i>";
	}
	
	print "<h2>Step 4</h2><BR>\n";
	print "<h3>$charname is speaking $fstring $topicname.</h3><BR>\n";
	
	$count = dosql("select count(spid) from speech where charid=$charid") + 1;
	
	print "The player needs to give you $count voting token(s).<BR><BR>\n";
		
	print "<form action=\"$thispage\" method=\"post\">";
	print "<h2>Step 5</h2><BR>\n";
	print "<p><i>Now you are ready to begin the speech.  Time the person and then enter the minutes and seconds below.  If you aren't sure, just leave it at 3:00.</i></p>\n";
	
	print "<input type=text	name=min value=\"3\" size=3>:";
	print "<input type=text	name=sec value=\"00\" size=3><BR><BR>";
	print "<p><i>Time matters.  Players get penalized if they're more than 3 minutes, so you can also leave it at 3:00 if you don't want them to lose points.</i></p>\n";
	
	print "<input type=\"hidden\" name=\"charid\" value=\"$charid\"><BR>";
	print "<input type=\"hidden\" name=\"gvid\" value=\"$gvid\"><BR>";
	print "<input type=\"hidden\" name=\"favors\" value=\"$favors\"><BR>";
	print "<input type=\"hidden\" name=\"step\" value=\"6\"><BR>";
	print "<input type=\"submit\" name=\"submit\" value=\"Finish Speech\"><BR>";
	print "</form>";
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	ParseForm($footer);
}
else
{
	print $CGI->header;
	ParseForm($header);
	
	print "<H1>Make A Speech</h1>\n";
	
	print "<p><i>This page is for assistant/floor GMs to handle making speeches.  If you need help working this page, find a GM.</i></p>\n";
	
	print "<form action=\"$thispage\" method=\"post\">";

	print "<h2>Step 1</h2>\n";
	
	print "<p><i>Select the speaker from the list below.  This is a list of all player characters with STATs. </i></p>\n";
	
	print createCharDrop() ."<BR>\n";

	print "<h2>Step 2</h2>\n";
	
	print "<p><i>Select the topic from the lists below.  If the topic is not the list, then click \"New Topic\".</i></p>\n";
	
	$sel1 = makeDropDown("global_variables", "gvid", "name", "speechable=1 order by name");
	print "Speech Topics: $sel1 &nbsp;&nbsp;&nbsp;\n";
	print "<input type=\"submit\" name=\"submit\" value=\"New Topic\"><BR><BR>";

	print "<h2>Step 3 -- Assorted Variables</h2>\n";
	
	print "<p><i>Is the character for (raises number) or against (lowers number) this topic?</i><BR>\n";
	
	print "<input type=radio name=favors value=\"1\" checked> <b>for</b></input><br>\n";   
	print "<input type=radio name=favors value=\"-1\"> <b>against</b></input><br></p>\n";   

	print "<input type=\"hidden\" name=\"step\" value=\"4\"><BR>";
	print "<input type=\"submit\" name=\"submit\" value=\"Go To Step 4\"><BR>";

	print "</form>";
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	ParseForm($footer);
}
exit 0;

sub createCharDrop
{
    local ($db) = dbconnect();
    $SQL = "select a.charid, concat(a.cfirst, ' ', a.clast), a.ctitle from characters a,  characterSTATs b where a.charid=b.charid and a.chartype <= $cast_character and a.charid > 0 order by a.clast;";
 
    local($query) = $db->prepare($SQL);
    #print "$SQL<BR>";
    $query->execute;

    local ($retVal) = "";
    if ($query->rows > 0)
    {
        $retVal = "<select name=\"charid\">\n";
        while (@array = $query->fetchrow_array)
        {
            $retVal .= "<option value=\"$array[0]\">$array[1]";
            if ($array[2] ne "")
            {
            	$retVal .= ", $array[2]";
            }
            
            $retVal .= "</option>\n";
        }
        $retVal .= "</select>\n";
    }
    $query->finish;
    $db->disconnect;
    return "$retVal";
}
