#!perl

#stat global variables.
$statallowed = 135;  #now includes the 35 "XP"
$aballowed = 70;
$ws_mult = 5; #5 points / level of Weird Science
$vl_mult = 4; #4 points / level of Virtual Locations
#actually, vl_mult now equals status.

$midtd = "<td style=\"font-family : Arial, Helvetica, sans-serif; font-size: 12;\" valign=top>";
$midtd2 = "<td style=\"font-family : Arial, Helvetica, sans-serif; font-size: 12;\" valign=top align=right>";
$smalltd1 = "<td style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\">";
$smalltd2 = "<td style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\" colspan=2>";
$smalltd3 = "<td style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\" align=center>";

$statusText[0] = "Enemies of Crown and Country";
$statusText[1] = "Criminals";
$statusText[2] = "Low Class";
$statusText[3] = "Higher Lower Class";
$statusText[4] = "Lower Middle Class";
$statusText[5] = "Middle Class";
$statusText[6] = "Upper Middle Class";
$statusText[7] = "Minor Nobles";
$statusText[8] = "Nobility";
$statusText[9] = "Lower Royalty";
$statusText[10] = "Royalty";

$helptabnum = 200;
$locationtabnum = 150;
$occupationtabnum = 100;
$STATtabnum = 0;

# **************
# * Occupation *
# **************

sub getoccupations()
{
	local ($cid) = $_[0];
  	local(@array);
	local(@retarray);
	$retarray[0] = 0;
	local($retnum) = 0;
	local($db) = dbconnect();
	local $sql = "select oid from characteroccupations where charid=$cid;";
	#print"$sql<BR>";
	local ($query) = $db->prepare($sql);
	$query->execute;
        while (@array = $query->fetchrow_array)
	{
	   $retarray[$retnum] = $array[0];
	   $retnum++;
	}
	$query->finish;
	$db->disconnect;
	return @retarray;
}

sub haskeyrole()
{
	local ($krname) = $_[0];
	$krname =~ s/'/''/g;
	local ($retval) = 0;
	local($db) = dbconnect();
	local $sql = "select * from keyroles a, keyrolecharacters b where b.charid=$charid and a.krid=b.krid and a.krname='$krname';";
	#print"$sql<BR>";
	local ($query) = $db->prepare($sql);
	$query->execute;
	local ($retval) = $query->rows;
	$query->finish;
	$db->disconnect;
	return $retval;
}

sub validateoccupation()
{
	local ($charid) = $_[0];
	local ($oid) = $_[1];
	local ($retVal) = 0;
	local ($levtot) = 0;
	local ($mylev) = 0;
	$occstr = "";
	local ($status) = dosql("select status from characterSTATs where charid=$charid;") + 0;
	local ($oname) = dosql("select oname from occupations where oid=$oid;");
	local ($req_status) = dosql("select req_status from occupations where oid=$oid;") + 0;
        if ($status < $req_status)
      	{
      		$occstr .= "<font color=red> Your Base Status of $status is not enough to perform the duties of a $oname.  Base Status of at least $req_status is required.</font><BR>\n";
   	        $retVal = -1;
      	}
	local($db) = dbconnect();
	local ($sql) = "select a.abid, a.minlevel, a.text, b.name, b.req_text from occupationabilities a, abilities b where a.oid=$oid and a.abid=b.abid order by b.name, a.text;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"name"};
	   $text = $resptr->{"text"};
	   $num = getlevel($name, $text) + 0;
	   $name =~ s/_//g;
	   if ($resptr->{"req_text"} > 0)
	   {
	     $name .= " $text";
	   }
	   
	   if ($num == 0 && $resptr->{"minlevel"} > 0)
	   {
	      $occstr .= "<font color=red>Error: You need at least a ".$resptr->{"minlevel"}." in $name.  You do not even have this Ability.</font><BR>\n";
   	      $retVal = -1;
	   }
	   elsif ($num < $resptr->{"minlevel"})
	   {
	      $occstr .= "<font color=red>Error: You need at least a ".$resptr->{"minlevel"}." in $name.  You only have a $num.</font><BR>\n";
   	      $retVal = -1;
	   }
	   $levtot += $resptr->{"minlevel"};
	   $mylev += $num;
	}
	$query->finish;
	$db->disconnect;
	
	local ($skill_bonus_threshold) = dosql("select skill_bonus_threshold from occupations where oid=$oid;") + 0;
	local ($uses_weird_science) = dosql("select uses_weird_science from occupations where oid=$oid;") + 0;
	if ($uses_weird_science > 0)
	{
	   local ($weirdscience) = dosql("select weirdscience from characterSTATs where charid=$charid;") + 0;
	   if ($weirdscience == 0)
	   {
	      $occstr .=  "<font color=red>Error: You need at least a 1 in Weird Science.  You do not even have this Ability.</font><BR>\n";
   	      $retVal = -1;
	   }
	   $levtot += 1;
	   $mylev += $weirdscience;
	}
	
	#print "mylev = $mylev<BR>";
	#print "levtot = $levtot<BR>";
	#print "skill_bonus_threshold = $skill_bonus_threshold<BR>";
	if (($mylev >= $levtot + $skill_bonus_threshold) && ($retVal == 0))
	{
	  $retVal = $mylev + 1 - ($levtot + $skill_bonus_threshold);
	}	
	return $retVal;
}

# *****************
# * Generic STATs *
# *****************

sub setSTATvars()
{
	local ($tempid) = $charid;
	$statallowed += getXP($tempid);
	local($db) = dbconnect();
	local($tab) = $db->prepare("explain characterSTATs");
	$tab->execute;
	$i = 0;
	while (@arrtemp = $tab->fetchrow_array)
	{
	  $arr[$i] = $arrtemp[0];
	  $arrTypes[$i] = $arrtemp[1];
	  #print "$arr[$i] - $arrTypes[$i]<br>\n";
	  $i++;
	}
	$numFields = $i;
	$tab->finish;
	local($query) = $db->prepare("select * from characterSTATs where charid = $charid");
	$query->execute;
	@cqquery = $query->fetchrow_array;
	for ($k=0;$k<$tab->rows;$k++)
	{
	    $cqquery[$k] =~ s/'/\\'/g;
	    $cqquery[$k] =~ s/"/\"/g;
	    #print "\$$arr[$k] = $cqquery[$k]<br>\n";
	    if ($arrTypes[$k] eq 'tinyint(1)')
	    {
		if ($cqquery[$k] > 0)
		{
		    eval("\$$arr[$k] = 'CHECKED'");
		}
		else
		{
		    eval("\$$arr[$k] = ''");
		}
	    }
	    elsif ($arrTypes[$k] eq 'int(11)')
	    {
		eval("\$$arr[$k] = '$cqquery[$k]' + 0");
	    }
	    else
	    {
		eval("\$$arr[$k] = '$cqquery[$k]'");
	    }
	}
	$query->finish;
	
	$charid = $tempid;
	
	$db->disconnect;
	
	$totalcost = gettotalcosts();
	$handicaptot = gettabtot("handicap","tabname");
	$statremain = $statallowed + $handicaptot - $totalcost;
	$hp = $str + $will;
	
	$unholyline = "<input type=hidden name=unholy value=\"$unholy\"><input type=hidden name=unholycost ID=\"unholycost\" value=\"$unholycost\">";
	if ($unholyallowed eq "CHECKED")
	{
	  $unholyline = "<tr><td>INFERNAL:</td><td><input type=\"text\" name=\"unholy\" value=\"$unholy\" maxsize=5 size=5 OnKeyUp=\"setcost(this.form,this.value,'unholycost','Hard');\"></td><td>Cost:</td>";
	  $unholyline .= "<td><input type=text name\"unholycost\" ID=\"unholycost\" value=\"$unholycost\" maxsize=5 size=5 READONLY style=\"background : #DDDDDD;\" ></td>
<td><i>INFERNAL allows you to take Infernal Abilities.  You must get special permission to have this.</i></td></tr>";
	  $unholyallowed = 1;
	}
	else
	{
	  $unholyallowed = 0;
	}
	
	if ($al >= $gm_access)
	{
	  $unholyline .= "<tr><td colspan=5>";
	  $unholyline .= "<input type=\"checkbox\" name=\"unholyallowed\" value=\"1\" $ischecked[$unholyallowed]>Allow Character to Have Infernal Abilities -- <font color=red>GM Only</font></input></td></tr>";
	}
	else
	{
	  $unholyline .= "<input type=\"hidden\" name=\"unholyallowed\" value=\"$unholyallowed\">";
	}
}

sub gettabtot()
{
	local ($thetab) = $_[0];
	local ($whichtab) = $_[1];
	local ($retval) = 0;
	local ($sql) = "select 0 from characterabilities;";
	local ($ws_tab) = dosql("select typeid from abilitytypes where type='Weird Science';") + 0;
	if ($whichtab eq "tabname")
	{
	   $sql = "select sum(a.cost) from characterabilities a, abilities b where charid=$charid and a.abid=b.abid and b.type = '$thetab';";
	}
	else
	{
	   if ($thetab == $STATtabnum)
	   {
	     	return gettotalcosts();
	   }
	   elsif ($thetab == $locationtabnum)
	   {
		$sql = "select vlpoints from characterSTATs where charid=$charid";
	   }
	   elsif ($thetab == $ws_tab)
	   {
		$sql = "select weirdscience from characterSTATs where charid=$charid";
		$retval = dosql($sql) + 0;
		return getcost($retval,2);
	   }
	   elsif ($thetab < 100)
	   {
		$sql = "select type from abilitytypes where typeid=$thetab;";
		$thetab = dosql($sql);
	   	$sql = "select sum(a.cost) from characterabilities a, abilities b where charid=$charid and a.abid=b.abid and b.type = '$thetab';";
	   }
	}
	#print"$sql<BR>";
	$retval = dosql($sql) + 0;
	return $retval;
}

sub gettotalcosts()
{
    local ($costval) = 0;
    $strcost = getcost($str,3);
    $dexcost = getcost($dex,3);
    $iqcost  = getcost($iq,3);
    $willcost = getcost($will,3);
    $manacost = getcost($mana,2);
    $holycost = getcost($holy,2);
    $inspirationcost = getcost($inspiration,2);
    $unholycost = getcost($unholy,2);

    $costval += $strcost;
    $costval += $dexcost;
    $costval += $iqcost;
    $costval += $willcost;
    $costval += $manacost;
    $costval += $holycost;
    $costval += $inspirationcost;
    $costval += $unholycost;

    return $costval;
}

sub getcost()
{
  local ($val) = $_[0];
  local ($costtype) = $_[1];
  local ($costval) = 0;
  if ("$costtype" eq "0")
  {
  	$costval = $val;
  }
  else
  {
	for ($i = 1; $i <= $val; $i++)
	{
	      $costval = $costval + $i;
	}
	$costval = $costval * $costtype;
  }
  return $costval;
}

sub abilityallowed()
{
	local ($abid) = $_[0];
	local ($retval) = 0;
	local($db) = dbconnect();
	local $sql = "select * from charabilityallowed where charid=$charid and abid=$abid;";
	#print"$sql<BR>";
	local ($query) = $db->prepare($sql);
	$query->execute;
	if ($query->rows > 0)
	{
	   $retval = 1;
	}
	$query->finish;
	$db->disconnect;
	return $retval;
}

sub geteffectivestatus()
{
	local ($charid) = $_[0];
	local ($retval) = 0;
	
	$retval -= getlevelforchar("SOCIAL STIGMA ______________","",$charid);
	$retval += getlevelforchar("GENUINE CURIOUSITY/FAMOUS","",$charid);
	return $retval;
}

sub getlevel()
{
	local ($abname) = $_[0];
	local ($abtext) = $_[1];
	local ($retval) = 0;

	$retval = getlevelforchar($abname, $abtext, $charid);
	return $retval;
}

sub getlevelforchar()
{
	local ($abname) = $_[0];
	local ($abtext) = $_[1];
	local ($varID) = $_[2];
	local ($retval) = 0;
	
	#print "getting level for $abnmame<BR>\n";
	local($tname) = $abname;
	local($ttext) = $abtext;
	$abname =~ s/'/''/g;
	$abtext =~ s/'/''/g;
	local($db) = dbconnect();
	local $sql = "select a.level, a.text, b.req_text from characterabilities a, abilities b where a.charid=$varID and a.abid=b.abid and b.name='$abname';";
	#print"$sql<BR>";
	local ($query) = $db->prepare($sql);
	$query->execute;
	local ($retval) = 0;
	if ($query->rows > 0)
	{
	   local (@array);
	   while (@array = $query->fetchrow_array)
	   {
	      if ($array[2] > 0 && length($abtext) > 0)
	      {
	         if (lc($array[1]) eq lc($abtext))
	         {
	             $retval += $array[0];
	         }
	      }
	      else
	      {
	         $retval += $array[0];
	      }
	   }
	}
	$query->finish;
	$db->disconnect;

	$retval += getkeyrolelevelforchar($tname, $ttext, $varID);
	
	#print "so far $retval<BR>";
	return $retval;
}

sub getkeyrolelevelforchar()
{
	local ($abname) = $_[0];
	local ($abtext) = $_[1];
	local ($varID) = $_[2];
	local ($retval) = 0;
	
	#print "getting level for $abname<BR>\n";
	$abname =~ s/'/''/g;
	$abtext =~ s/'/''/g;
	local($db) = dbconnect();
	local ($retval) = 0;
	#print "so far $retval<BR>";
	$sql = "select a.level, a.text, b.req_text from keyroleabilities a, abilities b, keyrolecharacters c where c.charid=$varID and a.abid=b.abid and b.name='$abname' and a.krid=c.krid;";
	#print"$sql<BR>";
	local ($query) = $db->prepare($sql);
	$query->execute;
	if ($query->rows > 0)
	{
	   local (@array);
	   while (@array = $query->fetchrow_array)
	   {
	      if ($array[2] > 0)
	      {
	         if (lc($array[1]) eq lc($abtext))
	         {
	             $retval += $array[0];
	         }
	      }
	      else
	      {
	         $retval += $array[0];
	      }
	   }
	}
	$query->finish;
	$db->disconnect;
	#print "so far $retval<BR>";
	return $retval;
}

sub hasability()
{
	local ($abname) = $_[0];
	$abname =~ s/'/''/g;
	local ($retval) = 0;
	local($db) = dbconnect();
	local $sql = "select a.level, a.text, b.req_text from characterabilities a, abilities b where a.charid=$charid and a.abid=b.abid and b.name='$abname';";
	#print"$sql<BR>";
	local ($query) = $db->prepare($sql);
	$query->execute;
	local ($retval) = $query->rows;
	$query->finish;
	$sql = "select a.level, a.text, b.req_text from keyroleabilities a, abilities b, keyrolecharacters c where c.charid=$charid and a.abid=b.abid and b.name='$abname' and a.krid=c.krid;";
	#print"$sql<BR>";
	$query = $db->prepare($sql);
	$query->execute;
	$retval += $query->rows;
	$query->finish;
	$db->disconnect;
	return $retval;
}

sub validtab()
{
  local ($basestat) = $_[0];
  if ("$basestat" eq "")
  {
      return 1;
  }
  
  local($db) = dbconnect();
  local ($sql) = "select $basestat from characterSTATs where charid = $charid";
  #print "$sql<BR>";  
  local ($query) = $db->prepare($sql);
  $query->execute;
  if ($query->rows > 0)
  {
	local(@array);
	@array = $query->fetchrow_array;
	$query=>finish;
	$db->disconnect;
	return $array[0];
    
  }
  $query->finish;
  $db->disconnect;
  return 0;
}

sub arestatsapproved()
{
	local ($sql) = "select charstatsapproved from characters where charid=$charid;";
	return dosql($sql) + 0;
}

sub getXP()
{
  	local ($varID) = $_[0];
	local ($sql) = "select sum(xp) from xp where charid=$varID;";
	return dosql($sql) + 0;
}


sub updateXP()
{
  	local ($varID) = $_[0];
  	local ($xp) = $_[1];
  	local ($reason) = $_[2];
	local ($sql) = "insert into xp (charid, xp, entrydate, notes) values ($varID, $xp, '".getDBDate()."', '$reason');";
	dosql($sql);
}


# *********************
# * Virtual Locations *
# *********************

sub getVLtotal()
{
  local ($vlid) = $_[0];
  local ($totstr1) = $_[1];
  local ($totstr2) = $_[2];
  local($db) = dbconnect();
  local ($sql) = "select sum($totstr1) from virtuallocations where vlid = $vlid;";
  #print "$sql<BR>";
  local($query) = $db->prepare($sql);
  $query->execute;
  local(@array);
  @array = $query->fetchrow_array;
  local ($ret_val) = $array[0];
  $query->finish;
  $sql = "select sum($totstr2) from VLaccess where vlid=$vlid;";
  #print "$sql<BR>";
  $query = $db->prepare($sql);
  $query->execute;
  local(@array);
  @array = $query->fetchrow_array;
  $ret_val += $array[0];
  $query->finish;
  $db->disconnect;
  return $ret_val;
}

sub getVLchars()
{
  local ($vlid) = $_[0];
  local($db) = dbconnect();
  local ($sql) = "select * from VLaccess where vlid = $vlid;";
  #print "$sql<BR>";
  local($query) = $db->prepare($sql);
  $query->execute;
  local ($ret_val) = $query->rows;
  $query->finish;
  $db->disconnect;
  return $ret_val;
}

sub deleteVL()
{
  local ($vlid) = $_[0];
  local($db) = dbconnect();
  local ($sql) = "delete from virtuallocations where vlid = $vlid;";
  $db->do($sql);
  local ($sql) = "delete from VLaccess where vlid = $vlid;";
  $db->do($sql);
  local ($sql) = "delete from VLstatlink where vlid = $vlid;";
  $db->do($sql);
  $db->disconnect;
}

# *****************
# * Weird Science *
# *****************

sub canshowmotiveforce()
{
  local ($mfid) = $_[0];
  local ($retval) = 0;
  local ($sql) = "select count(mfid) from characterMFallowed where mfid=$mfid and charid=$charid";
  #print "$sql<BR>\n";
  local ($retval) = dosql($sql) + 0;
  #print "returned $retval<BR>\n";
  return $retval;
}

sub getmotiveforce()
{
  local ($mfid) = $_[0];
  local ($sql) = "select level from charactermotiveforces where mfid=$mfid and charid=$charid";
  #print "$sql<BR>\n";
  local ($retval) = dosql($sql) + 0;
  #print "returns $retval<BR>\n";
  return $retval;
}

sub getapplication()
{
  local ($aid) = $_[0];
  local ($retval) = 0;
  local ($sql) = "select level from characterapplications where aid=$aid and charid=$charid";
  local($db) = dbconnect();
  local($query) = $db->prepare($sql);
  $query->execute;
  if ($query->rows > 0)
  {
     @aparray = $query->fetchrow_array;
     $retval = $aparray[0];
  }
  $query->finish;
  $db->disconnect;
  return $retval;
}

# ***************
# *   Status    *
# ***************
sub getStatusRank()
{
	local($varID) = $_[0];
	local($status) = dosql("select status from characterSTATs where charid=$varID");
	local($db) = dbconnect();
	local ($sql) = "select a.charid from characterSTATs a, characters b where a.status=$status and a.charid=b.charid and b.chartype != $test_character order by substatus desc;";
	#print "$sql<BR>";  
	local ($retVal) = 1;
	local ($query) = $db->prepare($sql);
	$query->execute;
	local (@array);
	while (@array = $query->fetchrow_array())
	{
	  if ($array[0] == $varID)
	  {
		$query->finish;
		$db->disconnect;
		return $retVal;
	  }
	  $retVal++;
	}
	$query->finish;
	$db->disconnect;
	return 0;
}

# ***************
# * Return True *
# ***************
# * A Perl Library must always return a true value,
# * or it doesn't compile in the require statement.
1;b