#!/usr/bin/perl

require 'stat_inc.pl';
require 'g_invest.pl';
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$tabnum = $CGI->param("tab") + 0;
$pid = getPlayerID();
$charid = $CGI->param("charid");
$action = $CGI->param("submit");
$al = getAccessLevel($pid);
$curtabtext = "";

$occupationtabtext = "occupation";

if ($pid != getPIDFromCharID($charid) && $al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to edit that character."));
}
elsif (arestatsapproved($charid) > 0 && $al < $gm_access)
{
	print $CGI->redirect("dispstats.pl?charid=$charid");
}
elsif ($action eq "Update" || $action eq "Done")
{
   #print $CGI->header;
   #print "$tabnum<BR>";
   local($ws_tab) = $CGI->param("ws_tab") + 0;
   if ($tabnum == $STATtabnum)
   {
	updateSTATs();
   }
   elsif ($tabnum == $locationtabnum)
   {
	updateVL();
   }
   elsif ($tabnum == $ws_tab && $tabnum > 0 && $ws_tab > 0)
   {
	updateWS();
   }
   elsif ($tabnum == $occupationtabnum)
   {
      if ($action ne "Done")
      {
	updateOccupation();
      }
   }
   elsif ($tabnum < 100)
   {
	updateAbilities();
   }
   if ($CGI->param("newtab") ne "")
   {
     $tabnum = $CGI->param("newtab");
   }
   if ($action eq "Done")
   {
   	print $CGI->redirect("characters.pl");
   }
   else
   {
   	print $CGI->redirect("stats.pl?tab=$tabnum&charid=$charid");
   }  

}
elsif ($action eq "AddVL")
{
   #print $CGI->header;
   updateVL();

   local($db) = dbconnect();
   local ($sql) = "insert into virtuallocations (vlname, vldesc, vlowner) values ('Name', 'Description', $charid)";
   $db->do($sql);
   $db->disconnect;
   
   print $CGI->redirect("stats.pl?tab=$tabnum&charid=$charid");

}
elsif ($action eq "RemoveVL")
{
   #print $CGI->header;
   local($vlid) = $CGI->param("vlid");
   updateVL();

   deleteVL($vlid);
   
   print $CGI->redirect("stats.pl?tab=$tabnum&charid=$charid");

}
elsif ($action eq "giveVLaccess")
{
   #print $CGI->header;
   local($vlid) = $CGI->param("vlid");
   updateVL();

   print $CGI->redirect("virtuallocations.pl?vlid=$vlid&action=giveaccess");

}
elsif ($action eq "AddAbility")
{
   #print $CGI->header;
   updateAbilities();

   local ($difficulty) = 0;
   local ($cost) = 0;
   local ($abid) = $CGI->param("abid");
   local($db) = dbconnect();
   local ($sql) = "select difficulty, cost, type from abilities where abid=$abid;";
   #print "$sql<BR>";
   local ($query) = $db->prepare($sql);
   $query->execute;
   while (@array = $query->fetchrow_array)
   {
     $difficulty = $array[0];
     $cost = $array[1];
     $type = $array[2];
   }
   $query->finish;
   $sql = "insert into characterabilities (charid, abid, difficulty, cost) values ($charid, $abid, '$difficulty', $cost);";
   #print "$sql<BR>";
   $db->do($sql);
   if ($type eq "Resource")
   {
   	$sql = "select max(caid) from characterabilities where charid=$charid and abid=$abid;";
   	$query = $db->prepare($sql);
   	$query->execute;
   	local ($caid) = 0;
   	while (@array = $query->fetchrow_array)
   	{
     	   $caid = $array[0]; 
   	}
   	$query->finish;
   	$sql = "select typeid, level from resourcetypelink where abid=$abid;";
   	$query = $db->prepare($sql);
   	$query->execute;
   	while (@array = $query->fetchrow_array)
   	{
     	   $sql = "insert into characterresourcetypelink (typeid, level, charid, abid) values ($array[0], $array[1], $charid, $caid)";
   	   $db->do($sql);
   	}
   	$query->finish;
   }
   
   $db->disconnect;
   
   print $CGI->redirect("stats.pl?tab=$tabnum&charid=$charid");

}
elsif ($action eq "RemoveAbility")
{
   #print $CGI->header;
   updateAbilities();
   local ($caid) = $CGI->param("abid");
   local($db) = dbconnect();
   $sql = "delete from characterabilities where caid=$caid;";
   #print "$sql<BR>";
   $db->do($sql);
   $sql = "delete from characterresourcetypelink where abid=$caid;";
   #print "$sql<BR>";
   $db->do($sql);
   $db->disconnect;
   
   print $CGI->redirect("stats.pl?tab=$tabnum&charid=$charid");

}
else
{
	print $CGI->header;
	$doctitle = "Edit your STATs/skills"; 
	ParseForm("revheader.tpl");
	print "<style TYPE=\"text/css\" MEDIA=screen>\n";
	print ".greytab { \n";
	print "    background-image : url(greytab.gif); \n";
	print "    background-position : center;\n";
	print "    background-repeat : no-repeat;  \n";
	print "    width : 100px; \n";
	print "    height : 27px; \n";
	print "    text-align : center;\n";
	print "    font-weight : bold;\n";
	print "    font-family : sans-serif;\n";
	print "    color : Black;\n";
	print "    cursor : pointer;\n";
	print "};\n";
	print "</style>\n";
	print "<style TYPE=\"text/css\" MEDIA=screen>\n";
	print ".blacktab { \n";
	print "    background-image : url(blacktab.gif); \n";
	print "    background-position : center;\n";
	print "    background-repeat : no-repeat;  \n";
	print "    width : 100px; \n";
	print "    height : 27px; \n";
	print "    text-align : center;\n";
	print "    font-weight : bold;\n";
	print "    font-family : sans-serif;\n";
	print "    color : White;\n";
	print "    cursor : default;\n";
	print "};\n";
	print "</style>\n";

	print "<H1>Edit STATs/Skills for: ".getCharName($charid)."</h1>\n";
	print "<form action=\"stats.pl\" name=\"myform\" method=\"post\">\n";

	showtabs();
	prepare();
	ParseForm("stats/$curtabtext.tpl");
	ParseForm("stats/stats-js.tpl");
	
	print "<input type=hidden name=\"charid\" value=\"$charid\">\n";
	print "<input type=hidden name=\"tab\" value=\"$tabnum\">\n";
	print "<input type=hidden name=\"tabname\" value=\"$curtabtext\">\n";
	print "</form>\n";

	print "<br><hr><a href=\"login.pl\">Main menu</a>\n"; 
	ParseForm($footer);
}
exit 0;

sub showtabs()
{
	local ($tottabs) = 1;
	local($db) = dbconnect();
	print "<table>\n";
	print "<tr>\n";
	if ("$tabnum" eq "$STATtabnum")
	{
		print "<td class=\"blacktab\">STATs</td>\n";
		$curtabtext = "stats";
	}
	else
	{
		print "<td class=\"greytab\" OnClick=\"createredirect('stats.pl?newtab=$STATtabnum&submit=Update')\">STATs</td>\n";
	}
	local ($sql) = "select * from abilitytypes order by type;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	$abcost = gettabtot($locationtabnum,"tabnum");
	while ($resptr = $query->fetchrow_hashref())
	{
	  local($typeid) = $resptr->{"typeid"};
	  local($basestat) = $resptr->{"basestat"};
	  if ($resptr->{"type"} ne "Handicap" && "$tabnum" ne "$typeid")
	  {
	       $abcost += gettabtot($typeid,"tabnum");
	       #print "gettabtot of $typeid (".$resptr->{"type"}.") is ".gettabtot($typeid)."<BR>\n";
	       #print "After ".$resptr->{"type"}.", abcost is $abcost<BR>\n";
	  }
	  if (validtab($basestat) > 0 )
	  {
	      if ("$tabnum" eq "$typeid")
	      {
		   print "<td class=\"blacktab\">".$resptr->{"type"}."s</td>\n";
		   $curtabtext = lc($resptr->{"type"});
	      }
	      else
	      {
		   print "<td class=\"greytab\" OnClick=\"createredirect('stats.pl?newtab=$typeid&submit=Update')\">".$resptr->{"type"}."s</td>\n";
	      }
	      $tottabs = $tottabs + 1;
	      if ($tottabs % 7 == 0)
	      {
	    	print "</tr><tr>\n";
	      }
	  }
	  elsif ($resptr->{"type"} eq "Weird Science" && getlevel("ALCHEMY","") > 0)
	  {
	      if ("$tabnum" eq "$typeid")
	      {
		   print "<td class=\"blacktab\">Alchemy</td>\n";
		   $curtabtext = lc($resptr->{"type"});
	      }
	      else
	      {
		   print "<td class=\"greytab\" OnClick=\"createredirect('stats.pl?newtab=$typeid&submit=Update')\">Alchemy</td>\n";
	      }
	      $tottabs = $tottabs + 1;
	      if ($tottabs % 7 == 0)
	      {
	    	print "</tr><tr>\n";
	      }
	  }
	}
	if ("$tabnum" eq "$occupationtabnum")
	{
	      print "<td class=\"blacktab\">Occupation<BR>& Key Roles</a></td>\n";
	      $curtabtext = $occupationtabtext;
	      $tottabs = $tottabs + 1;
	      if ($tottabs % 7 == 0)
	      {
	    	print "</tr><tr>\n";
	      }
	}
	else
	{
		print "<td class=\"greytab\" OnClick=\"createredirect('stats.pl?newtab=$occupationtabnum&submit=Update')\">Occupation<BR>& Key Roles</a></td>\n";
	      $tottabs = $tottabs + 1;
	      if ($tottabs % 7 == 0)
	      {
	    	print "</tr><tr>\n";
	      }
	}
	if ("$tabnum" eq "$locationtabnum")
	{
		print "<td class=\"blacktab\">Virtual<BR>Locations</a></td>\n";
		$curtabtext = "locations";
	      $tottabs = $tottabs + 1;
	      if ($tottabs % 7 == 0)
	      {
	    	print "</tr><tr>\n";
	      }
	}
	else
	{
		print "<td class=\"greytab\" OnClick=\"createredirect('stats.pl?newtab=$locationtabnum&submit=Update')\">Virtual<BR>Locations</a></td>\n";
	      $tottabs = $tottabs + 1;
	      if ($tottabs % 7 == 0)
	      {
	    	print "</tr><tr>\n";
	      }
	}
	if ("$tabnum" eq "$helptabnum")
	{
		print "<td class=\"blacktab\">Help</a></td>\n";
		$curtabtext = "help";
	}
	else
	{
		print "<td class=\"greytab\" OnClick=\"createredirect('stats.pl?newtab=$helptabnum&submit=Update')\">Help</a></td>\n";
	}
	print "</tr>\n";
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub prepare()
{
  if ("$tabnum" eq "$STATtabnum")
  {
  	setSTATvars();
  }
  elsif ("$tabnum" eq "$occupationtabnum")
  {
  	$mykeyroles = getmykeyroles();
	setoccvars();
  }
  elsif ("$tabnum" eq "$locationtabnum")
  {
  	getmyabilities();
  	setVLvars();
  	$abcost -= gettabtot($locationtabnum,"tabnum");
	$handicaptot = $statallowed + + getXP($charid) + gettabtot("handicap","tabname") - gettabtot($STATtabnum,"tabnum");
	if ($handicaptot < 0)
	{
	   $handicaptot = 0;
	}
	$abremain = $aballowed + $handicaptot - $abcost - $totalcost;
  }
  elsif ($tabnum + 0 < 100)
  {
  	setSTATvars();
	$myabilities = getmyabilities();
	$abilitiesstr = getabilitiesstr();
	$handicaptot = $statallowed + getXP($charid) + gettabtot("handicap","tabname") - gettabtot($STATtabnum,"tabnum");
	if ($handicaptot < 0)
	{
	   $handicaptot = 0;
	}
	
	if ($curtabtext eq "weird science")
	{
	   setWSvars();
	}
	
	if ($curtabtext eq "combat manuever")
	{
	   setCMvars();
	}
	
	$abremain = $aballowed + $handicaptot - $abcost - $totalcost;
  }

}

sub getmyabilities()
{
	$totalcost = 0;
	local ($retstr) = "";
	local($db) = dbconnect();
	if ($curtabtext eq "celestial")
	{
		$sql = "select a.caid, a.abid, b.name, a.level, a.text, a.difficulty, a.cost from characterabilities a, abilities b where a.charid=$charid and a.abid=b.abid and (b.type='$curtabtext' or b.type='Infernal') order by b.name;";
	}
	else
	{
		$sql = "select a.caid, a.abid, b.name, a.level, a.text, a.difficulty, a.cost, b.category from characterabilities a, abilities b where a.charid=$charid and a.abid=b.abid and b.type='$curtabtext' order by b.name;";
	}
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	$retstr .= "<table border=1>\n";
	$retstr .= "<tr>\n";
	$retstr .= "<td><b>Level</b></td>\n";
	$retstr .= "<td><b>$curtabtext Name</b></td>\n";
	if ($curtabtext eq "combat manuever")
	{
		$retstr .= "<td><b>Category</b></td>\n";
	}
	else
	{
		$retstr .= "<td><b>Text</b></td>\n";
	}
	$retstr .= "<td><b>Difficulty</b></td>\n";
	$retstr .= "<td><b>Cost</b></td>\n";
	$retstr .= "<td><b>Action</b></td>\n";
	$retstr .= "</tr>\n";
	local ($num) = 0;
	while ($resptr = $query->fetchrow_hashref())
	{
	   $retstr .= "<input type=hidden name=abid_$num value=".$resptr->{"abid"}.">\n";
	   $retstr .= "<input type=hidden name=caid_$num value=".$resptr->{"caid"}.">\n";
	   $retstr .= "<tr>\n";
	   $retstr .= "<td><input type=text name=level_$num value=".$resptr->{"level"}." maxsize=5 size=5 OnKeyUp=\"setcost(this.form,this.value,'cost_$num','".$resptr->{"difficulty"}."');\"></td>\n";
	   $retstr .= "<td><a href=\"\" onClick=\"javascript:window.open('abilitypop.pl?abid=".$resptr->{"abid"}."','','width=450,height=550,left = 500,top = 100,scrollbars=1,resizable=1');\">".$resptr->{"name"}."</a></td>\n";
	   if ($curtabtext eq "combat manuever")
	   {
		$retstr .= "<td>".$resptr->{"category"}."</td>\n";
	   }
	   else
	   {
	       $retstr .= "<td><input type=text name=text_$num value=\"".$resptr->{"text"}."\" maxsize=50 size=50>";
	       if ($curtabtext eq "resource")
	       {
	           $retstr .= showResourceLinks($resptr->{"caid"});
	       }
	       $retstr .= "</td>\n";
	   }
	   $retstr .= "<td>".$resptr->{"difficulty"}."</td>\n";
	   $retstr .= "<td><input type=text name=cost_$num ID=cost_$num value=".$resptr->{"cost"}." maxsize=5 size=5 READONLY style=\"background : #DDDDDD;\"></td>\n";
	   $retstr .= "<td><a href=\"javascript:createredirect('stats.pl?abid=".$resptr->{"caid"}."&submit=RemoveAbility')\">Remove</a></td>";
	   $retstr .= "</tr>\n";
	   $totalcost += $resptr->{"cost"};
	   $num += 1;
	}
	$query->finish;
	
	$sql = "select a.kraid, a.abid, b.name, a.level, a.text, a.difficulty, a.cost from keyroleabilities a, abilities b, keyrolecharacters c where a.abid=b.abid and b.type='$curtabtext' and c.charid=$charid and c.krid=a.krid order by b.name;";
	#print "$sql<BR>";  
	local ($query2) = $db->prepare($sql);
	$query2->execute;
	while ($resptr = $query2->fetchrow_hashref())
	{
	   $retstr .= "<tr bgcolor=#ddddff>\n";
	   $retstr .= "<td bgcolor=#ddddff>".$resptr->{"level"}."</td>\n";
	   $retstr .= "<td bgcolor=#ddddff><a href=\"\" onClick=\"javascript:window.open('abilitypop.pl?abid=".$resptr->{"abid"}."','','width=450,height=550,left = 500,top = 100,scrollbars=1,resizable=1');\">".$resptr->{"name"}."</a></td>\n";
	   $retstr .= "<td bgcolor=#ddddff>".$resptr->{"text"};
	   if ($curtabtext eq "resource")
	   {
	       $retstr .= showKRResourceLinks($resptr->{"kraid"});
	   }
	   $retstr .= "</td>\n";
	   $retstr .= "<td bgcolor=#ddddff>".$resptr->{"difficulty"}."</td>\n";
	   $retstr .= "<td bgcolor=#ddddff colspan=2>From Key Role</td>\n";
	   $retstr .= "</tr>\n";
	}
	$query2->finish;

	$retstr .= "</table>\n";
	$retstr .= "<input type=hidden name=num_abs value=$num>\n";
	
	$db->disconnect;
	return $retstr;
}

sub getabilitiesstr()
{
	local ($retstr) = "";
	local ($chartype) = getCharTypeFromCharID($charid);
	local($db) = dbconnect();
	if ($curtabtext eq "celestial")
	{
		$sql = "select distinct a.* from abilities a, charabilityallowed b where (type='$curtabtext' and allowed!='None') or (type='infernal' and a.abid=b.abid and b.asholy=1) order by name;";
	}
	else
	{
		$sql = "select * from abilities where type='$curtabtext' and allowed!='None' order by name;";
	}
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	$retstr .= "<table border=1>\n";
	$retstr .= "<tr>\n";
	$retstr .= "<td><b>$curtabtext Name</b></td>\n";
	if ($curtabtext eq "combat manuever")
	{
		$retstr .= "<td><b>Category</b></td>\n";
	}
	$retstr .= "<td><b>Action</b></td>\n";
	$retstr .= "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   if ($resptr->{"allowed"} eq "All" || $chartype eq "Test Character")
	   {
		$retstr .= "<tr>\n";
		$retstr .= "<td>".$resptr->{"name"}."</td>\n";
	        if ($curtabtext eq "combat manuever")
	        {
			$retstr .= "<td>".$resptr->{"category"}."</td>\n";
	        }
		$retstr .= "<td><a href=\"\" onClick=\"javascript:window.open('abilitypop.pl?abid=".$resptr->{"abid"}."','','width=450,height=550,left = 500,top = 100,scrollbars=1,resizable=1');\">Display</a>\n";
		$retstr .= " -- <a href=\"javascript:createredirect('stats.pl?abid=".$resptr->{"abid"}."&submit=AddAbility')\">Add</a>\n";
		$retstr .= "</tr>\n";
	   }
	   elsif ($resptr->{"allowed"} eq "NPC Only" && $chartype eq "Cast Character")
	   {
		$retstr .= "<tr>\n";
		$retstr .= "<td style=\"background : #FFFFDD;\">".$resptr->{"name"}." -- Cast Only</td>\n";
	        if ($curtabtext eq "combat manuever")
	        {
			$retstr .= "<td>".$resptr->{"category"}."</td>\n";
	        }
		$retstr .= "<td style=\"background : #FFFFDD;\"><a href=\"\" onClick=\"javascript:window.open('abilitypop.pl?abid=".$resptr->{"abid"}."','','width=450,height=550,left = 500,top = 100,scrollbars=1,resizable=1');\">Display</a>\n";
		$retstr .= " -- <a href=\"javascript:createredirect('stats.pl?abid=".$resptr->{"abid"}."&submit=AddAbility')\">Add</a>\n";
		$retstr .= "</tr>\n";
	   }
	   elsif (($resptr->{"allowed"} eq "By Request Only" && $chartype eq "Cast Character") || abilityallowed($resptr->{"abid"}) || $al >= $gm_access)
	   {
		$retstr .= "<tr>\n";
		$retstr .= "<td style=\"background : #DDDDDD;\">".$resptr->{"name"}." -- By Request Only</td>\n";
	        if ($curtabtext eq "combat manuever")
	        {
			$retstr .= "<td>".$resptr->{"category"}."</td>\n";
	        }
		$retstr .= "<td style=\"background : #DDDDDD;\"><a href=\"\" onClick=\"javascript:window.open('abilitypop.pl?abid=".$resptr->{"abid"}."','','width=450,height=550,left = 500,top = 100,scrollbars=1,resizable=1');\">Display</a>\n";
		$retstr .= " -- <a href=\"javascript:createredirect('stats.pl?abid=".$resptr->{"abid"}."&submit=AddAbility')\">Add</a>\n";
		$retstr .= "</tr>\n";
	   }
	}
	$retstr .= "</table>\n";
	$query->finish;
	$db->disconnect;
	return $retstr;
}


sub showResourceLinks()
{
  	local ($caid) = $_[0];
	local($db) = dbconnect();
	local ($sql) = "select * from resourcetypes a, characterresourcetypelink b where a.typeid=b.typeid and b.abid=$caid order by a.type;";
	#print "$sql<BR>";
	local($query) = $db->prepare($sql);
	$query->execute;
	local ($resptr);
	$rlretstr = "<table border = 0 width=100% cellspacing=0 cellpadding=0><tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   if ($resptr->{"showplayer"} == 0 && $al < $gm_access)
	   {
	   }
	   elsif ($resptr->{"isnumeric"} == 0)
	   {
	     $rlretstr .= "<td style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\"><u>".$resptr->{"type"}.":</u>  ".$levels[$resptr->{"level"}]."</td>";
	   }
	   else
	   {
	     $rlretstr .= "<td style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\"><u>".$resptr->{"type"}.":</u>  ".$resptr->{"level"}."</td>";
	   }
	}
	$rlretstr .= "</tr></table>\n";
	$query->finish;
	$db->disconnect;
	return $rlretstr;
}

sub setWSvars()
{
	$ws_level = dosql("select weirdscience from characterSTATs where charid = $charid") + 0;
	$inspiration = dosql("select inspiration from characterSTATs where charid = $charid") + 0;
	local($db) = dbconnect();
	
	$ws_points = $ws_level * $ws_mult;
	$ws_cost = getcost($ws_level,2);
	$totalcost = $ws_cost;
	
	#that was the easy part.
	$num_applications = 0;
	$sql = "select * from applications where amfid=0 order by aname";
	local($query) = $db->prepare($sql);
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())
	{
	   $aid[$num_applications] = $resptr->{"aid"};
	   $applications[$num_applications] = $resptr->{"aname"};
	   $application_text[$num_applications] = $resptr->{"adesc"};
	   $num_applications += 1;
	}
	$query->finish;
	
	$num_motives = 0;
	$sql = "select * from motiveforces order by mfsecret, mfname desc";
	local($query) = $db->prepare($sql);
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())
	{
	   $mfid[$num_motives] = $resptr->{"mfid"};
	   $mfsecret[$num_motives] = $resptr->{"mfsecret"} + 0;
	   $motives[$num_motives] = $resptr->{"mfname"};
	   $motive_text[$num_motives] = $resptr->{"mfdesc"};
	   $num_motives += 1;
	}
	$query->finish;
	
	$spent = 0;
	$ws_chart = "<table border=1 cellspacing=0 cellpadding=1 align=center>\n";
	$ws_chart .= "<tr bgcolor=#eeeeee><td colspan=2 rowspan=2>&nbsp;</td><td colspan=$num_applications align=center><b>Applications</b></td></tr>\n";
	$ws_chart .= "<tr bgcolor=#eeeeee>";
	for ($k=0; $k < $num_applications; $k++)
	{
	   if ($inspiration > 0)
	   {
	   	$ws_chart .= "<td title=\"$application_text[$k]\" align=center> $applications[$k] </td>";
	   }
	   else
	   {
	   	$ws_chart .= "<td align=center> &nbsp; </td>";
	   }
	}
	$ws_chart .= "</tr>\n";
	$ws_chart .= "<tr><td colspan=2 align=center bgcolor=#eeeeee><b>Motive Forces</b></td>";
	for ($k=0; $k < $num_applications; $k++)
	{
	   if ($inspiration > 0)
	   {
		   $apvals[$k] = getapplication($aid[$k]);
		   $ws_chart .= "<td align=center>";
		   $ws_chart .= "<input type=hidden name=aid_$k value=$aid[$k]>";
		   $ws_chart .= "<input type=text name=application_$k ID=application_$k value=$apvals[$k] maxsize=5 size=2 OnKeyUp=\"updateWScol(this.form,$k,this.value)\">";

		   $ws_chart .= "</td>";
		   $spent += $apvals[$k];
	   }
	   else
	   {
	   	$ws_chart .= "<td align=center> &nbsp; </td>";
	   }
	}
	$ws_chart .= "</tr>\n";
	$num_shown_motives = 0;
	for ($k=0; $k < $num_motives; $k++)
	{
	   local ($mfval) = getmotiveforce($mfid[$k]);
	   #print "$motives[$k]  ($mfid[$k]) -- mfval is $mfval<BR>\n";
	   #print "mfsecret: $mfsecret[$k]  inspiration: $inspiration<BR>\n";
	   #print "mfsecret: $mfsecret[$k]  inspiration: $inspiration<BR>\n";
	   if ("$mfsecret[$k]" eq "0" && $inspiration > 0)
	   {
		$ws_chart .= "<tr><td bgcolor=#eeeeee  title=\"$motive_text[$k]\">$motives[$k]</td>\n";
		$ws_chart .= "<td>";
		$ws_chart .= "<input type=hidden name=mfid_$num_shown_motives value=$mfid[$k]>";
		$ws_chart .= "<input type=text name=motive_$num_shown_motives ID=motive_$num_shown_motives value=$mfval maxsize=5 size=2 OnKeyUp=\"updateWSrow(this.form,$num_shown_motives,this.value)\"></td>";
		for ($j=0; $j < $num_applications; $j++)
		{
		   $ws_chart .= "<td align=center bgcolor=#EEEEEE><input type=text name=chart_".$j."_".$num_shown_motives." ID=chart_".$j."_".$num_shown_motives." value=".min($mfval,$apvals[$j])." maxsize=2 size=2 READONLY style=\"background : #EEEEEE;\">";
		   
		   $sql = "select aname from applications where amfid=$mfid[$k] and abaseid=$aid[$j];";
		   local($str) = dosql($sql);
		   #print "$sql<BR>";		   
		   if ($str ne "0")
		   {
		     $ws_chart .= "<BR><i>($str)</i>";
		   }
		   $ws_chart .= "</td>";
		}
		$ws_chart .= "</tr>\n";
		$spent += $mfval;
		$num_shown_motives++;
	   }
	   elsif (canshowmotiveforce($mfid[$k]) && $inspiration > 0)
	   {
		$ws_chart .= "<tr><td bgcolor=#ddddff title=\"$motive_text[$k]\">$motives[$k]</td>\n";
		$ws_chart .= "<td>";
		$ws_chart .= "<input type=hidden name=mfid_$num_shown_motives value=$mfid[$k]>";
		$ws_chart .= "<input type=text name=motive_$num_shown_motives ID=motive_$num_shown_motives value=\"$mfval\" maxsize=5 size=2 OnKeyUp=\"updateWSrow(this.form,$num_shown_motives,this.value)\"></td>";
		for ($j=0; $j < $num_applications; $j++)
		{
		   $ws_chart .= "<td align=center bgcolor=#ddddff><input type=text name=chart_".$j."_".$num_shown_motives." ID=chart_".$j."_".$num_shown_motives." value=".min($mfval,$apvals[$j])." maxsize=2 size=2 READONLY style=\"background : #ddddff;\">";
		   
		   $sql = "select aname from applications where amfid=$mfid[$k] and abaseid=$aid[$j];";
		   local($str) = dosql($sql);
		   #print "$sql<BR>";		   
		   if ($str ne "0")
		   {
		     $ws_chart .= "<BR><i>($str)</i>";
		   }
		   $ws_chart .= "</td>";
		}
		$ws_chart .= "</tr>\n";
		$spent += $mfval;
		$num_shown_motives++;
	   }
	   elsif (alchemyenabled($motives[$k]))
	   {
	   	$mfval = getlevel("ALCHEMY","");
		$ws_chart .= "<tr><td bgcolor=#ddddff title=\"$motive_text[$k]\">$motives[$k]</td>\n";
		$ws_chart .= "<td bgcolor=#ddddff >";
		$ws_chart .= "<input type=hidden name=mfid_$num_shown_motives value=$mfid[$k]>";
		$ws_chart .= "<input type=text name=motive_$num_shown_motives ID=motive_$num_shown_motives value=\"$mfval\" maxsize=5 size=2 READONLY style=\"background : #ddddff;\"></td>";
		for ($j=0; $j < $num_applications; $j++)
		{
		   $ws_chart .= "<td align=center bgcolor=#ddddff><input type=text name=chart_".$j."_".$num_shown_motives." ID=chart_".$j."_".$num_shown_motives." value=".min($mfval+$apvals[$j],6)." maxsize=2 size=2 READONLY style=\"background : #ddddff;\">";
		   
		   $sql = "select aname from applications where amfid=$mfid[$k] and abaseid=$aid[$j];";
		   local($str) = dosql($sql);
		   #print "$sql<BR>";		   
		   if ($str ne "0")
		   {
		     $ws_chart .= "<BR><i>($str)</i>";
		   }
		   $ws_chart .= "</td>";
		}
		$ws_chart .= "</tr>\n";
		$num_shown_motives++;
	   }	   
	}
	if ($inspiration > 0)
	{
		$ws_chart .= "<tr><td colspan=".($num_applications+2)." align=right>";
		$ws_chart .= "Points Spent: <input name=chart_spent ID=chart_spent value=$spent maxsize=2 size=2 READONLY style=\"background : #FFDDDD;\">";
		$ws_chart .= "&nbsp;&nbsp;&nbsp;Points Remaining: <input name=chart_remain ID=chart_remain value=".($ws_points - $spent)."  maxsize=2 size=2 READONLY style=\"background : #FFFFDD;\">";
		$ws_chart .= "</td></tr>\n";
	}
	$ws_chart .= "</table>\n";
	$ws_chart .= "<input type=hidden name=num_motives ID=num_motives value=$num_shown_motives>\n";
	$ws_chart .= "<input type=hidden name=num_applications ID=num_applications value=$num_applications>\n";
	$db->disconnect;
	
	if ($inspiration > 0)
	{
		$ws_explain = "Weird Science encompasses all science.  You may only take the Weird Science Ability if you have an inspiration of one or more.<BR><BR>\n";
		$ws_explain .= "Each level of Weird Science gives you 5 points to spend on Motive Forces and Applications.  Your level in building something is the lower of the two where they meet on the grid.  For example, if you have a 3 in Steam and a 2 in Automatons, your ability level to build a Steam Powered Weasel is a 2, the lower of the two values.  We encourage specialization.<BR><BR>\n";
		$ws_explain .= "Weird Science is treated as a HARD Ability.<BR><BR>\n";
		
		$ws_explain .=  "<p>I have a Weird Science ability level of <input type=\"text\" name=\"ws_level\" ID=\"ws_level\" value=\"$ws_level\" maxsize=\"2\" size=\"2\" OnKeyUp=\"setwspoints(this.form,this.value)\">, giving me <input type=\"text\" name=\"wspoints\" ID=\"wspoints\" value=\"$ws_points\" maxsize=\"2\" size=\"2\" READONLY style=\"background : #EEEEEE;\"> points to spend.</p>";
		

	}
	
	if (getlevel("ALCHEMY","") > 0)
	{
	$ws_explain .= "<u>Alchemy</u><BR><BR>\n";
	$ws_explain .= "Alchemy now uses the Weird Science system.  If you do not have the Weird Science skill, then the values in the chart below are just for you to see.  <BR><BR>\n";
	
	$ws_explain .= "To understand how to make potions in the new Alchemy system, first read the Weird Science System.  Here are the following changes:<BR><BR>\n";
	
	$ws_explain .= "Alchemy is now treated as a new Motive Force.  It is equal to your level in the Alchemy skill.<BR><BR>\n";
	
	$ws_explain .= "The five Applications for Alchemy are: <BR>\n";
	$ws_explain .= "<ul>";
	$ws_explain .= "<li>Curatives: Potions that heal or cure.<BR><BR>\n";
	$ws_explain .= "<li>Influences: Potions that allow you to influence the imbibers mental state, for example giving a bonus to fast talk, or a love potion.<BR><BR>\n";
	$ws_explain .= "<li>Knowledge: Potions that impart information to the imbiber, for example ones that give prophetic visions.<BR><BR>\n";
	$ws_explain .= "<li>Transformations: Potions that change the imbibers physical form somehow.  Note that permanent or drastic changes will probably be too complex to create.<BR><BR>\n";
	$ws_explain .= "<li>Impairments: Potions that harm the imbiber.<BR><BR>\n";
	$ws_explain .= "</ul>";
	
	$ws_explain .= "Your level in these Applications are equal to your Alchemy skill + any points you put in them via Weird Science (not greater than 6).<BR><BR>\n";
	
	$ws_explain .= "You use the same system to create alchemical concoctions that you do for weird science devices.  However, instead of weird science components, alchemy requires spell components and MANA.  Also, Alchemical blueprints can never be made higher than the beta stage of development.<BR><BR>\n";

	}
}

sub alchemyenabled()
{
   local ($mfname) = $_[0];
   
   if ("$mfname" ne "Alchemy")
   {
     return 0;
   }
   
   return getlevel("ALCHEMY","");
}

sub setVLvars()
{
	local($db) = dbconnect();
	local ($sql) = "select status, vlpoints, vlspecialpoints from characterSTATs where charid = $charid";
	local($query) = $db->prepare($sql);
	$query->execute;
	@array = $query->fetchrow_array;
	$status = $array[0];
	$vl_level = $array[1];
	$vlspecialpoints = $array[2];
	$query->finish;
	
	$vl_mult= $status;
	$statuspoints = $status * $vl_mult;
	$statuspoints = $status * $vl_mult;
	$vl_points = $statuspoints + ($vl_level * $vl_mult);
	$vl_cost = $vl_level;
	$totalcost = $vl_cost;
	
	#that was the easy part.
	$my_vl_list = "<table width=100% border = 1>";
	$my_vl_list .= "<tr>";
	$my_vl_list .= "<td><b>Name</b></td>";
	$my_vl_list .= "<td><b>Description</b></td>";
	$my_vl_list .= "<td><b>Action</b></td>";
	$my_vl_list .= "</tr>";
	$num_vls = 0;
	$spent = 0;
	
	$sql = "select * from virtuallocations where vlowner = $charid";
	$query = $db->prepare($sql);
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())
	{
	    $my_vl_list .= "<tr><input type=hidden name=vlid_$num_vls ID=vlid_$num_vls value=".$resptr->{"vlid"}.">";
	    $my_vl_list .= "<td><input type=text name=vlname_$num_vls ID=vlname_$num_vls size=30 value=\"".$resptr->{"vlname"}."\"></td>";
	    $my_vl_list .= "<td><input type=text name=vldesc_$num_vls ID=vldesc_$num_vls size=40 value=\"".$resptr->{"vldesc"}."\"></td>";
	    $my_vl_list .= "<td>";
	    $my_vl_list .= "<a href=\"javascript:createredirect('stats.pl?vlid=".$resptr->{"vlid"}."&submit=giveVLaccess')\">Set Characters</a>";
	    $my_vl_list .= " -- <a href=\"javascript:createredirect('stats.pl?vlid=".$resptr->{"vlid"}."&submit=RemoveVL')\">Remove</a>";
	    $my_vl_list .= "</td>";
	    $my_vl_list .= "</tr>\n";
	    $my_vl_list .= "<tr>";
	    $my_vl_list .= "<td colspan=2>";
	        local ($dosums) = getVLchars($resptr->{"vlid"});
	        $val = 0;
		$my_vl_list .= "<table border=1 width=100%>";
		$my_vl_list .= "<tr> ";
		$my_vl_list .= "<td>Fancy: <input type=text name=vlfancy_$num_vls ID=vlfancy_$num_vls size=1 value=\"".$resptr->{"vl_fancy"}."\" OnKeyUp=\"setvltotal(this.form,$num_vls)\">";
		$val += $resptr->{"vl_fancy"};
		if ($dosums > 0)
		{
		   $my_vl_list .= "+ <input type=text name=vlfancy_tot_$num_vls ID=vlfancy_tot_$num_vls size=1 value=\"".(getVLtotal($resptr->{"vlid"},"vl_fancy", "vla_fancy")-$resptr->{"vl_fancy"})."\" READONLY style=\"background : #EEEEEE;\"></td>";
		}
		else
		{
		   $my_vl_list .= "</td>\n";
		}
		$my_vl_list .= "<td>Secure: <input type=text name=vlsecure_$num_vls ID=vlsecure_$num_vls size=1 value=\"".$resptr->{"vl_secure"}."\" OnKeyUp=\"setvltotal(this.form,$num_vls)\">";
		$val += $resptr->{"vl_secure"};
		if ($dosums > 0)
		{
		    $my_vl_list .= "+ <input type=text name=vlsecure_tot_$num_vls ID=vlsecure_tot_$num_vls size=1 value=\"".(getVLtotal($resptr->{"vlid"},"vl_secure", "vla_secure")-$resptr->{"vl_secure"})."\" READONLY style=\"background : #EEEEEE;\"></td>";
		}
		else
		{
		   $my_vl_list .= "</td>\n";
		}
		$my_vl_list .= "<td>Location: <input type=text name=vllocation_$num_vls ID=vllocation_$num_vls size=1 value=\"".$resptr->{"vl_location"}."\" OnKeyUp=\"setvltotal(this.form,$num_vls)\">";
		$val += $resptr->{"vl_location"};
		if ($dosums > 0)
		{
		   $my_vl_list .= "+ <input type=text name=vllocation_tot_$num_vls ID=vllocation_tot_$num_vls size=1 value=\"".(getVLtotal($resptr->{"vlid"},"vl_location", "vla_location")-$resptr->{"vl_location"})."\" READONLY style=\"background : #EEEEEE;\"></td>";
		}
		else
		{
		   $my_vl_list .= "</td>\n";
		}
		$my_vl_list .= "<td>Inventory: <input type=text name=vlinventory_$num_vls ID=vlinventory_$num_vls size=1 value=\"".$resptr->{"vl_inventory"}."\" OnKeyUp=\"setvltotal(this.form,$num_vls)\">";
		$val += $resptr->{"vl_inventory"};
		if ($dosums > 0)
		{
		   $my_vl_list .= "+ <input type=text name=vlinventory_tot_$num_vls ID=vlinventory_tot_$num_vls size=1 value=\"".(getVLtotal($resptr->{"vlid"},"vl_inventory", "vla_inventory")-$resptr->{"vl_inventory"})."\" READONLY style=\"background : #EEEEEE;\"></td>";
		}
		else
		{
		   $my_vl_list .= "</td>\n";
		}
		$my_vl_list .= "</tr>\n";	
		$my_vl_list .= showspecialVLstats($resptr->{"vlid"}, $num_vls, "vl");
		$my_vl_list .= "</table>\n";
	    $my_vl_list .= "</td>";
	    $spent += $val;
	    $my_vl_list .= "<td>Total Spent: <input type=text name=vltotal_$num_vls ID=vltotal_$num_vls size=2 value=\"$val\" READONLY style=\"background : #EEEEEE;\"></td>";	    
	    $my_vl_list .= "</tr>\n";
	    $num_vls++;
	}
	$query->finish;
	$num_vlas = 0;
	$sql = "select * from virtuallocations a, VLaccess b where a.vlid=b.vlid and b.charid = $charid";
	$query = $db->prepare($sql);
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())
	{
	    $my_vl_list .= "<tr bgcolor=#DDDDFF><input type=hidden name=vlaid_$num_vlas ID=vlaid_$num_vlas value=".$resptr->{"vlid"}.">";
	    $my_vl_list .= "<td>".$resptr->{"vlname"}."</td>";
	    $my_vl_list .= "<td>".$resptr->{"vldesc"}."</td>";
	    $my_vl_list .= "<td>";
	    $my_vl_list .= "</td>";
	    $my_vl_list .= "</tr>\n";
	    $my_vl_list .= "<tr bgcolor=#DDDDFF>";
	    $my_vl_list .= "<td colspan=2>";
		$my_vl_list .= "<table border=1 width=100%>";
		$my_vl_list .= "<tr bgcolor=#DDDDFF> ";
		$my_vl_list .= "<td>Fancy: <input type=text name=vlafancy_$num_vlas ID=vlafancy_$num_vlas size=1 value=\"".$resptr->{"vla_fancy"}."\" OnKeyUp=\"setvlatotal(this.form,$num_vlas)\">";
		$val = $resptr->{"vla_fancy"};
		$my_vl_list .= "+ <input type=text name=vlafancy_tot_$num_vlas ID=vlafancy_tot_$num_vlas size=1 value=\"".(getVLtotal($resptr->{"vlid"},"vl_fancy", "vla_fancy")-$resptr->{"vla_fancy"})."\" READONLY style=\"background : #EEEEEE;\"></td>";
		$my_vl_list .= "<td>Secure: <input type=text name=vlasecure_$num_vlas ID=vlasecure_$num_vlas size=1 value=\"".$resptr->{"vla_secure"}."\" OnKeyUp=\"setvlatotal(this.form,$num_vlas)\">";
		$val += $resptr->{"vla_secure"};
		$my_vl_list .= "+ <input type=text name=vlasecure_tot_$num_vlas ID=vlasecure_tot_$num_vlas size=1 value=\"".(getVLtotal($resptr->{"vlid"},"vl_secure", "vla_secure")-$resptr->{"vla_secure"})."\" READONLY style=\"background : #EEEEEE;\"></td>";
		$my_vl_list .= "<td>Location: <input type=text name=vlalocation_$num_vlas ID=vlalocation_$num_vlas size=1 value=\"".$resptr->{"vla_location"}."\" OnKeyUp=\"setvlatotal(this.form,$num_vlas)\">";
		$val += $resptr->{"vla_location"};
		$my_vl_list .= "+ <input type=text name=vlalocation_tot_$num_vlas ID=vlalocation_tot_$num_vlas size=1 value=\"".(getVLtotal($resptr->{"vlid"},"vl_location", "vla_location")-$resptr->{"vla_location"})."\" READONLY style=\"background : #EEEEEE;\"></td>";
		$my_vl_list .= "<td>Inventory: <input type=text name=vlainventory_$num_vlas ID=vlainventory_$num_vlas size=1 value=\"".$resptr->{"vla_inventory"}."\" OnKeyUp=\"setvlatotal(this.form,$num_vlas)\">";
		$val += $resptr->{"vla_inventory"};
		$my_vl_list .= "+ <input type=text name=vlainventory_tot_$num_vlas ID=vlainventory_tot_$num_vlas size=1 value=\"".(getVLtotal($resptr->{"vlid"},"vl_inventory", "vla_inventory")-$resptr->{"vla_inventory"})."\" READONLY style=\"background : #EEEEEE;\"></td>";
		$my_vl_list .= "</tr>\n";		
		$my_vl_list .= showspecialVLstats($resptr->{"vlid"}, $num_vlas, "vla");
		$my_vl_list .= "</table>\n";
	    $my_vl_list .= "</td>";
	    $spent += $val;
	    $my_vl_list .= "<td>Total Spent: <input type=text name=vlatotal_$num_vlas ID=vlatotal_$num_vlas size=2 value=\"$val\" READONLY style=\"background : #EEEEEE;\"></td>";	    
	    $my_vl_list .= "</tr>\n";
	    $num_vlas++;
	}
	$query->finish;
	$my_vl_list .= "<tr><td colspan=3 align=right>";
	$my_vl_list .= "Points Lost From Depreciation: <input name=chart_lost ID=chart_lost value=\"$vlspecialpoints\" maxsize=2 size=2 READONLY style=\"background : #FFEBDD;\">";
	$my_vl_list .= "&nbsp;&nbsp;&nbsp;Points Spent: <input name=chart_spent ID=chart_spent value=\"$spent\" maxsize=2 size=2 READONLY style=\"background : #FFDDDD;\">";
	$my_vl_list .= "&nbsp;&nbsp;&nbsp;Points Remaining: <input name=chart_remain ID=chart_remain value=".($vl_points - $spent - $vlspecialpoints)."  maxsize=2 size=2 READONLY style=\"background : #FFFFDD;\">";
	$my_vl_list .= "</td></tr>\n";
	$my_vl_list .= "</table>\n";

	$db->disconnect;	
}

sub showspecialVLstats()
{
  local ($vlid) = $_[0];
  local ($nums) = $_[1];
  local ($jssub) = $_[2];
  local($db) = dbconnect();
  local ($sql) = "select b.vlsname, a.vlsid, b.vlsdesc from VLstatlink a, VLstats b, virtuallocations c where a.vlid=$vlid and a.vlsid=b.vlsid and a.charid=c.vlowner and c.vlid=$vlid;";
  #print "$sql<BR>";
  local($query) = $db->prepare($sql);
  $query->execute;
  local($retstr)= "";
  local ($sub) = 0;
  if ($query->rows > 0)
  {
     $retstr .= "<tr>\n";
     local ($resptr);
     while ($resptr = $query->fetchrow_hashref())
     {
        $sql = "select vlslevel from VLstatlink where vlid=$vlid and vlsid=".$resptr->{"vlsid"}." and charid=$charid;";
   	#print "$sql<BR>";
  	local($query2) = $db->prepare($sql);
  	$query2->execute;
  	local (@myval);
  	$myval[0] = 0;
  	if ($query2->rows > 0)
  	{
  		@myval = $query2->fetchrow_array();
  	}
	$query2->finish;
        $sql = "select sum(vlslevel) from VLstatlink where vlid=$vlid and vlsid=".$resptr->{"vlsid"}.";";
   	#print "$sql<BR>";
  	$query2 = $db->prepare($sql);
  	$query2->execute;
  	local (@mysum);
  	$mysum[0] = 0;
  	if ($query2->rows > 0)
  	{
  		@mysum = $query2->fetchrow_array();
  		$mysum[0] -= $myval[0];
  	}
	$query2->finish;
        local ($name) = $resptr->{"vlsname"};
     	$retstr .= "<td>";
     	$retstr .= "<input type=hidden name=".$jssub."subid_".$nums."_$sub ID=".$jssub."subid_".$nums."_$sub value=".$resptr->{"vlsid"}.">";
     	$retstr .= "<i title=\"".$resptr->{"vlsdesc"}."\">$name</i>: ";
     	$retstr .= "<input type=text name=".$jssub."subval_".$nums."_$sub ID=".$jssub."subval_".$nums."_$sub size=1 value=\"$myval[0]\" OnKeyUp=\"set".$jssub."total(this.form,$nums);\">";
     	if ($mysum[0] > 0)
     	{
     	     $retstr .= "+ <input type=text size=1 value=\"$mysum[0]\" READONLY style=\"background : #EEEEEE;\">";
     	}
     	$retstr .= "</td>\n";
     	$sub++;
	$val += $myval[0];
     }
     $retstr .= "</tr>\n";
  }
  $retstr .= "<input type=hidden name=".$jssub."subtot_".$nums." ID=".$jssub."subtot_".$nums." value=$sub>";
  $query->finish;
  $db->disconnect;
  return $retstr;
}

sub setCMvars()
{
  $uc = getlevel('UNARMED/CLOSE WEAPONS');
  $rw = getlevel('RANGED/THROWN WEAPONS');
  $def = getlevel('DODGE');
}

sub setoccvars()
{
  $numoccs = dosql("select count(oid) from characteroccupations where charid=$charid;") + 0;
  local(@myoccs) = getoccupations($charid);
  
  local($mystr) = "";
  if ($numoccs == 0)
  {
     $mystr="SELECTED";
  }
  
  $occdrop = makeMultipleBox("occupations", "oid", "oname", "oid >= 0", @myoccs);
  $occdrop =~ s|<select name="oid" MULTIPLE>|<select name="oid" MULTIPLE><option value="0" $mystr>No Occupation</option>|;
  $occdrop =~ s|<select name="oid" MULTIPLE>|<select name="oid" id="oid" onchange="javascript:createredirect('stats.pl?submit=Update');" multiple="multiple" size="7">|;
    
  $occstring = "";
  if ($numoccs > 0)
  {
     setSTATvars();
     local ($sql) = "select * from occupations a join characteroccupations b on a.oid=b.oid where charid=$charid order by a.oname;";
     #$occstring = "$sql<BR>";
     local($db) = dbconnect();
     local($query) = $db->prepare($sql);
     $query->execute;
     while ($resptr = $query->fetchrow_hashref())
     {
        $oid = $resptr->{"oid"};
        $oname = $resptr->{"oname"};
        $occstring .= "<BR><table border=0><tr><td>\n";
        $occstring .= "<H2>$oname</H2>";
        $occstring .= "</td><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";
        $occstring .= "(<a href=\"\" onClick=\"javascript:window.open('occpop.pl?oid=$oid&charid=$charid','','width=450,height=550,left = 500,top = 100,scrollbars=1,resizable=1');\">Details</a>)<BR>\n";
        $occstring .= "</td></tr></table>\n";
        $occstring .= "<p><i>".$resptr->{"odesc"}."</i></p>";
        $occstring .= "<p>In order to effectively be a $oname, you must have a base status of at least ".$resptr->{"req_status"}.".  ";
        $occstring .= "Your base status is $status.";
        if ($status < $resptr->{"req_status"})
        {
           $occstring .= "<font color=red>  Your base status is not high enough for you to make money at being a $oname.</font>";
        }
        $occstring .=  "</p>";
        $occstring .=  "<b>Abilities Required</b>:<BR>\n";
	$occstring .=  "<i>You must have the following abilities at the following levels or you will not gain money from this occupation between games.  If an Ability is listed at level 0, then it is an optional Ability that adds to your level bonus, but is not required.</i><BR>\n";
	
	$occstring .= getoccabilities($oid,$resptr->{"uses_weird_science"},$resptr->{"skill_bonus_threshold"});

     }
     $occstring .= "<BR><BR>\n";
     $query->finish;
     $db->disconnect;
  }
  else
  {
     $occstring = "<p><i>You have no occupation and thus no regular source of income.  You either live off your investments or what you find in the streets.</i></p>";
  }
 
}

sub getoccabilities()
{
  	local ($val) = $_[0];
  	local ($uses_weird_science) = $_[1];
  	local ($skill_bonus_threshold) = $_[2];
        $levtot = 0;
	local ($retstr) = "";
	local($db) = dbconnect();
	local ($sql) = "select a.ocabid, b.name, a.minlevel, a.text, b.req_text, b.abid from occupationabilities a, abilities b where a.oid=$val and a.abid=b.abid order by b.name, a.text;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	$retstr .= "<table border=1>\n";
	$retstr .= "<tr>\n";
	$retstr .= "<td><b>Name</b></td>\n";
	$retstr .= "<td><b>Text</b></td>\n";
	$retstr .= "<td><b>Min Level</b></td>\n";
	$retstr .= "<td><b>Your Level</b></td>\n";
	$retstr .= "</tr>\n";
	local ($num) = 0;
	local ($occtot) = 0;
	local ($myocctot) = 0;
	local ($resptr);
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"name"};
	   $name = $resptr->{"name"};
	   $text = $resptr->{"text"};
	   $num = getlevel($name, $text) + 0;
	   $name =~ s/_//g;
	   $retstr .= "<tr>\n";
	   $retstr .= "<td><a href=\"\" onClick=\"javascript:window.open('abilitypop.pl?abid=".$resptr->{"abid"}."','','width=450,height=550,left = 500,top = 100,scrollbars=1,resizable=1');\">$name</a></td>\n";
	   $retstr .= "<td>".$resptr->{"text"}."</td>\n";
	   $retstr .= "<td>".$resptr->{"minlevel"}."</td>\n";
	   $retstr .= "<td>$num</td>\n";
	   $occtot += $resptr->{"minlevel"};
	   $myocctot += $num;
	   $retstr .= "</tr>\n";
	}
	if ("$uses_weird_science" eq "1")
	{
	   $retstr .= "<tr>\n";
	   $retstr .= "<td>Weird Science</td>\n";
	   $retstr .= "<td> </td>\n";
	   $retstr .= "<td>1</td>\n";
	   $retstr .= "<td>$weirdscience</td>\n";
	   $occtot += 1;
	   $myocctot += $weirdscience;
	   $retstr .= "</tr>\n";
	}
	$retstr .= "<tr>\n";
	$retstr .= "<td style=\"border-top-width : thin; border-top-color : Black;\"><b>Total</b></td>\n";
	$retstr .= "<td style=\"border-top-width : thin; border-top-color : Black;\"> </td>\n";
	$retstr .= "<td style=\"border-top-width : thin; border-top-color : Black;\"><b>$occtot</b></td>\n";
	$retstr .= "<td style=\"border-top-width : thin; border-top-color : Black;\"><b>$myocctot</b></td>\n";
	$retstr .= "</tr>\n";
	$retstr .= "</table>\n";
	$retstr .= "<i>If <b>Your Level</b> totals at least ".($occtot + $skill_bonus_threshold).", then you will get additional income each BGP.</i><BR>\n";
	$query->finish;
	$db->disconnect;
	return $retstr;
}


sub updateSTATs()
{
	#print $CGI->header;
	$keyfield = "charid";
	$keyvalue = $charid;
	$table = "characterSTATs";
	
	if ($CGI->param("csid") + 0 > 0)
	{
	    $sql = filltablefromCGI($table, 0);
	}
	else
	{
	    $sql = filltablefromCGI($table, 1);
	}
	#print "$sql<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($sql);
	$dbvar->disconnect;
}

sub updateWS()
{
   #print $CGI->header;
   local ($ws_level) = $CGI->param("ws_level");
   local($db) = dbconnect();
   local ($sql) = "update characterSTATs set weirdscience=$ws_level where charid=$charid;";
   #print"$sql<BR>";
   $db->do($sql);
   
   #and now the chart
   $sql = "delete from charactermotiveforces where charid=$charid;";
   $db->do($sql);
   $sql = "delete from characterapplications where charid=$charid;";
   $db->do($sql);
   
   local ($num_applications) = $CGI->param("num_applications");
   local ($num_motives) = $CGI->param("num_motives");
   
   for ($k=0; $k < $num_applications; $k++)
   {
        local ($aid) = $CGI->param("aid_$k");
        local ($level) = $CGI->param("application_$k") + 0;
        if ($level > 0)
        {
	   $sql = "insert into characterapplications (aid, charid, level) values ($aid, $charid, $level)";
   	   #print"$sql<BR>";
   	   $db->do($sql);
	}
   }
   
   for ($k=0; $k < $num_motives; $k++)
   {
        local ($mfid) = $CGI->param("mfid_$k");
        local ($level) = $CGI->param("motive_$k") + 0;
        if ($level > 0)
        {
	   $sql = "insert into charactermotiveforces (mfid, charid, level) values ($mfid, $charid, $level)";
   	   $db->do($sql);
	}
   }
   
   $db->disconnect;
}


sub updateVL()
{
   #print $CGI->header;
   local ($vl_level) = $CGI->param("vl_level");
   local($db) = dbconnect();
   local ($sql) = "update characterSTATs set vlpoints=$vl_level where charid=$charid;";
   #print"$sql<BR>";
   $db->do($sql);
     
   local ($num_vls) = $CGI->param("num_vls") + 0;

   for ($k=0; $k < $num_vls; $k++)
   {
        local ($vlid) = $CGI->param("vlid_$k");
        local ($vlname) = $CGI->param("vlname_$k");
        local ($vldesc) = $CGI->param("vldesc_$k");
        local ($vl_fancy) = $CGI->param("vlfancy_$k");
        local ($vl_secure) = $CGI->param("vlsecure_$k");
        local ($vl_location) = $CGI->param("vllocation_$k");
        local ($vl_inventory) = $CGI->param("vlinventory_$k");
        $vlname =~ s/'/''/g;
        $vldesc =~ s/'/''/g;
	$sql = "update virtuallocations set vlname='$vlname', vldesc='$vldesc', vl_fancy=$vl_fancy, vl_secure=$vl_secure, vl_location=$vl_location, vl_inventory=$vl_inventory where vlid=$vlid;";
   	#print"$sql<BR>";
   	$db->do($sql);
   	
        local ($vlsubtot) = $CGI->param("vlsubtot_".$k) + 0;
   	for ($j=0; $j < $vlsubtot; $j++)
   	{
   	  local ($vlsid) = $CGI->param("vlsubid_".$k."_".$j);
   	  local ($vlslevel) = $CGI->param("vlsubval_".$k."_".$j);
	  $sql = "update VLstatlink set vlslevel=$vlslevel where vlsid=$vlsid and vlid=$vlid and charid=$charid;";
   	  #print"$sql<BR>";
   	  $db->do($sql);
   	}
   	
   }
   
   local ($num_vlas) = $CGI->param("num_vlas") + 0;

   for ($k=0; $k < $num_vlas; $k++)
   {
        local ($vlid) = $CGI->param("vlaid_$k");
        local ($vl_fancy) = $CGI->param("vlafancy_$k");
        local ($vl_secure) = $CGI->param("vlasecure_$k");
        local ($vl_location) = $CGI->param("vlalocation_$k");
        local ($vl_inventory) = $CGI->param("vlainventory_$k");
        $vlname =~ s/'/''/g;
        $vldesc =~ s/'/''/g;
	$sql = "update VLaccess set vla_fancy=$vl_fancy, vla_secure=$vl_secure, vla_location=$vl_location, vla_inventory=$vl_inventory where vlid=$vlid and charid=$charid;";
   	#print"$sql<BR>";
   	$db->do($sql);
   	
	local ($vlasubtot) = $CGI->param("vlasubtot_".$k) + 0;
	$sql = "delete from VLstatlink where vlid=$vlid and charid=$charid;";
	#print"$sql<BR>";
	$db->do($sql);
	for ($j=0; $j < $vlasubtot; $j++)
	{
	  local ($vlsid) = $CGI->param("vlasubid_".$k."_".$j);
	  local ($vlslevel) = $CGI->param("vlasubval_".$k."_".$j);
	  $sql = "insert into VLstatlink (vlslevel, vlsid, vlid, charid) values ($vlslevel, $vlsid, $vlid, $charid);";
	  #print"$sql<BR>";
	  $db->do($sql);
	}

   	
   }

   $db->disconnect;
}

sub updateAbilities()
{
	#print $CGI->header;
	local ($numabs) = $CGI->param("num_abs") * 1;
	local($db) = dbconnect();
	for ($num = 0; $num < $numabs; $num++)
	{
	  local ($level) = $CGI->param("level_$num");
	  local ($text) = $CGI->param("text_$num");
          $text =~ s/'/''/g;
	  local ($cost) = $CGI->param("cost_$num");
	  local ($caid) = $CGI->param("caid_$num");
	  local $sql = "update characterabilities set level=$level, text='$text',cost=$cost where caid=$caid;";
	  #print"$sql<BR>";
	  $db->do($sql);
	}
	$db->disconnect;
}

sub updateOccupation()
{
	#print $CGI->header;
	local ($str) = $CGI->param("oid");
	local (@oid) = split(/ /,$str);
	#print "@oid ($oid[2])<BR>";
	local($db) = dbconnect();
	local $sql = "delete from characteroccupations where charid=$charid;";
	#print"$sql<BR>";
	$db->do($sql);
	foreach $i (@oid)
	{
	  if ($i > 0)
	  {
	   local $sql = "insert into characteroccupations (charid, oid) values ($charid, $i);";
	   #print"$sql<BR>";
	   $db->do($sql);
	  }
	}
	$db->disconnect;
}

sub getmykeyroles()
{
	local ($retstr) = "";
	local($db) = dbconnect();
	local $sql = "select * from keyroles a, keyrolecharacters b where b.charid=$charid and a.krid=b.krid order by a.krname;";
	#print"$sql<BR>";
	local ($query) = $db->prepare($sql);
	$query->execute;
	if ($query->rows > 0)
	{
	  while ($resptr = $query->fetchrow_hashref())
	  {
		$retstr .= "<h3><u>".$resptr->{"krname"}."</u></h3>\n";
		$retstr .= "<p><b>Description:</b> ".$resptr->{"krdescription"}."<BR>\n";
	   	if ($curtabtext eq "resource")
	   	{
	            $retstr .= showKRResourceLinks($resptr->{"kraid"});
	   	}
		$retstr .= "<p><b>Requirements:</b> ".$resptr->{"krrequirements"}."</p>\n";
		$retstr .= getkeyroleabilities($resptr->{"krid"});
	  }
	}
	else 
	{
	   $retstr = "<BR><i>You have no Key Roles.</i><BR>";
	}
	$query->finish;
	$db->disconnect;
	return $retstr;
}

sub getkeyroleabilities()
{
	local ($krid) = $_[0];
	local ($retstr) = "";
	local($db) = dbconnect();
	local ($sql) = "select a.kraid, a.abid, b.name, b.type, a.level, a.text, a.difficulty, a.cost from keyroleabilities a, abilities b where a.krid=$krid and a.abid=b.abid order by b.type, b.name;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	$retstr .= "<table border=1>\n";
	$retstr .= "<tr>\n";
	$retstr .= "<td><b>Level</b></td>\n";
	$retstr .= "<td><b>Type</b></td>\n";
	$retstr .= "<td><b>Name</b></td>\n";
	$retstr .= "<td><b>Text</b></td>\n";
	$retstr .= "<td><b>Difficulty</b></td>\n";
	$retstr .= "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $retstr .= "<tr>\n";
	   $retstr .= "<td>".$resptr->{"level"}."</td>\n";
	   $retstr .= "<td>".$resptr->{"type"}."</td>\n";
	   $retstr .= "<td><a href=\"\" onClick=\"javascript:window.open('abilitypop.pl?abid=".$resptr->{"abid"}."','','width=450,height=550,left = 500,top = 100,scrollbars=1,resizable=1');\">".$resptr->{"name"}."</a></td>\n";
	   $retstr .= "<td>".$resptr->{"text"};
	   if ($resptr->{"type"} eq "Resource")
	   {
	       $retstr .= showKRResourceLinks($resptr->{"kraid"});
	   }
	   $retstr .= "</td>\n";
	   $retstr .= "<td>".$resptr->{"difficulty"}."</td>\n";
	   $retstr .= "</tr>\n";
	}
	$retstr .= "</table>\n";
	$query->finish;
	$db->disconnect;
	return $retstr;
}

sub showKRResourceLinks()
{
  	local ($abid) = $_[0];
	local($db) = dbconnect();
	local ($sql) = "select a.type, b.level from resourcetypes a, keyrolerresourcetypelink b where a.typeid=b.typeid and b.abid=$abid order by a.type;";
	#print "$sql<BR>";
	local($query) = $db->prepare($sql);
	$query->execute;
	local (@array);
	$rlretstr = "<table border = 0 width=100% cellspacing=0 cellpadding=0><tr>\n";
	while (@array = $query->fetchrow_array())
	{
	     $rlretstr .= "<td style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\"><b>$array[0]:</b>  $levels[$array[1]]</td>";
	}
	$rlretstr .= "</tr></table>\n";
	$query->finish;
	$db->disconnect;
	return $rlretstr;
}



