<p>
You create your character in two largish steps.  First, you create the STATs, then the Skills and Abilities.
</p>
<p>
You have two pools of points for character creation.  You use your STAT pool to create the STATs and the
XP pool to create skills/abilities.  Points gotten for handicaps may go in either pool.  You may move leftover STAT points to your skill/ability pool.
</p>
<p>
Most skills cost points based on their level.  The levels and costs are:
<table border = 1>
<tr>
<td><b>Level</b></td>
<td><b>Very Easy</b></td>
<td><b>Easy</b></td>
<td><b>Hard</b></td>
<td><b>Very Hard</b></td>
</tr>
<tr><td>1</td><td>1</td><td>1</td><td>2</td><td>3</td></tr>
<tr><td>2</td><td>2</td><td>3</td><td>6</td><td>9</td></tr>
<tr><td>3</td><td>3</td><td>6</td><td>12</td><td>18</td></tr>
<tr><td>4</td><td>4</td><td>10</td><td>20</td><td>30</td></tr>
<tr><td>5</td><td>5</td><td>15</td><td>30</td><td>45</td></tr>
<tr><td>6</td><td>6</td><td>21</td><td>42</td><td>62</td></tr>
</table>
</p>
<p>
Players may not take any STAT, Skill, or Ability at a level higher than 6.  The average human STAT is 2.  STATs are considered VERY HARD.
</p>
<p>
Abilities allow you to enter a short amount of additional text.  This is for Abilities such as Addiction in which you must list what you are addicted to.  Do not use this text field to justify your abilities to the GMs.
</p>
<H2>Tips</H2>
<p>Here are some helpful tips to keep in mind when creating your character.</p>

<p><b>OVERALL </b></p>
<p>
Remember that the online form currently does not prevent you from overspending. We'll be adding validation features later, but for now the database will not stop you from going over the legal limit. So keep an eye on your point totals. </p>

<p><b>STATS </b></p>
<p>If you're planning to play a character who either (a) uses magic, (b) uses Weird Science, or (c) uses Celestial (was Holy) powers, be sure you allocate some points to the optional stats (MANA, CELESTIAL, and INSPIRATION) at the bottom of the page. Also note that these optional stats are cheaper than the four main stats, and have no upper limit. So if your "thing" is to be the world's most powerful mage, go ahead and pump up that MANA score past six. <BR>
Also remember that STATUS is a special STAT that the GMs will assign.  You can't edit it.  Because STATUS is your key to working with Virtual Locations, the GMs will be assigning STATUSES on a regular basis.<BR>
<i>Note that assigning points to one of the optional stats will unlock other pages in the character creation database.</i></p>

<p><b>APTITUDES </b></p>
<p>"Faithful" and "Fearless" each protect you against a certain sort of Influence attack (either Seductions or Intimidations). "Stiff Upper Lip" protects you against both, and more besides, but is more expensive. <BR>
"Healthy" is terribly useful if you plan to be in combat, but also very expensive. "Impervious to Pain" is also very good for combat-oriented types. <BR>
"Insane Effort" is almost a must for Weird Scientists. <BR>
"Luck" is useful for just about everybody. </p>

<p><b>COMBAT MANEUVERS </b></p>
<p>You may have overlooked this page if you're building a character who isn't going to seek out combat. But don't be so quick to write off some of the Defense maneuvers, such as "Sprinting", "Flesh Wound", and "Total Defense". These can be useful in either keeping you alive or exiting you from the scene while all of the old soldiers deal with the problem more directly. <BR>
Also note that although Brassy's is explictly not a combat-oriented game, we make no promises about when or where bad things might happen. </p>

<p><b>HANDICAPS </b></p>
<p>Handicaps technically make your character weaker in some way, but they compensate not only in added points but also often in interesting plot hooks and twists. Every character should consider taking some handicaps. "Addiction", "Aversion", "Compulsion", "Dark Secret", "Delusional", "Moral Code", "Responsibilities" and "Social Stigma" are all particularly good at giving the GMs ways to keep your character running around. </p>

<p><b>RESOURCES </b></p>
<p>Investments will be <i>crucial</i> for most players of high status. The exact details will have to wait until our Economy system is put up on the web (coming very soon now). But consider putting some points aside for these. <BR>
Contacts and Blackmail Material are great ways to get the information to get tied into plots. </p>

<p><b>SKILLS </b></p>
<p>There are far too many skills to go over here. So just some general tips:<BR>
Consider taking one or more foreign languages. They're cheap as skills go (Very Easy) and you can never underestimate the benefit of overhearing the French Ambassador brief his aid in their native tongue. Useful modern day languages include, but are not limited to, French, German, Italian, Hindi (a stand-in for just about languages of the Indian subcontinent), and Swahili (a stand-in for most sub-Saharan African languages). Remember that you get your native language (It _is_ English, right?) at level 4 for free. (American characters are begrudingly allowed to claim English as their native language as well.) <BR>
There are three combat skills of note: Unarmed/Close Weapons, Ranged/Thrown Weapons, and Dodge. If you intend to be in combat at all, you ought to buy one of the first two, plus Dodge. Dodge is crucial for combat, as it greatly affects your chance to not be hit. <BR>
A common question is "how many different skills should I buy?" There's no single answer to this. However, once the Occupations are posted to the web (coming soon) it ought to be clearer what sort of skill levels are required to hold down a profession, which will be important to some characters. In general, read through the descriptions and pick skills that seem like they would match your character and be fun to play. Be warned that in general we will not allow "default" uses of skills - so if you didn't take "Operate Motorcar", for example, you won't make it far when you try to escape in one of those contraptions. </p>

<p><b>SPELLS and CELESTIAL POWERS </b></p>
<p>Coming Soon! For now, reserve some of your points for these areas if they would match your character. How many? Well, until we finish polishing the system we won't know for sure. But in general each spell or celestial power will be treated like a separate skill, so you can estimate from there. More information soon. </p>

<p><b>OCCUPATIONS and KEY ROLES</b></p>
<p>Some Key Roles should be showing up already - others will filter in. Occupations will be available once we're finished the system. Note that in general occupations do not cost additional points - you qualify for them by having certain skills at certain levels. So don't worry about reserving points for this area.</p>
<p>
Don't see an Ability you'd like to take?  <a href="mailto:$contact">Email the GMs</a>.
</p>