#!/usr/bin/perl

require 'stat_inc.pl';
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "status.pl";
$table = "characterSTATs";
$heading = "Status";
$keyfield = "csid";
$keyvalue = $CGI->param($keyfield);
#$tplfile = "status.tpl";
$errstr = $CGI->param("error");
$sortby = $CGI->param("sortby") + 0;

if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to edit Character Status."));
}
elsif ($submit eq "Update")
{
	#print $CGI->header();
   	local($dbvar) = dbconnect();
	# Update and Redirect
   	$thedate = getDBDate();
	local($num_stats) = $CGI->param("num_stats") + 0;
	#print "$num_stats<BR>";
	for ($num = 0; $num < $num_stats; $num++)
	{
	  local($csid) = $CGI->param("csid_$num");
	  local($charid) = dosql("select charid from $table where csid=$csid;");
	  local($status) = $CGI->param("status_$num");
	  local($substatus) = $CGI->param("substatus_$num");
	  local($oldrank) = getStatusRank($charid);
	  local($oldstatus) = dosql("select status from $table where csid=$csid;");
	  $SQL = "update $table set status=$status, substatus=$substatus where csid=$csid;";
	  #print "$SQL<BR>";
	  $dbvar->do($SQL);

	  local($freebie) = $CGI->param("freebie_$num");
	  local($actual) = dosql("select sum(points) from charactersubstatpoints where charid=$charid") + 0;
	  if ($freebie != $actual)
	  {
	    $val = $freebie - $actual;
	    $sql = "insert into charactersubstatpoints (charid,points,entrydate,notes) values ($charid, $val, '$thedate', 'Substatus Adjustment');";
	    $dbvar->do($sql);	   
	  }
	  
	  if (getStatusRank($charid) < $oldrank && $oldstatus > 0)
	  {
	    $sql = "insert into charactersubstatpoints (charid,points,entrydate,notes) values ($charid, 1, '$thedate', 'Character advanced in substatus rank');";
	    $dbvar->do($sql);	   
	  }
	  
	}
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Updated"));
}
elsif ($action eq "process")
{
   #print $CGI->header();
   local($dbvar) = dbconnect();
   $thedate = getDBDate();
   local(@array);

   for ($num = 1; $num <= 10; $num++)
   {
        #print "Status $num<BR>\n";
	$sql = "select count(charid) from characterSTATs where status=$num;";
	$statuscount = max(int((dosql($sql) / 10) + 0.5),1);
	
	$sql = "select charid from characterSTATs where status=$num order by substatus desc";
	local ($query) = $dbvar->prepare($sql);
	$query->execute;
	while (($statuscount > 0) && (@array = $query->fetchrow_array()))
	{
	   #print "$array[0] gets $statuscount<BR>\n";
	   $sql = "insert into charactersubstatpoints (charid,points,entrydate,notes) values ($array[0], $statuscount, '$thedate', 'Automatic Substatus Processing');";
	   $dbvar->do($sql);	   
	   $statuscount--;
	}
	$query->finish;
   }
   
   $sql = "select charid from characterSTATs where status > 0 order by substatus desc";
   $charid = dosql($sql);
   
   $sql = "insert into charactersubstatpoints (charid,points,entrydate,notes) values ($charid, 1, '$thedate', 'Most loved person in London');"; 
   $dbvar->do($sql);	   
   
   $dbvar->disconnect;
   print $CGI->redirect("$thispage?error=" . encodeURL("SubStatus Freebie Points Processed"));
}
elsif ($action eq "print")
{
	print $CGI->header();
	$doctitle = "Character Status";
	print "<HTML>\n";
	print "<HEAD>\n";
	print "<TITLE>$doctitle</TITLE>\n";
	print "<link href=\"../brassy.css\" rel=\"stylesheet\" type=\"text/css\">\n";
	print "</head>	\n";
	print "<body>\n";
	$num = 0;

	$sql = "select a.charid from characterSTATs a, characters b where a.status>0 and a.charid=b.charid and (b.chartype < $test_character or b.chartype = $alias_character) order by substatus desc;";
	$loved = dosql($sql);
	
	$sql = "select a.charid from characterSTATs a, characters b where a.status>0 and a.charid=b.charid and (b.chartype < $test_character or b.chartype = $alias_character) order by substatus;";
	$hated = dosql($sql);

        for ($i=8;$i>=1;$i--)
        {
	   showStatusText($i);
	   print "<BR><p>The most loved person in London:  ";
	   print getCharName($loved)." (".getFullNameFromCharID($loved).")<BR>\n";
	   print "The least appreciated person in London:  ";
	   print getCharName($hated)." (".getFullNameFromCharID($hated).")</p>\n";
	}
	print "</body>\n";
	print "</html>\n";
}
else
{
	print $CGI->header;
	$doctitle = "Character Status Menu";
	ParseForm($header);
	
	print "<font color=red>$errstr</font><BR><BR>\n";
	
	print "<H1>$doctitle</h1>\n";
	print "<p><i>This will only show character types whose hasstatus trait is 1.  <a href=\"chartypes.pl\">Manage character types</a></i></p>\n";
	
	print "<form action=\"$thispage?\" method=\"post\">\n";

	$num = 0;
	if ($sortby == 0)
	{
		for ($i=10;$i>=0;$i--)
		{
		   showStatus($i);
		}
	}
	
	if ($sortby == 1)
        {
	   showStatusByName($i);
	}
	
	print "<input type=hidden name=\"num_stats\" value=\"$num\">\n";
	print "<BR><input type=\"submit\" name=\"submit\" value=\"Update\"><BR>\n";
	
	print "</form>\n";

	print "<br><a href=\"javascript:processConfirm();\">Process Substatus Freebie Points</a>.<BR>"; 
	
	print "<br><a href=\"$thispage?action=print\" target=_new>Show Printable Substatus Page</a>.<BR><BR>"; 
	
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
		
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function processConfirm()\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Actually process the Substatus Freebie points?  This will change the points for all characters and should only be done at the end of each game period.\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=process;\"\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";

	ParseForm($footer);
}

exit 0;

sub showStatus()
{
	local($varID) = $_[0];
	local($db) = dbconnect();
	local ($sql) = "select a.* from characterSTATs a, characters b, chartypetraits c, chartypetraitlink d where a.status=$varID and a.charid=b.charid and b.chartype=d.ctypeid and c.cttid=d.cttid and c.traitname = 'hasstatus' and d.value=1 order by substatus desc;";
	print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<H2>Status $varID: $statusText[$varID]</H2>\n";
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td>Character Name (<a href=\"$thispage?sortby=1\">Sort</a>)</td>\n";
	print "<td>Base Status</td>\n";
	print "<td>Minor Status</td>\n";
	print "<td>Freebie Points</td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   showStatusLine($resptr);
	   $num++;
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub showStatusText()
{
	local($varID) = $_[0];
	local($db) = dbconnect();
	local ($sql) = "select a.charid from characterSTATs a, characters b, chartypetraits c, chartypetraitlink d where a.status=$varID and a.charid=b.charid and b.chartype=d.ctypeid and c.cttid=d.cttid and c.traitname = 'hasstatus' and d.value=1 order by substatus desc;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<H2>Status $varID: $statusText[$varID]</H2>\n";
	print "<table border=0>\n";
	$num = 1;
	local (@array);
	while (@array = $query->fetchrow_array())
	{
	   print "<tr>\n";
	   print "<td>$num.</td>\n";
	   print "<td>" . getCharName($array[0])." (".getFullNameFromCharID($array[0]).")</td>\n";
	   print "</tr>\n";
	   $num++;
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub showStatusByName()
{
	local($db) = dbconnect();
	local ($sql) = "select a.* from characterSTATs a, characters b, chartypetraits c, chartypetraitlink d where a.status=$varID and a.charid=b.charid and b.chartype=d.ctypeid and c.cttid=d.cttid and c.traitname = 'hasstatus' and d.value=1 order by b.clast;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<H2>Status Sorted By Name</H2>\n";
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td>Character Name</td>\n";
	print "<td>Base Status (<a href=\"$thispage?sortby=0\">Sort</a>)</td>\n";
	print "<td>Minor Status</td>\n";
	print "<td>Freebie Points</td>\n";
	print "</tr>\n";
	local($resptr);
	while ($resptr = $query->fetchrow_hashref())
	{
	   showStatusLine($resptr);
	   $num++;
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub showStatusLine()
{
	local($resptr) = $_[0];
	local ($charid) = $resptr->{"charid"};
	print "<input type=hidden name=csid_$num value=".$resptr->{"csid"}.">\n";
	print "<tr>\n";
	print "<td><a href=\"charquest.pl?mode=review&cqcharid=$charid\" target=new>".getCharName($charid)."</a> <i>(".getFullNameFromCharID($charid).")</i></td>\n";
	print "<td><input type=text size=2 name=status_$num value=".$resptr->{"status"}."></td>\n";
	print "<td><input type=text size=2 name=substatus_$num value=".$resptr->{"substatus"}."></td>\n";
	$sql = "select sum(points) from charactersubstatpoints where charid=$charid;";
	$points = dosql($sql) + 0;
	print "<td><input type=text size=2 name=\"freebie_$num\" value=\"$points\"></td>\n";
	print "</tr>\n";
}