#!/usr/bin/perl

require 'stat_inc.pl';
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "xp.pl";
$table = "players";
$heading = "Experience Points";
$keyfield = "playerid";
$keyvalue = $CGI->param($keyfield);
$namefield = "concat(pfirst,' ',plast)";
$tplfile = "xp.tpl";
$errstr = $CGI->param("error");

$charid = $CGI->param("charid") + 0;
$charname = getCharName($charid);
$approved = dosql("select charstatsapproved from characters where charid=$charid;") + 0;

$xp = getunspentpoints();

if ($pid != getPIDFromCharID($charid) && $al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to spend XP on that character!"));
}
elsif ($approved == 0 && $al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You may not spend XP until your character STATs are approved.  Please e-mail your GM to approve your STATs"));
}
elsif ($action eq "upstat")
{
   $statname = $CGI->param("stat");
   if ($statname eq "Strength")
   {
   	$sql = "update characterSTATs set str=str+1 where charid=$charid;";
	$cost = (($str + 4) * 3);
	$overhead = 9;
   }
   if ($statname eq "Dexterity")
   {
   	$sql = "update characterSTATs set dex=dex+1 where charid=$charid;";
	$cost = (($dex + 4) * 3);
	$overhead = 9;
   }
   if ($statname eq "IQ")
   {
   	$sql = "update characterSTATs set iq=iq+1 where charid=$charid;";
	$cost = (($iq + 4) * 3);
	$overhead = 9;
   }
   if ($statname eq "Will")
   {
   	$sql = "update characterSTATs set will=will+1 where charid=$charid;";
	$cost = (($will + 4) * 3);
	$overhead = 9;
   }
   if ($statname eq "Celestial")
   {
   	$sql = "update characterSTATs set holy=holy+1 where charid=$charid;";
	$cost = (($holy + 4) * 2);
	$overhead = 6;
   }
   if ($statname eq "MANA")
   {
   	$sql = "update characterSTATs set mana=mana+1 where charid=$charid;";
	$cost = (($mana + 4) * 2);
	$overhead = 6;
   }
   if ($statname eq "Inspiration")
   {
   	$sql = "update characterSTATs set inspiration=inspiration+1 where charid=$charid;";
	$cost = (($inspiration + 4) * 2);
	$overhead = 6;
   }
   if ($statname eq "Infernal")
   {
   	$sql = "update characterSTATs set unholy=unholy+1 where charid=$charid;";
	$cost = (($unholy + 4) * 2);
	$overhead = 6;
   }
   
   if ($cost < $xp)
   {
        dosql($sql);
        updateXP($charid,0-$overhead,"Upped a STAT");
	print $CGI->redirect("$thispage?action=stat&charid=$charid&error=" . encodeURL("$statname increased by 1"));        
   }
   else
   {
	print $CGI->redirect("$thispage?action=stat&charid=$charid&error=" . encodeURL("Good try, but you do not have the XP to increase your $statname"));        
   }
}
elsif ($action eq "stat")
{
	headprint();
	
	print "<H2>Increase Your Base STATs</H2>\n";
	
	if ($str < 6)

	{
		statprint($str, "Strength", 3);
	}
	if ($dex < 6)
	{
		statprint($dex, "Dexterity", 3);
	}
	if ($iq < 6)
	{
		statprint($iq, "IQ", 3);
	}
	if ($will < 6)
	{
		statprint($will, "Will", 3);
	}
	
	print "<H2>Increase Your Secondary STATs</H2>\n";
	
	if ($holy > 0)
	{
		statprint($holy, "Celestial", 2);
	}
	if ($mana > 0)
	{
		statprint($mana, "MANA", 2);
	}
	if ($inspiration > 0)
	{
		statprint($inspiration, "Inspiration", 2);
	}
	if ($unholy > 0)
	{
		statprint($unholy, "Infernal", 2);
	}

	jsconfirm();
	print "<br><hr><a href=\"$thispage?charid=$charid\">Return to Spend XP</a>."; 
	print "<br><a href=\"bga.pl?charid=$charid\">Return to BGAs</a>."; 
	print "<br><a href=\"login.pl\">Main menu</a>."; 
	ParseForm($footer);
}
elsif ($action eq "ability")
{
	headprint();
	
	print "<H2>Increase Your Abilities</H2>\n";
	
	local($db) = dbconnect();
	$sql = "select type from abilitytypes where type != 'Handicap' order by type;";
	#print"$sql<BR>";
	local ($query) = $db->prepare($sql);
	$query->execute;
  	local(@array);
	while (@array = $query->fetchrow_array)
	{
	   $abtype = $array[0];
	   
	   $sql = "select * from characterabilities a, abilities b, abilitydifficulty c where a.abid=b.abid and a.charid=$charid and b.type='$abtype' and a.level < 6 and a.difficulty != 'Cost' and a.difficulty=c.difficulty and a.difficulty!='Varies' order by b.name;";
	   
	   #print "$sql<BR>\n";
	   
  	   local ($query2) = $db->prepare($sql);
	   $query2->execute;
	   
	   if ($query2->rows > 0)
	   {
	   	print "<H3>$abtype</H3>\n";
		while ($resptr = $query2->fetchrow_hashref())
		{
		   $name = $resptr->{"name"};
		   $name =~ s/_//g;
		   $name .= " " . $resptr->{"text"};
	   	   print "Increase <a href=\"\" onClick=\"javascript:window.open('abilitypop.pl?abid=".$resptr->{"abid"}."','','width=450,height=550,left = 100,top = 100,scrollbars=1,resizable=1');\">$name</a> from ".$resptr->{"level"}." to ".($resptr->{"level"}+1).".  ";
	   	   $cost = getcost($resptr->{"level"} + 1,$resptr->{"diffid"} - 2);
	   	   $cost -= getcost($resptr->{"level"},$resptr->{"diffid"} - 2);
	   	   print "<i>This costs $cost XP.</i>  ";
		   if (checkcombatmanuever($resptr) <= 0)
		   {
		      	print "<i><font color=#DD0000>You must first increase your $targetskill.</font></i>";
		   }
		   elsif ($cost > $xp)
		   {
		      	print "<i><font color=#DD0000>You do not have the XP to do this.</font></i>";
		   }
		   else
		   {
		   	$confline = "This will cost $cost XP.  Are you sure?";
		   	$locstring = "$thispage?charid=$charid&action=upab&caid=".$resptr->{"caid"};
		  	print "<a href=\"javascript:jsConfirm('$confline','$locstring');\">Increase $name</a>";
		   }
	   	   print "<BR>\n";
		}
	   }
	   
	   $query2->finish;	   
	}
	$query->finish;
	$db->disconnect;
	
	
	print "<br><hr><a href=\"$thispage?charid=$charid\">Return to Spend XP</a>."; 
	print "<br><a href=\"bga.pl?charid=$charid\">Return to BGAs</a>."; 
	print "<br><a href=\"login.pl\">Main menu</a>."; 
	jsconfirm();
	ParseForm($footer);
}
elsif ($action eq "upab")
{
   $realcharid = $charid;
   $table = "characterabilities";
   $keyfield = "caid";
   $keyvalue = $CGI->param("caid");
   filltable();

   $diffid = dosql("select diffid from abilitydifficulty where difficulty='$difficulty';") - 2;
   $cost = getcost($level + 1,$diffid);
   $cost -= getcost($level,$diffid);
   
   if ($realcharid != $charid)
   {
	print $CGI->redirect("$thispage?action=ability&charid=$charid&error=" . encodeURL("Good try, but that is not one of your abilities"));        
   }
   elsif ($cost <= $xp)
   {
   	$sql = "update characterabilities set level=level+1, cost=cost+$cost where caid=$caid;";
        dosql($sql);
        $abname = dosql("select name from abilities where abid=$abid;");
	$abname =~ s/_//g;
	$abname .= " " . $text;
	print $CGI->redirect("$thispage?action=ability&charid=$charid&error=" . encodeURL("$abname increased by 1"));        
   }
   else
   {
	print $CGI->redirect("$thispage?action=ability&charid=$charid&error=" . encodeURL("Good try, but you do not have the XP to increase your $statname"));        
   }
}

elsif ($action eq "newab")
{
	headprint();
	
	print "<H2>Buy a New Ability</H2>\n";
	
	print "<form action=\"$thispage\" name=\"myform\" method=\"post\">\n";
	local($db) = dbconnect();
	$sql = "select type, basestat from abilitytypes where type != 'Handicap' order by type;";
	#print"$sql<BR>";
	local ($query) = $db->prepare($sql);
	$query->execute;
  	local(@array);
	while (@array = $query->fetchrow_array)
	{
	   $abtype = $array[0];
	   
	   if (validtab($array[1]) > 0)
	   {
	      $sql = "select * from abilities b, abilitydifficulty c where b.type='$abtype' and b.difficulty=c.difficulty order by b.name;";
	   
  	      local ($query2) = $db->prepare($sql);
	      $query2->execute;
	   
      	      print "<H3>$abtype</H3>\n";
              while ($resptr = $query2->fetchrow_hashref())
	      {
	        if (isallowedability($resptr) > 0)
	        {
		   $name = $resptr->{"name"};
		   $name =~ s/_//g;
	   	   print "Buy <a href=\"\" onClick=\"javascript:window.open('abilitypop.pl?abid=".$resptr->{"abid"}."','','width=450,height=550,left = 100,top = 100,scrollbars=1,resizable=1');\">$name</a>";
	   	   if ($resptr->{"req_text"} > 0)
	   	   {
	   	      print "<input type=text size=40 name=\"text_".$resptr->{"abid"}."\" style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10; margin-top : 0px; margin-bottom : 0px;\">  ";
	   	   }
	   	   else
	   	   {
	   	      print "<input type=hidden name=\"text_".$resptr->{"abid"}."\" value=\"\">  ";
	   	   }
	   	   
	   	   if ($resptr->{"difficulty"} eq "Cost")
	   	   {
	   	      $cost = $resptr->{"cost"} + 3;
	   	   }
	   	   elsif ($resptr->{"difficulty"} eq "Varies")
	   	   {
	   	      $cost = 5;
	   	   }
	   	   else
	   	   {
	   	      $cost = getcost(1,$resptr->{"diffid"} - 2) + 3;
	   	   }
	   	   print ".  <i>This costs $cost XP.</i>  -- <a href=\"\" onClick=\"javascript:window.open('abilitypop.pl?abid=".$resptr->{"abid"}."','','width=450,height=550,left = 500,top = 100,scrollbars=1,resizable=1');\">Display</a> -- ";
		   if (checknumcombatmanuever($resptr) <= 0)
		   {
		      	print "<i><font color=#DD0000>You must first increase your $targetskill.</font></i>";
		   }
		   elsif ($cost > $xp)
		   {
		      	print "<i><font color=#DD0000>You do not have the XP to do this.</font></i>";
		   }
		   else
		   {
		  	print "<a href=\"javascript:createredirect('".$resptr->{"abid"}."', '$cost')\">Purchase</a>";
		   }
	   	   print "<BR>\n";
	   	}
	      }
	   
	      $query2->finish;	   
	   } #is abtype allowed
	}
	$query->finish;
	$db->disconnect;
	
	print "<script language=\"javascript\">\n";
	print "function createredirect(abid,cost)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm('This will cost '+cost+' XP.  Are you sure?');\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    var myform = document.myform;\n";
	print "    var valfield = eval(\"myform.text_\" + abid);\n";
	print "	   var mystr = \"xp.pl?action=buyab&charid=$charid&abid=\" + abid + \"&text=\" + valfield.value;\n";
	print "    document.location = mystr;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
	print "</form>\n";
	
	print "<br><hr><a href=\"$thispage?charid=$charid\">Return to Spend XP</a>."; 
	print "<br><a href=\"bga.pl?charid=$charid\">Return to BGAs</a>."; 
	print "<br><a href=\"login.pl\">Main menu</a>."; 
	ParseForm($footer);
}
elsif ($action eq "buyab")
{
   $table = "abilities";
   $keyfield = "abid";
   $keyvalue = $CGI->param("abid");
   filltable();

   $diffid = dosql("select diffid from abilitydifficulty where difficulty='$difficulty';") - 2;
   if ($difficulty eq "Cost")
   {
      $cost = $cost;
   }
   elsif ($resptr->{"difficulty"} eq "Varies")
   {
      $cost = 2;
   }
   else
   {
      $cost = getcost(1,$diffid);
   }
      
   $text = $CGI->param("text");
   $text =~ s/'/''/g;
   
   if (isallowedability2($name,$req_text,$allowed,$abid) == 0)
   {
	print $CGI->redirect("$thispage?action=newab&charid=$charid&error=" . encodeURL("Good try, but you are not allowed to have that ability."));        
   }
   elsif ("$req_text" eq "CHECKED" && "$text" eq "")
   {
	print $CGI->redirect("$thispage?action=newab&charid=$charid&error=" . encodeURL("$name requires a text field."));        
   }
   elsif ($cost + 3 <= $xp)
   {
   	$name =~ s/_//g;
   	$name .= $text;
   	$sql = "insert into characterabilities (charid, abid, level, text, difficulty, cost) values ($charid, $abid, 1, '$text', '$difficulty', $cost);";
        dosql($sql);
        updateXP($charid,-3,"Bought an Ability");
	print $CGI->redirect("$thispage?action=newab&charid=$charid&error=" . encodeURL("$name purchased"));        
   }
   else
   {
	print $CGI->redirect("$thispage?action=newab&charid=$charid&error=" . encodeURL("Good try, but you do not have the XP to buy $name"));        
   }
}
elsif ($action eq "handicap")
{
	headprint();
	
	print "<H2>Buy Off A Handicap</H2><BR>\n";
	
	$sql = "select * from characterabilities a, abilities b, abilitydifficulty c where a.abid=b.abid and a.charid=$charid and b.type='Handicap' and a.difficulty=c.difficulty  order by b.name;";
	   
	local($db) = dbconnect();
  	local ($query2) = $db->prepare($sql);
	$query2->execute;
	   
	if ($query2->rows > 0)
	{
	   while ($resptr = $query2->fetchrow_hashref())
	   {
	       if ($resptr->{"abid"} != 8) #Dark secrets cannot be bought off
	       {
		   $name = $resptr->{"name"};
		   $name =~ s/_//g;
		   $name .= " " . $resptr->{"text"};
		   if ($resptr->{"difficulty"} eq "Cost")
		   {
		   	$cost = $resptr->{"cost"} + 1;
		   }
		   else
		   {
	   	   	$cost = getcost($resptr->{"level"},$resptr->{"diffid"} - 2) + 1;
	   	   }
	   	   #Social Stigmas are all or nothing
		   if ($resptr->{"level"} <= 1 || $resptr->{"abid"} == 22)
		   {
			   print "Eliminate <a href=\"\" onClick=\"javascript:window.open('abilitypop.pl?abid=".$resptr->{"abid"}."','','width=450,height=550,left = 100,top = 100,scrollbars=1,resizable=1');\">$name</a>. ";
			   print "<i>This costs $cost XP.</i>  ";
			   if ($cost > $xp)
			   {
				print "<i><font color=#DD0000>You do not have the XP to do this.</font></i>";
			   }
			   else
			   {
				$confstring = "This will cost $cost XP.  Are you sure?";
				$locstring = "$thispage?charid=$charid&action=downhand&caid=".$resptr->{"caid"};
				print "<a href=\"javascript:jsConfirm('$confstring','$locstring');\">Eliminate $name</a>";
			   }
		   }
		   else
		   {
	   	   	   $cost -= getcost($resptr->{"level"} - 1,$resptr->{"diffid"} - 2);
			   print "Lower <a href=\"\" onClick=\"javascript:window.open('abilitypop.pl?abid=".$resptr->{"abid"}."','','width=450,height=550,left = 100,top = 100,scrollbars=1,resizable=1');\">$name</a> from ".$resptr->{"level"}." to ".($resptr->{"level"}-1).".  ";
			   print "<i>This costs $cost XP.</i>  ";
			   if ($cost > $xp)
			   {
				print "<i><font color=#DD0000>You do not have the XP to do this.</font></i>";
			   }
			   else
			   {
				$confstring = "This will cost $cost XP.  Are you sure?";
				$locstring = "$thispage?charid=$charid&action=downhand&caid=".$resptr->{"caid"};
				print "<a href=\"javascript:jsConfirm('$confstring','$locstring');\">Lower $name</a>";
			   }
		   }
	   	   print "<BR>\n";
		}
	    }
	}
	$query2->finish;
	$db->disconnect;
	
	jsconfirm();
	print "<br><hr><a href=\"$thispage?charid=$charid\">Return to Spend XP</a>."; 
	print "<br><a href=\"bga.pl?charid=$charid\">Return to BGAs</a>."; 
	print "<br><a href=\"login.pl\">Main menu</a>."; 
	ParseForm($footer);
}
elsif ($action eq "downhand")
{
   $realcharid = $charid;
   $table = "characterabilities";
   $keyfield = "caid";
   $keyvalue = $CGI->param("caid");
   filltable();

   $diffid = dosql("select diffid from abilitydifficulty where difficulty='$difficulty';") - 2;
   if ($difficulty eq "Cost")
   {
	$cost = $cost;
   }
   else
   {
	$cost = getcost($level,$diffid);
   }
   if ($abid != 22)
   {
	$cost -= getcost($level - 1,$diffid);
   }
   
   if ($realcharid != $charid)
   {
	print $CGI->redirect("$thispage?action=handicap&charid=$charid&error=" . encodeURL("Good try, but that is not one of your handicaps."));        
   }
   elsif ($cost + 1 > $xp)
   {
        $abname = dosql("select name from abilities where abid=$abid;");
	$abname =~ s/_//g;
	$abname .= " " . $text;
	print $CGI->redirect("$thispage?action=handicap&charid=$charid&error=" . encodeURL("Good try, but you do not have the $cost XP needed to decrease $abname"));        
   }
   elsif ($level <= 1 || $abid == 22)
   {
   	$sql = "delete from characterabilities where caid=$caid;";
        dosql($sql);
        $abname = dosql("select name from abilities where abid=$abid;");
	$abname =~ s/_//g;
	$abname .= " " . $text;
	$abname =~ s/'/''/g;
        updateXP($charid,-1,"Bought off a Handicap: $abname");
	print $CGI->redirect("$thispage?action=handicap&charid=$charid&error=" . encodeURL("$abname eliminated"));        
   }
   else
   {
   	$sql = "select cost from characterabilities where caid=$caid;";
   	$oldcost = dosql($sql);
   	print "old handicap cost = $oldcost<BR>\n";
   	print "subtracting $cost to make ".($oldcost - $cost)."<BR>\n";
   	$sql = "update characterabilities set level=level-1, cost=cost-$cost where caid=$caid;";
        dosql($sql);
        $abname = dosql("select name from abilities where abid=$abid;");
	$abname =~ s/_//g;
	$abname .= " " . $text;
	$abname =~ s/'/''/g;
        updateXP($charid,-1,"Lowered a Handicap: $abname");
	print $CGI->redirect("$thispage?action=handicap&charid=$charid&error=" . encodeURL("$abname lowered by 1"));        
   }
}
elsif ($action eq "weird")
{
	headprint();
	
	print "<H2>Manage Your Weird Science</H2><BR>\n";
	
	dispWS($charid);
	
	if ($weirdscience < 6)
	{
	   print "Increase your <b>Weird Science</b> skill from $weirdscience to ".($weirdscience+1).".  ";
	   $cost = getcost($weirdscience + 1,2);
	   $cost -= getcost($weirdscience,2);
	   print "<i>This costs $cost XP.</i>  ";
	   if ($cost > $xp)
	   {
		print "<i><font color=#DD0000>You do not have the XP to do this.</font></i>";
	   }
	   else
	   {
		$confstring = "This will cost $cost XP.  Are you sure?";
		$locstring = "$thispage?charid=$charid&action=upws";
		print "<a href=\"javascript:jsConfirm('$confstring','$locstring');\">Increase Weird Science</a>";
	   }
	   print "<BR><hr>\n";
	}
	
	if ($spent < $ws_points)
	{
	    $available = $ws_points - $spent;
	    print "<i>You have $available Weird Science points available to spend.</i><BR><BR>";
	    
	    print "<h3>Motive Forces</h3>\n";
	    
	    for ($i = 0; $i < $num_motives; $i++)
	    {
	    	if (("$mfsecret[$i]" eq "0" || canshowmotiveforce($mfid[$i])) && $mfval[$i] < 6)
	    	{
	    	   print "Increase <b>$motives[$i]</b> from $mfval[$i] to ".($mfval[$i] + 1).".  \n";
		   $confstring = "Increase $motives[$i].  Are you sure?";
		   $locstring = "$thispage?charid=$charid&action=upmf&mfid=$mfid[$i]";
		   print "<a href=\"javascript:jsConfirm('$confstring','$locstring');\">Increase $motives[$i]</a><BR>";
	    	}
	    }

	    print "<h3>Applications</h3>\n";
	    
	    for ($i = 0; $i < $num_applications; $i++)
	    {
	    	if ($apval[$i] < 6)
	    	{
	    	   print "Increase <b>$applications[$i]</b> from $apvals[$i] to ".($apvals[$i] + 1).".  \n";
		   $confstring = "Increase $applications[$i].  Are you sure?";
		   $locstring = "$thispage?charid=$charid&action=upap&aid=$aid[$i]";
		   print "<a href=\"javascript:jsConfirm('$confstring','$locstring');\">Increase $applications[$i]</a><BR>";
	    	}
	    }

	}
	
	jsconfirm();
	print "<br><hr><a href=\"$thispage?charid=$charid\">Return to Spend XP</a>."; 
	print "<br><a href=\"bga.pl?charid=$charid\">Return to BGAs</a>."; 
	print "<br><a href=\"login.pl\">Main menu</a>."; 
	ParseForm($footer);
}
elsif ($action eq "upws")
{
	$cost = getcost($weirdscience + 1,2);
	$cost -= getcost($weirdscience,2);
	
	if ($cost <= $xp)
	{
	   $sql = "update characterSTATs set weirdscience=weirdscience+1 where charid=$charid;";
	   dosql($sql);
	   print $CGI->redirect("$thispage?action=weird&charid=$charid&error=" . encodeURL("Weird Science skill increased by 1."));  
	}
	else
	{
	   print $CGI->redirect("$thispage?action=weird&charid=$charid&error=" . encodeURL("Good try, but you do not have the XP to increase your Weird Science skill"));        
	}
}
elsif ($action eq "upmf")
{
	$mfid = $CGI->param("mfid"); 
	$mfval = getmotiveforce($mfid) + 1;
	$sql = "delete from charactermotiveforces where charid=$charid and mfid=$mfid;";
	dosql($sql);
	$sql = "insert into charactermotiveforces (charid, mfid, level) values ($charid, $mfid, $mfval);";
	dosql($sql);
	print $CGI->redirect("$thispage?action=weird&charid=$charid&error=" . encodeURL("Motive Force increased by 1."));        
}
elsif ($action eq "upap")
{
	$aid = $CGI->param("aid"); 
	$apval = getapplication($aid) + 1;
	$sql = "delete from characterapplications where charid=$charid and aid=$aid;";
	dosql($sql);
	$sql = "insert into characterapplications (charid, aid, level) values ($charid, $aid, $apval);";
	dosql($sql);
	print $CGI->redirect("$thispage?action=weird&charid=$charid&error=" . encodeURL("Application increased by 1."));        
}
elsif ($action eq "vls")
{
	headprint();
	
	print "<H2>Manage Your Virtual Locations</H2><BR>\n";
	
	$vl_points = ($status + $vlpoints) * $status;
	$spent = getVLSpent();
	
	$available = $vl_points - $spent - $vlspecialpoints;

	print "You have $available virtual location points to spend.<BR>\n";
	
	if ($xp > 0)
	{
	   print "You may spend 1 XP to increase your available VL points from $available to ".($available + $status).". ";
	   $confstring = "This will cost 1 XP.  Are you sure?";
	   $locstring = "$thispage?charid=$charid&action=upvl";
	   print "<a href=\"javascript:jsConfirm('$confstring','$locstring');\">Increase VL Points</a><BR>";
	}
	
	print "<BR><HR>\n";

	dispVL($charid);	
	
	jsconfirm();
	print "<br><hr><a href=\"$thispage?charid=$charid\">Return to Spend XP</a>."; 
	print "<br><a href=\"bga.pl?charid=$charid\">Return to BGAs</a>."; 
	print "<br><a href=\"login.pl\">Main menu</a>."; 
	ParseForm($footer);
}
elsif ($action eq "upvl")
{
	$cost = 1;
	
	if ($cost <= $xp)
	{
	   $sql = "update characterSTATs set vlpoints=vlpoints+1 where charid=$charid;";
	   dosql($sql);
	   print $CGI->redirect("$thispage?action=vls&charid=$charid&error=" . encodeURL("Virtual Locations Points increased."));  
	}
	else
	{
	   print $CGI->redirect("$thispage?action=vls&charid=$charid&error=" . encodeURL("Good try, but you do not have the XP to increase your Virtual Locations points"));        
	}
}
elsif ($action eq "upvlid")
{
	$vlid = $CGI->param("vlid"); 
	$vltype = $CGI->param("vltype"); 
	
	$vl_points = ($status + $vlpoints) * $status;
	$spent = getVLSpent() + $vlspecialpoints;
	
	if ($spent < $vl_points)
	{
	   $sql = "update virtuallocations set $vltype=$vltype+1 where vlowner=$charid and vlid=$vlid;";
	   dosql($sql);
	   print $CGI->redirect("$thispage?action=vls&charid=$charid&error=" . encodeURL("Virtual Location updated."));  
	}
	else
	{
	   print $CGI->redirect("$thispage?action=vls&charid=$charid&error=" . encodeURL("Good try, but you do not have the VL Points to increase any Virtual Locations stats"));        
	}
}
elsif ($action eq "upvlsp")
{
	$vlid = $CGI->param("vlid"); 
	$vlsid = $CGI->param("vlsid"); 
	
	$vl_points = ($status + $vlpoints) * $status;
	$spent = getVLSpent() + $vlspecialpoints;
	
	$level = dosql("select vlslevel from VLstatlink where vlid=$vlid and vlsid=$vlsid and charid=$charid;") + 1;
	
	if ($spent >= $vl_points)
	{
	   print $CGI->redirect("$thispage?action=vls&charid=$charid&error=" . encodeURL("Good try, but you do not have the VL Points to increase any Virtual Locations stats"));        
	}
	else
	{
	   $sql = "delete from VLstatlink where vlid=$vlid and vlsid=$vlsid and charid=$charid;";
	   dosql($sql);
	   $sql = "insert into VLstatlink (vlslevel, vlid, vlsid, charid) values ($level, $vlid, $vlsid, $charid);";
	   dosql($sql);
	}
	   
	print $CGI->redirect("$thispage?action=vls&charid=$charid&error=" . encodeURL("Virtual Location updated."));  
}
elsif ($action eq "upvlacc")
{
	$vlid = $CGI->param("vlid"); 
	$vltype = $CGI->param("vltype"); 
	
	$vl_points = ($status + $vlpoints) * $status;
	$spent = getVLSpent() + $vlspecialpoints;
	
	$exists = dosql("select count(vlid) from VLaccess where vlid=$vlid and charid=$charid;") + 0;
	
	if ($spent >= $vl_points)
	{
	   print $CGI->redirect("$thispage?action=vls&charid=$charid&error=" . encodeURL("Good try, but you do not have the VL Points to increase any Virtual Locations stats"));        
	}
	elsif ($exists > 0)
	{
	   $sql = "update VLaccess set $vltype=$vltype+1 where charid=$charid and vlid=$vlid;";
	}
	else
	{
	   $sql = "insert into VLaccess (vlid, charid, $vltype) values ($vlid, $charid, 1);";
	}
	   
	dosql($sql);
	print $CGI->redirect("$thispage?action=vls&charid=$charid&error=" . encodeURL("Virtual Location updated."));  
}
else
{
	headprint();
	print "<H2>Spend XP</H2>\n";
	print "<ul>\n";
	print "<li><a href=\"$thispage?charid=$charid&action=stat\">Increase a STAT</a></li>\n";
	print "<li><a href=\"$thispage?charid=$charid&action=ability\">Increase an Ability</a></li>\n";
	print "<li><a href=\"$thispage?charid=$charid&action=newab\">Buy a New Ability</a></li>\n";
	print "<li><a href=\"$thispage?charid=$charid&action=handicap\">Buy off a Handicap</a></li>\n";
	print "<li><a href=\"$thispage?charid=$charid&action=weird\">Manage your Weird Science</a></li>\n";
	print "<li><a href=\"$thispage?charid=$charid&action=vls\">Manage Your Virtual Locations</a></li>\n";
	print "</ul>\n";
	
	print "<br><hr><a href=\"bga.pl?charid=$charid\">Return to BGAs</a>."; 
	print "<br><a href=\"login.pl\">Main menu</a>."; 
		
	ParseForm($footer);
}

exit 0;

sub headprint()
{
	print $CGI->header;
	$doctitle = "Spend XP for $charname";
	ParseForm($header);
		
	print "<font color=red>$errstr</font><BR><BR>\n";
	
	print "<H1>$doctitle</h1>\n";
		
	print "<i>You have $xp XP to spend.  This includes unspent character points.</i><BR><BR>\n";
}

sub getunspentpoints()
{
    setSTATvars();
    $skillcost = dosql("select sum(a.cost) from characterabilities a, abilities b where charid=$charid and a.abid=b.abid and b.type != 'Handicap';") + 0;
    $wscost += getcost($weirdscience,2);
    #print "Stat Remain: $statremain<BR>\n";
    #print "Abilities Allowed: $aballowed<BR>\n";
    #print "Skill spent: $skillcost<BR>\n";
    #print "Weird Science spent: $wscost<BR>\n";
    #print "VL spent: $vlpoints<BR>\n";
    $abcost = $statremain + $aballowed - ($skillcost + $wscost + $vlpoints);   
    #print "Total remaining: $abcost<BR>\n";
    return $abcost;
}

sub statprint()
{
	($statvar, $statname, $statmult) = @_;
	print "Increase your <b>$statname</b> from $statvar to ".($statvar + 1).".  ";
	$cost = (($statvar + 4) * $statmult);
	print "<i>Cost: $cost XP.  </i>";
	if ($cost > $xp)
	{
	  print "<i><font color=#DD0000>You do not have the XP to do this.</font></i>";
	}
	else
	{
	  $confstring = "This will cost $cost XP.  Are you sure?";
	  $locstring = "$thispage?charid=$charid&action=upstat&stat=$statname";
	  print "<a href=\"javascript:jsConfirm('$confstring','$locstring');\">Increase $statname</a>";
	}
	print "<BR>\n";
}

sub checkcombatmanuever()
{
	local ($resptr) = $_[0];
	$targetskill = "";
	$num = 0;

	if ($resptr->{"type"} ne "Combat Manuever")
	{
	    return 1;
	}

	if ($resptr->{"category"} eq "Unarmed/Close")
	{
	   $targetskill = "UNARMED/CLOSE WEAPONS";
	}

	if ($resptr->{"category"} eq "Ranged")
	{
	   $targetskill = "RANGED/THROWN WEAPONS";
	}

	if ($resptr->{"category"} eq "Defense")
	{
	   $targetskill = "DODGE";
	}

	$num = getlevel($targetskill);
	
	return $num - $resptr->{"level"};
}

sub checknumcombatmanuever()
{
	local ($resptr) = $_[0];
	$targetskill = "";
	$sql = "";
	$num = 0;

	if ($resptr->{"type"} ne "Combat Manuever")
	{
	    return 1;
	}

	if ($resptr->{"category"} eq "Unarmed/Close")
	{
	   $targetskill = "UNARMED/CLOSE WEAPONS";
	   $sql = "select count(a.caid) from characterabilities a, abilities b where a.charid=$charid and a.abid=b.abid and b.category='Unarmed/Close';";
	}

	if ($resptr->{"category"} eq "Ranged")
	{
	   $targetskill = "RANGED/THROWN WEAPONS";
	   $sql = "select count(a.caid) from characterabilities a, abilities b where a.charid=$charid and a.abid=b.abid and b.category='Ranged';";
	}

	if ($resptr->{"category"} eq "Defense")
	{
	   $targetskill = "DODGE";
	   $sql = "select count(a.caid) from characterabilities a, abilities b where a.charid=$charid and a.abid=b.abid and b.category='Defense';";
	}

	$num = dosql($sql) + 0;
	$num2 = getlevel($targetskill);
	
	return $num - $num2;
}


sub isallowedability()
{
	local ($resptr) = $_[0];
	
	return isallowedability2($resptr->{"name"},$ischecked[$resptr->{"req_text"}],$resptr->{"allowed"},$resptr->{"abid"});
}

sub isallowedability2()
{
	local($name, $req_text, $allowed, $abid) = @_;
	local($chartype) = dosql("select chartype from characters where charid=$charid;");
	local($lev) = getlevel($name) - getkeyrolelevelforchar($name,"",$charid);

	if ($lev > 0 && "$req_text" ne "CHECKED")
	{
	    return 0;
	}

        if ($allowed eq "All" || "$chartype" eq "$test_character")
        {
            return 1;
        }

	if ($allowed eq "NPC Only" && "$chartype" eq "$cast_character")
	{
	    return 1;
	}
	
	if (($allowed eq "By Request Only" && "$chartype" eq "$cast_character") || abilityallowed($abid))
	{
	    return 1;
	}
	
	return 0;
}

sub dispWS()
{
   local ($charid) = $_[0];
   
   if ($inspiration > 0)
   {
	local($db) = dbconnect();
	$ws_level = $weirdscience;
	
	$ws_points = $ws_level * $ws_mult;
	$ws_cost = getcost($ws_level,2);
	$totalcost = $ws_cost;
	
	#that was the easy part.
	$num_applications = 0;
	$sql = "select * from applications where amfid=0 order by aname";
	local($query) = $db->prepare($sql);
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())
	{
	   $aid[$num_applications] = $resptr->{"aid"};
	   $applications[$num_applications] = $resptr->{"aname"};
	   $application_text[$num_applications] = $resptr->{"adesc"};
	   $num_applications += 1;
	}
	$query->finish;
	
	$num_motives = 0;
	$sql = "select * from motiveforces order by mfsecret, mfname desc";
	local($query) = $db->prepare($sql);
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())
	{
	   $mfid[$num_motives] = $resptr->{"mfid"};
	   $mfsecret[$num_motives] = $resptr->{"mfsecret"} + 0;
	   $motives[$num_motives] = $resptr->{"mfname"};
	   $motive_text[$num_motives] = $resptr->{"mfdesc"};
	   $num_motives += 1;
	}
	$query->finish;
	
	$spent = 0;
	$ws_chart = "<table border=1 cellspacing=0 cellpadding=1 align=center>\n";
	$ws_chart .= "<tr><td colspan=2 rowspan=2 style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\">&nbsp;</td><td colspan=$num_applications align=center style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\"><b>Applications</b></td></tr>\n";
	$ws_chart .= "<tr>";
	for ($k=0; $k < $num_applications; $k++)
	{
	   $ws_chart .= "$smalltd3 $applications[$k] </td>";
	}
	$ws_chart .= "</tr>\n";
	$ws_chart .= "<tr><td colspan=2 align=center style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\"><b>Motive Forces</b></td>";
	for ($k=0; $k < $num_applications; $k++)
	{
	   $apvals[$k] = getapplication($aid[$k]);
	   $ws_chart .= "$smalltd3";
	   $ws_chart .= "$apvals[$k]</td>";
	   $spent += $apvals[$k];
	}
	$ws_chart .= "</tr>\n";
	$num_shown_motives = 0;
	for ($k=0; $k < $num_motives; $k++)
	{
	   $mfval[$k] = getmotiveforce($mfid[$k]) + 0;
	   if ("$mfsecret[$k]" eq "0")
	   {
		$ws_chart .= "<tr>$smalltd1 $motives[$k]</td>\n";
		$ws_chart .= "$smalltd3 $mfval[$k]</td>";
		for ($j=0; $j < $num_applications; $j++)
		{
		   $ws_chart .= "$smalltd3". min($mfval[$k],$apvals[$j]);
		   
		   $sql = "select aname from applications where amfid=$mfid[$k] and abaseid=$aid[$j];";
		   local($str) = dosql($sql);
		   #print "$sql<BR>";		   
		   if ($str ne "0")
		   {
		     $ws_chart .= "<BR><i>($str)</i>";
		   }
		   $ws_chart .= "</td>";
		}
		$ws_chart .= "</tr>\n";
		$spent += $mfval[$k];
		$num_shown_motives++;
	   }
	   elsif (canshowmotiveforce($mfid[$k]))
	   {
		$ws_chart .= "<tr><td bgcolor=#eeeeee style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\">$motives[$k]</td>\n";
		$ws_chart .= "$smalltd1 $mfval[$k]</td>";
		for ($j=0; $j < $num_applications; $j++)
		{
		   $ws_chart .= "<td align=center bgcolor=#eeeeee style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\">". min($mfval[$k],$apvals[$j]);
		    
		   $ws_chart .= "</td>";
		}
		$ws_chart .= "</tr>\n";
		$spent += $mfval[$k];
		$num_shown_motives++;
	   }
	}
	$ws_chart .= "</table>\n";
	$db->disconnect;	

   	print "<h2 style=\"font-family : Arial, Helvetica, sans-serif; font-size: 14;\">Weird Science</H2><BR>\n";
   	print "<B>Weird Science Skill Level: $weirdscience</b><BR>\n";
 	print $ws_chart;
   	print "<BR><hr>\n";
   }
}

sub dispVL()
{
  	local($charid) = $_[0];
   	local($db) = dbconnect();
   	print "<h2 style=\"font-family : Arial, Helvetica, sans-serif; font-size: 14;\">Virtual Locations</H2><BR>\n";
	print "<table width=100% border = 1>";
	print "<tr>";
	print "$midtd <b>Name</b></td>";
	print "$midtd <b>Description</b></td>";
	print "</tr>";
	$num_vls = 0;
	
	$sql = "select * from virtuallocations where vlowner = $charid";
	local($query) = $db->prepare($sql);
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())
	{
	    print "<tr>";
	    print "$midtd ".$resptr->{"vlname"}."</td>";
	    print "$midtd ".$resptr->{"vldesc"}."</td>";
	    print "</tr>\n";
	    print "<tr>";
	    print "<td colspan=2>";
	        $val = 0;
		print "<table border=1 width=100%>";
		print "<tr> ";
		$vlid = $resptr->{"vlid"};
		$val = getVLtotal($vlid,"vl_fancy", "vla_fancy");
		print "$smalltd1 Fancy: $val &nbsp; ";
		print "<a href=\"$thispage?charid=$charid&action=upvlid&vlid=$vlid&vltype=vl_fancy\">Increase</a></td>";
		$val = getVLtotal($vlid,"vl_secure", "vla_secure");
		print "$smalltd1 Secure: $val &nbsp; ";
		print "<a href=\"$thispage?charid=$charid&action=upvlid&vlid=$vlid&vltype=vl_secure\">Increase</a></td>";
		$val = getVLtotal($vlid,"vl_location", "vla_location");
		print "$smalltd1 Location: $val &nbsp; ";
		print "<a href=\"$thispage?charid=$charid&action=upvlid&vlid=$vlid&vltype=vl_location\">Increase</a></td>";
		$val = getVLtotal($vlid,"vl_inventory", "vla_inventory");
		print "$smalltd1 Inventory: $val &nbsp; ";
		print "<a href=\"$thispage?charid=$charid&action=upvlid&vlid=$vlid&vltype=vl_inventory\">Increase</a></td>";
		print "</tr>\n";	
		print showspecialVLstats($vlid, $num_vls, "vl");
		print "</table>\n";
	    print "</td>";
	    print "</tr>\n";
	    $num_vls++;
	}
	$query->finish;
	$num_vlas = 0;
	$sql = "select * from virtuallocations a, VLaccess b where a.vlid=b.vlid and b.charid = $charid";
	local($query) = $db->prepare($sql);
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())
	{
	    print "<tr bgcolor=#EEEEEE>";
	    print "$midtd ".$resptr->{"vlname"}."</td>";
	    print "$midtd ".$resptr->{"vldesc"}."</td>";
	    print "</tr>\n";
	    print "<tr bgcolor=#EEEEEE>";
	    print "<td colspan=2>";
		print "<table border=1 width=100%>";
		print "<tr bgcolor=#EEEEEE> ";
		$vlid = $resptr->{"vlid"};
		$val = getVLtotal($vlid,"vl_fancy", "vla_fancy");
		print "$smalltd1 Fancy: $val &nbsp; ";
		print "<a href=\"$thispage?charid=$charid&action=upvlacc&vlid=$vlid&vltype=vla_fancy\">Increase</a></td>";
		$val = getVLtotal($vlid,"vl_secure", "vla_secure");
		print "$smalltd1 Secure: $val &nbsp; ";
		print "<a href=\"$thispage?charid=$charid&action=upvlacc&vlid=$vlid&vltype=vla_secure\">Increase</a></td>";
		$val = getVLtotal($vlid,"vl_location", "vla_location");
		print "$smalltd1 Location: $val &nbsp; ";
		print "<a href=\"$thispage?charid=$charid&action=upvlacc&vlid=$vlid&vltype=vla_location\">Increase</a></td>";
		$val = getVLtotal($vlid,"vl_inventory", "vla_inventory");
		print "$smalltd1 Inventory: $val &nbsp; ";
		print "<a href=\"$thispage?charid=$charid&action=upvlacc&vlid=$vlid&vltype=vla_inventory\">Increase</a></td>";
		print "</tr>\n";		
		print showspecialVLstats($vlid, $num_vlas, "vla");
		print "</table>\n";
	    print "</td>";
	    print "</tr>\n";
	    $num_vlas++;
	}
	$query->finish;
	print "</table>\n";
	$query->finish;
   	$db->disconnect;
}

sub showspecialVLstats()
{
  local ($vlid) = $_[0];
  local ($nums) = $_[1];
  local ($jssub) = $_[2];
  local($db) = dbconnect();
  local ($sql) = "select b.vlsname, a.vlsid, b.vlcanupdate from VLstatlink a, VLstats b, virtuallocations c where a.vlid=$vlid and a.vlsid=b.vlsid and a.charid=c.vlowner and c.vlid=$vlid;";
  #print "$sql<BR>";
  local($query) = $db->prepare($sql);
  $query->execute;
  local($retstr)= "";
  local ($sub) = 0;
  if ($query->rows > 0)
  {
     $retstr .= "<tr>\n";
     local ($resptr);
     while ($resptr = $query->fetchrow_hashref())
     {
        $sql = "select vlslevel from VLstatlink where vlid=$vlid and vlsid=".$resptr->{"vlsid"}." and charid=$charid;";
   	#print "$sql<BR>";
  	local($query2) = $db->prepare($sql);
  	$query2->execute;
  	local (@myval);
  	$myval[0] = 0;
  	if ($query2->rows > 0)
  	{
  		@myval = $query2->fetchrow_array();
  	}
	$query2->finish;
        $sql = "select sum(vlslevel) from VLstatlink where vlid=$vlid and vlsid=".$resptr->{"vlsid"}.";";
   	#print "$sql<BR>";
  	$query2 = $db->prepare($sql);
  	$query2->execute;
  	local (@mysum);
  	$mysum[0] = 0;
  	if ($query2->rows > 0)
  	{
  		@mysum = $query2->fetchrow_array();
  	}
	$query2->finish;
        local ($name) = $resptr->{"vlsname"};
     	$retstr .= "$smalltd1 ";
     	$retstr .= "<i>$name: ";
     	$retstr .= $mysum[0];
     	$retstr .= "</i> &nbsp; ";
     	if ($resptr->{"vlcanupdate"} > 0)
     	{
	   $retstr .= "<a href=\"$thispage?charid=$charid&action=upvlsp&vlid=$vlid&vlsid=".$resptr->{"vlsid"}."\">Increase</a>";
	}
	print "</td>\n";
     }
     $retstr .= "</tr>\n";
  }
  $query->finish;
  $db->disconnect;
  return $retstr;
}

sub getVLSpent()
{
	local ($num) = dosql ("select sum(vl_fancy) from virtuallocations where vlowner=$charid;");
	$num += dosql ("select sum(vl_secure) from virtuallocations where vlowner=$charid;");
	$num += dosql ("select sum(vl_location) from virtuallocations where vlowner=$charid;");
	$num += dosql ("select sum(vl_inventory) from virtuallocations where vlowner=$charid;");
	$num += dosql ("select sum(vla_fancy) from VLaccess where charid=$charid;");
	$num += dosql ("select sum(vla_secure) from VLaccess where charid=$charid;");
	$num += dosql ("select sum(vla_location) from VLaccess where charid=$charid;");
	$num += dosql ("select sum(vla_inventory) from VLaccess where charid=$charid;");
	$num += dosql ("select sum(vlslevel) from VLstatlink where charid=$charid;");
	return $num;
}

sub jsconfirm()
{
	print "<script language=\"javascript\">\n";
	print "var confline, locstring;\n";
	print "function jsConfirm(confline, locstring)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(confline);\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = locstring;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
}